Package: InPAS
Title: Identify Novel Alternative PolyAdenylation Sites (PAS) from
        RNA-seq data
Version: 2.21.0
Authors@R: c(person("Jianhong", "Ou", role = c("aut", "cre"), 
             email = "jou@morgridge.org"), 
             person("Haibo", "Liu", role = c("aut"), 
             email = "haibo.liu@umassmed.edu"),
             person("Lihua Julie", "Zhu", role = c("aut"), 
             email = "Julie.Zhu@umassmed.edu"), 
             person("Sungmi M.", "Park", role = "aut"),
             person("Michael R.", "Green", role = "aut"))
Maintainer: Jianhong Ou <jou@morgridge.org>
Description: Alternative polyadenylation (APA) is one of the important post-
             transcriptional regulation mechanisms which occurs in most human
             genes. InPAS facilitates the discovery of novel APA sites and the
             differential usage of APA sites from RNA-Seq data. It leverages 
             cleanUpdTSeq to fine tune identified APA sites by removing false 
             sites.
biocViews: Alternative Polyadenylation, Differential Polyadenylation
        Site Usage, RNA-seq, Gene Regulation, Transcription
License: GPL (>= 2)
Imports:
        AnnotationDbi,batchtools,Biobase,Biostrings,BSgenome,cleanUpdTSeq,
        depmixS4,dplyr,flock,future,future.apply,GenomeInfoDb,GenomicRanges,
        GenomicFeatures, ggplot2, IRanges, limma,
        magrittr,methods,parallelly, plyranges, preprocessCore,
        readr,reshape2, RSQLite, Seqinfo, stats, S4Vectors, utils
Depends: R (>= 3.5)
Suggests: BiocGenerics,BiocManager, BiocStyle,
        BSgenome.Mmusculus.UCSC.mm10, BSgenome.Hsapiens.UCSC.hg19,
        EnsDb.Hsapiens.v86, EnsDb.Mmusculus.v79, knitr, markdown,
        rmarkdown, rtracklayer, RUnit, grDevices,
        TxDb.Hsapiens.UCSC.hg19.knownGene,TxDb.Mmusculus.UCSC.mm10.knownGene
VignetteBuilder: knitr
RoxygenNote: 7.3.3
Roxygen: list(markdown = TRUE)
LazyData: true
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/InPAS
git_branch: devel
git_last_commit: 15afd99
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:19:43 UTC; biocbuild
Author: Jianhong Ou [aut, cre],
  Haibo Liu [aut],
  Lihua Julie Zhu [aut],
  Sungmi M. Park [aut],
  Michael R. Green [aut]

# InPAS

[![platforms](http://bioconductor.org/shields/availability/devel/InPAS.svg)](http://bioconductor.org/packages/devel/bioc/html/InPAS.html)
[![build](http://bioconductor.org/shields/build/devel/bioc/InPAS.svg)](http://bioconductor.org/packages/devel/bioc/html/InPAS.html)

Identification of Novel alternative PolyAdenylation Sites (PAS)

Alternative polyadenylation (APA) is one of the important post-transcriptional regulation mechanisms which occurs in most human genes. InPAS facilitates the discovery of novel APA sites from RNAseq data. It leverages cleanUpdTSeq to fine tune identified APA sites.

## Installation

To install this package, start R and enter:

```r
library(BiocManager)
BiocManager::install("InPAS")
```

## Documentation

To view documentation of InPAS, start R and enter:
```r
browseVignettes("InPAS")
```

#' Assemble coverage files for a given chromosome for all samples
#'
#' Process individual sample-chromosome-specific coverage files in an
#'   experiment into a file containing a list of chromosome-specific Rle
#'   coverage of all samples
#'
#' @param sqlite_db A path to the SQLite database for InPAS, i.e.
#'   the output of setup_sqlitedb()
#' @param seqname A character(1) vector, the name of a chromosome/scaffold
#' @param outdir A character(1) vector, a path with write permission for storing
#'   InPAS analysis results. If it doesn't exist, it will be created.
#' @param genome An object of [BSgenome::BSgenome-class]
#' @return A list of paths to per-chromosome coverage files of all samples.
#' \itemize{\item seqname, chromosome/scaffold name
#'             \itemize{
#'                         \item  tag1, name tag for sample1
#'                         \item  tag2, name tag for sample2
#'                         \item  tagN, name tag for sampleN
#'                     }
#'         }
#' @export
#' @import RSQLite
#' @author Haibo Liu
#' @examples
#' if (interactive()) {
#'   library(BSgenome.Mmusculus.UCSC.mm10)
#'   genome <- BSgenome.Mmusculus.UCSC.mm10
#'   bedgraphs <- system.file("extdata", c(
#'     "Baf3.extract.bedgraph",
#'     "UM15.extract.bedgraph"
#'   ),
#'   package = "InPAS"
#'   )
#'   tags <- c("Baf3", "UM15")
#'   metadata <- data.frame(
#'     tag = tags,
#'     condition = c("Baf3", "UM15"),
#'     bedgraph_file = bedgraphs
#'   )
#'   outdir <- tempdir()
#'   write.table(metadata,
#'     file = file.path(outdir, "metadata.txt"),
#'     sep = "\t", quote = FALSE, row.names = FALSE
#'   )
#'
#'   sqlite_db <- setup_sqlitedb(
#'     metadata = file.path(
#'       outdir,
#'       "metadata.txt"
#'     ),
#'     outdir
#'   )
#'   coverage <- list()
#'   addLockName(filename = tempfile())
#'   for (i in seq_along(bedgraphs)) {
#'     coverage[[tags[i]]] <- get_ssRleCov(
#'       bedgraph = bedgraphs[i],
#'       tag = tags[i],
#'       genome = genome,
#'       sqlite_db = sqlite_db,
#'       outdir = outdir,
#'       chr2exclude = "chrM"
#'     )
#'   }
#'   chr_coverage <- assemble_allCov(sqlite_db,
#'     seqname = "chr6",
#'     outdir = outdir,
#'     genome = genome
#'   )
#' }
assemble_allCov <- function(sqlite_db,
                            seqname,
                            outdir = getInPASOutputDirectory(),
                            genome = getInPASGenome()) {
  if (!is(genome, "BSgenome")) {
    stop("genome must be an object of BSgenome.")
  }
  if (missing(sqlite_db) || !file.exists(sqlite_db) ||
    length(sqlite_db) != 1) {
    stop("The sqlite_db length is not 1 or it doesn't exist!")
  }
  lock_filename <- getLockName()
  if (!file.exists(lock_filename)) {
    stop(
      "lock_filename must be an existing file.",
      "Please call addLockName() first!"
    )
  }

  file_lock <- lock(lock_filename)
  db_conn <- dbConnect(
    drv = RSQLite::SQLite(),
    dbname = sqlite_db
  )
  res <- dbGetQuery(db_conn, "SELECT * FROM sample_coverage;")
  dbDisconnect(db_conn)
  unlock(file_lock)

  if (nrow(res) < 1) {
    stop("The sample_coverage table in the sqlite_db is empty")
  }
  if (!seqname %in% res$chr) {
    stop("seqname", seqname, "is not in the sample_coverage table")
  }
  if (!is.character(outdir) || length(outdir) != 1) {
    stop("A directory of write permission is required!")
  }
  outdir <- file.path(outdir, "003.chromosomewise.RleCov")
  if (!dir.exists(outdir)) {
    dir.create(outdir, recursive = TRUE)
  }
  outdir <- normalizePath(outdir, mustWork = TRUE)

  seqLen <- get_seqLen(genome)

  chr_cov <- list()
  for (tag in unique(res$tag)) {
    file_name <- res$coverage_file[res$tag == tag &
      res$chr == seqname]
    if (length(file_name) == 1) {
      chr_cov[[seqname]][[tag]] <- readRDS(file_name)
    } else {
      chr_cov[[seqname]][[tag]] <-
        Rle(values = 0, lengths = seqLen[seqname])
    }
  }
  filename_chr <- file.path(
    outdir,
    paste(seqname,
      "RleCov.RDS",
      sep = "_"
    )
  )
  ## chr_cov: chr_cov[[seqname]][[tag]]
  saveRDS(chr_cov, file = filename_chr)

  tryCatch(
    {
      file_lock <- lock(lock_filename)
      db_conn <- dbConnect(
        drv = RSQLite::SQLite(),
        dbname = sqlite_db
      )
      res <- dbSendStatement(
        db_conn,
        paste0("DELETE FROM chromosome_coverage
                                      WHERE chr = '", seqname, "';")
      )
      dbClearResult(res)
      res <- dbSendStatement(
        db_conn,
        paste0("INSERT INTO
                        chromosome_coverage (chr, coverage_file)
                        VALUES ('", seqname, "',", "'", filename_chr, "');")
      )
      dbClearResult(res)
    },
    error = function(e) {
      print(paste(conditionMessage(e)))
    },
    finally = {
      dbDisconnect(db_conn)
      unlock(file_lock)
    }
  )
  chr_cov
}

#' Prepare data for predicting cleavage and polyadenylation (CP) sites using
#'   parallel computing
#'
#' @param sqlite_db A path to the SQLite database for InPAS, i.e. the output of
#'   [setup_sqlitedb()].
#' @param genome An object of [BSgenome::BSgenome-class]
#' @param utr3 An object of [GenomicRanges::GRangesList-class], the output of
#'   [extract_UTR3Anno()]
#' @param seqnames A character(1), the names of all chromosomes/scaffolds with
#'   both coverage and 3' UTR annotation. Users can get this by calling the
#'   get_chromosomes().
#' @param background A character(1) vector, the range for calculating cutoff
#'   threshold of local background. It can be "same_as_long_coverage_threshold",
#'   "1K", "5K","10K", or "50K".
#' @param TxDb an object of [GenomicFeatures::TxDb-class]
#' @param hugeData A logical(1) vector, indicating whether it is huge data
#' @param outdir A character(1) vector, a path with write permission for storing
#'   InPAS analysis results. If it doesn't exist, it will be created.
#' @param silence report progress or not. By default it doesn't report progress.
#' @param minZ A numeric(1), a Z score cutoff value
#' @param cutStart An integer(1) vector a numeric(1) vector. What percentage or
#'   how many nucleotides should be removed from 5' extremities before searching
#'   for CP sites? It can be a decimal between 0, and 1, or an integer greater
#'   than 1. 0.1 means 10 percent, 25 means cut first 25 bases
#' @param MINSIZE A integer(1) vector, specifying the minimal length in bp of a
#'   short/proximal 3' UTR. Default, 10
#' @param coverage_threshold An integer(1) vector, specifying the cutoff
#'   threshold of coverage for first 100 nucleotides. If the coverage of first
#'   100 nucleotides is lower than coverage_threshold, that transcript will be
#'   not considered for further analysis. Default, 5.
#' @param future.chunk.size The average number of elements per future
#'   ("chunk"). If Inf, then all elements are processed in a single future.
#'   If NULL, then argument future.scheduling = 1 is used by default. Users can
#'   set future.chunk.size = total number of elements/number of cores set for
#'   the backend. See the future.apply package for details.
#' @param chr2exclude A character vector, NA or NULL, specifying chromosomes or
#'   scaffolds to be excluded for InPAS analysis. `chrM` and alternative scaffolds
#'   representing different haplotypes should be excluded.
#'
#' @return A list of list as described below:
#'   \describe{\item{background}{The type of methods for background
#'                    coverage calculation}
#'             \item{z2s}{Z-score cutoff thresholds for each 3' UTRs}
#'             \item{depth.weight}{A named vector containing depth weight}
#'             \item{chr.cov.merge}{A list of matrice storing condition/sample-
#'             specific coverage for 3' UTR and next.exon.gap (if exist)}
#'             \item{conn_next_utr3}{A logical vector, indicating whether a 3'UTR
#'             has a convergent 3' UTR of its downstream transcript}
#'             \item{chr.utr3}{A GRangesList, storing extracted 3' UTR annotation
#'             of transcript on a given chr}
#'             }
#'
#' @import S4Vectors Biobase GenomicRanges GenomicFeatures methods
#' @importFrom plyranges as_granges complement_ranges disjoin_ranges
#'   reduce_ranges reduce_ranges_directed remove_names
#'   set_genome_info shift_downstream
#' @importFrom Seqinfo seqlengths seqlevels
#' @importFrom GenomeInfoDb seqlevelsStyle mapSeqlevels
#' @export
#' @author Jianhong Ou, Haibo Liu

setup_parCPsSearch <- function(sqlite_db,
                               genome = getInPASGenome(),
                               utr3,
                               seqnames,
                               background = c(
                                 "same_as_long_coverage_threshold",
                                 "1K", "5K", "10K", "50K"
                               ),
                               TxDb = getInPASTxDb(),
                               future.chunk.size = 1,
                               chr2exclude = getChr2Exclude(),
                               hugeData = TRUE,
                               outdir = getInPASOutputDirectory(),
                               silence = FALSE,
                               minZ = 2,
                               cutStart = 10,
                               MINSIZE = 10,
                               coverage_threshold = 5) {
  if (!is.null(chr2exclude) && !is.character(chr2exclude)) {
    stop("chr2Exclude must be NULL or a character vector")
  }
  if (!is.character(outdir) || length(outdir) != 1) {
    stop("An explicit output directory is required")
  }
  if (missing(utr3)) {
    stop("chr.utr3 are required.")
  }
  if (!is(utr3, "GRangesList")) {
    stop(
      "utr3 must be a GRangesList object, outputted by the function of ",
      "extract_UTR3Anno()"
    )
  }
  if (!is(TxDb, "TxDb")) {
    stop("TxDb must be a TxDb object")
  }
  if (!is(genome, "BSgenome")) {
    stop("genome must be an object of BSgenome.")
  }

  if (seqlevelsStyle(names(utr3)) != seqlevelsStyle(genome)) {
    stop("The seqlevelsStyle of utr3 must be same as genome")
  }
  if (missing(sqlite_db) || length(sqlite_db) != 1 ||
    !file.exists(sqlite_db)) {
    stop("sqlite_db, a path to the SQLite database is required!")
  }
  lock_filename <- getLockName()
  if (!file.exists(lock_filename)) {
    stop(
      "lock_filename must be an existing file.",
      "Please call addLockName() first!"
    )
  }
  if (missing(seqnames) || !is.character(seqnames)) {
    stop("seqnames of length > 1 is required")
  }
  seqnames <- seqnames[!seqnames %in% chr2exclude]
  if (length(seqnames) == 0) {
    stop("After excluding unwanted chromosomes, no chromosome left")
  }
  background <- match.arg(
    arg = background,
    choices = c(
      "same_as_long_coverage_threshold",
      "1K", "5K", "10K", "50K"
    )
  )

  null <- future_lapply(seqnames, function(.x) {
    setup_CPsSearch(
      sqlite_db = sqlite_db,
      genome = genome,
      chr.utr3 = utr3[[.x]],
      seqname = .x,
      background = background,
      TxDb = TxDb,
      hugeData = hugeData,
      outdir = outdir,
      silence = silence,
      minZ = minZ,
      cutStart = cutStart,
      MINSIZE = MINSIZE,
      coverage_threshold = coverage_threshold
    )
  }, future.chunk.size = future.chunk.size)
}

#' prepare data for predicting cleavage and polyadenylation (CP) sites
#'
#' @param sqlite_db A path to the SQLite database for InPAS, i.e. the output of
#'   [setup_sqlitedb()].
#' @param genome An object of [BSgenome::BSgenome-class]
#' @param chr.utr3 An object of [GenomicRanges::GRanges-class], an element of the
#'   output of [extract_UTR3Anno()]
#' @param seqname A character(1), the name of a chromosome/scaffold
#' @param background A character(1) vector, the range for calculating cutoff
#'   threshold of local background. It can be "same_as_long_coverage_threshold",
#'   "1K", "5K","10K", or "50K".
#' @param TxDb an object of [GenomicFeatures::TxDb-class]
#' @param hugeData A logical(1) vector, indicating whether it is huge data
#' @param outdir A character(1) vector, a path with write permission for storing
#'   InPAS analysis results. If it doesn't exist, it will be created.
#' @param silence report progress or not. By default it doesn't report progress.
#' @param minZ A numeric(1), a Z score cutoff value
#' @param cutStart An integer(1) vector a numeric(1) vector. What percentage or
#'   how many nucleotides should be removed from 5' extremities before searching
#'   for CP sites? It can be a decimal between 0, and 1, or an integer greater
#'   than 1. 0.1 means 10 percent, 25 means cut first 25 bases
#' @param MINSIZE A integer(1) vector, specifying the minimal length in bp of a
#'   short/proximal 3' UTR. Default, 10
#' @param coverage_threshold An integer(1) vector, specifying the cutoff
#'   threshold of coverage for first 100 nucleotides. If the coverage of first
#'   100 nucleotides is lower than coverage_threshold, that transcript will be
#'   not considered for further analysis. Default, 5.
#'
#' @return A file storing a list as described below:
#'   \describe{\item{background}{The type of methods for background
#'                    coverage calculation}
#'             \item{z2s}{Z-score cutoff thresholds for each 3' UTRs}
#'             \item{depth.weight}{A named vector containing depth weight}
#'             \item{chr.cov.merge}{A matrix storing condition/sample-specific
#'             coverage for 3' UTR and next.exon.gap (if exist)}
#'             \item{conn_next_utr3}{A logical vector, indicating whether a 3'UTR
#'             has a convergent 3' UTR of its downstream transcript}
#'             \item{chr.utr3}{A GRangesList, storing extracted 3' UTR annotation
#'             of transcript on a given chr}
#'             }
#'
#' @import S4Vectors Biobase GenomicRanges GenomicFeatures methods
#' @importFrom plyranges as_granges complement_ranges disjoin_ranges
#'   reduce_ranges reduce_ranges_directed remove_names
#'   set_genome_info shift_downstream
#' @importFrom Seqinfo seqlengths seqlevels
#' @importFrom GenomeInfoDb seqlevelsStyle mapSeqlevels
#' @export
#' @author Jianhong Ou, Haibo Liu
#'
#' @examples
#' if (interactive()) {
#'   library(BSgenome.Mmusculus.UCSC.mm10)
#'   library("TxDb.Mmusculus.UCSC.mm10.knownGene")
#'   genome <- BSgenome.Mmusculus.UCSC.mm10
#'   TxDb <- TxDb.Mmusculus.UCSC.mm10.knownGene
#'
#'   ## load UTR3 annotation and convert it into a GRangesList
#'   data(utr3.mm10)
#'   utr3 <- split(utr3.mm10, seqnames(utr3.mm10), drop = TRUE)
#'
#'   bedgraphs <- system.file("extdata", c(
#'     "Baf3.extract.bedgraph",
#'     "UM15.extract.bedgraph"
#'   ),
#'   package = "InPAS"
#'   )
#'   tags <- c("Baf3", "UM15")
#'   metadata <- data.frame(
#'     tag = tags,
#'     condition = c("Baf3", "UM15"),
#'     bedgraph_file = bedgraphs
#'   )
#'   outdir <- tempdir()
#'   write.table(metadata,
#'     file = file.path(outdir, "metadata.txt"),
#'     sep = "\t", quote = FALSE, row.names = FALSE
#'   )
#'
#'   sqlite_db <- setup_sqlitedb(
#'     metadata = file.path(
#'       outdir,
#'       "metadata.txt"
#'     ),
#'     outdir
#'   )
#'   addLockName(filename = tempfile())
#'   coverage <- list()
#'   for (i in seq_along(bedgraphs)) {
#'     coverage[[tags[i]]] <- get_ssRleCov(
#'       bedgraph = bedgraphs[i],
#'       tag = tags[i],
#'       genome = genome,
#'       sqlite_db = sqlite_db,
#'       outdir = outdir,
#'       chr2exclude = "chrM"
#'     )
#'   }
#'   data4CPsitesSearch <- setup_CPsSearch(sqlite_db,
#'     genome,
#'     chr.utr3 = utr3[["chr6"]],
#'     seqname = "chr6",
#'     background = "10K",
#'     TxDb = TxDb,
#'     hugeData = TRUE,
#'     outdir = outdir
#'   )
#' }
setup_CPsSearch <- function(sqlite_db,
                            genome = getInPASGenome(),
                            chr.utr3,
                            seqname,
                            background = c(
                              "same_as_long_coverage_threshold",
                              "1K", "5K", "10K", "50K"
                            ),
                            TxDb = getInPASTxDb(),
                            hugeData = TRUE,
                            outdir = getInPASOutputDirectory(),
                            silence = FALSE,
                            minZ = 2,
                            cutStart = 10,
                            MINSIZE = 10,
                            coverage_threshold = 5) {
  gcCompensation <- NA
  mappabilityCompensation <- NA
  FFT <- FALSE
  fft.sm.power <- 20

  if (!is.character(outdir) || length(outdir) != 1) {
    stop("An explicit output directory is required")
  } else {
    outdir_total <- file.path(outdir, "004.TotalCov.out")
    if (!dir.exists(outdir_total)) {
      dir.create(outdir_total,
        recursive = TRUE,
        showWarnings = FALSE
      )
    }
    outdir_total <- normalizePath(outdir_total)

    outdir_utr3 <- file.path(outdir, "005.UTR3TotalCov.out")
    if (!dir.exists(outdir_utr3)) {
      dir.create(outdir_utr3,
        recursive = TRUE,
        showWarnings = FALSE
      )
    }
    outdir_utr3 <- normalizePath(outdir_utr3)
  }

  if (missing(chr.utr3)) {
    stop("chr.utr3 are required.")
  }
  if (!is(chr.utr3, "GRanges") ||
    !all(chr.utr3$feature %in% c("utr3", "next.exon.gap", "CDS"))) {
    stop(
      "utr3 must be one element of the output of function of ",
      "extract_UTR3Anno()"
    )
  }
  if (!is(genome, "BSgenome")) {
    stop("genome must be an object of BSgenome.")
  }

  if (seqlevelsStyle(chr.utr3) != seqlevelsStyle(genome)) {
    stop("The seqlevelsStyle of utr3 must be same as genome")
  }
  if (missing(sqlite_db) || length(sqlite_db) != 1 ||
    !file.exists(sqlite_db)) {
    stop("sqlite_db, a path to the SQLite database is required!")
  }
  lock_filename <- getLockName()
  if (!file.exists(lock_filename)) {
    stop(
      "lock_filename must be an existing file.",
      "Please call addLockName() first!"
    )
  }

  background <- match.arg(
    arg = background,
    choices = c(
      "same_as_long_coverage_threshold",
      "1K", "5K", "10K", "50K"
    )
  )
  introns <- GRanges()
  if (background != "same_as_long_coverage_threshold") {
    if (missing(TxDb) || !is(TxDb, "TxDb")) {
      stop("TxDb is missing when you want local background")
    }
    if (!seqname %in% seqlevels(TxDb)) {
      stop("seqname", seqname, "is not included in TxDb")
    }
    seqlevels(TxDb) <- seqname
    introns <- unlist(intronsByTranscript(TxDb, use.names = TRUE)) %>%
      plyranges::disjoin_ranges() ## strand-unaware
    exons <- exons(TxDb) %>% plyranges::disjoin_ranges()

    intron_exons <- disjoin(c(exons, introns))
    ol.exons <- findOverlaps(exons, intron_exons)

    ## pure intronic regions
    introns <- intron_exons[-unique(subjectHits(ol.exons))]
  }

  chr.utr3 <- chr.utr3[chr.utr3$feature != "CDS"]
  if (length(chr.utr3) == 0) {
    return(NULL)
  }

  if (!silence) {
    message(
      "coverage per sample per chromosome start at ",
      date(), ".\n"
    )
  }
  ## assemble coverage data into chromosome-oriented list of Rle objects
  chr.cov <- assemble_allCov(
    sqlite_db = sqlite_db,
    seqname = seqname,
    outdir = outdir,
    genome = genome
  )
  if (!silence) {
    message(
      "coverage per sample per chromosome done at ",
      date(), ".\n"
    )
  }

  ## calculate coverage weight
  file_lock <- flock::lock(lock_filename)
  db_conn <- dbConnect(
    drv = RSQLite::SQLite(),
    dbname = sqlite_db
  )
  metadata <- dbReadTable(db_conn, "metadata")
  dbDisconnect(db_conn)
  flock::unlock(file_lock)

  depth.weight <- get_depthWeight(
    metadata = metadata,
    hugeData = hugeData
  )

  if (!silence) message("total coverage start at ", date(), ".\n")
  ## get collapsed coverage per condition per chromosome
  chr.totalCov <- get_totalCov(
    outdir = outdir_total,
    sqlite_db = sqlite_db,
    chr.cov = chr.cov,
    seqname = seqname,
    metadata = metadata,
    hugeData = hugeData
  )
  if (!silence) message("total coverage done at ", date(), ".\n")

  ## calculate background
  z2s <- get_zScoreCutoff(
    background = background,
    chr.introns = introns,
    chr.totalCov = chr.totalCov,
    chr.utr3 = chr.utr3,
    seqname = seqname,
    z = minZ
  )
  if (!silence) message("backgroud around 3utr done at ", date(), ".\n")

  ## get UTR3 total coverage
  chr.cov <- get_UTR3TotalCov(
    chr.utr3 = chr.utr3,
    chr.totalCov = chr.totalCov,
    gcCompensation = gcCompensation,
    mappabilityCompensation =
      mappabilityCompensation,
    FFT = FFT,
    fft.sm.power = fft.sm.power
  )
  if (!silence) message("utr3 TotalCov done at ", date(), ".\n")

  chr.cov <- chr.cov[sapply(chr.cov, mean) > 0]
  if (length(chr.cov) == 0) {
    return(NULL)
  }
  utr3.utr <- chr.utr3[chr.utr3$feature == "utr3"]
  utr3.gap <- chr.utr3[chr.utr3$feature == "next.exon.gap"]
  co <- countOverlaps(utr3.gap, utr3.utr,
    maxgap = 1,
    ignore.strand = TRUE
  )
  utr3.gap <- utr3.gap[co > 1]
  chr.utr3$conn_next_utr3 <-
    chr.utr3$transcript %in% utr3.gap$transcript

  ## remove utr3 Granges without coverage
  chr.utr3 <- chr.utr3[names(chr.utr3) %in% names(chr.cov)]
  if (length(chr.utr3) == 0) {
    return(NULL)
  }

  chr.utr3 <- split(chr.utr3, chr.utr3$transcript)
  conn_next_utr3 <- sapply(chr.utr3, function(.UTR) {
    .UTR$conn_next_utr3[1]
  })

  merge_chrCov <- function(.UTR) {
    .UTR <- .UTR[order(start(.UTR))]
    chr.utr3TotalCov <- chr.cov[names(.UTR)]
    chr.utr3TotalCov <-
      mapply(function(.covList, .start, .end, .property) {
        # set names for each position
        .posList <- .start:.end

        # if not a matrix
        if (length(dim(.covList)) == 0 && !is.null(.covList)) {
          .covList <- t(.covList)
        }
        rownames(.covList) <- paste(.property, .posList, sep = "_SEP_")
        .covList
      }, chr.utr3TotalCov, start(.UTR), end(.UTR),
      .UTR$feature,
      SIMPLIFY = FALSE
      )

    chr.utr3TotalCov <- do.call(rbind, chr.utr3TotalCov)
    ## reverse the negative strand
    if (as.character(strand(.UTR))[1] == "-") {
      chr.utr3TotalCov <-
        chr.utr3TotalCov[rev(rownames(chr.utr3TotalCov)), ,
          drop = FALSE
        ]
    }

    # if the range of "cutstart" is (0, 1), percentage;
    # otherwise, absolute bases
    if (!is.na(cutStart)) {
      if (cutStart < 1) {
        cutStart <- floor(length(chr.utr3TotalCov) * cutStart)
      }
      if (cutStart > 0) {
        chr.utr3TotalCov <- chr.utr3TotalCov[-(1:cutStart), ,
          drop = FALSE
        ]
      }
    }
    chr.utr3TotalCov
  }

  chr.cov.merge <- lapply(chr.utr3, merge_chrCov)
  if (!silence) message("chromsome ", seqname, " coverage merged.\n")

  ## filter UTR3 based on coverage of the first 100 bases
  coverage_quality <- sapply(chr.cov.merge, function(.ele) {
    if (nrow(.ele[grepl("utr3_SEP_", rownames(.ele)), ,
      drop = FALSE
    ]) > MINSIZE) {
      any(colMeans(.ele[1:min(nrow(.ele), 100), ,
        drop = FALSE
      ]) > coverage_threshold)
    } else {
      FALSE
    }
  })

  chr.cov.merge <- chr.cov.merge[coverage_quality]
  conn_next_utr3 <- conn_next_utr3[coverage_quality]
  chr.utr3 <- chr.utr3[coverage_quality]

  if (!silence) {
    message(
      "Preparation for CPsite search done at ",
      date(), ".\n"
    )
  }

  if (length(chr.cov.merge) > 0 && length(chr.utr3) > 0) {
    CPsSearch_data <- list(
      background = background,
      z2s = z2s,
      depth.weight = depth.weight,
      chr.cov.merge = chr.cov.merge,
      conn_next_utr3 = conn_next_utr3,
      chr.utr3 = chr.utr3
    )
    tmpfile <- file.path(
      outdir_utr3,
      paste(seqname, "data4CPsSearch.RDS",
        sep = "_"
      )
    )
    saveRDS(CPsSearch_data, file = tmpfile)

    tryCatch(
      {
        file_lock <- flock::lock(lock_filename)
        db_conn <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
        res <- dbSendStatement(
          db_conn,
          paste0("DELETE FROM utr3_total_coverage
                                      WHERE chr = '", seqname, "';")
        )
        dbClearResult(res)
        ## insert into database the per-chromosome utr3_total_coverage
        res <- dbSendStatement(
          db_conn,
          paste0("INSERT INTO
                           utr3_total_coverage (chr, coverage_file)
                           VALUES ('", seqname, "',", "'", tmpfile, "');")
        )
        dbClearResult(res)
      },
      error = function(e) {
        print(paste(conditionMessage(e)))
      },
      finally = {
        dbDisconnect(db_conn)
        flock::unlock(file_lock)
      }
    )
    return(tmpfile)
  } else {
    return(NULL)
  }
}

#' UTR3eSet-class and its methods
#'
#' An object of class [UTR3eSet-class] representing the results of 3' UTR usage;
#' methods for constructing, showing, getting and setting attributes of objects;
#' methods for coercing object of other class to [UTR3eSet-class] objects.
#'
#' @section Objects from the Class:
#' Objects can be created by calls of the form \code{new("UTR3eSet", ...)}
#'
#' @section Slots:
#' \describe{
#'    \item{\code{usage}}{Object of class \code{"GRanges"}}
#'    \item{\code{PDUI}}{Object of class \code{"matrix"}}
#'    \item{\code{PDUI.log2}}{Object of class \code{"matrix"}}
#'    \item{\code{short}}{Object of class \code{"matrix"}}
#'    \item{\code{long}}{Object of class \code{"matrix"}}
#'    \item{\code{signals}}{Object of class \code{"list"}}
#'    \item{\code{testRes}}{Object of class \code{"matrix"}}
#' }
#'
#' @section UTR3eSet-class methods:
#' \describe{
#'    \item{$}{\code{signature(x = "UTR3eSet")}: ... }
#'    \item{$<-}{\code{signature(x = "UTR3eSet")}: ... }
#'    \item{coerce}{\code{signature(from = "UTR3eSet", to = "ExpressionSet")}: ... }
#'    \item{coerce}{\code{signature(from = "UTR3eSet", to = "GRanges")}: ... }
#'    \item{show}{\code{signature(object = "UTR3eSet")}: ... }
#' }
#'
#' @name UTR3eSet-class
#' @aliases UTR3eSet-class $,UTR3eSet-method $<-,UTR3eSet-method
#' coerce,UTR3eSet,ExpressionSet-method coerce,UTR3eSet,GRanges-method
#' show,UTR3eSet-method
#' @docType class
#' @section Objects from the Class: Objects can be created by calls of the form
#' \code{new("UTR3eSet", ...)}.
#' @seealso \code{GRanges}
#' @export
#' @author Jianhong Ou

setClass(
  "UTR3eSet",
  representation(
    usage = "GRanges", PDUI = "matrix",
    PDUI.log2 = "matrix",
    short = "matrix",
    long = "matrix",
    signals = "list",
    testRes = "matrix"
  )
)

UTR3eSet <- function(...) {
  new("UTR3eSet", ...)
}

setMethod("$", "UTR3eSet", function(x, name) slot(x, name))

setReplaceMethod(
  "$", "UTR3eSet",
  function(x, name, value) {
    slot(x, name, check = TRUE) <- value
    x
  }
)

setAs(from = "UTR3eSet", to = "ExpressionSet", function(from) {
  ExpressionSet(
    assayData = from$PDUI.log2,
    featureData = AnnotatedDataFrame(as.data.frame(from$usage))
  )
})

setAs(from = "UTR3eSet", to = "GRanges", function(from) {
  n <- from$usage$transcript
  short <- from$short
  long <- from$long
  colnames(short) <- paste(colnames(short), "short.form.usage", sep = "_")
  colnames(long) <- paste(colnames(long), "long.form.usage", sep = "_")
  PDUI <- from$PDUI
  colnames(PDUI) <- paste(colnames(PDUI), "PDUI", sep = "_")

  r <- from$usage
  mcol_r <- as.data.frame(mcols(r))

  if (length(from$testRes) != 0) {
    test <- from$testRes
    mcols(r) <- cbind(
      mcol_r,
      short[match(n, rownames(short)), , drop = FALSE],
      long[match(n, rownames(long)), , drop = FALSE],
      PDUI[match(n, rownames(short)), , drop = FALSE],
      test[match(n, rownames(test)), , drop = FALSE]
    )
  } else {
    mcols(r) <- cbind(
      mcol_r,
      short[match(n, rownames(short)), , drop = FALSE],
      long[match(n, rownames(long)), , drop = FALSE],
      PDUI[match(n, rownames(short)), , drop = FALSE]
    )
  }
  r
})

setMethod("show", "UTR3eSet", function(object) {
  cat("This is an object of UTR3eSet\n", "slot usage:\n")
  show(object$usage)
  if (length(object$PDUI) > 0) {
    cat(
      "slot PDUI: matrix object with ", nrow(object$PDUI),
      " rows ", ncol(object$PDUI), "columns\n"
    )
    show(head(object$PDUI))
    cat("...\n")
    cat(
      "slot PDUI.log2: matrix object with ", nrow(object$PDUI.log2),
      " rows ", ncol(object$PDUI.log2), "columns\n"
    )
    show(head(object$PDUI.log2))
    cat("...\n")
    cat(
      "slot short: matrix object with ", nrow(object$short),
      " rows ", ncol(object$short), "columns\n"
    )
    show(head(object$short))
    cat("...\n")
    cat(
      "slot long: matrix object with ", nrow(object$long),
      " rows ", ncol(object$long), "columns\n"
    )
    show(head(object$long))
    cat("...\n")
  }
  if (length(object$signals) > 0) {
    cat("slot signals: length ", length(object$signals), "\n")
  }
  if (length(object$testRes) > 0) {
    cat(
      "slot testRes: matrix object with ", nrow(object$testRes),
      " rows ", ncol(object$testRes), "columns\n"
    )
    show(head(object$testRes))
    cat("...\n")
  }
})

#' prepare files for GSEA analysis
#'
#' output the log2 transformed delta PDUI txt file, chip file, rank file and
#'  phynotype label file for GSEA analysis
#'
#' @param eset A [UTR3eSet-class] object, output of [test_dPDUI()]
#' @param groupList A list of grouped sample tag names, with the group names as
#'   the list's name, such as list(groupA = c("sample_1", "sample_2",
#'   "sample_3"), groupB = c("sample_4", "sample_5", "sample_6"))
#' @param preranked A logical(1) vector, out preranked or not
#' @param rankBy A character(1) vector, indicating how the gene list is ranked.
#'   It can be "logFC" or "P.value".
#' @param outdir A character(1) vector, a path with write permission for storing
#'   InPAS analysis results. If it doesn't exist, it will be created.
#' @param rnkFilename A character(1) vector, specifying a filename for the
#'   preranked file
#' @param chipFilename A character(1) vector, specifying a filename for the
#'   chip file
#' @param dataFilename A character(1) vector, specifying a filename for the
#'   dataset file
#' @param PhenFilename A character(1) vector, specifying a filename for the
#'   file containing samples' phenotype labels
#'
#' @seealso  data formats for GSEA.
#' \url{https://software.broadinstitute.org/cancer/software/gsea/wiki/index.php/Data_formats}
#'
#' @import Biobase
#' @importFrom utils write.table
#' @export
#' @author Jianhong Ou, Haibo Liu
#' @examples
#' library(limma)
#' path <- system.file("extdata", package = "InPAS")
#' load(file.path(path, "eset.MAQC.rda"))
#' tags <- colnames(eset@PDUI)
#' g <- factor(gsub("\\..*$", "", tags))
#' design <- model.matrix(~ -1 + g)
#' colnames(design) <- c("Brain", "UHR")
#' contrast.matrix <- makeContrasts(
#'   contrasts = "Brain-UHR",
#'   levels = design
#' )
#' res <- test_dPDUI(
#'   eset = eset,
#'   method = "limma",
#'   normalize = "none",
#'   design = design,
#'   contrast.matrix = contrast.matrix
#' )
#' gp1 <- c("Brain.auto", "Brain.phiX")
#' gp2 <- c("UHR.auto", "UHR.phiX")
#' groupList <- list(Brain = gp1, UHR = gp2)
#' setup_GSEA(res,
#'   groupList = groupList,
#'   outdir = tempdir(),
#'   preranked = TRUE,
#'   rankBy = "P.value"
#' )
setup_GSEA <- function(eset,
                       groupList,
                       outdir = getInPASOutputDirectory(),
                       preranked = TRUE,
                       rankBy = c("logFC", "P.value"),
                       rnkFilename = "InPAS.rnk",
                       chipFilename = "InPAS.chip",
                       dataFilename = "dPDUI.txt",
                       PhenFilename = "group.cls") {
  if (missing(eset) || !is(eset, "UTR3eSet")) {
    stop("eset must be an object of UTR3eSet class")
  }
  if (missing(outdir) || length(outdir) != 1) {
    stop("An explicit output directory is required")
  } else {
    outdir <- file.path(outdir, "011.GSEA.files")
    if (!dir.exists(outdir)) {
      dir.create(outdir,
        recursive = TRUE,
        showWarnings = FALSE
      )
    }
    outdir <- normalizePath(outdir, mustWork = TRUE)
  }
  if (!is.logical(preranked) || length(preranked) != 1) {
    stop("preranked must be a logical(1) vector")
  }

  if (preranked) {
    if (length(eset$testRes) < 1) {
      stop("There is no p.value for ranking. Please try test_dPDUI first")
    }
    rankBy <- match.arg(arg = rankBy, choices = c("logFC", "P.value"))
    testRes <- eset$testRes
    usage <- eset$usage
    if (!identical(usage$transcript, rownames(testRes))) {
      stop("The rownames of eset slots are not identical")
    }
    if (rankBy == "P.value") {
      # rank by p-values, why not by log2FC?
      rank <- data.frame(
        symbol = usage$symbol,
        p.value = 1 - testRes[, "P.Value"]
      )
    } else if (rankBy == "logFC") {
      rank <- data.frame(
        symbol = usage$symbol,
        logFC = testRes[, "logFC"]
      )
    }
    write.table(rank, file.path(outdir, rnkFilename),
      sep = "\t", quote = FALSE, row.names = F, col.names = F
    )
  } else {
    eset <- as(eset, "ExpressionSet")
    exprs <- exprs(eset)
    samples <- colnames(exprs)
    fD <- fData(eset)
    chip <- fD[, c("transcript", "symbol", "gene")]
    colnames(chip) <- c("Probe Set ID", "Gene Symbol", "Gene Title")
    dir.create(outdir, showWarnings = FALSE)
    write.table(chip, file.path(outdir, chipFilename),
      sep = "\t", quote = FALSE, row.names = F
    )
    exprs <- cbind(NAME = rownames(exprs), exprs)
    write.table(exprs, file.path(outdir, dataFilename),
      sep = "\t", quote = FALSE, row.names = F
    )
    if ((!missing(groupList)) && is.list(groupList)) {
      gp <- rep(names(groupList), sapply(groupList, length))
      names(gp) <- unlist(groupList)
      if (all(samples %in% names(gp))) {
        gp <- gp[samples]
        levels <- unique(gp)
        out <- c(
          paste(length(gp), length(levels), 1),
          paste("#", paste(levels, collapse = " ")),
          paste(gp, collapse = " ")
        )
        writeLines(out, con = file.path(outdir, PhenFilename))
      }
    }
  }
}

#' Run Fisher Exact Test for differential usage of 3' UTRs for a two-group experimental design
#'
#' @param UTR3eset An object of [UTR3eSet-class], output of [get_UTR3eSet()]
#' @param gp1 tag names of group 1
#' @param gp2 tag names of group 2
#'
#' @return a matrix of test results
#'
#' @seealso [run_singleSampleAnalysis()] for a single-sample APA
#'   analysis,[run_singleGroupAnalysis()] for a single-group sample APA analysis,
#'   [run_limmaAnalysis()] for limma-based APA analysis of complex experimental
#'   design
#' @keywords internal
#' @author Jianhong Ou

run_fisherExactTest <- function(UTR3eset,
                                gp1,
                                gp2) {
  short <- UTR3eset$short
  long <- UTR3eset$long

  if (!all(c(gp1, gp2) %in% colnames(UTR3eset$short))) {
    stop("gp1 and gp2 must be the same as the sample name tags")
  }
  short.gp1 <- short[, gp1, drop = FALSE]
  short.gp2 <- short[, gp2, drop = FALSE]
  long.gp1 <- long[, gp1, drop = FALSE]
  long.gp2 <- long[, gp2, drop = FALSE]
  short.mean.gp1 <- rowMeans(short.gp1)
  short.mean.gp2 <- rowMeans(short.gp2)
  long.mean.gp1 <- rowMeans(long.gp1)
  long.mean.gp2 <- rowMeans(long.gp2)
  mat <- cbind(
    short.mean.gp1,
    short.mean.gp2,
    long.mean.gp1,
    long.mean.gp2
  )
  mat[is.na(mat)] <- 0
  P.Value <- apply(mat, 1, function(.d) {
    fisher.test(matrix(floor(.d), ncol = 2))$p.value
  })
  adj.P.Val <- p.adjust(P.Value, method = "BH")
  PDUI.gp1 <- long.mean.gp1 / (long.mean.gp1 + short.mean.gp1)
  PDUI.gp2 <- long.mean.gp2 / (long.mean.gp2 + short.mean.gp2)
  dPDUI <- PDUI.gp1 - PDUI.gp2
  logFC <- log2(PDUI.gp1 + .Machine$double.xmin) -
    log2(PDUI.gp2 + .Machine$double.xmin)
  cbind(
    short.mean.gp1, long.mean.gp1,
    short.mean.gp2, long.mean.gp2,
    PDUI.gp1, PDUI.gp2, dPDUI, logFC,
    P.Value, adj.P.Val
  )
}

#' Quality control on read coverage over gene bodies and 3UTRs
#'
#' Calculate coverage over gene bodies and 3UTRs. This function is used for
#' quality control of the coverage.The coverage rate can show the complexity of
#' RNA-seq library.
#'
#' @param sqlite_db A path to the SQLite database for InPAS, i.e. the output of
#'   [setup_sqlitedb()].
#' @param TxDb An object of [GenomicFeatures::TxDb-class]
#' @param edb An object of [ensembldb::EnsDb-class]
#' @param genome An object of [BSgenome::BSgenome-class]
#' @param chr2exclude A character vector, NA or NULL, specifying chromosomes or
#'   scaffolds to be excluded for InPAS analysis. `chrM` and alternative scaffolds
#'   representing different haplotypes should be excluded.
#' @param cutoff_readsNum cutoff reads number. If the coverage in the location
#'   is greater than cutoff_readsNum,the location will be treated as covered by
#'   signal
#' @param cutoff_expdGene_cvgRate cutoff_expdGene_cvgRate and
#'   cutoff_expdGene_sampleRate are  the  parameters used to calculate which
#'   gene is expressed in all input dataset. cutoff_expdGene_cvgRateset the
#'   cutoff value for the coverage rate of each gene;
#'   cutoff_expdGene_sampleRateset the cutoff value for ratio of numbers of
#'   expressed and all samples for each gene. for example, by default,
#'   cutoff_expdGene_cvgRate=0.1 and cutoff_expdGene_sampleRate=0.5,suppose
#'   there are 4 samples, for one gene, if the coverage rates by base are:0.05,
#'   0.12, 0.2, 0.17, this gene will be count as expressed gene because
#'   mean(c(0.05,0.12, 0.2, 0.17) > cutoff_expdGene_cvgRate) >
#'   cutoff_expdGene_sampleRate if the coverage rates by base are: 0.05, 0.12,
#'   0.07, 0.17, this gene will be count as un-expressed gene because
#'   mean(c(0.05, 0.12, 0.07, 0.17) > cutoff_expdGene_cvgRate)<=
#'   cutoff_expdGene_sampleRate
#' @param cutoff_expdGene_sampleRate See cutoff_expdGene_cvgRate
#' @param which an object of [GenomicRanges::GRanges-class] or NULL. If it is
#'   not NULL, only the exons overlapping the given ranges are used. For fast
#'   data quality control, set which to Granges for one or a few large
#'   chromosomes.
#' @param future.chunk.size The average number of elements per future
#'   ("chunk"). If Inf, then all elements are processed in a single future.
#'   If NULL, then argument future.scheduling = 1 is used by default. Users can
#'   set future.chunk.size = total number of elements/number of cores set for
#'   the backend. See the future.apply package for details.
#' @param ... Not used yet
#'
#' @return A data frame as described below.
#' \describe{
#'   \item{gene.coverage.rate}{overage per base for
#'   all genes}
#'   \item{expressed.gene.coverage.rate}{coverage per base for expressed
#'   genes}
#'   \item{UTR3.coverage.rate}{coverage per base for all 3'
#'   UTRs}
#'   \item{UTR3.expressed.gene.subset.coverage.rate}{coverage per base for 3'
#'   UTRs of expressed genes}
#'   \item{rownames}{the names of coverage}
#' }
#' @import GenomicRanges
#' @importFrom future.apply future_mapply
#'
#' @export
#' @author Jianhong Ou, Haibo Liu
#' @examples
#' if (interactive()) {
#'   library("BSgenome.Mmusculus.UCSC.mm10")
#'   library("TxDb.Mmusculus.UCSC.mm10.knownGene")
#'   library("EnsDb.Mmusculus.v79")
#'
#'   genome <- BSgenome.Mmusculus.UCSC.mm10
#'   TxDb <- TxDb.Mmusculus.UCSC.mm10.knownGene
#'   edb <- EnsDb.Mmusculus.v79
#'
#'   bedgraphs <- system.file("extdata", c(
#'     "Baf3.extract.bedgraph",
#'     "UM15.extract.bedgraph"
#'   ),
#'   package = "InPAS"
#'   )
#'   tags <- c("Baf3", "UM15")
#'   metadata <- data.frame(
#'     tag = tags,
#'     condition = c("Baf3", "UM15"),
#'     bedgraph_file = bedgraphs
#'   )
#'   outdir <- tempdir()
#'   write.table(metadata,
#'     file = file.path(outdir, "metadata.txt"),
#'     sep = "\t", quote = FALSE, row.names = FALSE
#'   )
#'
#'   sqlite_db <- setup_sqlitedb(
#'     metadata = file.path(
#'       outdir,
#'       "metadata.txt"
#'     ),
#'     outdir
#'   )
#'   tx <- parse_TxDb(
#'     sqlite_db = sqlite_db,
#'     TxDb = TxDb,
#'     edb = edb,
#'     genome = genome,
#'     outdir = outdir,
#'     chr2exclude = "chrM"
#'   )
#'   addLockName(filename = tempfile())
#'   coverage <- list()
#'   for (i in seq_along(bedgraphs)) {
#'     coverage[[tags[i]]] <- get_ssRleCov(
#'       bedgraph = bedgraphs[i],
#'       tag = tags[i],
#'       genome = genome,
#'       sqlite_db = sqlite_db,
#'       outdir = outdir,
#'       chr2exclude = "chrM"
#'     )
#'   }
#'   chr_coverage <- assemble_allCov(sqlite_db,
#'     seqname = "chr6",
#'     outdir,
#'     genome
#'   )
#'   run_coverageQC(sqlite_db, TxDb, edb, genome,
#'     chr2exclude = "chrM",
#'     which = GRanges("chr6",
#'       ranges = IRanges(98013000, 140678000)
#'     )
#'   )
#' }
run_coverageQC <- function(sqlite_db,
                           TxDb = getInPASTxDb(),
                           edb = getInPASEnsDb(),
                           genome = getInPASGenome(),
                           cutoff_readsNum = 1,
                           cutoff_expdGene_cvgRate = 0.1,
                           cutoff_expdGene_sampleRate = 0.5,
                           chr2exclude = getChr2Exclude(),
                           which = NULL,
                           future.chunk.size = 1,
                           ...) {
  stopifnot(is(TxDb, "TxDb"))
  stopifnot(is(edb, "EnsDb"))
  stopifnot(is(genome, "BSgenome"))
  if (!is.null(chr2exclude) && !is.character(chr2exclude)) {
    stop("chr2Exclude must be NULL or a character vector")
  }
  if (missing(sqlite_db) || length(sqlite_db) != 1 ||
    !file.exists(sqlite_db)) {
    stop("sqlite_db, a path to the SQLite database is required!")
  }

  seqnames <- trim_seqnames(genome, chr2exclude)
  seqLen <- get_seqLen(genome, chr2exclude)

  if (length(which) > 0) {
    stopifnot(is(which, "GRanges"))
    message("strand information will be ignored.")
    query_seqname <- unique(as.character(seqnames(which)))
    seqnames <- seqnames[seqnames %in% query_seqname]
    if (length(seqnames) < 1) {
      stop("The seqnames defined by 'which' is not valid")
    }
  }

  db_conn <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
  coverage_files <- dbGetQuery(
    db_conn,
    "SELECT * FROM sample_coverage;"
  )
  coverage_files <- coverage_files[coverage_files$chr %in% seqnames, ]
  anno_files <- dbGetQuery(
    db_conn,
    "SELECT * FROM genome_anno;"
  )
  dbDisconnect(db_conn)

  if (nrow(coverage_files) < 1) {
    stop("No coverage files in the SQLite database!")
  }

  coverage <- tags <- unique(coverage_files$tag)
  names(coverage) <- tags

  seqRle <- sapply(seqLen, function(.ele) {
    Rle(0, .ele)
  },
  simplify = FALSE
  )

  tx <- readRDS(anno_files[anno_files$type == "transcripts", 2])
  # tx <- parse_TxDb(sqlite_db, TxDb, edb,
  #                  chr2exclude = chr2exclude)
  exon <- tx
  mcols(exon) <- mcols(exon)[, c('exon', 'feature', 'gene')]
  UTR3 <- tx[tx$feature %in% c("lastutr3", "utr3")]
  UTR3$feature <- 'utr3'
  
  if (length(which) > 0) {
    ol <- GenomicRanges::findOverlaps(exon, which, ignore.strand = TRUE)
    tx <- exon[sort(unique(queryHits(ol)))]
    ol <- GenomicRanges::findOverlaps(UTR3, which, ignore.strand = TRUE)
    UTR3 <- UTR3[sort(unique(queryHits(ol)))]
  }

  ## reduce exon and UTR3 for each gene
  reduce_by_gene <- function(gr) {
    gr <- gr %>%
      group_by(seqnames, gene) %>%
      plyranges::reduce_ranges_directed()
    gr
  }

  exon <- reduce_by_gene(exon)
  UTR3 <- reduce_by_gene(UTR3)

  feature.cvg <- function(cov, feature, seqnames, seqRle) {
    ## read in sample coverage data
    sample_cov <- list()
    for (chr in seqnames) {
      f <- coverage_files$tag == cov & coverage_files$chr == chr
      if (sum(f) == 1) {
        sample_cov[[chr]] <-
          readRDS(coverage_files$coverage_file[f])
      } else { ## no coverage
        sample_cov[[chr]] <- seqRle[[chr]]
      }
    }
    cov <- sample_cov
    cov <- cov[seqnames]
    names(cov) <- seqnames
    cvg.base <- future_mapply(function(cov.seq, feature.seq) {
      vw <- Views(cov.seq,
        start = start(feature.seq),
        end = end(feature.seq)
      )
      viewApply(vw, function(.ele) {
        sum(unlist(.ele > cutoff_readsNum))
      })
    }, cov[seqnames], feature[seqnames],
    SIMPLIFY = FALSE,
    future.chunk.size = future.chunk.size
    )
    stopifnot(identical(
      sapply(cvg.base, length),
      sapply(feature, length)
    ))
    unlist(cvg.base, use.names = FALSE)
  }

  exon.s <- split(exon, as.character(seqnames(exon)))
  seqnames <- seqnames[seqnames %in% names(exon.s)]
  if (length(seqnames) < 1) {
    stop("No chromosome is selected.")
  }
  exon.s <- exon.s[seqnames]
  seqRle <- seqRle[seqnames]
  exon.unlist <-
    if (!is(exon.s, "GRangesList")) GRangesList(exon.s) else exon.s
  exon.unlist <- unlist(exon.s)
  exon.cvg <- lapply(coverage, feature.cvg,
    feature = exon.s,
    seqnames = seqnames, seqRle = seqRle
  )
  names(exon.cvg) <- names(coverage)

  ## coverage per sample in each column
  exon.cvg <- do.call(cbind, exon.cvg)
  exon.cvg.wid <- cbind(exon.cvg, gene.width = width(exon.unlist))

  ## summary of exonic coverage and width per genes
  gene.cvg <- rowsum(exon.cvg.wid, exon.unlist$gene, reorder = FALSE)
  gene.expd.rate <- gene.cvg[, -ncol(gene.cvg)] / gene.cvg[, ncol(gene.cvg)]
  gene.expd.rate <- gene.expd.rate > cutoff_expdGene_cvgRate

  gene.expd.overall <- rowSums(gene.expd.rate) >
    (cutoff_expdGene_sampleRate * ncol(gene.expd.rate))
  gene.expd.overall.rate <- mean(gene.expd.overall)

  ## overall averaged gene.cvg.rate per sample
  gene.cvg.rate <- colSums(gene.cvg[, -ncol(gene.cvg)]) /
    sum(gene.cvg[, ncol(gene.cvg)])
  if (gene.expd.overall.rate > 0) {
    gene.cvg.rate.subsetBy.expd.gene <-
      colSums(gene.cvg[gene.expd.overall, -ncol(gene.cvg)]) /
        sum(gene.cvg[gene.expd.overall, ncol(gene.cvg)])
  } else {
    gene.cvg.rate.subsetBy.expd.gene <- rep(0, length(coverage))
    names(gene.cvg.rate.subsetBy.expd.gene) <- names(coverage)
  }

  UTR3.s <- split(UTR3, as.character(seqnames(UTR3)))
  seqnames <- seqnames[seqnames %in% names(UTR3.s)]
  if (length(seqnames) < 1) {
    stop("No chromosome is selected.")
  }
  UTR3.s <- UTR3.s[seqnames]
  seqRle <- seqRle[seqnames]
  UTR3.unlist <- if (!is(UTR3.s, "GRangesList")) GRangesList(UTR3.s) else UTR3.s
  UTR3.unlist <- unlist(UTR3.s)

  UTR3.cvg <- lapply(coverage, feature.cvg,
    feature = UTR3.s,
    seqnames = seqnames, seqRle = seqRle
  )
  names(UTR3.cvg) <- names(coverage)
  UTR3.cvg <- do.call(cbind, UTR3.cvg)
  UTR3.cvg.rate <- colSums(UTR3.cvg) / sum(width(UTR3.unlist))
  idx <- UTR3.unlist$gene %in% names(gene.expd.overall[gene.expd.overall])
  if (sum(idx) > 0) {
    UTR3.cvg.rate.subsetBy.expd.gene <-
      colSums(UTR3.cvg[idx, , drop = FALSE]) / sum(width(UTR3.unlist[idx]))
  } else {
    UTR3.cvg.rate.subsetBy.expd.gene <- rep(0, length(coverage))
    names(UTR3.cvg.rate.subsetBy.expd.gene) <- names(coverage)
  }

  data.frame(
    gene.coverage.rate = gene.cvg.rate,
    expressed.gene.coverage.rate =
      gene.cvg.rate.subsetBy.expd.gene,
    UTR3.coverage.rate = UTR3.cvg.rate,
    UTR3.expressed.gene.subset.coverage.rate =
      UTR3.cvg.rate.subsetBy.expd.gene
  )
}

#' Visualize the dPDUI events using ggplot2
#'
#' Visualize the dPDUI events by plotting the MSE, and total coverage per group
#' along 3' UTR regions with dPDUI using [ggplot2::geom_line ()].
#'
#' @param usage_data An object of [GenomicRanges::GRanges-class], an output from
#'   [get_usage4plot()].
#' @param vline_color color for vertical line showing position of predicated
#'   proximal CP site. Default, purple.
#' @param vline_type line type for vertical line showing position of predicated
#'   proximal CP site. Default, dashed. See \href{https://cran.r-project.org/web/packages/ggplot2/vignettes/ggplot2-specs.html}{ggplot2 linetype}.
#'
#' @return A ggplot object for refined plotting
#' @importFrom ggplot2 ggplot geom_line geom_vline facet_grid ylab ggtitle theme
#'   element_text aes vars
#' @export
#' @author Haibo Liu
#' @seealso For example, see [get_usage4plot()].

plot_utr3Usage <- function(usage_data,
                           vline_color = "purple",
                           vline_type = "dashed") {
  p <- list()
  for (gr in names(usage_data)) {
    data <- usage_data[names(usage_data) == gr, ]$dat[[1]]
    p[[gr]] <- ggplot(data = data, aes(
      x = Position, y = value,
      colour = Coverage
    )) +
      geom_line() +
      geom_vline(
        xintercept =
          usage_data[names(usage_data) == gr, ]$offset,
        colour = vline_color, linetype = vline_type
      ) +
      facet_grid(rows = vars(Coverage), scales = "free_y") +
      ylab("") +
      ggtitle(gsub("\\.", ":", gr, perl = TRUE)) +
      theme(
        plot.title = element_text(hjust = 0.5),
        legend.position = "none"
      )
    print(p[[gr]])
  }
  invisible(p)
}

#' Extract the last unspliced region of each transcript
#'
#' Extract the last unspliced region of each transcript from a TxDb. These
#' regions could be the last 3'UTR exon for transcripts whose 3' UTRs are
#' composed of multiple exons or last CDS regions and 3'UTRs for transcripts
#' whose 3'UTRs and last CDS regions are on the same single exon.
#'
#' @param TxDb An object of [GenomicFeatures::TxDb-class]
#' @param genome An object of [BSgenome::BSgenome-class]
#' @param chr2exclude A character vector, NA or NULL, specifying chromosomes or
#'   scaffolds to be excluded for InPAS analysis. `chrM` and alternative scaffolds
#'   representing different haplotypes should be excluded.
#' @param outdir A character(1) vector, a path with write permission for storing
#'   InPAS analysis results. If it doesn't exist, it will be created.
#' @param MAX_EXONS_GAP An integer(1) vector, maximal gap sizes between the last
#'   known CP sites to a nearest downstream exon. Default is 10 kb for mammalian
#'   genomes. For other species, user need to adjust this parameter.
#' @import GenomicRanges
#' @importFrom IRanges IRanges
#' @importFrom plyranges as_granges complement_ranges disjoin_ranges
#' reduce_ranges reduce_ranges_directed remove_names
#' set_genome_info shift_downstream
#' @importFrom dplyr as_tibble mutate filter arrange bind_rows group_by
#'   left_join summarise n
#' @return A BED file with 6 columns: chr, chrStart, chrEnd, name, score, and
#'   strand.
#' @export

get_lastCDSUTR3 <- function(TxDb = getInPASTxDb(),
                            genome = getInPASGenome(),
                            chr2exclude = getChr2Exclude(),
                            outdir = getInPASOutputDirectory(),
                            MAX_EXONS_GAP = 10000) {
  if (!is(TxDb, "TxDb")) {
    stop("TxDb must be an object of TxDb!")
  }
  if (!is(genome, "BSgenome")) {
    stop("genome must be a BSgenome object!")
  }
  if (!is.null(chr2exclude) && !is.character(chr2exclude)) {
    stop("chr2Exclude must be NULL or a character vector!")
  }
  if (!is.character(outdir) || length(outdir) != 1) {
    stop(
      "A path with write permission for storing \n",
      "the parsed transcriptome is required!"
    )
  }
  if (!dir.exists(outdir)) {
    dir.create(outdir, recursive = TRUE)
  }
  outdir <- normalizePath(outdir)
  seqnames <- trim_seqnames(
    genome = genome,
    chr2exclude = chr2exclude
  )
  seqlevels <- seqlevels(TxDb)
  seqlevels <- seqlevels[!seqlevels %in% chr2exclude]
  if (!all(seqlevels %in% seqnames)) {
    stop(
      "chromosome names in TxDb and BSgenome are not consistent!",
      "\nPlease make sure they match."
    )
  }
  seqlevels(TxDb) <- seqlevels

  ## get all transcripts
  tx <- unlist(transcriptsBy(TxDb, by = "gene"))
  tx$gene <- names(tx)
  names(tx) <- NULL
  tx$tx_id <- as.character(tx$tx_id)
  tx <- data.frame(tx) %>%
    as_tibble()

  ## get all exons and label the last exons
  exons <- grl_to_tibble(
    exonsBy(TxDb, by = "tx", use.names = TRUE),
    name_col = 'tx_name',
    drop = c('exon_id', 'exon_name')
  ) %>%
    dplyr::arrange(seqnames, tx_name, -exon_rank)

  num_exons <- exons %>%
    dplyr::group_by(tx_name) %>%
    summarise(num_exon = n()) %>%
    as.data.frame()
  rownames(num_exons) <- num_exons[, 1]
  num_exons <- num_exons[, -1, drop = FALSE]
  num_exons <- num_exons[unique(exons$tx_name), , drop = F]

  exons$feature <-
    do.call("c", lapply(num_exons[, 1], function(.x) {
      c("lastutr3", rep("other", time = .x - 1))
    }))
  exons <-
    exons %>%
    dplyr::left_join(dplyr::select(tx, tx_id, tx_name, gene),
      by = "tx_name"
    ) %>%
    dplyr::filter(!is.na(gene)) %>%
    dplyr::mutate(exon = paste(seqnames,
      feature,
      paste(tx_name, exon_rank, sep = "_"),
      sep = ":"
    )) %>%
    dplyr::rename(transcript = tx_name) %>%
    plyranges::as_granges()

  ## reduce by strand
  last_exons <- exons[exons$feature == "lastutr3"] %>%
    plyranges::reduce_ranges_directed()
  names(last_exons) <-
    paste0("last_exon", seq.int(length(last_exons)))

  last_exons_bed <-
    data.frame(
      chr = as.character(seqnames(last_exons)),
      start = start(last_exons) - 1,
      end = end(last_exons),
      name = paste0("utr", seq.int(length(last_exons))),
      score = 0,
      strand = strand(last_exons)
    )
  write.table(
    last_exons_bed,
    file = "last.exons.bed",
    sep = "\t",
    quote = FALSE,
    row.names = FALSE,
    col.names = FALSE
  )

  ## get next exon gap
  if (is(genome, "BSgenome")) {
    genome.info <- as.data.frame(seqinfo(genome))[, 1:2]
  } else {
    genome.info <- as.data.frame(seqinfo(TxDb))[, 1:2]
  }
  genome.info <-
    genome.info[!rownames(genome.info) %in% chr2exclude, ]

  gaps <- exons %>%
    plyranges::reduce_ranges() %>%
    plyranges::set_genome_info(
      seqnames = rownames(genome.info),
      seqlengths = genome.info$seqlengths,
      is_circular = genome.info$isCircular
    ) %>%
    plyranges::complement_ranges()
  last_exons.ext1 <- last_exons %>%
    plyranges::shift_downstream(shift = 1L)

  ol <- findOverlaps(last_exons.ext1, gaps,
    ignore.strand = TRUE
  )
  ol.utr3.clean <- last_exons[queryHits(ol)]

  next.exons.gap <- gaps[subjectHits(ol)]
  strand(next.exons.gap) <- strand(ol.utr3.clean)
  mcols(next.exons.gap) <- mcols(ol.utr3.clean)
  names(next.exons.gap) <- names(ol.utr3.clean)

  wid <- width(next.exons.gap) > MAX_EXONS_GAP
  width(next.exons.gap)[wid &
    as.character(strand(next.exons.gap)) == "+"] <-
    MAX_EXONS_GAP
  start(next.exons.gap)[wid &
    as.character(strand(next.exons.gap)) == "-"] <-
    end(next.exons.gap)[wid &
      as.character(strand(next.exons.gap)) == "-"] - MAX_EXONS_GAP + 1
  next.exons.gap$feature <- rep('next.exon.gap', length(next.exons.gap))
  next.exons.gap.width <- width(next.exons.gap)
  names(next.exons.gap.width) <- names(next.exons.gap)
  next.exons.gap.width <-
    next.exons.gap.width[names(last_exons)]
  next.exons.gap.width <-
    ifelse(is.na(next.exons.gap.width), 0,
      next.exons.gap.width
    )

  # adjust end for Granges on + strand
  end(last_exons[as.character(strand(next.exons.gap)) == "+"]) <-
    end(last_exons[as.character(strand(next.exons.gap)) == "+"]) +
    next.exons.gap.width[as.character(strand(next.exons.gap)) == "+"] - 1
  # adjust start for Granges on - strand
  start(last_exons[as.character(strand(next.exons.gap)) == "-"]) <-
    start(last_exons[as.character(strand(next.exons.gap)) == "-"]) -
    next.exons.gap.width[as.character(strand(next.exons.gap)) == "-"] + 1
  # reduce
  last_exons <- last_exons %>% plyranges::reduce_ranges()
  last_exons_extended_bed <-
    data.frame(
      chr = as.character(seqnames(last_exons)),
      start = start(last_exons) -
        1,
      end = end(last_exons),
      name = paste0("utr", seq.int(length(last_exons))),
      score = 0,
      strand = "*"
    )
  write.table(
    last_exons_extended_bed,
    file = "last.exons.extended.reduced.bed",
    sep = "\t",
    quote = FALSE,
    row.names = FALSE,
    col.names = FALSE
  )
  tx_file <-
    file.path(outdir, "00.lastCDS_UTR3.labeled.TxDb.RDS")
  saveRDS(last_exons_extended_bed, file = tx_file)
  last_exons_extended_bed
}

#' calculate the CP score
#'
#' calculate CP score by cleanUpdTSeq
#'
#' @param seqname a character(1) vector, the chromosome/scaffold's name
#' @param pos genomic positions
#' @param str DNA strand
#' @param idx offset position
#' @param idx.gp group number of the offset position
#' @param genome an object of [BSgenome::BSgenome-class]
#' @param classifier An R object for Naive Bayes classifier model, like the one
#'   in the cleanUpdTSeq package.
#' @param classifier_cutoff A numeric(1) vector. A cutoff of probability that a
#'   site is classified as true CP sites. The value should be between 0.5 and 1.
#'   Default, 0.8.
#' @return a data frame or NULL
#' @seealso [get_PAscore()]
#' @importFrom cleanUpdTSeq buildFeatureVector predictTestSet
#' @importFrom future plan multicore multisession
#' @importFrom future.apply future_lapply
#' @import GenomicRanges
#' @keywords internal
#' @author Jianhong Ou, Haibo Liu

get_PAscore2 <- function(seqname,
                         pos,
                         str,
                         idx,
                         idx.gp,
                         genome,
                         classifier,
                         classifier_cutoff) {
  if (length(pos) < 1) {
    return(NULL)
  }
  coor <- paste(seqname, pos, str, sep = "_")
  gr <- GRanges(seqname,
    IRanges(pos, pos, names = coor),
    strand = str
  )

  gr$id <- 1:length(gr)
  coor.id <- !duplicated(coor)
  gr$duplicated <- gr$id[coor.id][match(coor, coor[coor.id])]
  gr.s <- gr[coor.id]

  nbc_scoring <- function(.gr.s) {
    testSet.NaiveBayes <- buildFeatureVector(
      .gr.s,
      genome = genome,
      upstream = classifier@info@upstream,
      downstream = classifier@info@downstream,
      wordSize = classifier@info@wordSize,
      alphabet = classifier@info@alphabet,
      sampleType = "unknown",
      replaceNAdistance = 30,
      method = "NaiveBayes",
      fetchSeq = TRUE,
      return_sequences = FALSE
    )

    ## seqname is not needed
    suppressMessages({
      .pred.prob.test <-
        predictTestSet(
          testSet.NaiveBayes = testSet.NaiveBayes,
          classifier = classifier,
          outputFile = NULL,
          assignmentCutoff = classifier_cutoff,
          return_sequences = FALSE
        )
    })
    .pred.prob.test[, -2]
  }
  gr_lists <- split(gr.s, ceiling(seq_along(gr.s) / 100))
  cores <- parallelly::availableCores() -1
  scores <- future_lapply(gr_lists, nbc_scoring, 
        future.scheduling = floor(length(gr_lists)/cores))
  pred.prob.test <- do.call(rbind, scores)
  pred.prob.test <- pred.prob.test[match(
    names(gr.s),
    pred.prob.test$peak_name
  ), ,
  drop = FALSE
  ]
  if (any(duplicated(coor))) {
    ## need to recover the order of inputs
    pred.prob.test <- pred.prob.test[match(gr$duplicated, gr.s$id), ,
      drop = FALSE
    ]
    pred.prob.test[, "peak_name"] <- names(gr)
  }
  pred.prob.test <- cbind(pred.prob.test, idx, idx.gp)
  pred.prob.test <- pred.prob.test[!is.na(pred.prob.test[, "pred_class"]), ]
  pred.prob.test <- pred.prob.test[pred.prob.test[, "pred_class"] == 1, ]
  if (nrow(pred.prob.test) > 0) {
    pred.prob.test <- pred.prob.test[order(
      pred.prob.test[, "idx.gp"],
      -pred.prob.test[, "prob_true_pA"]
    ), ]
    pred.prob.test <- pred.prob.test[!duplicated(pred.prob.test[, "idx.gp"]), ]
    pred.prob.test
  } else {
    # message("no CP sites!")
    NULL
  }
}

########################################################
# On Load / Attach
########################################################

InPASDefaults <- list(
  InPAS.logging = TRUE,
  InPAS.genome = NULL,
  InPAS.TxDb = NULL,
  future.globals.maxSize = +Inf,
  InPAS.EnsDb = NULL,
  InPAS.outdir = NULL,
  InPAS.sqliteDb = NULL,
  InPAS.lockname = NULL,
  InPAS.chr2exclude = c(
    "chrM", "MT",
    "chrPltd", "Pltd"
  )
)

#' A function called upon a package is attached to the search path
#'
#' @param libname library name
#' @param pkgname package name
#'
#' @keywords internal
#' @importFrom utils packageVersion
#'
.onAttach <- function(libname, pkgname) {
  # if (!interactive()) return()
  v <- packageVersion("InPAS")
  packageStartupMessage(
    "InPAS : Version ", v,
    "\nFor more information see our website : ",
    "https://bioconductor.org/packages/release/bioc/vignettes/InPAS/inst/doc/InPAS.html\n",
    "If you encounter a bug, please report : https://github.com/jianhong/InPAS/InPAS/issues"
  )
  op <- options()
  toset <- !(names(InPASDefaults) %in% names(op))
  if (any(toset)) {
    options(InPASDefaults[toset])
  }
  invisible(0)
}

#############################################################################
# filtering out scaffolds or not from the genome
#############################################################################
#' Add a globally-applied requirement for filtering out scaffolds from
#' all analysis
#'
#' This function will set the default requirement of filtering out scaffolds
#' from all analysis.
#'
#' @param chr2exclude A character vector, NA or NULL, specifying chromosomes or
#'   scaffolds to be excluded for InPAS analysis. `chrM` and alternative scaffolds
#'   representing different haplotypes should be excluded.
#' @import BSgenome
#' @export
addChr2Exclude <- function(chr2exclude = c(
                             "chrM", "MT",
                             "Pltd", "chrPltd"
                           )) {
  if (!is.null(chr2exclude) && !is.character(chr2exclude)) {
    stop("chr2exclude must be NULL, or a character vector!")
  }
  options(InPAS.chr2exclude = chr2exclude)
}

#' Get a globally-applied requirement for filtering scaffolds.
#'
#' This function will get the default requirement of filtering scaffolds.
#'
#' @export
getChr2Exclude <- function() {
  chr2exclude <- options()$InPAS.chr2exclude
  if (is.null(chr2exclude) || is.character(chr2exclude)) {
    return(chr2exclude)
  } else {
    stop(
      "chr to exclude is not set correctly.\n",
      "Please call addChr2Exclude() first"
    )
  }
}

################################################################################
# Add BSgenome as global default
################################################################################

#' Add a globally defined genome to all InPAS functions.
#'
#' This function will set the genome across all InPAS functions.
#'
#' @param genome A BSgenome object indicating the default genome to be
#' used for all InPAS functions. This value is stored as a global environment
#' variable. This can be overwritten on a per-function basis using the given
#' function's `genome` parameter.
#' @import BSgenome
#' @export
addInPASGenome <- function(genome = NULL) {
  if (is(genome, "BSgenome")) {
    message("Setting default genome to ", metadata(genome)$genome, ".")
    options(InPAS.genome = genome)
  } else {
    stop("genome must be a BSgenome object!")
  }
  invisible(0)
}

#' Get the globally defined genome
#'
#' This function will retrieve the genome that is currently in use by InPAS.
#' @export
getInPASGenome <- function() {
  .InPASGenome <- options()$InPAS.genome
  if (!is(.InPASGenome, "BSgenome")) {
    stop(
      "genome is not set. Please call the function\n",
      "addInPASGenome() first"
    )
  }
  .InPASGenome
}

#' Add a globally defined TxDb for InPAS functions.
#'
#' @param TxDb An object of [GenomicFeatures::TxDb-class]
#' @import GenomicFeatures
#' @export
#'
#' @examples
#' library("TxDb.Hsapiens.UCSC.hg19.knownGene")
#' addInPASTxDb(TxDb = TxDb.Hsapiens.UCSC.hg19.knownGene)
addInPASTxDb <- function(TxDb = NULL) {
  if (!is(TxDb, "TxDb")) {
    stop("TxDb must be an object of TxDb!")
  }
  message("Setting default TxDb to ", deparse(substitute(TxDb)), ".")
  options(InPAS.TxDb = TxDb)
  invisible(0)
}

#' Get the globally defined TxDb.
#'
#' @return An object of [GenomicFeatures::TxDb-class]
#' @export
#'
#' @examples
#' library("TxDb.Hsapiens.UCSC.hg19.knownGene")
#' addInPASTxDb(TxDb = TxDb.Hsapiens.UCSC.hg19.knownGene)
#' getInPASTxDb()
getInPASTxDb <- function() {
  TxDb <- options()$InPAS.TxDb
  if (!is(TxDb, "TxDb")) {
    stop(
      "TxDb is not set. Please call the function\n",
      "addInPASTxDb() first"
    )
  }
  TxDb
}

#' Add a globally defined EnsDb to some InPAS functions.
#'
#' @param EnsDb An object of [ensembldb::EnsDb-class]
#'
#' @export
addInPASEnsDb <- function(EnsDb = NULL) {
  if (!is(EnsDb, "EnsDb")) {
    stop("EnsDb must be an object of EnsDb!")
  }
  message("Setting default EnsDb to ", deparse(substitute(EnsDb)), ".")
  options(InPAS.EnsDb = EnsDb)
  invisible(0)
}

#' Get the globally defined EnsDb.
#'
#' @return An object of [ensembldb::EnsDb-class]
#' @export
getInPASEnsDb <- function() {
  EnsDb <- options()$InPAS.EnsDb
  if (!is(EnsDb, "EnsDb")) {
    stop("EnsDb is not set. Please call the function addInPASEnsDb() first")
  }
  EnsDb
}

#' Add a filename for locking a SQLite database
#'
#' @param filename A character(1) vector, specifyong a path to a file for locking.
#' @export
addLockName <- function(filename = NULL) {
  if (is.null(filename) || file.exists(filename)) {
    filename <- tempfile()
    message(
      "The file for locking should not pre-exist!\n",
      "A tempfile ", filename, " is used for locking."
    )
  }
  file.create(filename)
  options(InPAS.lockname = filename)
  invisible(0)
}

#' Get the path to a file for locking the SQLite database
#'
#' @return A path to a file for locking
#' @export

getLockName <- function() {
  filename <- options()$InPAS.lockname
  if (is.null(filename) || !file.exists(filename)) {
    stop(
      "file for locking is not set. please call the function\n",
      "addLockName() first"
    )
  }
  filename
}

#' Add a globally defined output directory to some InPAS functions.
#'
#' @param outdir A character(1) vector, a path with write permission for storing
#'   InPAS analysis results. If it doesn't exist, it will be created.
#' @export

addInPASOutputDirectory <- function(outdir = NULL) {
  if (!is.character(outdir) || length(outdir) != 1) {
    stop("An output directory for InPAS analysis is required")
  }
  if (!dir.exists(outdir)) {
    dir.create(outdir, recursive = TRUE)
  }
  outdir <- normalizePath(outdir)
  options(InPAS.outdir = outdir)
}

#' Get the path to a output directory for InPAS analysis
#'
#' @return a normalized path to a output directory for InPAS analysis
#' @export
#'
getInPASOutputDirectory <- function() {
  outdir <- options()$InPAS.outdir
  if (!is.character(outdir) || length(outdir) != 1) {
    stop(
      "outdir is not defined, please call the function\n",
      "addInPASOutputDirectory() first"
    )
  }
  if (!dir.exists(outdir)) {
    dir.create(outdir, recursive = TRUE)
  }
  outdir <- normalizePath(outdir)
  outdir
}

#' Set up global variables for an InPAS analysis
#'
#' @param genome An object [BSgenome::BSgenome-class]. To make things easy, we
#'   suggest users creating a [BSgenome::BSgenome-class] instance from the
#'   reference genome used for read alignment. For details, see the
#'   documentation of [BSgenome::forgeBSgenomeDataPkg()].
#' @param TxDb An object of [GenomicFeatures::TxDb-class]
#' @param EnsDb An object of [ensembldb::EnsDb-class]
#' @param outdir A character(1) vector, a path with write permission for storing
#'   InPAS analysis results. If it doesn't exist, it will be created.
#' @param chr2exclude A character vector, NA or NULL, specifying chromosomes or
#'   scaffolds to be excluded for InPAS analysis. `chrM` and alternative scaffolds
#'   representing different haplotypes should be excluded.
#' @param lockfile A character(1) vector, specifying a file name used for
#'   parallel writing to a SQLite database
#'
#' @export
set_globals <- function(genome = NULL,
                        TxDb = NULL,
                        EnsDb = NULL,
                        outdir = NULL,
                        chr2exclude = c(
                          "chrM", "MT",
                          "Pltd", "chrPltd"
                        ),
                        lockfile = tempfile(tmpdir = getInPASOutputDirectory())) {
  addInPASGenome(genome)
  addInPASEnsDb(EnsDb)
  addInPASTxDb(TxDb)
  addInPASOutputDirectory(outdir)
  addLockName(lockfile)
  addChr2Exclude(chr2exclude)
  invisible(0)
}


#' @noRd
#' @param grl GRanges
#' @param feature additional features
#' @param drop columns to be dropped
#' @param name_col name column
grl_to_tibble <- function(grl, feature = NULL, drop = NULL,
                          name_col = "transcript",
                          output=c('tibble', 'granges')) {
  output <- match.arg(output)
  gr <- unlist(grl)
  
  ## add name column from the GRangesList names
  mcols(gr)[[name_col]] <- names(gr)
  
  ## remove names() on the GRanges object
  names(gr) <- NULL
  
  ## add feature column if provided
  if (!is.null(feature)) {
    gr$feature <- feature
  }
  
  ## drop metadata columns if provided
  if (!is.null(drop)) {
    for (d in drop) {
      if (d %in% colnames(mcols(gr))) {
        mcols(gr)[[d]] <- NULL
      }
    }
  }
  
  if(output=='tibble'){
    ## return tibble
    as_tibble(as.data.frame(gr))
  }else{
    gr
  }
}

checkCPs <- function(CP, proximal, distal, type) {
  if (!missing(proximal)) {
    checkEquals(CP[1]$Predicted_Proximal_APA, proximal)
  }
  if (!missing(distal)) {
    checkEquals(CP[1]$Predicted_Distal_APA, distal)
  }
  if (!missing(type)) {
    checkEquals(CP[1]$Predicted_Distal_APA_type, type)
  }
}

generateGRs <- function(starts, ends, scores) {
  GRanges("chr1",
    IRanges(start = starts, end = ends),
    strand = "*", score = scores
  )
}

generateUTR3 <- function(normal = TRUE) {
  if (normal) {
    chr1_gr <- GRanges("chr1", IRanges(c(100, 600), c(599, 2000),
      names = c(
        "transcript1|gene1|utr3",
        "transcript1|gene1|next.exon.gap"
      )
    ),
    strand = "+",
    feature = c("utr3", "next.exon.gap"),
    annotatedProximalCP = "unknown",
    exon = "transcript1", 
    transcript = "transcript1|",
    gene = "1", 
    truncated = FALSE,
    symbol = "gene1"
    )
    chr1_gr
  } else {
    data(utr3.mm10)
    utr3.mm10 <- utr3.mm10[seqnames(utr3.mm10) == "chr1" & end(utr3.mm10) < 10000000]
    utr3.mm10
  }
}

genome <- BSgenome.Mmusculus.UCSC.mm10
TxDb <- TxDb.Mmusculus.UCSC.mm10.knownGene
addLockName(filename = tempfile())
outdir <- tempdir()
addInPASOutputDirectory(outdir)

get_CPs <- function(tags, conditions, filenames,
                    genome, TxDb, utr3) {
  metadata <- data.frame(
    tag = tags,
    condition = conditions,
    bedgraph_file = filenames
  )
  write.table(metadata,
    file = file.path(outdir, "metadata.txt"),
    sep = "\t", quote = FALSE, row.names = FALSE
  )

  sqlite_db <- setup_sqlitedb(
    metadata = file.path(
      outdir,
      "metadata.txt"
    ),
    outdir
  )
  cov <- list()
  for (i in seq_along(filenames)) {
    cov[[tags[i]]] <- get_ssRleCov(
      bedgraph = filenames[i],
      tag = tags[i],
      genome = genome,
      sqlite_db = sqlite_db,
      outdir = outdir,
      chr2exclude = NULL
    )
  }

  data4CPsitesSearch <- setup_CPsSearch(sqlite_db,
    genome = genome,
    chr.utr3 = utr3,
    seqname = "chr1",
    background = "same_as_long_coverage_threshold",
    TxDb = TxDb,
    hugeData = TRUE,
    outdir = outdir,
    coverage_threshold = 5,
    silence = FALSE
  )

  CP <- search_CPs(
    seqname = "chr1",
    sqlite_db = sqlite_db,
    genome = genome,
    MINSIZE = 10,
    window_size = 100,
    search_point_START = 50,
    search_point_END = NA,
    cutEnd = 0,
    filter.last = FALSE,
    adjust_distal_polyA_end = TRUE,
    long_coverage_threshold = 2,
    PolyA_PWM = NA,
    classifier = NA,
    classifier_cutoff = 0.8,
    shift_range = 100,
    step = 1,
    outdir = outdir,
    silence = FALSE,
    DIST2END = 0,
    output.all = FALSE
  )
  list(CP = CP, sqlite_db = sqlite_db)
}

NOtest_searchDistalCPs <- function() {
  # drop from end
  utr3 <- generateUTR3()
  testGR <- generateGRs(
    c(5, 600, 1001),
    c(599, 1000, 1500), c(40, 10, 1)
  )

  filename <- tempfile()
  export(testGR, filename, format = "BEDGraph")
  CP <- get_CPs(
    tags = "test", conditions = "test",
    filenames = filename, genome = genome,
    TxDb = TxDb, utr3 = utr3
  )$CP
  checkCPs(CP, 599, 1000, "extended novel distal")

  # local background
  set.seed(393993)
  utr3 <- generateUTR3(normal = FALSE)
  background <- rep(rnbinom(140000, 10e9, mu = 2), each = 50)
  signal <- rep(
    c(0, 5, 10, 11, 0),
    c(1909199, 276, 998, 189, 5089338)
  ) + background
  signal <- signal[1899200:1920662]
  signal <- rle(signal)
  signal.cumsum <- cumsum(signal$lengths)
  testGR <- generateGRs(
    4899200 + c(0, signal.cumsum[-length(signal.cumsum)]),
    4899199 + signal.cumsum, signal$values
  )
  export(testGR, filename, format = "BEDGraph")

  CP <- get_CPs(
    tags = "test", conditions = "test",
    filenames = filename, genome = genome,
    TxDb = TxDb, utr3 = utr3
  )$CP

  checkCPs(CP, proximal = 4909451, type = "extended novel distal")
}

test_CPsites_utr3Usage <- function() {
  utr3 <- generateUTR3()
  testGR <- generateGRs(c(5, 600),
    c(599, 1000),
    scores = c(40, 10)
  )

  filename <- tempfile()
  export(testGR, filename, format = "BEDGraph")

  CP <- get_CPs(
    tags = "test", conditions = "test",
    filenames = filename, genome = genome,
    TxDb = TxDb, utr3 = utr3
  )

  checkCPs(CP$CP, 599, 1000, "extended novel distal")

  sqlite_db <- CP$sqlite_db
  utr3_cds_cov <- get_regionCov(
    chr.utr3 = utr3,
    sqlite_db,
    outdir,
    phmm = FALSE
  )

  res <- get_UTR3eSet(sqlite_db,
    normalize = "none",
    singleSample = FALSE
  )

  testGR2 <- GRanges("chr1", IRanges(5, 1000),
    strand = "*", score = 20
  )

  filename2 <- tempfile()
  export(testGR2, filename2, format = "BEDGraph")

  CP <- get_CPs(
    tags = c("test1", "test2"),
    conditions = c("test1", "test2"),
    filenames = c(filename, filename2),
    genome = genome, TxDb = TxDb, utr3 = utr3
  )
  checkCPs(CP$CP, 599, 1000, "extended novel distal")

  sqlite_db <- CP$sqlite_db
  utr3_cds_cov <- get_regionCov(
    chr.utr3 = utr3,
    sqlite_db,
    outdir,
    phmm = FALSE
  )

  res <- get_UTR3eSet(sqlite_db,
    normalize = "none",
    singleSample = FALSE
  )
  checkEqualsNumeric(res@PDUI[, "test1"], 0.25, tolerance = 1.0e-2)
  checkEqualsNumeric(res@PDUI[, "test2"], 1, tolerance = 1.0e-2)

  test_out <- InPAS:::run_fisherExactTest(
    UTR3eset = res,
    gp1 = "test1",
    gp2 = "test2"
  )
  res$testRes <- test_out
  res <- filter_testOut(res = res, gp1 = "test1", gp2 = "test2")
  checkEquals(as.logical(res$PASS), TRUE)
}

test_getCov_seqlevelsStyle <- function() {
  utr3 <- generateUTR3()
  testGR <- generateGRs(
    c(5, 400, 1001),
    c(399, 1000, 1500),
    c(40, 10, 1)
  )

  seqlevelsStyle(testGR) <- "NCBI"

  filename <- tempfile()
  export(testGR, filename, format = "BEDGraph")

  err <- try({
    CP <- get_CPs(
      tags = c("test1"),
      conditions = c("test1"),
      filenames = c(filename),
      genome = genome, TxDb = TxDb,
      utr3 = utr3
    )
  })
  checkEquals(is(err, "try-error"), TRUE)
}

test_get_ssRleCov <- function() {
  ## generate a bedgraph file
  start <- seq(1, 9, by = 2)
  end <- seq(2, 10, by = 2)
  testGR <- GRanges("chr1", IRanges(start, end),
    strand = "+", score = 1:5
  )
  filename <- tempfile()
  export(testGR, filename, format = "BEDGraph")

  tag <- c("test")
  metadata <- data.frame(
    tag = tag,
    condition = "test",
    bedgraph_file = filename
  )
  outdir <- tempdir()
  write.table(metadata,
    file = file.path(outdir, "metadata.txt"),
    sep = "\t", quote = FALSE, row.names = FALSE
  )

  sqlite_db <- setup_sqlitedb(
    metadata = file.path(outdir, "metadata.txt"),
    outdir
  )
  addLockName(filename = tempfile())

  cov <- get_ssRleCov(
    bedgraph = filename,
    tag = "test",
    genome = BSgenome.Mmusculus.UCSC.mm10,
    sqlite_db = sqlite_db,
    outdir = outdir,
    chr2exclude = NULL
  )
  cov <- readRDS(cov$coverage_file[cov$tag == "test" & cov$chr == "chr1"])
  checkEquals(rep(2, 5), runLength(cov)[1:5])
  checkEquals(1:5, runValue(cov)[1:5])
}

#' Helper function to label the last component of a genomic feature for each
#' transcript
#'
#' @param gr A tibble converted from an object of [GenomicRanges::GRanges-class]
#' @param feature_alt A character(1) vector, specifying the type of genomic
#'   features, such as "CDS", "exon", "utr3", "utr5".
#'
#' @importFrom dplyr as_tibble mutate filter arrange bind_rows group_by
#'   left_join summarise n
#' @author Haibo Liu
#' @return An object of [GenomicRanges::GRanges-class]
#' @keywords internal

assign_feature <- function(gr, feature_alt = "utr3") {
  gr <- gr %>%
    dplyr::arrange(
      seqnames, transcript,
      ifelse(strand == "+", -start, start)
    ) %>%
    dplyr::mutate(feature = ifelse(!duplicated(paste0(seqnames, "|", transcript)),
      feature_alt, feature
    ))
  gr
}

#' Extract gene models from a TxDb object
#'
#' Extract gene models from a TxDb object and annotate last 3' UTR exons and
#' the last CDSs
#'
#' @details A good practice is to perform read alignment using a
#' reference genome from Ensembl/GenCode including only the primary
#' assembly and build a TxDb using the GTF/GFF files downloaded
#' from the same source as the reference genome, such as
#' BioMart/Ensembl/GenCode. For instruction, see Vignette of the
#' GenomicFeatures. The UCSC reference genomes and their
#' annotation can be very cumbersome.
#'
#' @param sqlite_db A path to the SQLite database for InPAS, i.e. the output of
#'   [setup_sqlitedb()]. It can be `NULL`.
#' @param TxDb An object of [GenomicFeatures::TxDb-class]
#' @param edb An object of [ensembldb::EnsDb-class]
#' @param genome An object of [BSgenome::BSgenome-class]
#' @param chr2exclude A character vector, NA or NULL, specifying chromosomes or
#'   scaffolds to be excluded for InPAS analysis. `chrM` and alternative scaffolds
#'   representing different haplotypes should be excluded.
#' @param outdir A character(1) vector, a path with write permission for storing
#'   InPAS analysis results. If it doesn't exist, it will be created.
#' @return A [GenomicRanges::GRanges-class] object for gene models
#'
#' @import GenomicFeatures
#' @importFrom plyranges as_granges complement_ranges disjoin_ranges
#'   reduce_ranges reduce_ranges_directed remove_names
#'   set_genome_info shift_downstream
#' @importFrom dplyr as_tibble mutate select pull filter arrange bind_rows
#'   group_by left_join summarise n
#' @importFrom magrittr %>%
#' @importFrom AnnotationDbi mapIds
#' @author Haibo Liu
#' @export
#'
#' @examples
#' library("EnsDb.Hsapiens.v86")
#' library("BSgenome.Hsapiens.UCSC.hg19")
#' library("GenomicFeatures")
#'
#' ## set a sqlite database
#' bedgraphs <- system.file("extdata", c(
#'   "Baf3.extract.bedgraph",
#'   "UM15.extract.bedgraph"
#' ),
#' package = "InPAS"
#' )
#' tags <- c("Baf3", "UM15")
#' metadata <- data.frame(
#'   tag = tags,
#'   condition = c("Baf3", "UM15"),
#'   bedgraph_file = bedgraphs
#' )
#' outdir <- tempdir()
#' write.table(metadata,
#'   file = file.path(outdir, "metadata.txt"),
#'   sep = "\t", quote = FALSE, row.names = FALSE
#' )
#' sqlite_db <- setup_sqlitedb(
#'   metadata =
#'     file.path(outdir, "metadata.txt"),
#'   outdir
#' )
#'
#' samplefile <- system.file("extdata",
#'   "hg19_knownGene_sample.sqlite",
#'   package = "GenomicFeatures"
#' )
#' TxDb <- loadDb(samplefile)
#' edb <- EnsDb.Hsapiens.v86
#' genome <- BSgenome.Hsapiens.UCSC.hg19
#' seqnames <- seqnames(BSgenome.Hsapiens.UCSC.hg19)
#' chr2exclude <- c(
#'   "chrM", "chrMT",
#'   seqnames[grepl("_(hap\\d+|fix|alt)$",
#'     seqnames,
#'     perl = TRUE
#'   )]
#' )
#' parsed_Txdb <- parse_TxDb(sqlite_db, TxDb, edb, genome,
#'   chr2exclude = chr2exclude
#' )
parse_TxDb <- function(sqlite_db = NULL,
                       TxDb = getInPASTxDb(),
                       edb = getInPASEnsDb(),
                       genome = getInPASGenome(),
                       chr2exclude = getChr2Exclude(),
                       outdir = getInPASOutputDirectory()) {
  if (!is.null(sqlite_db)) {
    if (length(sqlite_db) != 1 || !file.exists(sqlite_db)) {
      stop("sqlite_db, a path to the SQLite database is required!")
    }
  }

  if (!is(TxDb, "TxDb")) {
    stop("TxDb must be an object of TxDb!")
  }

  if (!is(edb, "EnsDb")) {
    stop("edb must be an object of EnsDb!")
  }
  if (!is(genome, "BSgenome")) {
    stop("genome must be a BSgenome object!")
  }
  if (!is.null(chr2exclude) && !is.character(chr2exclude)) {
    stop("chr2Exclude must be NULL or a character vector!")
  }
  if (!is.character(outdir) || length(outdir) != 1) {
    stop(
      "A path with write permission for storing \n",
      "the parsed transcriptome is required!"
    )
  }
  if (!dir.exists(outdir)) {
    dir.create(outdir, recursive = TRUE)
  }
  outdir <- normalizePath(outdir)
  seqnames <- trim_seqnames(
    genome = genome,
    chr2exclude = chr2exclude
  )
  seqlevels <- seqlevels(TxDb)
  seqlevels <- seqlevels[!seqlevels %in% chr2exclude]
  if (!all(seqlevels %in% seqnames)) {
    stop(
      "chromosome names in TxDb and BSgenome are not consistent!",
      "\nPlease make sure they match."
    )
  }
  seqlevels(TxDb) <- seqlevels
  
  ## get all transcripts
  tx <- grl_to_tibble(
    transcriptsBy(TxDb, by = "gene"),
    name_col = "gene",
    drop = 'tx_id'
  )
  
  ## recover CDS and UTRs for coding transcripts
  cds <- grl_to_tibble(
    cdsBy(TxDb, by = "tx", use.names = TRUE),
    name_col = 'transcript',
    feature = "CDS",
    drop= c('cds_id', 'cds_name')
  )
  cds <- assign_feature(cds, feature_alt = "lastCDS")

  ## UTR5
  utr5 <- grl_to_tibble(
    fiveUTRsByTranscript(TxDb, use.names = TRUE),
    name_col = 'transcript',
    feature = "utr5",
    drop = c('exon_id', 'exon_name')
  )

  ## UTR3
  utr3 <- grl_to_tibble(
    threeUTRsByTranscript(TxDb, use.names = TRUE),
    name_col = "transcript",
    feature = "utr3",
    drop = c('exon_id', 'exon_name')
  )
  utr3 <- assign_feature(utr3, feature_alt = "lastutr3")

  ## exons for non-coding transcripts
  exons <- grl_to_tibble(
    exonsBy(TxDb,
            by = "tx",
            use.names = TRUE),
    name_col = 'transcript',
    drop = c('exon_id', 'exon_name'),
    output = 'granges'
  )

  noncoding_exons <- exons[!exons$transcript %in% cds$transcript] %>%
    data.frame() %>%
    dplyr::as_tibble() %>%
    dplyr::arrange(seqnames, transcript, -exon_rank)

  nexons <- noncoding_exons %>%
    dplyr::group_by(transcript) %>%
    summarise(num_exon = n())

  # noncoding RNA with single exon
  singleton <- nexons$transcript[nexons$num_exon == 1]
  noncoding_exons_singleton <- noncoding_exons %>%
    dplyr::filter(transcript %in% singleton) %>%
    dplyr::mutate(feature = "ncRNA")

  # noncoding RNA with mulitple exon
  noncoding_exons_multiplex <- noncoding_exons %>%
    dplyr::filter(!transcript %in% singleton)

  multiplex <- nexons[nexons$num_exon != 1, ] %>%
    as.data.frame()
  rownames(multiplex) <- multiplex[, 1]
  multiplex <- multiplex[, -1, drop = FALSE]
  multiplex <-
    multiplex[unique(noncoding_exons_multiplex$transcript), , drop = F]
  feature <- do.call("c", lapply(multiplex[, 1], function(.x) {
    c("lastutr3", "lastCDS", rep("CDS", .x - 2))
  }))
  noncoding_exons_multiplex$feature <- feature
  noncoding_exons <- noncoding_exons_multiplex %>%
    bind_rows(noncoding_exons_singleton)

  ## reconstruct the transcriptome
  tx <- bind_rows(utr5, cds, utr3, noncoding_exons) %>%
    dplyr::left_join(dplyr::select(tx, tx_name, gene),
      by = c("transcript" = "tx_name")
    ) %>%
    dplyr::filter(!is.na(gene)) %>%
    dplyr::mutate(exon = paste(seqnames, feature,
      paste(transcript, exon_rank, sep = "_"),
      sep = ":"
    ))

  ## clean up
  rm(
    utr5, cds, utr3, noncoding_exons, singleton,
    noncoding_exons_multiplex, noncoding_exons_singleton,
    multiplex, nexons, exons
  )
  gc()

  ## Gene ID type
  keytype <- ""
  if (any(grepl("^ENS", tx$gene[1:10], perl = TRUE))) {
    keytype <- "GENEID"
    ensembl_gene_id <- gsub("\\.\\d+$", "", tx$gene, perl = TRUE)
  } else if (any(grepl("^\\d+$", tx$gene[1:10], perl = TRUE))) {
    keytype <- "ENTREZID"
    ensembl_gene_id <- tx$gene
  }

  if (keytype == "GENEID" || keytype == "ENTREZID") {
    symbol <- AnnotationDbi::mapIds(edb,
      keys = unique(ensembl_gene_id),
      column = "GENENAME",
      keytype = keytype,
      multiVals = "list"
    )
    symbol <- sapply(symbol, function(.ele) {
      paste(unique(.ele[!is.na(.ele)]), collapse = ";")
    })
    symbol <- ifelse(symbol[ensembl_gene_id] == "",
      ensembl_gene_id, symbol[ensembl_gene_id]
    )
    tx <- tx %>% dplyr::mutate(symbol = symbol[ensembl_gene_id])
  } else {
    tx <- tx %>% dplyr::mutate(symbol = gene)
  }
  tx <- tx %>% plyranges::as_granges()
  tx_file <- file.path(outdir, "00.parsed.TxDb.RDS")
  saveRDS(tx, file = tx_file)

  if (!is.null(sqlite_db)) {
    filename_df <- data.frame(type = "transcripts", anno_file = tx_file)
    db_conn <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
    res <- dbSendStatement(
      db_conn,
      paste0(
        "DELETE FROM genome_anno ",
        "WHERE type = 'transcripts';"
      )
    )
    dbClearResult(res)
    res <- dbSendStatement(
      db_conn,
      "INSERT INTO
                          genome_anno (type, anno_file)
                          VALUES (:type, :anno_file);",
      filename_df
    )
    dbClearResult(res)
    dbDisconnect(db_conn)
  }
  tx
}

#' do APA analysis for a single sample
#'
#' @description do APA event analysis for a single sample Using Poisson Hidden
#'   Markov models
#' @details the test will be performed by comparing a two-state versus an
#'   one-state Poisson Hidden Markov models.
#'
#' @param UTR3eset the output of [get_UTR3eSet()]
#' @importFrom depmixS4 depmix fit posterior getpars
#' @importFrom stats BIC fft fisher.test loess.smooth model.matrix p.adjust
#'   pnorm poisson t.test
#' @return a matrix containing test results
#' @seealso [UTR3eSet-class], [get_UTR3eSet()], [depmixS4::depmix()]
#' @keywords internal
#' @author Jianhong Ou
#' @examples
#' path <- system.file("extdata", package = "InPAS")
#' load(file.path(path, "eset.MAQC.rda"))
#' res <- InPAS:::run_singleSampleAnalysis(eset)
run_singleSampleAnalysis <- function(UTR3eset) {
  ## could we use coverage instead of counts for poisson distribution?
  phmm <- function(counts) {
    counts <- floor(counts)
    at <- counts[1]
    counts <- counts[-1]
    mu.1 <- mean(counts[1:at]) + 1
    mu.2 <- mean(counts[-(1:at)]) + 1
    m1 <- depmix(
      response = counts ~ 1, nstates = 1,
      data = as.data.frame(counts),
      family = poisson(),
      respstart = log(mean(counts))
    )
    m2 <- depmix(
      response = counts ~ 1, nstates = 2,
      data = as.data.frame(counts),
      family = poisson(),
      respstart = c(log(mu.1), log(mu.2))
    )
    fm1 <- try(fit(m1, verbose = FALSE), silent = TRUE)
    if (inherits(fm1, "try-error")) {
      return(1)
    }
    fm2 <- try(fit(m2, verbose = FALSE), silent = TRUE)
    if (inherits(fm2, "try-error")) {
      return(1)
    }
    if (BIC(fm2) > BIC(fm1)) {
      return(1)
    }
    sts <- posterior(fm2)$state
    pars <- getpars(fm2)
    hi.state <- ifelse(pars[7] > pars[8], 1, 2)
    keytrans <- ifelse(pars[7] > pars[8], pars[5], pars[4])
    if (sts[1] != hi.state) {
      return(1)
    }
    if (sum(sts == sts[1]) - at > 1) {
      return(1)
    }
    return(keytrans)
  }

  P.Value <- lapply(UTR3eset$signals, phmm)
  adj.P.Val <- p.adjust(P.Value, method = "BH")
  short <- UTR3eset$short[, 1]
  long <- UTR3eset$long[, 1]
  PDUI <- long / (long + short)
  cbind(
    short.mean = short,
    long.mean = long,
    PDUI, P.Value, adj.P.Val
  )
}

#' prepare coverage data and fitting data for plot
#'
#' @param gr An object of [GenomicRanges::GRanges-class]
#' @param proximalSites An integer(n) vector, specifying the coordinates of
#'   proximal CP sites. Each of the proximal sites must match one entry in the
#'   GRanges object, \code{gr}.
#' @param sqlite_db A path to the SQLite database for InPAS, i.e. the output of
#'   [setup_sqlitedb()].
#' @param hugeData A logical(1), indicating whether it is huge data
#'
#' @return An object of [GenomicRanges::GRanges-class] with metadata:
#'   \item{dat}{A data.frame, first column is the position, the other columns are
#'   Coverage and value}
#'   \item{offset}{offset from the start of 3' UTR}
#' @import GenomicRanges
#' @importFrom reshape2 melt
#' @export
#' @author Jianhong Ou, Haibo Liu
#' @examples
#' library(BSgenome.Mmusculus.UCSC.mm10)
#' library(TxDb.Mmusculus.UCSC.mm10.knownGene)
#' genome <- BSgenome.Mmusculus.UCSC.mm10
#' TxDb <- TxDb.Mmusculus.UCSC.mm10.knownGene
#'
#' ## load UTR3 annotation and convert it into a GRangesList
#' data(utr3.mm10)
#' utr3 <- split(utr3.mm10, seqnames(utr3.mm10), drop = TRUE)
#'
#' bedgraphs <- system.file("extdata", c(
#'   "Baf3.extract.bedgraph",
#'   "UM15.extract.bedgraph"
#' ),
#' package = "InPAS"
#' )
#' tags <- c("Baf3", "UM15")
#' metadata <- data.frame(
#'   tag = tags,
#'   condition = c("baf", "UM15"),
#'   bedgraph_file = bedgraphs
#' )
#' outdir <- tempdir()
#' write.table(metadata,
#'   file = file.path(outdir, "metadata.txt"),
#'   sep = "\t", quote = FALSE, row.names = FALSE
#' )
#'
#' sqlite_db <- setup_sqlitedb(
#'   metadata = file.path(
#'     outdir,
#'     "metadata.txt"
#'   ),
#'   outdir
#' )
#' addLockName(filename = tempfile())
#' coverage <- list()
#' for (i in seq_along(bedgraphs)) {
#'   coverage[[tags[i]]] <- get_ssRleCov(
#'     bedgraph = bedgraphs[i],
#'     tag = tags[i],
#'     genome = genome,
#'     sqlite_db = sqlite_db,
#'     outdir = outdir,
#'     chr2exclude = "chrM"
#'   )
#' }
#' data4CPsSearch <- setup_CPsSearch(sqlite_db,
#'   genome,
#'   chr.utr3 = utr3[["chr6"]],
#'   seqname = "chr6",
#'   background = "10K",
#'   TxDb = TxDb,
#'   hugeData = TRUE,
#'   outdir = outdir
#' )
#'
#' gr <- GRanges("chr6", IRanges(128846245, 128850081), strand = "-")
#' names(gr) <- "chr6:128846245-128850081"
#' data4plot <- get_usage4plot(gr,
#'   proximalSites = 128849148,
#'   sqlite_db,
#'   hugeData = TRUE
#' )
#' plot_utr3Usage(
#'   usage_data = data4plot,
#'   vline_color = "purple",
#'   vline_type = "dashed"
#' )
get_usage4plot <- function(gr,
                           proximalSites,
                           sqlite_db,
                           hugeData) {
  gcCompensation <- NA
  mappabilityCompensation <- NA
  FFT <- FALSE
  fft.sm.power <- 20

  if (!is(gr, "GRanges")) {
    stop("gr must be an object of GRanges")
  }
  if (is.null(names(gr))) {
    names(gr) <-
      paste("X", formatC(1:length(gr),
        width = nchar(length(gr)),
        flag = "0"
      ), sep = "")
  }
  if (is.null(names(proximalSites))) {
    names(proximalSites) <- names(gr)
  } else {
    if (!all(names(gr) %in% names(proximalSites))) {
      stop("not all GRanges has proximalSites")
    }
  }

  grs <- split(gr, as.character(seqnames(gr)))
  seqnames <- names(grs)

  db_conn <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
  metadata <- dbReadTable(db_conn, "metadata")
  total_cov <- dbReadTable(db_conn, "total_coverage")
  on.exit(dbDisconnect(db_conn))
  ## only need to do this for the specified gr??
  depth.weight <- get_depthWeight(
    metadata = metadata,
    hugeData
  )

  total_cov <- total_cov[total_cov$chr %in% seqnames, ]
  if (nrow(total_cov) < 1) {
    stop("chromosomes in gr are not covered")
  }
  totalCov <- lapply(total_cov$coverage_file, function(.x) {
    readRDS(.x)[[1]]
  })
  names(totalCov) <- total_cov$chr

  ## get coverage for each region
  utr3TotalCov <- list()
  for (seqname in seqnames) {
    utr3TotalCov[[seqname]] <-
      get_UTR3TotalCov(grs[[seqname]], totalCov[seqname],
        gcCompensation = gcCompensation,
        mappabilityCompensation =
          mappabilityCompensation,
        FFT = FFT,
        fft.sm.power = fft.sm.power
      )
  }

  ## get least square error
  datInfo <- lapply(utr3TotalCov, function(.cov) {
    .gr <- gr[names(.cov)]
    data <- mapply(function(.ele, .str) {
      # reverse coverage data if strand is "-"
      if (.str) .ele <- .ele[nrow(.ele):1, , drop = FALSE]
      se <- nrow(.ele) - 1
      ## normalized coverage
      .ele <- .ele / depth.weight
      cov_diff <- apply( .ele, 2, calculate_mse,
        search_point_START = 1,
        search_point_END = se
      )
      cov_diff <- rowMeans(cov_diff)
      cvg <- .ele[1:se, , drop = FALSE]

      # reformat data from wide to long
      dat <- as.data.frame(cbind(
        Position = 1:nrow(cvg),
        MSE = cov_diff, cvg
      ))
      dat <- reshape2::melt(dat,
        variable.name = "Coverage",
        measure.vars = colnames(dat)[2:4]
      )
      dat$Coverage <- as.character(dat$Coverage)
      dat$Coverage <- ifelse(dat$Coverage != "MSE",
        paste(dat$Coverage, "coverage"),
        dat$Coverage
      )
      dat$Coverage <- factor(dat$Coverage,
        levels = c(
          "MSE",
          unique(dat$Coverage[dat$Coverage != "MSE"])
        )
      )
      dat
    }, .cov, as.character(strand(.gr)) == "-", SIMPLIFY = FALSE)
    .gr$dat <- data
    .gr$offset <- ifelse(strand(.gr) == "+",
      proximalSites[names(.cov)] - start(.gr),
      end(.gr) - proximalSites[names(.cov)] + 1
    )
    .gr
  })
  datInfo <- unlist(GRangesList(datInfo))
}

#' do test for dPDUI
#'
#' do test for dPDUI
#'
#' @param eset An object of [UTR3eSet-class]. It is an output of
#'   [get_UTR3eSet()]
#' @param sqlite_db A path to the SQLite database for InPAS, i.e. the output of
#'   setup_sqlitedb().
#' @param outdir A character(1) vector, a path with write permission for storing
#'   InPAS analysis results. If it doesn't exist, it will be created.
#' @param method A character(1), indicating the method for testing dPDUI. It can
#'   be "limma", "fisher.exact", "singleSample", or "singleGroup"
#' @param normalize A character(1), indicating the normalization method. It can
#'   be "none", "quantiles", "quantiles.robust", "mean", or "median"
#' @param design a design matrix of the experiment, with rows corresponding to
#'   samples and columns to coefficients to be estimated. Defaults to the unit
#'   vector meaning that the samples are treated as replicates. see
#'   [stats::model.matrix()]. Required for limma-based analysis.
#' @param contrast.matrix a numeric matrix with rows corresponding to
#'   coefficients in fit and columns containing contrasts. May be a vector if
#'   there is only one contrast. see [limma::makeContrasts()]. Required for
#'   limma-based analysis.
#' @param coef column number or column name specifying which coefficient or
#'   contrast of the linear model is of interest. see more [limma::topTable()].
#'   default value: 1
#' @param robust A logical(1) vector, indicating whether the estimation of the empirical Bayes prior
#'   parameters should be robustified against outlier sample variances.
#' @param ... other arguments are passed to lmFit
#'
#' @return An object of [UTR3eSet-class], with the last element \code{testRes} containing the test results in a matrix.
#' @details if method is "limma", design matrix and contrast is required. if
#'   method is "fisher.exact", gp1 and gp2 is required.
#' @export
#' @seealso [run_singleSampleAnalysis()], [run_singleGroupAnalysis()],
#'   [run_fisherExactTest()], [run_limmaAnalysis()]
#' @author Jianhong Ou, Haibo Liu
#' @examples
#' library(limma)
#' path <- system.file("extdata", package = "InPAS")
#' load(file.path(path, "eset.MAQC.rda"))
#' tags <- colnames(eset@PDUI)
#' g <- factor(gsub("\\..*$", "", tags))
#' design <- model.matrix(~ -1 + g)
#' colnames(design) <- c("Brain", "UHR")
#' contrast.matrix <- makeContrasts(
#'   contrasts = "Brain-UHR",
#'   levels = design
#' )
#' res <- test_dPDUI(
#'   eset = eset,
#'   sqlite_db,
#'   method = "limma",
#'   normalize = "none",
#'   design = design,
#'   contrast.matrix = contrast.matrix
#' )
test_dPDUI <- function(eset,
                       sqlite_db,
                       outdir = getInPASOutputDirectory(),
                       method = c(
                         "limma", "fisher.exact",
                         "singleSample", "singleGroup"
                       ),
                       normalize = c(
                         "none", "quantiles",
                         "quantiles.robust",
                         "mean", "median"
                       ),
                       design,
                       contrast.matrix,
                       coef = 1,
                       robust = FALSE,
                       ...) {
  if (missing(eset)) {
    stop("eset is required")
  }
  if (!is(eset, "UTR3eSet")) {
    stop("eset must be an object of UTR3eSet")
  }
  if (!is.character(outdir) || length(outdir) != 1) {
    stop("An explicit output directory is required")
  } else {
    outdir <- file.path(outdir, "009.test_dPDUI")
    if (!dir.exists(outdir)) {
      dir.create(outdir,
        recursive = TRUE,
        showWarnings = FALSE
      )
    }
    outdir <- normalizePath(outdir)
  }
  if (!is.logical(robust) || length(robust) != 1) {
    stop("robust must be a logical(1) vector")
  }

  method <- match.arg(arg = method, choices = c(
    "limma", "fisher.exact",
    "singleSample", "singleGroup"
  ))
  normalize <- match.arg(arg = normalize, choices = c(
    "none", "quantiles",
    "quantiles.robust",
    "mean", "median"
  ))
  res <- NULL
  if (method != "singleSample") {
    if (method == "limma") {
      if (missing(design) || missing(contrast.matrix)) {
        stop("design and contrast.matrix are required.")
      }
      res <- run_limmaAnalysis(eset, design, contrast.matrix,
        coef = coef, robust = FALSE, ...
      )
    }
    if (method == "fisher.exact") {
      if (missing(sqlite_db) || length(sqlite_db) != 1 ||
        !file.exists(sqlite_db)) {
        stop("sqlite_db is required for Fisher exact test.")
      }
      db_conn <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
      metadata <- dbReadTable(db_conn, "metadata")
      dbDisconnect(db_conn)
      groups <- split(metadata$tag, metadata$condition)

      if (length(groups) != 2) {
        stop(
          "The number of groups is not 2. Fisher exact",
          "test is not appropriate!"
        )
      } else {
        res <- run_fisherExactTest(eset, gp1 = groups[[1]], gp2 = groups[[2]])
      }
    }
    if (method == "singleGroup") {
      res <- run_singleGroupAnalysis(eset)
    }
  } else {
    res <- run_singleSampleAnalysis(eset)
  }
  eset$testRes <- res
  saveRDS(eset, file = file.path(outdir,
                                 paste0(method, ".test.dPDUI.RDS")))
  return(eset)
}

#' Get coverage for 3' UTR and last CDS regions on a single chromosome
#'
#' @param chr.utr3 An object of [GenomicRanges::GRanges-class], one element of an output of [extract_UTR3Anno()]
#' @param sqlite_db A path to the SQLite database for InPAS, i.e. the output of
#'   [setup_sqlitedb()].
#' @param outdir A character(1) vector, a path with write permission for storing
#'   InPAS analysis results. If it doesn't exist, it will be created.
#' @param phmm A logical(1) vector, indicating whether data should be
#'   prepared for singleSample analysis? By default, FALSE
#' @param min.length.diff An integer(1) vector, specifying minimal length 
#' difference between proximal and distal APA sites which should be met to be 
#' considered for differential APA analysis. Default is 200 bp.
#'
#' @return coverage view in GRanges
#' @export
#' @author Jianhong Ou, Haibo Liu

get_regionCov <- function(chr.utr3,
                          sqlite_db,
                          outdir = getInPASOutputDirectory(),
                          phmm = FALSE,
                          min.length.diff = 200) {
  if (!is(chr.utr3, "GRanges") ||
    !all(chr.utr3$feature %in% c("utr3", "next.exon.gap", "CDS"))) {
    stop(
      "chr.utr3 must be one element of an output of function of",
      "extract_UTR3Anno()"
    )
  }
  if (missing(sqlite_db)) {
    stop("sqlite_db, a path to the SQLite database is required")
  }
  if (!is.character(outdir) || length(outdir) != 1) {
    stop("An explicit output directory is required")
  } else {
    outdir0 <- outdir
    outdir <- file.path(outdir, "008.UTR3_lastCDS.RleCov")
    if (!dir.exists(outdir)) {
      dir.create(outdir,
        recursive = TRUE,
        showWarnings = FALSE
      )
    }
    outdir <- normalizePath(outdir)
  }

  ## get 3'UTRs and their last CDS regions
  chr.regions <- get_UTR3CDS(
    sqlite_db,
    chr.utr3,
    outdir0,
    min.length.diff
  )
  if (length(chr.regions) == 0) {
    return(NULL)
  }

  chr <- unique(as.character(seqnames(chr.regions)))
  if (length(chr) != 1) {
    stop("chr.regions should only be for a single chromosome/scaffold")
  }

  end <- end(chr.regions)
  maxEnd <- max(end)
  lock_filename <- getLockName()
  if (is.null(lock_filename) || !file.exists(lock_filename)) {
    stop(
      "lock_filename must be an existing file.",
      "Please call addLockName() first!"
    )
  }
  file_lock <- flock::lock(lock_filename)
  db_conn <- dbConnect(
    drv = RSQLite::SQLite(),
    dbname = sqlite_db
  )
  chr.coverage <- dbReadTable(db_conn, "chromosome_coverage")
  dbDisconnect(db_conn)
  unlock(file_lock)
  chr.coverage <-
    chr.coverage$coverage_file[chr.coverage$chr == chr]
  if (length(chr.coverage) != 1) {
    stop(paste0("No coverage data for ", chr))
  }
  ## load coverage of each sample for chr
  chr.coverage <- readRDS(chr.coverage)[[1]]

  .cov <- list()
  if (phmm) {
    all.tx <- list()
  }
  for (i in seq_along(chr.coverage)) {
    .ele <- chr.coverage[[i]]

    ## This should not happen for my implementation
    if (maxEnd > length(.ele)) {
      .ele <- append(.ele, rep(0, maxEnd - length(.ele) + 1))
    }
    if (is(.ele, "Rle")) {
      .cvg <- Views(.ele, start(chr.regions), end(chr.regions))
      if (phmm) {
        all.tx[[names(chr.coverage)[i]]] <-
          viewApply(.cvg, as.integer)
      }
      .cvg <- viewMeans(.cvg, na.rm = TRUE)
    } else {
      if (sum(.ele) != 0) {
        stop(
          "Sum of current chromosome, which is not covered,",
          "is not zero."
        )
      }
      .cvg <- rep(0, length(chr.regions))
    }
    .cov[[names(chr.coverage)[i]]] <- .cvg
  }

  this.trans <- list()
  for (i in 1:length(.cov[[1]])) {
    this.trans[[i]] <- list()
    for (j in names(.cov)) {
      this.trans[[i]][[j]] <- .cov[[j]][[i]]
    }
    this.trans[[i]] <- do.call(cbind, this.trans[[i]])
  }
  chr.regions$data <- this.trans
  if (phmm) {
    chr.regions$data2 <- all.tx[[1]]
  }

  filename <- file.path(outdir, paste(chr,
    "utr3_CDS.RleCov.RDS",
    sep = "_"
  ))
  saveRDS(chr.regions, file = filename)

  tryCatch(
    {
      file_lock <- flock::lock(lock_filename)
      db_conn <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
      res <- dbSendStatement(
        db_conn,
        paste0("DELETE FROM
                                utr3cds_coverage WHERE chr = '", chr, "';")
      )
      dbClearResult(res)
      res <- dbSendStatement(
        db_conn,
        paste0("INSERT INTO
                         utr3cds_coverage (chr, coverage_file)
                         VALUES ('", chr, "','", filename, "');")
      )
      dbClearResult(res)
    },
    error = function(e) {
      print(paste(conditionMessage(e)))
    },
    finally = {
      dbDisconnect(db_conn)
      unlock(file_lock)
    }
  )
  chr.regions
}

#' use limma to analyze the PDUI
#'
#' use limma to analyze the PDUI
#'
#' @param UTR3eset An object of [UTR3eSet-class], output of [get_UTR3eSet()]
#' @param design A design matrix of the experiment, with rows corresponding to
#'   arrays and columns to coefficients to be estimated. Defaults to the unit
#'   vector meaning that the arrays are treated as replicates. see
#'   [stats::model.matrix()]
#' @param contrast.matrix A numeric matrix with rows corresponding to coefficients
#'   in fit and columns containing contrasts. May be a vector if there is only
#'   one contrast. see [limma::makeContrasts()]
#' @param coef An integer(1) vector specifying which coefficient or a character(1)
#'   vector specifying which contrast of the linear model is to test. see more
#'   [limma::topTable()]. Default, 1.
#' @param robust A logical(1) vector,indicating whether the estimation of the
#'   empirical Bayes prior parameters be robustified against outlier sample
#'   variances?
#' @param ... other arguments which are passed to [limma::lmFit()]
#'
#' @return fit results of eBayes by limma. It is an object of class
#'   [limma::MArrayLM-class] containing everything found by fit. see
#'   [limma::eBayes()]
#' @export
#' @import limma
#' @author Jianhong Ou
#' @seealso [run_singleSampleAnalysis()], [run_singleGroupAnalysis()], [run_fisherExactTest()]
#'
#' @keywords internal

run_limmaAnalysis <- function(UTR3eset,
                              design,
                              contrast.matrix,
                              coef = 1,
                              robust = FALSE,
                              ...) {
  if (missing(design) || missing(contrast.matrix)) {
    stop("desing and contrast.matrix is required.")
  }
  if (!is(design, "matrix")) {
    stop("design must be an design matrix")
  }
  if (!is(contrast.matrix, "matrix")) {
    stop("contrast.matrix must be an object of matrix")
  }
  short <- UTR3eset@short
  long <- UTR3eset@long
  if (!identical(rownames(short), rownames(long))) {
    stop("the rownames are not identical for short form and long form")
  }
  txid <- rep(rownames(short), 2)
  formid <- c(
    paste(rownames(short), "short", sep = ":"),
    paste(rownames(long), "long", sep = ":")
  )
  y <- rbind(short, long)
  rownames(y) <- formid
  lib.size <- colSums(y)
  y <- log2(y + 0.001)
  y <- normalizeBetweenArrays(y)
  fit <- lmFit(y, design, ...)
  fit <- contrasts.fit(fit, contrast.matrix)

  ex <- diffSplice(fit,
    geneid = txid, exonid = formid,
    robust = robust, verbose = FALSE
  )
  ts <- topSplice(ex, coef = coef, test = "simes", number = nrow(ex))
  p <- ts[match(rownames(short), ts$GeneID), "P.Value"]
  BH <- ts[match(rownames(short), ts$GeneID), "FDR"]
  out <- cbind(P.Value = p, adj.P.Val = BH)
  rownames(out) <- rownames(short)
  out
}

#' Filter sequence names from a BSgenome object
#'
#' Filter sequence names for scaffolds from a BSgenome object so that only
#'   chromosome-level seqnames are kept.
#'
#' @param genome An object of [BSgenome::BSgenome-class]
#' @param chr2exclude A character vector, NA or NULL, specifying chromosomes or
#'   scaffolds to be excluded for InPAS analysis. `chrM` and alternative scaffolds
#'   representing different haplotypes should be excluded.
#'
#' @return An character vector containing filtered seqnames
#' @author Jianhong Ou, Haibo Liu
#' @keywords internal

trim_seqnames <- function(genome = getInPASGenome(),
                          chr2exclude = getChr2Exclude()) {
  if (!is(genome, "BSgenome")) {
    stop("genome must be an object of BSgenome")
  }
  if (!is.null(chr2exclude) && !is.character(chr2exclude)) {
    stop("chr2exclude must be NULL or a character vector")
  }
  seqnames <- seqnames(genome)
  seqnames <- seqnames[!seqnames %in% chr2exclude]
  seqnames
}

#' Calculate the CP score
#'
#' Calculate the CP score by using PWM of polyadenylation signal with sequence
#' around given position
#'
#' @param seqname a character(n) vector, the chromosome/scaffold' name
#' @param pos genomic positions
#' @param str DNA strand
#' @param idx offset position
#' @param PWM An R object for a position weight matrix (PWM) for a hexamer
#'   polyadenylation signal (PAS), such as AAUAAA.
#' @param genome an object of [BSgenome::BSgenome-class]
#' @param ups the number of upstream bases for PAS search.
#' @param dws the number of downstream bases for PAS search.
#' @return A list containing offset positions after PA score-based filtering
#' @import GenomicRanges
#' @seealso [get_PAscore2()]
#' @keywords internal
#' @author Jianhong Ou

get_PAscore <- function(seqname,
                        pos,
                        str,
                        idx,
                        PWM,
                        genome,
                        ups = 50,
                        dws = 50) {
  pos <- pos[!is.na(pos)]
  if (length(pos) < 1) {
    return(NULL)
  }
  start <- pos - ups
  start[start < 1] <- 1
  end <- pos + dws
  gr <- GRanges(seqname, IRanges(start, end,
    names = as.character(pos)
  ),
  strand = str
  )
  seq <- getSeq(genome, gr)

  mT <- future_lapply(seq, matchPWM,
    pwm = PWM,
    min.score = "70%", with.score = TRUE
  )

  hits <- sapply(mT, function(.ele) {
    if (!is(.ele, "XStringViews")) {
      return(FALSE)
    }
    if (length(.ele) == 0) {
      return(FALSE)
    }
    TRUE
  })
  idx[hits]
}

#' Compensate the coverage with GC-content or mappability
#'
#' @param view A list of view object
#' @param comp A numeric vector of weight for GC composition or mappability
#' @param start An integer vector, starting coordinates
#' @param end  An integer vector, end coordinates
#'
#' @return a list of GC composition or mappability corrected coverage
#' @keywords internal
#' @author Jianhong Ou

compensation <- function(view, comp, start, end) {
  mapply(function(.ele, .s, .e) {
    .ele * comp[.s:.e]
  }, view, start, end, SIMPLIFY = FALSE)
}


#' Smoothing using Fast Discrete Fourier Transform
#'
#' @param sn a real or complex array containing the values to be transformed.
#'   see [stats::fft()]
#' @param p An integer(1), fft smoothing power
#'
#' @return a numeric vector, the real part of inverse fft-transformed signal
#' @keywords internal
#' @author Jianhong Ou

fft.smooth <- function(sn, p) {
  if (length(sn) <= p) {
    return(sn)
  }
  sn.fft <- fft(sn)
  sn.fft[p:length(sn.fft)] <- 0 + 0i
  sn.ifft <- fft(sn.fft, inverse = TRUE) / length(sn.fft)
  Re(sn.ifft)
}

#' extract coverage of 3' UTR for CP sites prediction
#'
#' extract 3' UTR coverage from totalCov according to the
#'   [GenomicRanges::GRanges-class] object utr3.
#'
#' @param chr.utr3 An object of [GenomicRanges::GRanges-class]. It must be an
#'   element of the output of [extract_UTR3Anno()] for a given chromosome.
#' @param chr.totalCov total coverage for each condition of a given chromosome. It
#'   must be an output of [get_totalCov()]
#' @param gcCompensationensation GC compensation vector. Not support yet.
#' @param mappabilityCompensation mappability compensation vector. Not support
#'   yet.
#' @param FFT Use FFT smooth or not.
#' @param fft.sm.power the cut-off frequency of FFT smooth.
#'
#' @return path to a file storing the UTR3 total coverage for a given
#'   chromosome/scaffold
#' @keywords internal
#' @import GenomicRanges
#' @importFrom IRanges Views viewApply IRanges viewMeans
#' @author Jianhong Ou

get_UTR3TotalCov <- function(chr.utr3,
                             chr.totalCov,
                             gcCompensation = NA,
                             mappabilityCompensation = NA,
                             FFT = FALSE,
                             fft.sm.power = 20) {
  ## output of get_totalCov() is a list of list:
  ## chr.totalCov[[seqname]][[condition]]
  chr.totalCov <- chr.totalCov[[1]]
  ## memory consuming if gcCompensation, and mappabilityCompensation are
  ## used for coverage correction
  ## memory consuming if gcComp, and mapComp are used for coverage correction
  utr3_totalCov <- function(.utr, .cvg, gcComp, mapComp) {
    strand <- as.character(strand(.utr))
    start <- start(.utr)
    end <- end(.utr)
    maxEnd <- max(end)
    for (i in 1:length(.cvg)) {
      ## why this can happen?
      if (maxEnd > length(.cvg[[i]])) {
        .cvg[[i]] <-
          append(
            .cvg[[i]],
            ## no  + 1 by Haibo
            rep(0, maxEnd - length(.cvg[[i]]))
          )
      }
    }

    view <- lapply(.cvg, Views,
      start = start,
      end = end, names = names(.utr)
    )
    view <- sapply(view, function(.view) {
      viewApply(.view, as.integer)
    })
    if (is.list(view[1, ])) {
      view <- apply(view, 1, function(.ele) {
        do.call(cbind, .ele)
      })
    } else {
      view <- list(view)
      names(view) <- names(.utr)
    }
    if (length(view) > 0) view <- view[sapply(view, mean) > 0]
    if (!is.na(gcComp[1]) && length(gcComp) == length(.cvg[[1]])) {
      view <- compensation(view, gcComp, start, end)
    }
    if (!is.na(mapComp[1]) && length(mapComp) == length(.cvg[[1]])) {
      view <- compensation(view, mapComp, start, end)
    }
    if (FFT) {
      view <- lapply(view, function(.ele) {
        apply(.ele, 2, fft.smooth, p = fft.sm.power)
      })
    } else {
      view
    }
  }

  view <- utr3_totalCov(
    .utr = chr.utr3,
    .cvg = chr.totalCov,
    gcComp = gcCompensation,
    mapComp = mappabilityCompensation
  )
  view
}

#' search distal CP sites
#'
#' search distal CP sites
#'
#' @param chr.cov.merge merged coverage data for a given chromosome
#' @param conn_next_utr3 A logical(1) vector, indicating whether joint to next
#'   3UTR or not (used by [remove_convergentUTR3s()])
#' @param curr_UTR GRanges of 3' UTR for a given chromosome
#' @param window_size An integer(1) vector, the window size for novel distal or
#'   proximal CP site searching. default: 100.
#' @param depth.weight A named vector. One element of an output of
#'   [setup_CPsSearch()] for coverage depth weight, which is the output of
#'   [get_depthWeight()]
#' @param long_coverage_threshold An integer(1) vector, specifying the cutoff
#'   threshold of coverage for the terminal of long form 3' UTRs. If the coverage
#'   of first 100 nucleotides is lower than coverage_threshold, that transcript
#'   will be not considered for further analysis. Default, 2.
#' @param background A character(1) vector, the range for calculating cutoff
#'   threshold of local background. It can be "same_as_long_coverage_threshold",
#'   "1K", "5K","10K", or "50K".
#' @param z2s one element of an output of [setup_CPsSearch()] for Z-score cutoff
#'   values, which is the output of [get_zScoreCutoff()]
#'
#' @return a list
#' #' \itemize{\item dCPs, a data frame converted from GRanges
#'             \item chr.cov.merge, depth-normalized sample/condition specific
#'             coverage
#'             \item next.exon.gap, all-in-one collapsed, refined next.exon.gap
#'              coverage
#'             \item annotated.utr3,all-in-one collapsed coverage for annotated
#'             proximal UTRs
#'         }
#' @seealso [get_PAscore2()]
#' @import S4Vectors
#' @keywords internal
#' @author Jianhong Ou

search_distalCPs <- function(chr.cov.merge,
                             conn_next_utr3,
                             curr_UTR,
                             window_size,
                             depth.weight,
                             long_coverage_threshold,
                             background,
                             z2s) {
  find_distalCPs <- function(chr.cov.merge.ele,
                             conn_next_utr,
                             curr_UTR.ele) {

    ## sequencing depth-normalized sample/condition-specific utr3_total_coverage
    ## next.exon.gap total coverage
    chr.cov.merge.ele <-
      t(t(chr.cov.merge.ele) / depth.weight[colnames(chr.cov.merge.ele)])
    ## all-in-one collapsed utr3_total_coverage
    .ele <- rowSums(chr.cov.merge.ele)

    # By Jianhong, if there are reads covered to the next.exon.gap the proximal
    # CP site should be the known-utr3-end and distal site should be the end
    # of gap.
    # But per Haibo, this might be NOT correct in many cases.
    next.exon.gap <- .ele[grepl("next.exon.gap", names(.ele))]
    annotated.utr3 <- .ele[grepl("utr3", names(.ele))]
    
    ## due to cutStart = 10, the first 10 bases are missing.
    utr3start <- as.numeric(gsub("^.*_SEP_", "", 
                                 names(annotated.utr3)[1]))
    utr3end <- as.numeric(gsub(
        "^.*_SEP_", "",
        names(annotated.utr3)[length(annotated.utr3)]
    ))
    
    ## prepare output data.frame
    info <- as.data.frame(curr_UTR.ele)[1, ]
    info$utr3start <- utr3start
    info$utr3end <- utr3end
    info$preliminary_distal_APA <- 0
    info$NBC_adjusted_distal_APA <- NA 
    info$Predicted_Distal_APA <- NA
    info$Predicted_Distal_APA_type <- NA

    # detect gaps > window_size with 0 coverage and their width 
    # and trimming the collapsed next.exon.gap coverage.
    refine_gap <- function(gap.cov, window_size,
                           conn_next_utr,
                           n_window = 1,
                           is_first = TRUE) {
      gap.cov.rle <- Rle(gap.cov)
      id <- which(runLength(gap.cov.rle) > n_window * window_size &
        runValue(gap.cov.rle) == 0)
      ## find first uncovered region
      if (length(id) >= 1) {
        conn_next_utr <- FALSE
        id <- {
          if (is_first) {
            id[1] - 1
          } else {
            id[length(id)] - 1
          }
        }
        if (id > 0) {
          tot_len <- sum(runLength(gap.cov.rle)[1:id])
          gap.cov <- gap.cov[1:tot_len]
        } else {
          gap.cov <- numeric(0)
        }
      }
      list(
        conn_next_utr = conn_next_utr,
        gap.cov = gap.cov
      )
    }

    if (length(next.exon.gap) > 0) {
        # If the next.exon.gap is shared by two convergent 3' UTRs, cut at the first
        # gap with 0 coverage,otherwise, cut at the first gap with 0 coverage
        refined_gap <- refine_gap(
            gap.cov = next.exon.gap,
            window_size = window_size,
            conn_next_utr = conn_next_utr,
            n_window = 1,
            is_first = TRUE
        )
        next.exon.gap <- refined_gap$gap.cov
        conn_next_utr <- refined_gap$conn_next_utr
    } 
        ## By Jianhong, cut if any connected two windows different from 30 times,
        ## to separate connected two UTRs or strange peaks. This cut is not
        ## implemented any more.
    if (length(next.exon.gap) > 1) {
      if (background != "same_as_long_coverage_threshold") {
        threshold <- z2s[names(curr_UTR.ele[curr_UTR.ele$feature == "utr3"])]
        if (is.na(threshold)) {
          threshold <- long_coverage_threshold
        }
      } else {
        threshold <- long_coverage_threshold
      }
      next.exon.gap.thresholded <- next.exon.gap
      
      # if coverage < threshold, set to 0
      next.exon.gap.thresholded[next.exon.gap.thresholded < threshold] <- 0
      
      ## depending on if this next.exon.gao is shared by two convergent
      ## transcripts
      refined_gap <- refine_gap(
        gap.cov = next.exon.gap.thresholded,
        window_size = window_size,
        conn_next_utr = conn_next_utr,
        n_window = 1,
        is_first = TRUE
      )
      next.exon.gap.thresholded <- refined_gap$gap.cov
      conn_next_utr <- refined_gap$conn_next_utr
      if (length(next.exon.gap.thresholded) > 0) {
        next.exon.gap <- next.exon.gap[1:length(next.exon.gap.thresholded)]
      } else {
        next.exon.gap <- numeric(0)
      }
    }
    ## remove utr3---___---utr3, need to improve.
    if (conn_next_utr && length(next.exon.gap) > 50) {
      ## find split position by the deepest valley in coverage profile
      next.exon.gap <- InPAS:::remove_convergentUTR3s(next.exon.gap)
      conn_next_utr <- FALSE
    }
    
    ## By Jianhong, trim low coverage from the 3' end if basewise coverage <
    ## long_coverage_threshold.
    next.exon.gap.end.pos <- 0
    if (length(next.exon.gap) > 5) {
      ## make it simple, smooth and cutoff
      fit.loess <- loess.smooth(1:length(next.exon.gap),
                                next.exon.gap,
                                evaluation = length(next.exon.gap),
                                family = "gaussian",
                                span = .75, degree = 1
      )
      next.exon.gap.abun <- fit.loess$y
      id <- which(next.exon.gap.abun >= long_coverage_threshold)
      if (length(id) > 0) {
        next.exon.gap.abun <- next.exon.gap[1:id[length(id)]]
        id <- which(next.exon.gap.abun >= long_coverage_threshold)
      }
      if (length(id) > 0) {
        next.exon.gap.end.pos <- id[length(id)]
      } 
    }
    
    if (next.exon.gap.end.pos > 0) # longer 3' utr ending in next.exon.gap
    {
      distal.utr3.len <- length(annotated.utr3) + next.exon.gap.end.pos
      info$Predicted_Distal_APA_type <- "extended novel distal"
      ## final utr3 extended by valid next exon gap
      final.utr3 <- .ele[1:distal.utr3.len]
      ## absolute coordinates of distal CP sites
      info$preliminary_distal_APA <- as.numeric(gsub(
        "^.*_SEP_", "",
        names(final.utr3)[length(final.utr3)]
      ))
    } else { ## check annotated 3' UTR region
      original_len <- length(annotated.utr3)
      annotated.utr3.rle <- Rle(annotated.utr3)

      ## trimming uncovered tails > 100 bp
      if (runLength(annotated.utr3.rle)[nrun(annotated.utr3.rle)] >= 100 &&
        runValue(annotated.utr3.rle)[nrun(annotated.utr3.rle)] == 0) {
        annotated.utr3.rle <-
          Rle(
            values = runValue(annotated.utr3.rle)[-nrun(annotated.utr3.rle)],
            lengths = runLength(annotated.utr3.rle)[-nrun(annotated.utr3.rle)]
          )
      }
      len <- sum(runLength(annotated.utr3.rle))
      annotated.utr3 <- annotated.utr3[seq_len(len)]
      
      final.utr3 <- numeric(0)
      ## no 3' UTR of valid length
      info$preliminary_distal_APA <- -1
      info$Predicted_Distal_APA_type <- "undetectable"
      
      ## trimming by background threshold from 3' end
      if (length(annotated.utr3) > 0) {
        if (background != "same_as_long_coverage_threshold") {
          threshold <- z2s[names(curr_UTR.ele[curr_UTR.ele$feature == "utr3"])]
          if (is.na(threshold)) {
            threshold <- long_coverage_threshold
          }
        } else {
          threshold <- long_coverage_threshold
        }
        annotated.utr3.threshold <- annotated.utr3

        # if coverage < threshold, set to 0
        annotated.utr3.threshold[annotated.utr3.threshold < threshold] <- 0
        annotated.utr3.threshold.rle <- Rle(annotated.utr3.threshold)

        ## trimming annotated 3'UTR from 3' end conservatively
        ## remove trailing zeroes if there are more than 100 zeros
        if (runLength(annotated.utr3.threshold.rle)[nrun(annotated.utr3.threshold.rle)] >= 100 &&
          runValue(annotated.utr3.threshold.rle)[nrun(annotated.utr3.threshold.rle)] == 0) {
          annotated.utr3.threshold.rle <-
            Rle(
              values = runValue(annotated.utr3.threshold.rle)[-nrun(annotated.utr3.threshold.rle)],
              lengths = runLength(annotated.utr3.threshold.rle)[-nrun(annotated.utr3.threshold.rle)]
            )
        }
        trimmed_len <- sum(runLength(annotated.utr3.threshold.rle))

        if (trimmed_len > 0) {
          final.utr3 <- annotated.utr3[1:trimmed_len]
          ## just a little shortened
          if (trimmed_len >= original_len - 200) {
            info$Predicted_Distal_APA_type <- "known distal"
            info$preliminary_distal_APA <- {if (info$strand == "-"){info$start} 
                else {info$end}}
          } else {
            info$Predicted_Distal_APA_type <- "shortened novel distal"
            info$preliminary_distal_APA <- as.numeric(gsub(
              "^.*_SEP_", "",
              names(final.utr3)[length(final.utr3)]
            ))
          }
        }
      }
    }
    info$Predicted_Distal_APA <- info$preliminary_distal_APA
    return(list(
      info = info,
      cov = chr.cov.merge.ele,
      final.utr3 = final.utr3
    ))
  }

  distalCPs <- mapply(find_distalCPs,
    chr.cov.merge,
    conn_next_utr3,
    curr_UTR,
    SIMPLIFY = FALSE
  )
  dCPs <- do.call(rbind, lapply(distalCPs, `[[`, "info"))
  
  ## depth-normalized sample/condition-specific coverage (utr3 + gap)
  chr.cov.merge <- lapply(distalCPs, `[[`, "cov")
  ## annotated 3' UTR coverage
  final.utr3 <- lapply(distalCPs, `[[`, "final.utr3")

  list(
    dCPs = dCPs, ## see info above
    chr.cov.merge = chr.cov.merge,
    final.utr3 = final.utr3
  )
}

#' remove the converging candidates 3' UTRs LIKE UTR3___UTR3
#'
#' some of the results is from connected two 3' UTRs. We want to remove them.
#'
#' The algorithm need to be improved.
#'
#' @param x the collapsed next.exon.gap coverage
#'
#' @return the collapsed next.exon.gap after removing the next 3UTR
#' @keywords internal
#' @author Jianhong Ou, Haibo Liu

remove_convergentUTR3s <- function(x) {
  if (length(x) > 100) {
    id <- InPAS:::find_valleyBySpline(x,
      ss = 1,
      se = length(x), 
      n = 1,
      filter.last = FALSE
    )
    if (!is.na(id)) {
      x <- x[seq_len(id)]
    }
  }
  x
}

#' Adjust distal CP sites by the cleanUpdTSeq algorithm
#'
#' Adjust distal CP sites by the cleanUpdTSeq algorithm
#'
#' @param distalCPs the output of [search_distalCPs()]
#' @param classifier An R object for Naive Bayes classifier model, like the one
#'   in the cleanUpdTSeq package.
#' @param classifier_cutoff A numeric(1) vector. A cutoff of probability that a
#'   site is classified as true CP sites. The value should be between 0.5 and 1.
#'   Default, 0.8.
#' @param shift_range An integer(1) vector, specifying a shift range for
#'   adjusting the proximal and distal CP sites. Default, 50. It determines the
#'   range flanking the candidate CP sites to search the most likely CP sites.
#' @param genome a [BSgenome::BSgenome-class] object
#' @param seqname A character(1) vector, specifying a chromososome/scaffold name
#' @param step An integer (1) vector, specifying the step size used for adjusting
#'   the proximal or distal CP sites using the Naive Bayes classifier from the
#'   cleanUpdTSeq package. Default 1. It can be in the range of 1 to 5.
#' @seealso [search_proximalCPs()], [get_PAscore2()]
#' @keywords internal
#' @author Jianhong Ou

adjust_distalCPs <- function(distalCPs,
                             classifier,
                             classifier_cutoff,
                             shift_range,
                             genome,
                             seqname,
                             step = 1) {
  if (is(classifier, "PASclassifier")) {
    dCPs <- distalCPs$dCPs
    final.utr3 <- distalCPs$final.utr3
    truncated <- dCPs$truncated
    chr.length <- seqlengths(genome)[seqname]
    ## only adjust distal APA if there is a proximal APA
    ## to speed up
    proximal.APA <- lapply(distalCPs$Predicted_Proximal_APA, 
                          function(x) {!all(is.na(x))})
    
    generate_gapCov <- function(gap, .proximal.APA, truncated,
                                cp, ID, strand, chr.length) {
      ## longer 3'UTR must be at least 200 nt long
      if (cp > 0 && .proximal.APA && !truncated) {
        ## base coordinates of refined gap
        coor <- as.integer(gsub("^.*_SEP_", "", names(gap)))
        ## adjusting start from the end of gap
        start <- coor[length(coor)]
        ## adjust ending backward only? No, search for downstream is preferred
        end <- ifelse(strand == "+",
                      coor[length(coor)] + shift_range,
                      coor[length(coor)] - shift_range)
        pos <- seq(start, end, by = ifelse(strand == "+",
                                            1 * step, -1 * step))
        idx <- match(pos, coor) ## not needed
        # pos: relative position of search start to end
        # idx: absolute coordinates for pos
        # ID: final.utr3 unique id (from 1 to Nth)
        pos.mat <- cbind(pos, idx, ID)
        
        # remove out of range position
        pos.mat <- pos.mat[pos.mat[, "pos"] > 0 & 
                             pos.mat[, "pos"] <= chr.length, ]
        return(pos.mat)
      } else {
        return(NULL)
      }
    }
    
    gap.cov <- mapply(generate_gapCov,
                      final.utr3,
                      proximal.APA,
                      truncated,
                      dCPs$preliminary_distal_APA, 
                      seq_along(final.utr3),
                      dCPs$strand,
                      chr.length,
                      SIMPLIFY = FALSE
    )
    gap.cov <- do.call(rbind, gap.cov)
    if (length(gap.cov) > 0) {
      idx <- InPAS:::get_PAscore2(
        dCPs$seqnames[gap.cov[, "ID"]],
        gap.cov[, "pos"],
        dCPs$strand[gap.cov[, "ID"]],
        gap.cov[, "idx"],
        gap.cov[, "ID"],
        genome, classifier,
        classifier_cutoff
      )
      ## add adjusted distal CP sites to dCPs data.frame
      if (!is.null(idx)) {
        dCPs[idx$idx.gp, "NBC_adjusted_distal_APA"] <-
          as.numeric(gsub(
            ".*_(\\d+)_.+",
            "\\1", idx$peak_name
          ))
      }
      dCPs$Predicted_Distal_APA[!is.na(dCPs$NBC_adjusted_distal_APA)] <-
        dCPs$NBC_adjusted_distal_APA[!is.na(dCPs$NBC_adjusted_distal_APA)]
    }
    distalCPs$dCPs <- dCPs
  }
  distalCPs
}

#' Get 3' UTRs and their last CDS regions based on CP sites
#'
#' @param sqlite_db A path to the SQLite database for InPAS, i.e. the output of
#'   setup_sqlitedb().
#' @param chr.utr3 An object of [GenomicRanges::GRanges-class], specifying UTR3
#'   GRanges for a chromosome. It must be one element of an output of
#'   [extract_UTR3Anno()].
#' @param outdir A character(1) vector, a path with write permission for storing
#'   InPAS analysis results. If it doesn't exist, it will be created.
#' @param min.length.diff An integer(1) vector, specifying minimal length 
#' difference between proximal and distal APA sites which should be met to be 
#' considered for differential APA analysis. Default is 200 bp.
#'
#' @return An object of [GenomicRanges::GRanges-class] containing GRanges for
#'   UTRs with alternative CP sites and the corresponding last CDSs.
#' @keywords internal
#' @author Jianhong Ou, Haibo Liu

get_UTR3CDS <- function(sqlite_db,
                        chr.utr3,
                        outdir = getInPASOutputDirectory(),
                        min.length.diff = 200) {
  if (missing(sqlite_db) || missing(chr.utr3)) {
    stop("sqlite_db and chr.utr3 are required")
  }
  if (length(sqlite_db) != 1 || !file.exists(sqlite_db)) {
    stop("The path to the SQLite database is invalid!")
  }
  if (!is(chr.utr3, "GRanges") ||
    !all(chr.utr3$feature %in% c("utr3", "next.exon.gap", "CDS"))) {
    stop(
      "chr.utr3 must be one element of an output of function of",
      "extract_UTR3Anno()"
    )
  }
  if (!is.character(outdir) || length(outdir) != 1) {
    stop("An explicit output directory is required")
  } else {
    outdir <- file.path(outdir, "007.UTR3CDS.out")
    if (!dir.exists(outdir)) {
      dir.create(outdir,
        recursive = TRUE,
        showWarnings = TRUE
      )
    }
    outdir <- normalizePath(outdir)
  }
  lock_filename <- getLockName()
  if (is.null(lock_filename) || !file.exists(lock_filename)) {
    stop(
      "lock_filename must be an existing file.",
      "Please call addLockName() first!"
    )
  }

  seqname <- unique(as.character(seqnames(chr.utr3)))
  if (length(seqname) != 1) {
    stop("chr.utr3 should contains only one chromosome/scaffold")
  }
  file_lock <- flock::lock(lock_filename)
  db_conn <- dbConnect(
    drv = RSQLite::SQLite(),
    dbname = sqlite_db
  )
  CPsites <- dbReadTable(db_conn, "CPsites")
  dbDisconnect(db_conn)
  unlock(file_lock)
  chr.CPsites <- CPsites$cpsites_file[CPsites$chr == seqname]
  if (length(chr.CPsites) != 1) {
    stop(paste("No CP sites for", seqname))
  }

  chr.CPsites <- readRDS(chr.CPsites)
  
  ## filter invalid APA entries
  chr.CPsites <- chr.CPsites[!is.na(chr.CPsites$Predicted_Proximal_APA) & 
                 abs(chr.CPsites$Predicted_Proximal_APA - 
                       chr.CPsites$Predicted_Distal_APA) >= min.length.diff]
  if (length(chr.CPsites) == 0) {
    return(NULL)
  }
  chr.CPsites <- split(chr.CPsites, names(chr.CPsites))
  utr3.regions <- lapply(chr.CPsites, get_UTR3region)
  utr3.regions <- unlist(GRangesList(utr3.regions))

  ## merge utr3.regions with CDS of the same set of transcripts whose
  ## utr3.regions are considered
  CDS <- chr.utr3[chr.utr3$feature == "CDS" &
                    chr.utr3$transcript %in% unique(utr3.regions$transcript)]
  utr3.cds.regions <- c(utr3.regions, CDS)
  saveRDS(utr3.cds.regions, 
          file = file.path(outdir, paste0(seqname, "_UTR3CDS.RDS")))
  utr3.cds.regions
}

#' Find major valleys after spline smoothing
#'
#' Find major valleys after spline smoothing
#'
#' @param x A vector of numeric(n), containing MSEs for a given range
#' @param ss An positive integer, search start site relative to the leftmost base
#' @param se An positive integer, search end site relative to the leftmost base
#' @param nknots An positive integer, the number of knots for smoothing using
#'   spline[stats::smooth.spline()]. By default, set to 10 knots per kb.
#' @param n An integer, specifying the number of location where MSE are local
#'   minima (candidate CP sites). If set to -1, return all candidate CP sites.
#' @param min.dist An integer, minimal distance allowed between two adjacent
#'   candidate CP sites otherwise collapsed by selecting the one with lower MSE.
#' @param filter.last A logical(1), whether to filter out the last valley, which
#'   is likely the 3' end of the longer 3' UTR if no novel distal CP site is
#'   detected and the 3' end excluded by setting cutEnd/search_point_END is small.
#' @param DIST2END An integer, specifying a cutoff of the distance between last valley
#'   and the end of the 3' UTR (where MSE of the last base is calculated). If 
#'   the last valley is closer to the end than the specified distance, it will be
#'   not be considered because it is very likely due to RNA coverage decay at the
#'   end of mRNA. Default is 1200. User can consider a value between 1000 and 
#'   1500, depending on the library preparation procedures: RNA fragmentation and
#'   size selection.
#' @param plot A logical(1), whether to plot the MSE profile and the candidate
#'   valleys.
#' @importFrom graphics abline lines
#' @importFrom stats smooth.spline
#' @return A vector of integer.
#' @keywords internal

find_valleyBySpline <- function(x,
                                ss,
                                se = length(x),
                                nknots = ceiling((se - ss + 1) / 1000 * 10),
                                n = -1,
                                min.dist = 200,
                                filter.last = TRUE,
                                DIST2END = 1200,
                                plot = FALSE) {
  df <- data.frame(index = seq.int(length(x)), mse = x)

  ## remove the pos < ss, which are 0s
  df <- df[-c(1:(ss - 1)), ]
  ## smoothing MSE profile
  pos <- try({
    ss_pred <-suppressMessages(smooth.spline(df[, 2], 
                                             nknots = nknots, cv = TRUE))
    ## find local minima
    pos <- which(diff(c(sign(diff(c(ss_pred$y[1], ss_pred$y))), 0)) == 2) +
      ss - 1
    pos
  }, silent = TRUE)
  while (is(pos, "try-error")) {
    nknots <- nknots * 4
    pos <- try({
      ss_pred <- suppressMessages(smooth.spline(df[, 2], 
                                                nknots = nknots, cv = TRUE))
      ## find local minima
      pos <- which(diff(c(sign(diff(c(
        ss_pred$y[1],
        ss_pred$y
      ))), 0)) == 2) + ss - 1
      pos
    }, silent  = TRUE)
  }

  ## add ss or se if it is smaller than mse[pos]
  tobeadd <- ifelse(x[ss] < x[se], ss, se)
  if (length(pos) > 0) {
    w <- x[tobeadd] < min(x[pos])
    if (length(w) > 0 && !is.na(w[1]) && is.logical(w[1])) {
      if (any(w)) pos <- unique(c(pos, tobeadd))
    }
  } else {
    pos <- tobeadd
  }

  if (length(pos) > 0) {
    pos <- pos[!is.na(x[pos])]
  }

  ## remove minor minima
  if (length(pos) > 0) {
    pos <- pos[max(x[-c(1:ss)]) - x[pos] > (max(x[-c(1:ss)]) - 
                                              min(x[-c(1:ss)])) * 0.1]
  }

  if (length(pos) >= 1) {
    ## get original position with local minimal unsmoothed MSE
    pos <- unlist(lapply(pos, function(.pos) {
      left <- .pos - 100
      right <- .pos + 100
      if (left < ss) {
        left <- ss
      }
      if (right > se) {
        right <- se
      }
      raw_mse <- x[left:right]
      .pos <- which(raw_mse == min(raw_mse)) + left - 1
      .pos
    }))
    
    ## merge adjacent local minima with min.dist by picking the smallest
    ## from neighboring positions
    if (length(pos) > 1) {
      interval_dist <- diff(pos)
      while (any(interval_dist <= min.dist)) {
        index_rmv <- numeric()
        for (i in seq_along(interval_dist))
        {
          if (interval_dist[i] <= min.dist) {
            index_rmv <- ifelse(x[pos[i]] > x[pos[i + 1]], i, i + 1)
          }
        }
        index_rmv <- unique(index_rmv)
        pos <- pos[-(index_rmv)]
        interval_dist <- diff(pos)
      }
    }
    
    ## filter last
    if (length(pos) > 0 && filter.last) {
      pos <- sort(pos)
      if (length(x) - pos[length(pos)] <= DIST2END) {
         if (x[pos[length(pos)]] == min(x[pos]))
         {
             return(NA)
         } else {
             pos <- pos[-length(pos)]
         }
      }
    }
    if (length(pos) > 0) {
      pos <- pos[x[pos] < 0.95*mean(x[ss:(ss+49)])]
    }
    
    if (length(pos) > 0) {
      if (plot) {
        plot(x = df[, 1], y = df[, 2], xlab = "relative position", ylab = "MSE")
        lines(ss_pred$x + ss - 1, ss_pred$y, col = "red")
        abline(v = pos, col = "purple")
      }
      if (n == -1 || n > length(pos)) {
        n <- length(pos)
      }
      pos <- pos[order(x[pos])][1:n]
    } else {
      pos <- NA
    }
  } else {
    pos <- NA
  }
  return(pos)
}

#' Calculate local background cutoff value
#'
#' calculate local background z-score cutoff
#'
#' @param background A character(1) vector, indicating how background coverage
#'   is defined.
#' @param chr.introns An object of [GenomicRanges::GRanges-class] for introns
#'   of a give chromosome/scaffold
#' @param chr.totalCov total coverage for a given chromosome/scaffold, an output
#'   from [get_totalCov()] for a given chromosome/scaffold
#' @param chr.utr3 An object of [GenomicRanges::GRanges-class], an element of
#'   the output of [extract_UTR3Anno()] for a given chromosome/scaffold
#' @param seqname A character(1), the name of a chromosome/scaffold
#' @param z Z score cutoff value
#'
#' @return A named numeric vector containing local background Z-score cutoff
#'   values. The names are GRanges's name for 3' UTRs.
#' @keywords internal
#' @import GenomicRanges
#' @importFrom IRanges IRanges
#' @author Jianhong Ou, Haibo Liu

get_zScoreCutoff <- function(background,
                             chr.introns,
                             chr.totalCov,
                             chr.utr3,
                             seqname,
                             z = 2) {
  ## output of get_totalCov() is a list of list:
  ## chr.totalCov[[seqname]][[condition]]
  chr.totalCov <- chr.totalCov[[1]]
  if (background == "same_as_long_coverage_threshold" ||
    length(chr.introns) < 1) {
    return(0)
  }
  background <- switch(background,
    "1K" = 1000,
    "5K" = 5000,
    "10K" = 10000,
    "50K" = 50000,
    1000
  )

  curr_range <- chr.utr3[chr.utr3$feature == "utr3"]
  curr_str <- as.character(strand(curr_range)) == "+"
  start(curr_range) <- ifelse(curr_str,
    start(curr_range) - background - 1,
    end(curr_range)
  )
  width(curr_range) <- background

  ol <- findOverlaps(curr_range, chr.introns)
  if (length(ol) < 1) {
    return(0)
  }
  chr.introns <- chr.introns[subjectHits(ol)]
  chr.introns$id <- names(curr_range)[queryHits(ol)]

  # no introns for some seqnames
  get_cvg <- function(.intron, .cov) {
    .cvg <-
      lapply(.cov, function(.cv) {
        .cv <- Views(.cv,
          start = start(.intron),
          end = end(.intron)
        )
        .cv <- viewApply(.cv, as.integer, simplify = FALSE)
      })

    # cvg is a list of length(#number_sample) of list of length(#number_introns)
    # correct Jianhong's bug here
    .cvg1 <- vector("list", length(.cvg[[1]]))
    for (k in seq_along(.cvg1))
    {
      .cvg1[[k]] <- list()
    }

    for (i in names(.cvg)) {
      for (j in seq_along(.cvg[[1]])) {
        .cvg1[[j]][[i]] <- .cvg[[i]][[j]]
      }
    }
    .cvg1 <- lapply(.cvg1, function(.e) {
      colSums(do.call("rbind", .e))
    })
    .intron$cvg <- .cvg1
    .intron
  }

  cvg <- get_cvg(.intron = chr.introns, .cov = chr.totalCov)

  cvg <- split(cvg$cvg, cvg$id)
  cvg <- sapply(cvg, function(.ele) {
    .ele <- unlist(.ele)
    mu <- mean(.ele, na.rm = TRUE)
    std <- sd(.ele, na.rm = TRUE)
    z * std + mu ## assuming normal distribution?
  })

  cvg <- cvg[match(names(curr_range), names(cvg))]
  names(cvg) <- names(curr_range)
  cvg[is.na(cvg)] <- 0
  cvg
}

#' search proximal CPsites
#'
#' @param CPs output from [search_distalCPs()]
#' @param curr_UTR GRanges for current 3' UTR
#' @param window_size window size
#' @param MINSIZE MINSIZE for short form
#' @param cutEnd A numeric(1) between 0 and 1 or an integer(1) greater than 1,
#'   specifying the percentage of or the number of nucleotides should be removed
#'   from the end before search for proximal CP sites, 0.1 means 10 percent.
#'   It is recommended to use an integer great than 1, such as 200, 400 or 600,
#'   because read coverage at 3' extremities is determined by fragment size due
#'   to RNA fragmentation and size selection during library construction.
#' @param search_point_START An integer, specifying the start position to
#'   calculate MSE
#' @param search_point_END A numeric(1) between 0 and 1 or an integer(1) greater
#'  than 1, specifying the percentage of or the number of nucleotides should not
#'  be excluded from the end to calculate MSE.
#' @param filter.last A logical(1), whether to filter out the last valley, which
#'   is likely the 3' end of the longer 3' UTR if no novel distal CP site is
#'   detected and the 3' end excluded by setting cutEnd/search_point_END is small.
#' @param DIST2END An integer, specifying a cutoff of the distance between last valley
#'   and the end of the 3' UTR (where MSE of the last base is calculated). If 
#'   the last valley is closer to the end than the specified distance, it will be
#'   not be considered because it is very likely due to RNA coverage decay at the
#'   end of mRNA. Default is 1200. User can consider a value between 1000 and 
#'   1500, depending on the library preparation procedures: RNA fragmentation and
#'   size selection.
#' @return a list
#' @seealso [adjust_proximalCPs()], [polish_CPs()],[adjust_proximalCPsByPWM()],
#'   [adjust_proximalCPsByNBC()], [get_PAscore()], [get_PAscore2()]
#' @keywords internal
#' @author Jianhong Ou

search_proximalCPs <- function(CPs,
                               curr_UTR,
                               window_size,
                               MINSIZE,
                               cutEnd = NA,
                               search_point_START,
                               search_point_END = NA,
                               filter.last = TRUE,
                               DIST2END = 1000) {
  dCPs <- CPs$dCPs
  chr.cov.merge <- CPs$chr.cov.merge
  utr_len <- sapply(CPs$final.utr3, length)

  ## annotated proximal CP sites per 3' UTR
  ## known candidate proximal CP sites recorded in UTR3 annotation
  utr_end <- ifelse(dCPs$strand == "-", dCPs$start, dCPs$end)
  saved.id <-
    mapply(function(anno.cp, truncated, end) {
      if (!truncated) {
        if (anno.cp == "unknown") {
          return(end)
        } else {
          annotated.proximal <- as.numeric(unlist(strsplit(gsub(
            "proximalCP_", "",
            anno.cp
          ), "_")))
          annotated.proximal <- c(annotated.proximal, end)
          return(sort(annotated.proximal))
        }
      } else {
        if (anno.cp == "unknown") {
          return(NA)
        } else {
          annotated.proximal <- as.numeric(unlist(strsplit(gsub(
            "proximalCP_", "",
            anno.cp
          ), "_")))
          return(sort(annotated.proximal))
        }
      }
    }, dCPs$annotatedProximalCP, dCPs$truncated,
    utr_end,
    SIMPLIFY = FALSE
    )
  names(saved.id) <- rownames(dCPs)
  ## trimming chr.cov.merge according to current 3' utr length
  chr.cov.merge <- mapply(function(d, len) {
    if (len > 0) {
      d[1:len, , drop = FALSE]
    } else {
      d[FALSE, , drop = FALSE]
    }
  }, chr.cov.merge, utr_len, SIMPLIFY = FALSE)

  if (!is.na(cutEnd)) {
    if (cutEnd < 1 && cutEnd > 0) { ## By proportion
      chr.cov.merge <- lapply(chr.cov.merge, function(.ele) {
        if (nrow(.ele) >= 1) {
          .ele[1:floor((nrow(.ele) - 1) * (1 - cutEnd)), ,
               drop = FALSE
          ]
        }
      })
    } else if (cutEnd >= 1) { ## actual length
      chr.cov.merge <- lapply(chr.cov.merge, function(.ele) {
        if (nrow(.ele) >= 1) {
          .ele[1:max(nrow(.ele) - 1 - floor(cutEnd), 1), ,
               drop = FALSE
          ]
        }
      })
    }
  }

  minStartPos <- utr_len >= max(c(search_point_START, MINSIZE, 200))
  len <- sapply(chr.cov.merge, nrow)
  search_point_END <- rep(abs(search_point_END), nrow(dCPs))
  search_point_end <- ifelse(is.na(search_point_END),
    len - 1,
    ifelse(search_point_END < 1,
      ceiling(len * (1 - search_point_END)),
      floor(len - search_point_END)
    )
  )
  flag <- minStartPos & (search_point_end > search_point_START)

  Predicted_Proximal_APA <- vector("list", length = nrow(dCPs))
  fit_value <- vector("list", length = nrow(dCPs))
  dCPs$min_fit_value <- NA
  dCPs$Predicted_Proximal_APA <- NA
  dCPs$Predicted_Proximal_APA_Type <- NA

  ## find proximal CP sites if the utr3 is valid in term of length
  fit_value[flag] <- mapply(function(.ele, search_point_END) {
    cov_diff <- apply(.ele, 2, InPAS:::calculate_mse,
      search_point_START = search_point_START,
      search_point_END = search_point_END
    )
    cov_diff <- rowMeans(cov_diff)
  }, chr.cov.merge[flag],
  search_point_end[flag],
  SIMPLIFY = FALSE
  )
  names(fit_value) <- names(chr.cov.merge)

  Predicted_Proximal_APA[flag] <-
    mapply(function(cov_diff, search_point_END) {
      idx <- InPAS:::find_valleyBySpline(cov_diff,
        search_point_START,
        search_point_END,
        n = 1,  #be more accurate, only return the one with minimal MSE
        filter.last = filter.last,
        DIST2END = DIST2END
      )
      if (search_point_START < MINSIZE) {
        idx <- idx[idx != search_point_START]
      }
      idx
    }, fit_value[flag],
    search_point_end[flag],
    SIMPLIFY = FALSE
    )
  Predicted_Proximal_APA <- lapply(Predicted_Proximal_APA, function(x) {
    x[is.null(x)] <- NA
    x
  })

  list(
    dCPs = dCPs,
    chr.cov.merge = chr.cov.merge,
    final.utr3 = CPs$final.utr3,
    saved.id = saved.id,
    flag = flag,
    fit_value = fit_value,
    Predicted_Proximal_APA = Predicted_Proximal_APA
  )
}

pkgs_required <- c(
  "BSgenome.Mmusculus.UCSC.mm10",
  "TxDb.Mmusculus.UCSC.mm10.knownGene",
  "EnsDb.Mmusculus.v79",
  "rtracklayer",
  "GenomicRanges",
  "RUnit",
  "limma", "future.apply"
)
for (pkg in pkgs_required)
{
  require(pkg, character.only = TRUE) || stop(pkg, " can't be loaded!")
}

BiocGenerics:::testPackage("InPAS")

#' Get Rle coverage from a bedgraph file for a sample
#'
#' Get RLe coverage from a bedgraph file for a sample
#'
#' @param bedgraph A path to a bedGraph file
#' @param tag A character(1) vector, a name tag used to label the bedgraph file.
#'   It must match the tag specified in the metadata file used to setup the
#'   SQLite database
#' @param genome an object [BSgenome::BSgenome-class]. To make things easy, we
#'   suggest users creating a [BSgenome::BSgenome-class] instance from the
#'   reference genome used for read alignment. For details, see the
#'   documentation of [BSgenome::forgeBSgenomeDataPkg()].
#' @param sqlite_db A path to the SQLite database for InPAS, i.e. the output of
#'   [setup_sqlitedb()].
#' @param future.chunk.size The average number of elements per future
#'   ("chunk"). If Inf, then all elements are processed in a single future.
#'   If NULL, then argument future.scheduling = 1 is used by default. Users can
#'   set future.chunk.size = total number of elements/number of cores set for
#'   the backend. See the future.apply package for details. You may adjust
#'   this number based based on the available computing resource: CPUs and RAM.
#'   This parameter affects the time for converting coverage from bedgraph to Rle.
#' @param chr2exclude A character vector, NA or NULL, specifying chromosomes or
#'   scaffolds to be excluded for InPAS analysis. `chrM` and alternative scaffolds
#'   representing different haplotypes should be excluded.
#' @param outdir A character(1) vector, a path with write permission for storing
#'   InPAS analysis results. If it doesn't exist, it will be created.
#' @return A data frame, as described below.
#'   \describe{
#'            \item{tag}{the sample tag}
#'            \item{chr}{chromosome name}
#'            \item{coverage_file}{path to Rle coverage files for each chromosome
#'             per sample tag}
#'           }
#' @importFrom dplyr as_tibble mutate filter arrange bind_rows group_by
#'   left_join summarise n bind_cols syms desc pull
#' @importFrom Seqinfo seqlengths
#' @importFrom GenomeInfoDb seqlevelsStyle mapSeqlevels
#' @import readr RSQLite S4Vectors GenomicRanges flock
#' @importFrom future.apply future_lapply
#' @importFrom magrittr %>%
#'
#' @export
#' @author Jianhong Ou, Haibo Liu
#' @examples
#' if (interactive()) {
#'   library(BSgenome.Mmusculus.UCSC.mm10)
#'   genome <- BSgenome.Mmusculus.UCSC.mm10
#'   bedgraphs <- system.file("extdata", c(
#'     "Baf3.extract.bedgraph",
#'     "UM15.extract.bedgraph"
#'   ),
#'   package = "InPAS"
#'   )
#'   tags <- c("Baf3", "UM15")
#'   metadata <- data.frame(
#'     tag = tags,
#'     condition = c("Baf3", "UM15"),
#'     bedgraph_file = bedgraphs
#'   )
#'   outdir <- tempdir()
#'   write.table(metadata,
#'     file = file.path(outdir, "metadata.txt"),
#'     sep = "\t", quote = FALSE, row.names = FALSE
#'   )
#'
#'   sqlite_db <- setup_sqlitedb(
#'     metadata = file.path(
#'       outdir,
#'       "metadata.txt"
#'     ),
#'     outdir
#'   )
#'   addLockName()
#'   coverage_info <- get_ssRleCov(
#'     bedgraph = bedgraphs[1],
#'     tag = tags[1],
#'     genome = genome,
#'     sqlite_db = sqlite_db,
#'     outdir = outdir,
#'     chr2exclude = "chrM"
#'   )
#'   # check read coverage depth
#'   db_connect <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
#'   dbReadTable(db_connect, "metadata")
#'   dbDisconnect(db_connect)
#' }
get_ssRleCov <- function(bedgraph,
                         tag,
                         genome = getInPASGenome(),
                         sqlite_db,
                         future.chunk.size = NULL,
                         outdir = getInPASOutputDirectory(),
                         chr2exclude = getChr2Exclude()) {
  if (!is(genome, "BSgenome")) {
    stop("genome,an object of BSgenome, required.")
  }
  if (missing(tag) || missing(bedgraph)) {
    stop("tags and bedgraphs are required.")
  }
  if (length(bedgraph) != 1 || length(tag) != 1) {
    stop("length of bedgraph must be 1")
  }
  if (!file.exists(bedgraph)) {
    stop("bedgraph file does not exist")
  }
  if (!is.character(outdir) || length(outdir) != 1) {
    stop("A writable output directory is required!")
  }
  if (missing(sqlite_db) || !file.exists(sqlite_db)) {
    stop("The SQLite database for InPAS is required!")
  }
  if (!is.null(chr2exclude) && !is.character(chr2exclude)) {
    stop("chr2Exclude must be NULL, or a character vector")
  }
  lock_filename <- getLockName()
  if (!file.exists(lock_filename)) {
    stop(
      "lock_filename must be an existing file.",
      "Please call addLockName() first!"
    )
  }
  seqnames.bedfile <-
    as.data.frame(read_tsv(
      bedgraph,
      comment = "#",
      col_names = FALSE, skip = 0,
      col_types = cols(
        X1 = col_factor(),
        X2 = "-", X3 = "-", X4 = "-"
      )
    ))[, 1]

  seqnames <- trim_seqnames(genome, chr2exclude)

  seqStyle <- seqlevelsStyle(genome)
  seqStyle.bed <- seqlevelsStyle(levels(seqnames.bedfile))

  if (any(seqStyle.bed != seqStyle)) {
    stop("seqlevelsStyle of genome is different from bedgraph file.")
  }
  seqnames <- sort(intersect(levels(seqnames.bedfile), seqnames))
  if (length(seqnames) < 1) {
    stop(paste(
      "there is no intersect seqname in",
      bedgraph, "and the genome"
    ))
  }

  ## save coverage file of each chr of a sample into a directory
  ## called "samplewise_RleCov"
  outdir <- file.path(outdir, "002.samplewise.RleCov", tag)
  if (!dir.exists(outdir)) {
    dir.create(outdir, recursive = TRUE)
  }
  outdir <- normalizePath(outdir, mustWork = TRUE)

  seqLen <- get_seqLen(genome, chr2exclude)

  summaryFunction <- function(seqname) {
    seqL <- seqLen[seqname]

    ## apply some trick here by using "FALSE"
    lines2read <- Rle(c(FALSE, seqnames.bedfile == seqname))
    true <- which(runValue(lines2read))
    skip <- runLength(lines2read)[true - 1]
    skip[1] <- skip[1] - 1
    nrow <- runLength(lines2read)[true]

    dat <- read_tsv(bedgraph,
      comment = "#",
      col_names = FALSE,
      skip = skip[1],
      n_max = nrow[1],
      col_types = cols(
        X1 = "-", X2 = "i",
        X3 = "i", X4 = "d"
      )
    )

    if (length(true) > 1) { ## this should never happen for bedgraph files
      cul_skip <- skip[1] + nrow[1]
      for (i in 2:length(true)) {
        cul_skip <- cul_skip + skip[i]
        lines <-
          read_tsv(bedgraph,
            comment = "#",
            col_names = FALSE,
            skip = cul_skip,
            n_max = nrow[i],
            col_types = cols(
              X1 = "-", X2 = "i",
              X3 = "i", X4 = "d"
            )
          )
        dat <- dplyr::bind_rows(dat, lines)
        cul_skip <- cul_skip + nrow[i]
      }
    }
    ## convert bedgraph 0-based index to 1-based index for GRanges
    dat <- dat %>% dplyr::mutate(X2 = X2 + 1)

    ## convert uncovered regions as gaps
    ## This step can be avoided when generate bedgraph with bedtools:
    ## bedtools genomecov -bga -split -ibam  <coordinate-sorted BAM file>
    gaps <-
      as_tibble(as.data.frame(gaps(IRanges(
        dplyr::pull(dat, 1),
        dplyr::pull(dat, 2)
      ),
      start = 1, end = seqL
      )))
    if (nrow(gaps) > 0) {
      gaps <- dplyr::bind_cols(gaps[, 1:2],
        V4 = rep(0, nrow(gaps))
      )
      colnames(gaps) <- colnames(dat)
      dat <- dplyr::bind_rows(dat, gaps)
    }
    rm(gaps)
    gc()

    dat <- dat %>%
      dplyr::arrange(X2) %>%
      dplyr::mutate(width = X3 - X2 + 1)
    seqname_cov <- Rle(dplyr::pull(dat, 3), dplyr::pull(dat, width))
    rm(dat)
    gc()

    filename <- file.path(
      outdir,
      paste(tag, seqname, "RleCov.RDS", sep = "_")
    )
    saveRDS(seqname_cov, file = filename)
    cov_file <- list(
      seqname = seqname_cov,
      filename = filename,
      depth = sum(as.double(runLength(seqname_cov) *
        runValue(seqname_cov)))
    )
    names(cov_file)[1] <- seqname
    cov_file
  }

  ## get coverage
  cvg <- future_lapply(seqnames, summaryFunction,
    future.stdout = NA,
    future.chunk.size = future.chunk.size
  )

  depth <- sum(sapply(cvg, function(.cov) {
    .cov[[3]]
  }))
  coverage_file <- sapply(cvg, function(.cov) {
    .cov[[2]]
  })

  rm(cvg)
  gc()

  filename_df <- data.frame(
    tag = tag,
    chr = seqnames,
    coverage_file = coverage_file
  )
  
  update_db <- function(lock_filename, sqlite_db, filename_df)
  {
      tryCatch(
          {
              file_lock <- flock::lock(lock_filename)
              db_conn <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
              res <- dbSendStatement(
                  db_conn,
                  paste0(
                      "UPDATE metadata SET depth = ",
                      depth, " WHERE tag = '",
                      tag, "';"
                  )
              )
              dbClearResult(res)
              ## remove existing record for the same "tag"
              res <- dbSendStatement(
                  db_conn,
                  paste0(
                      "DELETE FROM sample_coverage WHERE tag = '",
                      tag, "';"
                  )
              )
              dbClearResult(res)
              res <- dbSendStatement(
                  db_conn,
                  "INSERT INTO
                       sample_coverage (tag, chr, coverage_file)
                       VALUES (:tag, :chr, :coverage_file);",
                  filename_df
              )
              dbClearResult(res)
          },
          error = function(e) {
              print(paste(conditionMessage(e)))
          },
          finally = {
              dbDisconnect(db_conn)
              unlock(file_lock)
          }
      )
      db_conn <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
      metadata <- dbReadTable(db_conn, "metadata")
      dbDisconnect(db_conn)
      fail <- metadata$depth[metadata$tag == tag] == 0
      fail
  }
  fail <- TRUE
  while (fail) 
  {
      fail <- update_db(lock_filename, sqlite_db, filename_df)
  }
  filename_df
}

#' Calculate the total coverage
#'
#' For hugeData, coverage of samples in each condition is merged chromosome
#' by chromosome. For non-hugeData, per-chromosome coverage of all samples
#'
#' @param sqlite_db A path to the SQLite database for InPAS, i.e. the output of
#'   [setup_sqlitedb()].
#' @param chr.cov A list of Rle objects storing coverage per sample for a given
#'   chromosome/scaffold
#' @param seqname A character(1), the chromosome/scaffold name
#' @param metadata A data frame containing the metadata for a RNA-seq experiment,
#'  which can be extract from the SQLite database set up by [setup_sqlitedb()]
#' @param outdir A character(1) vector, a path with write permission for storing
#'   InPAS analysis results. If it doesn't exist, it will be created.
#' @param hugeData A logical(1), indicating whether it is huge data
#' @return A list containing pooled coverage data. For hugeData, coverage of
#'   samples under each condition is merged chromosome by chromosome.
#'   For non-hugeData, per-chromosome coverage of all samples are returned.
#'   \describe{
#'           \item{seqname}{chromosome/scaffold name}
#'             \describe{
#'                      \item{condition1}{condition name 1}
#'                      \item{condition1}{condition name 2}
#'                      }
#'   }
#' @keywords internal
#' @import S4Vectors RSQLite
#' @author Haibo Liu, Jianhong Ou

get_totalCov <- function(sqlite_db,
                         chr.cov,
                         seqname,
                         metadata,
                         outdir,
                         hugeData) {
  lock_filename <- getLockName()
  if (!file.exists(lock_filename)) {
    stop(
      "lock_filename must be an existing file.",
      "Please call addLockName() first!"
    )
  }
  if (hugeData) {
    cov <- list()
    condition_tag <- split(metadata$tag, metadata$condition)
    for (condition in names(condition_tag)) {
      cov[[seqname]][[condition]] <- Rle(values = 0, lengths = 1)
      # for (tag in condition_tag[[condition]]){
      #   cov[[seqname]][[condition]] <- cov[[seqname]][[condition]] +
      #     seqname_cov[[seqname]][[tag]]
      # }
      # Reduce() is faster
      cov[[seqname]][[condition]] <-
        Reduce(function(.x, .y) {
          .x + .y
        },
        chr.cov[[seqname]][condition_tag[[condition]]],
        init = cov[[seqname]][[condition]]
        )
    }
  } else {
    cov <- chr.cov
  }
  filename_total <- file.path(
    outdir,
    paste(seqname,
      "totalCov.RDS",
      sep = "_"
    )
  )

  ## chr_cov: chr_cov[[seqname]][[tag]]
  saveRDS(cov, file = filename_total)

  tryCatch(
    {
      file_lock <- flock::lock(lock_filename)
      db_conn <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
      res <- dbSendStatement(
        db_conn,
        paste0("DELETE FROM total_coverage
                                  WHERE chr = '", seqname, "';")
      )
      dbClearResult(res)

      ## insert into database the per-chromosome utr3_total_coverage
      res <- dbSendStatement(
        db_conn,
        paste0(
          "INSERT INTO
                           total_coverage (chr, coverage_file)
                           VALUES ('", seqname, "',", "'",
          filename_total, "');"
        )
      )
      dbClearResult(res)
    },
    error = function(e) {
      print(paste(conditionMessage(e)))
    },
    finally = {
      dbDisconnect(db_conn)
      unlock(file_lock)
    }
  )
  cov
}

#' extract long and short 3UTR region
#'
#' extract long and short 3UTR region
#'
#' @param .grs output of [search_CPs()]
#'
#' @return A [GenomicRanges::GRanges-class] object with short form and long 3' UTR forms
#' @keywords internal
#' @import GenomicRanges
#' @importFrom IRanges IRanges
#' @author Jianhong Ou

get_UTR3region <- function(.grs) {
  .ra <- c(
    ranges(.grs),
    IRanges(min(
      .grs$Predicted_Proximal_APA[1],
      .grs$Predicted_Distal_APA[1]
    ),
    max(
      .grs$Predicted_Proximal_APA[1],
      .grs$Predicted_Distal_APA[1]
    ),
    names = "CPsite"
    )
  )
  .ra <- disjoin(.ra)
  .ra <- .ra[width(.ra) > 1]
  if (as.character(strand(.grs))[1] == "+") {
    short <- .ra[start(.ra) < .grs$Predicted_Proximal_APA[1], ]
    long <- .ra[start(.ra) >= .grs$Predicted_Proximal_APA[1], ]
  } else {
    long <- .ra[start(.ra) < .grs$Predicted_Proximal_APA[1], ]
    short <- .ra[start(.ra) >= .grs$Predicted_Proximal_APA[1], ]
  }
  long <- reduce(long)
  short <- reduce(short)
  if (length(long) == 0) {
    gr <- GRanges(as.character(seqnames(.grs))[1], short,
      strand = as.character(strand(.grs))[1],
      source = rep("short", length(short))
    )
  } else {
    if (length(short) == 0) {
      gr <- GRanges(as.character(seqnames(.grs))[1], long,
        strand = as.character(strand(.grs))[1],
        source = rep("long", length(long))
      )
    } else {
      gr <- c(
        GRanges(as.character(seqnames(.grs))[1], long,
          strand = as.character(strand(.grs))[1],
          source = rep("long", length(long))
        ),
        GRanges(as.character(seqnames(.grs))[1], short,
          strand = as.character(strand(.grs))[1],
          source = rep("short", length(short))
        )
      )
    }
  }
  for (mc in colnames(mcols(.grs))) {
    if (mc != "exon") {
      mcols(gr)[, mc] <- mcols(.grs)[1, mc]
    }
  }
  gr
}

#' extract 3' UTR information from a [GenomicFeatures::TxDb-class] object
#'
#' extract 3' UTR information from a [GenomicFeatures::TxDb-class] object. The
#' 3'UTR is defined as the last 3'UTR fragment for each transcript and it will
#' be cut if there is any overlaps with other exons.
#'
#' @details A good practice is to perform read alignment using a reference
#'   genome from Ensembl/GenCode including only the primary assembly and build a
#'   TxDb and EnsDb using the GTF/GFF files downloaded from the same source as
#'   the reference genome, such as BioMart/Ensembl/GenCode. For instruction, see
#'   Vignette of the GenomicFeatures. The UCSC reference genomes and their
#'   annotation packages can be very cumbersome.
#'
#' @param sqlite_db A path to the SQLite database for InPAS, i.e. the output of
#'   [setup_sqlitedb()].
#' @param TxDb An object of [GenomicFeatures::TxDb-class]
#' @param edb An object of [ensembldb::EnsDb-class]
#' @param genome An object of [BSgenome::BSgenome-class]
#' @param chr2exclude A character vector, NA or NULL, specifying chromosomes or
#'   scaffolds to be excluded for InPAS analysis. `chrM` and alternative scaffolds
#'   representing different haplotypes should be excluded.
#' @param outdir A character(1) vector, a path with write permission for storing
#'   InPAS analysis results. If it doesn't exist, it will be created.
#' @param MAX_EXONS_GAP An integer(1) vector, maximal gap sizes between the last
#'   known CP sites to a nearest downstream exon. Default is 10 kb for mammalian
#'   genomes. For other species, user need to adjust this parameter.
#' @import GenomicRanges
#' @importFrom IRanges IRanges
#' @importFrom plyranges as_granges complement_ranges disjoin_ranges
#' reduce_ranges reduce_ranges_directed remove_names 
#' set_genome_info shift_downstream
#' @importFrom dplyr as_tibble mutate filter arrange bind_rows group_by
#'   left_join summarise n
#'
#' @author Jianhong Ou, Haibo Liu
#' @return An object of [GenomicRanges::GRangesList], containing GRanges for
#'   extracted 3' UTRs, and the corresponding last CDSs and next.exon.gap for
#'   each chromosome/scaffold. Chromosome
#'
#' @export
#'
#' @examples
#' library("EnsDb.Hsapiens.v86")
#' library("BSgenome.Hsapiens.UCSC.hg19")
#' library("GenomicFeatures")
#' ## set a sqlite database
#' bedgraphs <- system.file("extdata", c(
#'   "Baf3.extract.bedgraph",
#'   "UM15.extract.bedgraph"
#' ),
#' package = "InPAS"
#' )
#' tags <- c("Baf3", "UM15")
#' metadata <- data.frame(
#'   tag = tags,
#'   condition = c("Baf3", "UM15"),
#'   bedgraph_file = bedgraphs
#' )
#' outdir <- tempdir()
#'
#' write.table(metadata,
#'   file = file.path(outdir, "metadata.txt"),
#'   sep = "\t", quote = FALSE, row.names = FALSE
#' )
#' sqlite_db <- setup_sqlitedb(
#'   metadata =
#'     file.path(outdir, "metadata.txt"),
#'   outdir
#' )
#'
#' samplefile <- system.file("extdata",
#'   "hg19_knownGene_sample.sqlite",
#'   package = "GenomicFeatures"
#' )
#' TxDb <- loadDb(samplefile)
#' edb <- EnsDb.Hsapiens.v86
#' genome <- BSgenome.Hsapiens.UCSC.hg19
#' addInPASOutputDirectory(outdir)
#' seqnames <- seqnames(BSgenome.Hsapiens.UCSC.hg19)
#' chr2exclude <- c(
#'   "chrM", "chrMT",
#'   seqnames[grepl("_(hap\\d+|fix|alt)$",
#'     seqnames,
#'     perl = TRUE
#'   )]
#' )
#' utr3 <- extract_UTR3Anno(sqlite_db, TxDb, edb,
#'   genome = genome,
#'   chr2exclude = chr2exclude,
#'   outdir = tempdir(),
#'   MAX_EXONS_GAP = 10000L
#' )
extract_UTR3Anno <- function(sqlite_db,
                             TxDb = getInPASTxDb(),
                             edb = getInPASEnsDb(),
                             genome = getInPASGenome(),
                             outdir = getInPASOutputDirectory(),
                             chr2exclude = getChr2Exclude(),
                             MAX_EXONS_GAP = 10000L) {
  if (missing(sqlite_db) || length(sqlite_db) != 1 ||
    !file.exists(sqlite_db)) {
    stop("sqlite_db, a path to the SQLite database is required!")
  }
  if (!is(TxDb, "TxDb")) {
    stop("TxDb is required and must be an object of GenomicFeatures::TxDb-class!")
  }
  if (!is(genome, "BSgenome")) {
    stop("genome must be an object of BSgenome")
  }
  if (!is(edb, "EnsDb")) {
    stop("edb is required and must be an object of ensembldb::EnsDb-class!")
  }
  if (!is.null(chr2exclude) && !is.character(chr2exclude)) {
    stop("chr2Exclude must be NULL or a character vector")
  }
  if (!is.character(outdir) || length(outdir) != 1) {
    stop("outdir is required!")
  }
  if (!dir.exists(outdir)) {
    dir.create(outdir, recursive = TRUE)
  }
  if (!is.integer(MAX_EXONS_GAP) || MAX_EXONS_GAP < 1) {
    stop("MAX_EXONS_GAP must be an positive integer")
  }

  tx <- parse_TxDb(sqlite_db,
    TxDb, edb,
    genome = genome,
    chr2exclude = chr2exclude,
    outdir = outdir
  )
  ## extract utr3 sharing same start positions from same gene
  if (any(is.na(tx$gene)) || any(tx$gene == "")) {
    stop(
      "unexpected things happend at checking gene IDs",
      "\ngene should not contain NA or empty strings"
    )
  }

  # mono-exon ncRNA is not used for InPAS analysis
  utr3 <- unique(tx[tx$feature!="ncRNA"&
              tx$feature %in% c("utr3", "lastutr3")])
  utr3.last <- utr3[utr3$feature == "lastutr3"]

  exons.not.utr3.last <- unique(tx[tx$feature != "lastutr3"])

  utr3.last.block <- utr3.last

  ## reduce GRanges to cover from min_start to max_end
  # getRange <- function(gr, f) {
  #   gr <- gr %>%
  #     plyranges::group_by(seqnames, !!!syms(f), strand) %>%
  #     plyranges::summarise(start = min(start), end = max(end)) %>%
  #     plyranges::as_granges()
  #   gr
  # }

  ## mask 5UTR-CDS and any other region from last 3UTR
  # non.utr3 <- getRange(exons.not.utr3.last, "transcript") %>%
  #    plyranges::filter(width < 1000) ##why 1000? because some gene is unbelievable huge.
  # non.utr3 <- reduce(c(non.utr3, reduce(exons.not.utr3.last)))
  non.utr3 <- reduce(exons.not.utr3.last)

  removeMask <- function(gr, mask) {
    ol.mask <- findOverlaps(mask, gr,
      ignore.strand = TRUE, minoverlap = 1
    )
    if (length(ol.mask) > 0) {
      gr.ol <- gr[subjectHits(ol.mask)]
      gr.nol <- gr[-unique(subjectHits(ol.mask))]
      mask.ol <- mask[queryHits(ol.mask)]
      gr.ol$rel <- "ol"
      gr.ol$rel[end(mask.ol) >= start(gr.ol) &
        start(mask.ol) <= start(gr.ol)] <- "left"
      gr.ol$rel[end(mask.ol) >= end(gr.ol) &
        start(mask.ol) <= end(gr.ol)] <- "right"
      # remove covered gr by mask
      gr.ol$rel[end(mask.ol) >= end(gr.ol) &
        start(mask.ol) <= start(gr.ol)] <- "cover"
      # Haibo add "-1" and " +1"
      end(gr.ol)[gr.ol$rel == "right"] <-
        start(mask.ol)[gr.ol$rel == "right"] - 1
      start(gr.ol)[gr.ol$rel == "left"] <-
        end(mask.ol)[gr.ol$rel == "left"] + 1

      # mask in between gr
      start(gr.ol)[gr.ol$rel == "ol" &
        as.character(strand(gr.ol)) == "+"] <-
        end(mask.ol)[gr.ol$rel == "ol" &
          as.character(strand(gr.ol)) == "+"] + 1
      end(gr.ol)[gr.ol$rel == "ol" &
        as.character(strand(gr.ol)) == "-"] <-
        start(mask.ol)[gr.ol$rel == "ol" &
          as.character(strand(gr.ol)) == "-"] - 1
      gr.ol <- gr.ol[gr.ol$rel != "cover"]
      gr.ol$rel <- NULL

      gr.ol <- unique(gr.ol)
      exons.dup <- gr.ol[gr.ol$exon %in%
        gr.ol$exon[duplicated(gr.ol$exon)]]
      if (length(exons.dup) > 0) {
        exons.nd <- gr.ol[!gr.ol$exon %in%
          gr.ol$exon[duplicated(gr.ol$exon)]]
        exons.dup <- split(exons.dup, exons.dup$exon)
        exons.dup <- lapply(exons.dup, function(.ele) {
          ## get disjoined parts
          .disj <- disjoin(.ele)
          .cnt <- countOverlaps(.disj, .ele)
          .disj <- .disj[order(-.cnt)]
          ## get the last 3' UTR segment not masked by any non-utr frags
          .disj <- .disj[1]
          mcols(.disj) <- mcols(.ele[1])
          .disj
        })
        exons.dup <- unlist(GRangesList(exons.dup))
        names(exons.dup) <- NULL
        if (length(exons.nd) > 0) {
          gr.ol <- c(exons.dup, exons.nd)
        } else {
          gr.ol <- exons.dup
        }
      }
      gr <- c(gr.ol, gr.nol)
    } else {
      gr
    }
  }
  ####################################################################
  #               MASK ONE by non-UTR exonic regions                 #
  ####################################################################

  utr3.last <- removeMask(utr3.last, non.utr3)
  utr3.last <- unique(utr3.last)
  ####################################################################
  #           MASK TWO by 3' UTR on the opposite strand              #
  ####################################################################
  utr3.reverse.strand <- utr3.last
  strand(utr3.reverse.strand) <- ifelse(strand(utr3.reverse.strand) == "+", "-", "+")
  utr3.reverse.strand <- plyranges::reduce_ranges_directed(utr3.reverse.strand)

  ol.utr3.rev <- findOverlaps(utr3.last, utr3.reverse.strand,
    ignore.strand = FALSE, minoverlap = 1
  )
  if (length(ol.utr3.rev) > 0) {
    utr3.last.ol <- utr3.last[queryHits(ol.utr3.rev)]
    utr3.last.nol <- utr3.last[-unique(queryHits(ol.utr3.rev))]
    utr3.rev.ol <- utr3.reverse.strand[subjectHits(ol.utr3.rev)]
    strand <- as.character(strand(utr3.last.ol)) == "+"
    idx <- (start(utr3.last.ol) < start(utr3.rev.ol) & strand) |
      (end(utr3.last.ol) > end(utr3.rev.ol) & !strand)
    utr3.last.ol <- utr3.last.ol[idx]
    utr3.rev.ol <- utr3.rev.ol[idx]
    strand <- strand[idx]
    end(utr3.last.ol)[strand] <- start(utr3.rev.ol)[strand] - 1
    start(utr3.last.ol)[!strand] <- end(utr3.rev.ol)[!strand] + 1
    utr3.last <- c(utr3.last.nol, utr3.last.ol[width(utr3.last.ol) > 1])
  }

  ## keep the last 3' utr for each transcripts
  utr3.last$feature <- rep("utr3", length(utr3.last))
  utr3.last <- assign_feature(utr3.last, feature_alt = "lastutr3")
  utr3.last <- utr3.last[utr3.last$feature == "lastutr3" &
                           width(utr3.last)>1] %>%
    unique()

  #####################################################################
  #      Collapsing last UTRs of the same start/end coordinates       #
  #                on the +/- strand, respectively, per gene          #
  #####################################################################

  collapse_same_start_utr <- function(gr) {
    utr3.last <- gr
    utr3.last <- unique(utr3.last)
    mcols(utr3.last)$start.utr3.last <- paste(as.character(seqnames(gr)),
                                              start(gr),
                                              gr$gene, sep = ":")
    mcols(utr3.last)$end.utr3.last   <- paste(as.character(seqnames(gr)),
                                              end(gr),
                                              gr$gene, sep = ":")

    start.dup <- with(
      utr3.last,
      unique(start.utr3.last[duplicated(start.utr3.last) &
        as.character(strand(utr3.last)) == "+"])
    )
    end.dup <- with(
      utr3.last,
      unique(end.utr3.last[duplicated(end.utr3.last) &
        as.character(strand(utr3.last)) == "-"])
    )
    utr3.last.dup <- utr3.last[utr3.last$start.utr3.last %in% start.dup |
                                 utr3.last$end.utr3.last %in% end.dup] 

    if (length(utr3.last.dup) > 0) {
      utr3.last.nd <- utr3.last[!(utr3.last$start.utr3.last %in% start.dup |
                                  utr3.last$end.utr3.last %in% end.dup)]
      utr3.last.nd$start.utr3.last <- NULL
      utr3.last.nd$end.utr3.last <- NULL
      utr3.last.nd <- utr3.last.nd %>%
        dplyr::mutate(annotatedProximalCP = "unknown")

      utr3.last.dup$dup.group <- ifelse(strand(utr3.last.dup) == "+",
                                        utr3.last.dup$start.utr3.last,
                                        utr3.last.dup$end.utr3.last)
      utr3.last.dup$start.utr3.last <- NULL
      utr3.last.dup$end.utr3.last <- NULL
      
      utr3.last.dup <- utr3.last.dup %>%
        data.frame() %>%
        dplyr::as_tibble() %>%
        dplyr::arrange(dup.group, desc(width))

      utr3_end <- ifelse(utr3.last.dup$strand == "+",
        utr3.last.dup$end, utr3.last.dup$start
      )
      utr3_end <- split(utr3_end, utr3.last.dup$dup.group)
      annotation <- lapply(utr3_end, function(.x) {
        label <- paste("proximalCP",
          paste(.x[-1], collapse = "_"),
          sep = "_"
        )
      })
      annotation <- do.call("c", annotation)
      utr3.last.dup <- utr3.last.dup %>%
        dplyr::filter(!duplicated(dup.group)) %>%
        dplyr::mutate(
          annotatedProximalCP =
            annotation[dup.group]
        ) %>%
        dplyr::select(-dup.group) %>%
        as_granges()

      utr3.last <- c(utr3.last.nd, utr3.last.dup)
    } else {
      utr3.last <- gr 
      utr3.last$annotatedProximalCP <- rep('unknown', length(gr))
    }
    utr3.last
  }
  utr3.last <- collapse_same_start_utr(utr3.last)

  ######################################################################
  #               Mark truncated 3UTR (3821 truncated utr3)            #
  ######################################################################

  utr3.last$truncated <- rep(FALSE, length(utr3.last))
  utr3.last$truncated[as.character(strand(utr3.last)) == "+" &
    end(utr3.last) <
      end(utr3.last.block[match(
        utr3.last$exon,
        utr3.last.block$exon
      )])] <- TRUE
  utr3.last$truncated[as.character(strand(utr3.last)) == "-" &
    start(utr3.last) >
      start(utr3.last.block[match(
        utr3.last$exon,
        utr3.last.block$exon
      )])] <- TRUE

  #####################################################################
  #            split the overlapping UTRs of the same genes           #
  #####################################################################
  utr3.last_reduced <- reduce(utr3.last, ignore.strand = FALSE)
  count_overlap <- countOverlaps(utr3.last_reduced, utr3.last)

  if (sum(count_overlap > 1) > 0) {
    utr3.last_reduced <- utr3.last_reduced[count_overlap > 1]

    utr3.last_ol <- GenomicRanges::findOverlaps(utr3.last_reduced,
      utr3.last,
      ignore.strand = TRUE, minoverlap = 1
    )
    # non-overlapping utr3
    utr3.last_isolated <- utr3.last[-unique(subjectHits(utr3.last_ol))]

    # split overlapping utr3.last of the same genes into
    # compatible segments for coverage calculation
    # !!! overlapping utr3.last of different genes are removed
    uniq_pairs <- data.frame(utr3.last_ol)

    uniq_pairs <- split(uniq_pairs[, 2], uniq_pairs[1])
    utr3.last_overlap_split <- lapply(uniq_pairs, function(.x) {
      gr <- utr3.last[.x]
      if (length(unique(gr$gene)) > 1) {
        gr <- NULL
      } else {
        gr_reduced <- reduce(gr)

        strand <- strand(gr_reduced)
        feature <- gr$feature[1]
        gene <- gr$gene[1]
        symbol <- gr$symbol[1]

        if (as.character(strand(gr_reduced)) == "+") {
          gr <- gr[order(start(gr))]
          st <- start(gr)
          segment_start <- st
          segment_end <- c(st[-1] - 1, end(gr_reduced))
          end_sort <- gr[order(-end(gr))]
          transcript <- gr$transcript
          exon <- gr$exon
          exon_rank <- gr$exon_rank
          truncated <- c(
            rep(TRUE, length(st) - 1),
            end_sort$truncated[1]
          )
          CP <- grep("^proximalCP_", gr$annotatedProximalCP,
            perl = TRUE, value = TRUE
          )
          if (length(CP) >= 1) {
            CP <- gsub("proximalCP_", "", paste(CP, collapse = "_"))
            CP <- paste(CP, paste(end(end_sort)[-1], collapse = "_"),
              sep = "_"
            )
          } else {
            CP <- paste("proximalCP", paste(end(end_sort)[-1],
              collapse = "_"
            ), sep = "_")
          }
        } else {
          gr <- gr[order(end(gr))]
          end <- end(gr)
          segment_end <- end
          segment_start <- c(start(gr_reduced), end[-length(end)] + 1)
          transcript <- gr$transcript
          exon <- gr$exon
          exon_rank <- gr$exon_rank
          start_sort <- gr[order(start(gr))]
          truncated <- c(
            start_sort$truncated[1],
            rep(TRUE, length(end) - 1)
          )
          CP <- grep("^proximalCP_", gr$annotatedProximalCP,
            perl = TRUE, value = TRUE
          )
          if (length(CP) >= 1) {
            CP <- gsub("proximalCP_", "", paste(CP, collapse = "_"))
            CP <- paste(CP, paste(start(start_sort)[-1],
              collapse = "_"
            ), sep = "_")
          } else {
            CP <- paste("proximalCP", paste(start(start_sort)[-1],
              collapse = "_"
            ), sep = "_")
          }
        }
        gr <- GRanges(data.frame(
          seqnames = seqnames(gr_reduced),
          start = segment_start,
          end = segment_end,
          strand = strand(gr_reduced)
        ),
        exon_rank = exon_rank,
        transcript = transcript,
        feature = feature,
        gene = gene,
        exon = exon,
        symbol = symbol,
        annotatedProximalCP = CP,
        truncated = truncated
        )
      }
      gr
    })
    rmv_idx <- do.call("c", lapply(utr3.last_overlap_split, is.null))
    utr3.last_overlap_split <-
      unlist(GRangesList(utr3.last_overlap_split[!rmv_idx]))
    utr3.last <- c(utr3.last_isolated, utr3.last_overlap_split)
  }

  ###################################################################
  #    reprocess 3' UTRs with the same start                        #
  ###################################################################
  utr3.last.sameStart <- utr3.last[grepl(
    "proximalCP",
    utr3.last$annotatedProximalCP
  )]
  utr3.last.unknown <- utr3.last[utr3.last$annotatedProximalCP == "unknown"]
  utr3.last.sameStart.CP <-
    strsplit(gsub(
      "proximalCP_", "",
      utr3.last.sameStart$annotatedProximalCP
    ), "_")
  utr3.last.sameStart.Start <- start(utr3.last.sameStart)
  utr3.last.sameStart.End <- end(utr3.last.sameStart)
  utr3.last.sameStart$annotatedProximalCP <- mapply(function(cp, st, en) {
    cp <- as.integer(cp)
    cp <- cp[cp > st & cp < en]
    if (length(cp) == 0) {
      return("unknown")
    } else {
      return(paste("proximalCP", paste(cp, collapse = "_"), sep = "_"))
    }
  }, utr3.last.sameStart.CP,
  utr3.last.sameStart.Start,
  utr3.last.sameStart.End,
  SIMPLIFY = TRUE
  )

  utr3.clean <- c(utr3.last.unknown, utr3.last.sameStart)
  utr3.clean <-
    utr3.clean[order(
      as.character(seqnames(utr3.clean)),
      start(utr3.clean)
    )]

  ####################################################################
  #       Determine the gap between the untrucated 3' UTRs end       #
  #                 and the nearest downstream exon                  #
  ####################################################################
  if (is(genome, "BSgenome")) {
    genome.info <- as.data.frame(seqinfo(genome))[, 1:2]
  } else {
    genome.info <- as.data.frame(seqinfo(TxDb))[, 1:2]
  }
  genome.info <- genome.info[!rownames(genome.info) %in% chr2exclude, ]

  gaps <- tx %>%
    plyranges::reduce_ranges() %>%
    plyranges::set_genome_info(
      seqnames = rownames(genome.info),
      seqlengths = genome.info$seqlengths,
      is_circular = genome.info$isCircular
    ) %>% plyranges::complement_ranges()
  
  utr3.clean.intact <- utr3.clean[!utr3.clean$truncated]
  utr3.clean.ext1 <- utr3.clean.intact %>% 
    plyranges::shift_downstream(shift = 1L)
  
  ol <- findOverlaps(utr3.clean.ext1, gaps, ignore.strand = TRUE)
  ol.utr3.clean <- utr3.clean.intact[queryHits(ol)]

  next.exons.gap <- gaps[subjectHits(ol)]
  strand(next.exons.gap) <- strand(ol.utr3.clean)
  mcols(next.exons.gap) <- mcols(ol.utr3.clean)

  wid <- width(next.exons.gap) > MAX_EXONS_GAP
  width(next.exons.gap)[wid & as.character(strand(next.exons.gap)) == "+"] <-
    MAX_EXONS_GAP
  start(next.exons.gap)[wid & as.character(strand(next.exons.gap)) == "-"] <-
    end(next.exons.gap)[
      wid & as.character(strand(next.exons.gap)) == "-"
    ] - MAX_EXONS_GAP +1
  next.exons.gap$feature <- rep('next.exon.gap', length(next.exons.gap))
  utr3.clean$feature <- rep("utr3", length(utr3.clean))

  ###################################################################
  #             Get last CDS for coverage compensation              #
  ###################################################################
  if ("lastCDS" %in% tx$feature) {
    CDS.last <- tx[tx$feature=="lastCDS"]
    CDS.last <- CDS.last[CDS.last$transcript %in% utr3.clean$transcript]
    CDS.last <- CDS.last[match(
      utr3.clean$transcript,
      CDS.last$transcript
    )]
    mcols(CDS.last) <- mcols(utr3.clean)
    CDS.last$feature <- rep("CDS", length(CDS.last))

    utr3.fixed <- c(utr3.clean, next.exons.gap, CDS.last)
    names(utr3.fixed) <-
      paste(utr3.fixed$exon, utr3.fixed$symbol,
        utr3.fixed$feature,
        sep = "|"
      )
    ## unlist the column "annotatedProximalCP"
    utr3.fixed$annotatedProximalCP <- unlist(utr3.fixed$annotatedProximalCP)
    utr3.fixed <- split(utr3.fixed, seqnames(utr3.fixed), drop = TRUE)
  } else {
    utr3.fixed <- c(utr3.clean, next.exons.gap)
    utr3.fixed$annotatedProximalCP <- unlist(utr3.fixed$annotatedProximalCP)
    names(utr3.fixed) <-
        paste(utr3.fixed$exon, utr3.fixed$symbol,
              utr3.fixed$feature,
              sep = "|"
        )
    utr3.fixed <- split(utr3.fixed, seqnames(utr3.fixed), drop = TRUE)
  }
  
  utrs_file <- file.path(outdir, "01.3UTR.annotation.RDS")
  saveRDS(utr3.fixed, file = utrs_file)
  filename_df <- data.frame(type = "utr3", anno_file = utrs_file)
  db_conn <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
  res <- dbSendStatement(
    db_conn,
    paste0(
      "DELETE FROM genome_anno ",
      "WHERE type = 'utr3';"
    )
  )
  dbClearResult(res)
  res <- dbSendStatement(
    db_conn,
    "INSERT INTO
                          genome_anno (type, anno_file)
                          VALUES (:type, :anno_file);",
    filename_df
  )
  dbClearResult(res)
  dbDisconnect(db_conn)
  utr3.fixed
}

#' Create an SQLite database for storing metadata and paths to coverage files
#'
#' Create an SQLite database with five tables, "metadata","sample_coverage",
#'   "chromosome_coverage", "CPsites", and "utr3_coverage", for storing metadata
#'   (sample tag, condition, paths to bedgraph files, and sample total read
#'   coverage), sample-then-chromosome-oriented coverage files (sample tag,
#'   chromosome, paths to bedgraph files for each chromosome), and paths to
#'   chromosome-then-sample-oriented coverage files (chromosome, paths to
#'   bedgraph files for each chromosome), CP sites on each chromosome (chromosome,
#'   paths to cpsite files), read coverage for 3' UTR and last CDS regions on each
#'   chromosome (chromosome, paths to utr3 coverage file), respectively
#'
#' @param metadata A path to a tab-delimited file, with columns "tag", "condition",
#'   and "bedgraph_file", storing a unique name tag for each sample, a condition
#'   name for each sample, such as "treatment" and "control", and a path to the
#'   bedgraph file for each sample
#' @param outdir A character(1) vector, a path with write permission for storing
#'   InPAS analysis results. If it doesn't exist, it will be created.
#' @import RSQLite
#' @importFrom utils read.delim
#' @export
#' @author Haibo Liu
#' @return A character(1) vector, the path to the SQLite database
#' @examples
#' if (interactive()) {
#'   bedgraphs <- system.file("extdata", c(
#'     "Baf3.extract.bedgraph",
#'     "UM15.extract.bedgraph"
#'   ),
#'   package = "InPAS"
#'   )
#'   tags <- c("Baf3", "UM15")
#'   metadata <- data.frame(
#'     tag = tags,
#'     condition = c("Baf3", "UM15"),
#'     bedgraph_file = bedgraphs
#'   )
#'   outdir <- tempdir()
#'   write.table(metadata,
#'     file = file.path(outdir, "metadata.txt"),
#'     sep = "\t", quote = FALSE, row.names = FALSE
#'   )
#'   sqlite_db <- setup_sqlitedb(
#'     metadata =
#'       file.path(outdir, "metadata.txt"),
#'     outdir
#'   )
#' }
setup_sqlitedb <- function(metadata,
                           outdir = getInPASOutputDirectory()) {
  if (missing(metadata) || !file.exists(metadata)) {
    stop(
      "A path to a tab-delimited file, with columns:",
      "tag, condition, and bedgraph_file, is required"
    )
  }
  if (!is.character(outdir) || length(outdir) != 1) {
    stop(
      "A path with write permission for storing",
      "the SQLite database is required"
    )
  }
  if (!dir.exists(outdir)) {
    dir.create(outdir, recursive = TRUE)
  }
  outdir <- normalizePath(outdir)
  sqlite_db <- file.path(outdir, "InPAS_hugeData.sqlite")
  db_conn <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)

  ## Drop existing tables
  tables <- c(
    "metadata", "genome_anno",
    "chromosome_coverage",
    "sample_coverage", "total_coverage",
    "utr3_total_coverage", "CPsites",
    "utr3cds_coverage"
  )
  for (table in tables) {
    res <- dbSendStatement(db_conn, paste("DROP TABLE IF EXISTS ", table, ";"))
    dbClearResult(res)
  }

  ## create table: metadata
  res <- dbSendStatement(db_conn, "CREATE TABLE
                       metadata (tag TEXT,
                       condition TEXT,
                       bedgraph_file TEXT,
                       depth INTEGER,
                       PRIMARY KEY (tag));")
  dbClearResult(res)

  metadata <- read.delim(metadata, header = TRUE)
  required_cols <- c("tag", "condition", "bedgraph_file")
  if (any(!required_cols %in% colnames(metadata))) {
    stop(
      "Your metadata file does NOT contain the essential columns: ",
      "tag, condition, bedgraph_file"
    )
  }
  metadata$depth <- 0
  dbWriteTable(db_conn, "metadata", metadata,
    overwrite = TRUE, row.names = FALSE
  )
  ## create table: genome_anno
  res <- dbSendStatement(db_conn, "CREATE TABLE
                genome_anno (
                type TEXT,
                anno_file TEXT,
                PRIMARY KEY(type));")
  dbClearResult(res)

  ## create table: sample_coverage
  res <- dbSendStatement(db_conn, "CREATE TABLE
                sample_coverage (
                tag TEXT,
                chr TEXT,
                coverage_file TEXT,
                PRIMARY KEY(tag, chr),
                FOREIGN KEY(tag) REFERENCES metadata(tag));")
  dbClearResult(res)

  ## create table: chromosome_coverage
  res <- dbSendStatement(db_conn, "CREATE TABLE
                chromosome_coverage (
                chr TEXT,
                coverage_file TEXT,
                PRIMARY KEY(chr),
                FOREIGN KEY(chr) REFERENCES sample_coverage(chr));")
  dbClearResult(res)

  ## create table: total_coverage for CP site search
  res <- dbSendStatement(db_conn, "CREATE TABLE
                total_coverage (
                chr TEXT,
                coverage_file TEXT,
                PRIMARY KEY (chr),
                FOREIGN KEY(chr) REFERENCES sample_coverage(chr));")
  dbClearResult(res)

  ## create table: utr3_total_coverage for CP site search
  res <- dbSendStatement(db_conn, "CREATE TABLE
                utr3_total_coverage (
                chr TEXT,
                coverage_file TEXT,
                PRIMARY KEY(chr),
                FOREIGN KEY(chr) REFERENCES sample_coverage(chr));")
  dbClearResult(res)

  ## create table: CPsites
  res <- dbSendStatement(db_conn, "CREATE TABLE
                CPsites (
                chr TEXT,
                cpsites_file TEXT,
                PRIMARY KEY(chr),
                FOREIGN KEY(chr) REFERENCES sample_coverage(chr));")
  dbClearResult(res)

  ## create table utr3cds_coverage
  res <- dbSendStatement(db_conn, "CREATE TABLE
                utr3cds_coverage (
                chr TEXT,
                coverage_file TEXT,
                PRIMARY KEY (chr),
                FOREIGN KEY(chr) REFERENCES sample_coverage(chr));")
  dbClearResult(res)

  if (!any(dbListTables(db_conn) %in% tables)) {
    stop("The SQLite database has NOT been sep up correctly!")
  }
  dbDisconnect(db_conn)
  options(InPAS.sqliteDb = sqlite_db)
  sqlite_db
}

#' Get the path to an SQLite database
#'
#' @return A path to an SQLite database
#' @export
getInPASSQLiteDb <- function() {
  sqlite_db <- options()$InPAS.sqliteDb
  if (!file.exists(sqlite_db)) {
    stop(
      "SQLite database doesn't exist!\n",
      "Please call setup_sqlitedb() first"
    )
  }
  sqlite_db
}

#' Identify chromosomes/scaffolds for CP site discovery
#'
#' Identify chromosomes/scaffolds which have both coverage and annotated
#' 3' utr3 for CP site discovery
#'
#' @param utr3 An object of [GenomicRanges::GRangesList-class]. An output of
#'   [extract_UTR3Anno()].
#' @param sqlite_db A path to the SQLite database for InPAS, i.e. the output of
#'   [setup_sqlitedb()].
#'
#' @return A vector of characters, containing names of chromosomes/scaffolds
#'   for CP site discovery
#' @export
#' @examples
#' library(BSgenome.Mmusculus.UCSC.mm10)
#' genome <- BSgenome.Mmusculus.UCSC.mm10
#' data(utr3.mm10)
#' utr3 <- split(utr3.mm10, seqnames(utr3.mm10), drop = TRUE)
#' bedgraphs <- system.file("extdata", c(
#'   "Baf3.extract.bedgraph",
#'   "UM15.extract.bedgraph"
#' ),
#' package = "InPAS"
#' )
#' tags <- c("Baf3", "UM15")
#' metadata <- data.frame(
#'   tag = tags,
#'   condition = c("Baf3", "UM15"),
#'   bedgraph_file = bedgraphs
#' )
#' outdir <- tempdir()
#' write.table(metadata,
#'   file = file.path(outdir, "metadata.txt"),
#'   sep = "\t", quote = FALSE, row.names = FALSE
#' )
#'
#' sqlite_db <- setup_sqlitedb(
#'   metadata = file.path(
#'     outdir,
#'     "metadata.txt"
#'   ),
#'   outdir
#' )
#' addLockName(filename = tempfile())
#' coverage <- list()
#' for (i in seq_along(bedgraphs)) {
#'       coverage[[tags[i]]] <- get_ssRleCov(
#'       bedgraph = bedgraphs[i],
#'       tag = tags[i],
#'       genome = genome,
#'       sqlite_db = sqlite_db,
#'       outdir = outdir,
#'       chr2exclude = "chrM"
#'     )
#' }
#' get_chromosomes(utr3, sqlite_db)
get_chromosomes <- function(utr3, sqlite_db) {
  if (missing(utr3) || !is(utr3, "GRangesList")) {
    stop("utr3 must be a GRangesList object")
  }
  if (missing(sqlite_db) || !file.exists(sqlite_db)) {
    stop("sqlite_db must be an exisiting path to SQLite database")
  }

  db_conn <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
  covered_chrs <- unique(dbReadTable(db_conn, "sample_coverage")$chr)
  depth <- dbReadTable(db_conn, "metadata")$depth
  dbDisconnect(db_conn)
  
  if (any(depth == 0)) {
      stop("Some bedgraph files were not correctly read in!\n",
           "Please call get_ssRleCov() again.")
  }

  ## only consider chromosomes with utr3 annotation and coverage
  chromosomes <- intersect(names(utr3), covered_chrs)
  chromosomes
}

#' Calculate mean squared errors (MSE)
#'
#' Calculate mean squared errors (MSE) for each searched site which is assumed
#' bisection site (i.e. potential CP site).
#'
#' @param .ele A numeric vector, storing 3' UTR coverage for a give sample or
#'   collapsed 3' UTR coverage for a given condition
#' @param search_point_START An integer, specifying the start position to
#'   calculate MSE
#' @param search_point_END An integer, specifying end position to calculate MSE
#'
#' @return a vector of numeric, containing mean squared errors for each searched
#'   site when which is assumed as a bisection site (i.e. potential CP site).
#' @keywords internal
#' @author Jianhong Ou, Haibo Liu

calculate_mse <- function(.ele,
                          search_point_START,
                          search_point_END) {
  .l <- length(.ele)
  ## averaged coverage as abundance
  short_UTR_abun <- cumsum(.ele) / (1:.l)

  ## cumulative coverage from end to start
  long_UTR_abun <- cumsum(rev(.ele)) / (1:.l)

  ## reverse the cumulative coverage from end to start so it
  ## the matches the indexing order of "short_UTR_abun"
  long_UTR_abun <- rev(long_UTR_abun)

  short_UTR_abun <- short_UTR_abun[-length(short_UTR_abun)]
  long_UTR_abun <- long_UTR_abun[-1]
  short_UTR_abun <- short_UTR_abun - long_UTR_abun
  short_UTR_abun <- ifelse(short_UTR_abun < 0, 0, short_UTR_abun)

  ## initiate a vector of length set
  cov_diff <- numeric(length(short_UTR_abun)) ## initiate with 0s
  ss <- max(search_point_START, 1)
  se <- min(search_point_END, .l)
  
  for (i in ss:se) {
    cov_diff_tmp <- .ele
    cov_diff_tmp <- cov_diff_tmp - long_UTR_abun[i]
    cov_diff_tmp[1:i] <- cov_diff_tmp[1:i] - short_UTR_abun[i]
    cov_diff[i] <- mean(cov_diff_tmp^2)
  }
  cov_diff
}

#' do analysis for single group samples
#'
#' do analysis for single group samples by ANOVA test
#'
#' @param UTR3eset An object of [UTR3eSet-class], output of [get_UTR3eSet()]
#' @return a matrix of test results
#' @import limma
#' @keywords internal
#' @author Jianhong Ou
#' @examples
#' path <- system.file("extdata", package = "InPAS")
#' load(file.path(path, "eset.MAQC.rda"))
#' res <- InPAS:::run_singleGroupAnalysis(eset)
run_singleGroupAnalysis <- function(UTR3eset) {
  data.long <- UTR3eset$long
  data.short <- UTR3eset$short
  data <- log2(cbind(data.long, data.short) + .Machine$double.xmin)
  treatments <- cbind(
    long = c(rep(c(1, 0), c(ncol(data.long), ncol(data.short)))),
    short = c(rep(c(0, 1), c(ncol(data.long), ncol(data.short))))
  )
  design <- model.matrix(~ -1 + treatments)
  colnames(design) <- c("long", "short")
  fit <- lmFit(data, design)
  contrast.matrix <- makeContrasts(
    contrasts = "long-short",
    levels = design
  )
  fit <- contrasts.fit(fit, contrast.matrix)
  fit <- eBayes(fit)
  data <- topTable(fit, number = nrow(fit), sort.by = "none")
  P.Value <- data$P.Value
  adj.P.Val <- p.adjust(P.Value, method = "BH")
  long <- rowMeans(data.long)
  short <- rowMeans(data.short)
  PDUI <- long / c(long + short)
  cbind(
    short.mean = short,
    long.mean = long,
    PDUI, P.Value, adj.P.Val
  )
}

#' polish the searching results of CP sites
#'
#' remove the multiple positions of CP sites for the same 3' UTRs and only keep
#' the best CP sites for proximal and distal.
#'
#' @param CPs output of [search_proximalCPs()] or [adjust_proximalCPs()]
#' @param output.all A logical(1), indicating whether to output entries with only 
#'   single CP site for a 3' UTR.
#' @param DIST2END An integer(1) vector, specifying minimal length 
#' difference between proximal and distal APA sites which should be met to be 
#' considered for outputted if *output.all* is set to TRUE. Default is 200 bp.
#'
#' @return a data.frame with columns: "fit_value", "Predicted_Proximal_APA",
#'   "Predicted_Distal_APA", "utr3start", "utr3end", "Predicted_Distal_APA_type"
#' @keywords internal
#' @seealso [adjust_proximalCPs()], [adjust_proximalCPsByPWM()],
#'   [adjust_proximalCPsByNBC()], [get_PAscore2()]
#' @author Jianhong Ou

polish_CPs <- function(CPs, output.all, DIST2END = 200) {
  dCPs <- CPs$dCPs
  coors <- lapply(
    CPs$chr.cov.merge,
    function(.ele) {
      as.numeric(gsub(".*_SEP_", "", rownames(.ele)))
    }
  )
  flag <- CPs$flag

  ## make a copy of fit_value and predicted_proximal_APA for visualization if
  ## necessary
  CPs$Predicted_Proximal_APA <- mapply(function(.ele, .id) {
    ifelse(is.na(.id[1]) | is.null(.id[1]), NA, .ele[.id[1]])
  }, coors, CPs$Predicted_Proximal_APA, SIMPLIFY = FALSE)
  
  dCPs$min_fit_value <- unlist(CPs$fit_value_min)
  CPs$Predicted_Proximal_APA[sapply(
    CPs$Predicted_Proximal_APA,
    length
  ) == 0] <- NA
  dCPs$Predicted_Proximal_APA <- 
      unlist(ifelse(is.na(dCPs$Predicted_Proximal_APA),
             unlist(CPs$Predicted_Proximal_APA),
             dCPs$Predicted_Proximal_APA))
  dCPs$Predicted_Proximal_APA_Type <- 
      ifelse(!is.na(dCPs$Predicted_Proximal_APA) & 
                 is.na(dCPs$Predicted_Proximal_APA_Type),
             "Novel proximal APA",
             dCPs$Predicted_Proximal_APA_Type)
  dCPs$annotatedProximalCP <- unlist(dCPs$annotatedProximalCP)
  
  ## remove entries with no detected Predicted_Proximal_APA and 
  ## Predicted_Proximal_APA very close to Predicted_Distal_APA
  if (!output.all) 
  {
    dCPs <- dCPs[!is.na(dCPs$Predicted_Proximal_APA) & 
                   abs(dCPs$Predicted_Proximal_APA - 
                         dCPs$Predicted_Distal_APA) >= DIST2END, ]
  }
  dCPs
}

#' adjust the proximal CP sites by matching PWM
#'
#' adjust the proximal CP sites by polyA Position Weight Matrix. It only need
#' the PWM to get match in upstream or downstream shift_range nr.
#'
#' @param idx  the offset of positions of CP sites
#' @param PolyA_PWM polyA PWM
#' @param seqnames a character(n) vector, the chromosome/scaffolds' names
#' @param starts start position in the genome
#' @param strands strands
#' @param genome an [BSgenome::BSgenome-class] object
#' @param shift_range  the shift range of PWM hits
#' @param search_point_START  Not use
#' @return the offset of positions of CP sites after filter
#' @details the hits is searched by [Biostrings::matchPWM()] and the cutoff is
#'   70\%
#' @seealso [adjust_proximalCPsByNBC()], [get_PAscore()]
#' @keywords internal
#' @author Jianhong Ou

adjust_proximalCPsByPWM <- function(idx,
                                    PolyA_PWM,
                                    seqnames,
                                    starts,
                                    strands,
                                    genome,
                                    shift_range,
                                    search_point_START) {
  idx.list <- mapply(function(id, seqname, start, strand) {
    if (length(id) == 1) {
      if (is.na(id)) {
        return(NULL)
      }
    }
    if (length(id) > 0) {
      pos <- {
        if (strand == "+") start + id - 1 else start - id + 1
      }
      id <- InPAS:::get_PAscore(seqname, pos, strand,
        id,
        PWM = PolyA_PWM,
        genome = genome,
        # ups = shift_range + 25, # why + 25?
        # dws = shift_range + 25
        ups = 0, 
        dws = 2 * shift_range
      )
    }
    id
  }, idx, seqnames, starts, strands, SIMPLIFY = FALSE)
}

## ----load_package-------------------------------------------------------------
logger <- file(tempfile(), open = "wt")
sink(logger, type="message")
suppressPackageStartupMessages({
library(InPAS)
library(BSgenome.Mmusculus.UCSC.mm10)
library(BSgenome.Hsapiens.UCSC.hg19)
library(TxDb.Mmusculus.UCSC.mm10.knownGene)
library(EnsDb.Hsapiens.v86)
library(EnsDb.Mmusculus.v79)
library(cleanUpdTSeq)
library(RSQLite)
library(future.apply)
})

## ----setup_sqlitedb-----------------------------------------------------------
plan(sequential)
data_dir <- system.file("extdata", package = "InPAS")
bedgraphs <- c(file.path(data_dir, "Baf3.extract.bedgraph"), 
               file.path(data_dir, "UM15.extract.bedgraph"))
hugeData <- FALSE
genome <- BSgenome.Mmusculus.UCSC.mm10

tags <- c("Baf3", "UM15")
metadata <- data.frame(tag = tags, 
                      condition = c("Baf3", "UM15"),
                      bedgraph_file = bedgraphs)

## In reality, don't use a temporary directory for your analysis. Instead, use a
## persistent directory to save your analysis output.
outdir = tempdir()
write.table(metadata, file = file.path(outdir =outdir, "metadata.txt"), 
            sep = "\t", quote = FALSE, row.names = FALSE)
    
sqlite_db <- setup_sqlitedb(metadata = file.path(outdir = outdir, 
                                                 "metadata.txt"),
                           outdir = outdir)

## check the database
db_conn <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
dbListTables(db_conn)
dbReadTable(db_conn, "metadata")
dbDisconnect(db_conn)

## ----extract_annotation-------------------------------------------------------
samplefile <- system.file("extdata", 
                          "hg19_knownGene_sample.sqlite",
            package="GenomicFeatures")
TxDb <- loadDb(samplefile)
seqnames <- seqnames(BSgenome.Hsapiens.UCSC.hg19)

# exclude mitochondrial genome and alternative haplotypes
chr2exclude <- c("chrM", "chrMT", seqnames[grepl("_(hap\\d+|fix|alt)$", seqnames, perl = TRUE)])

# set up global variables for InPAS analysis
set_globals(genome = BSgenome.Hsapiens.UCSC.hg19,
            TxDb = TxDb,
            EnsDb = EnsDb.Hsapiens.v86,
            outdir = tempdir(),
            chr2exclude = chr2exclude,
            lockfile = tempfile())
utr3_anno <- 
  extract_UTR3Anno(sqlite_db = sqlite_db,
                   TxDb = getInPASTxDb(),
                   edb = getInPASEnsDb(),
                   genome = getInPASGenome(),
                   outdir = getInPASOutputDirectory(),
                   chr2exclude = getChr2Exclude())

head(utr3_anno$chr1)

## ----load_anno----------------------------------------------------------------
## set global variables for mouse InPAS analysis
set_globals(genome = BSgenome.Mmusculus.UCSC.mm10,
            TxDb = TxDb.Mmusculus.UCSC.mm10.knownGene,
            EnsDb = EnsDb.Mmusculus.v79,
            outdir = tempdir(),
            chr2exclude = "chrM",
            lockfile = tempfile())

tx <- parse_TxDb(sqlite_db = sqlite_db,
                 TxDb = getInPASTxDb(),
                 edb = getInPASEnsDb(),
                 genome = getInPASGenome(),
                 outdir = getInPASOutputDirectory(),
                 chr2exclude = getChr2Exclude())

# load R object: utr3.mm10
data(utr3.mm10)

## convert the GRanges into GRangesList for the 3' UTR annotation
utr3.mm10 <- split(utr3.mm10, seqnames(utr3.mm10), 
                   drop = TRUE)

## ----format_coverage----------------------------------------------------------
coverage <- list()
for (i in seq_along(bedgraphs)){
coverage[[tags[i]]] <- get_ssRleCov(bedgraph = bedgraphs[i],
                                    tag = tags[i],
                                    genome = genome,
                                    sqlite_db = sqlite_db,
                                    outdir = outdir,
                                    chr2exclude = getChr2Exclude())
}
coverage <- assemble_allCov(sqlite_db,
                            seqname = "chr6",
                            outdir, 
                            genome = getInPASGenome())

## ----coverage_QC--------------------------------------------------------------
if (.Platform$OS.type == "windows")
{
  plan(multisession)
} else {
  plan(multicore)
}
run_coverageQC(sqlite_db, 
               TxDb = getInPASTxDb(), 
               edb = getInPASEnsDb(), 
               genome = getInPASGenome(),
               chr2exclude = getChr2Exclude(),
               which = GRanges("chr6",
               ranges = IRanges(98013000, 140678000)))
plan(sequential)

## ----search_CPs---------------------------------------------------------------
## load the Naive Bayes classifier model for classify CP sites from the 
## cleanUpdTseq package
data(classifier)

prepared_data <- setup_CPsSearch(sqlite_db,
                                 genome = getInPASGenome(), 
                                 chr.utr3 = utr3.mm10$chr6,
                                 seqname = "chr6",
                                 background = "10K",
                                 TxDb = getInPASTxDb(),
                                 hugeData = TRUE,
                                 outdir = outdir,
                                 silence = TRUE,
                                 coverage_threshold = 5)

CPsites <- search_CPs(seqname = "chr6",
                       sqlite_db = sqlite_db,
                       genome = getInPASGenome(),
                       MINSIZE = 10, 
                       window_size = 100,
                       search_point_START = 50,
                       search_point_END = NA,
                       cutEnd = 0,
                       filter.last = TRUE,
                       adjust_distal_polyA_end = TRUE,
                       long_coverage_threshold = 2,
                       PolyA_PWM = NA, 
                       classifier = classifier,
                       classifier_cutoff = 0.8,
                       shift_range = 50,
                       step = 5,
                       outdir = outdir, 
                       silence = TRUE)

## ----estimate_PDUI------------------------------------------------------------
utr3_cds_cov <- get_regionCov(chr.utr3 = utr3.mm10[["chr6"]],
                              sqlite_db,
                              outdir,
                              phmm = FALSE)

eSet <- get_UTR3eSet(sqlite_db,
                     normalize ="none", 
                     singleSample = FALSE)

## ----dPDUI_test---------------------------------------------------------------
test_out <- test_dPDUI(eset = eSet, 
                       method = "fisher.exact",
                       normalize = "none",
                       sqlite_db = sqlite_db)

## ----filter_dPDUI-------------------------------------------------------------
filter_out <- filter_testOut(res = test_out,
                             gp1 = "Baf3",
                             gp2 = "UM15",
                             background_coverage_threshold = 2,
                             P.Value_cutoff = 0.05,
                             adj.P.Val_cutoff = 0.05,
                             dPDUI_cutoff = 0.3,
                             PDUI_logFC_cutoff = 0.59)

## ----visualization------------------------------------------------------------
## Visualize dPDUI events                       
gr <- GRanges("chr6", IRanges(128846245, 128850081), strand = "-")
names(gr) <- "128846245-128850081"
data4plot <- get_usage4plot(gr, 
                            proximalSites = 128849130, 
                            sqlite_db,
                            hugeData = TRUE) 

plot_utr3Usage(usage_data = data4plot, 
               vline_color = "purple", 
               vline_type = "dashed")

## ----setup_GSEA---------------------------------------------------------------
## prepare a rank file for GSEA
setup_GSEA(eset = test_out,
           groupList= list(Baf3 = "Baf3", UM15 ="UM15"),
           outdir = outdir,
           preranked = TRUE,
           rankBy = "logFC",
           rnkFilename = "InPAS.rnk")

## ----sessionInfo, results='asis'----------------------------------------------
sessionInfo()
sink(type="message")
close(logger)

#' Annotation of 3' UTRs for mouse (mm10)
#'
#' A dataset containing the annotation of the 3' UTRs of the mouse
#'
#' @format An object of [GenomicRanges::GRanges-class] with 7 metadata columns
#' \describe{
#'   \item{feature}{feature type, utr3, CDS, next.exon.gap}
#'   \item{annotatedProximalCP}{candidate proximal CPsites}
#'   \item{exon}{exon ID}
#'   \item{transcript}{transcript ID}
#'   \item{gene}{gene ID}
#'   \item{symbol}{gene symbol}
#'   \item{truncated}{whether the 3' UTR is trucated}
#' }
"utr3.mm10"

#' Calculate the depth weight for each sample or each experimental condition
#'
#' Calculate the depth weight for each sample of non-hugeData or each
#'   experimental condition for hugeData: depth/mean(depth)
#'
#' @param metadata A data frame containing the metadata for a RNA-seq experiment,
#'  which can be extract from the SQLite database set up by [setup_sqlitedb()]
#' @param hugeData A logical(1), indicating whether it is huge data
#' @return A named numeric vector containing depth weight for each sample for
#'   non-hugeData, or depth weight for each condition if hugeData.
#' @import S4Vectors RSQLite
#' @keywords internal
#' @author Jianhong Ou, Haibo Liu

get_depthWeight <- function(metadata, hugeData) {
  tags <- metadata$tag
  depth <- metadata$depth
  condition <- metadata$condition

  if (hugeData) {
    if (length(unique(condition)) > 1) {
      depth <- split(depth, condition)
      ## group mean depth
      depth <- sapply(depth, mean)
      depth.weight <- depth / mean(depth)
      names(depth.weight) <- names(depth)
    } else {
      depth.weight <- 1
      names(depth.weight) <- unique(condition)
    }
  } else if (length(unique(condition)) == 1) {
    depth.weight <- depth / mean(depth)
    names(depth.weight) <- tags
  }
  depth.weight
}

#' filter 3' UTR usage test results
#'
#' filter results of [test_dPDUI()]
#'
#' @param res a [UTR3eSet-class] object, output of [test_dPDUI()]
#' @param gp1 tag names involved in group 1. gp1 and gp2 are used for filtering
#'   purpose if both are specified; otherwise only other specified thresholds
#'   are used for filtering.
#' @param gp2 tag names involved in group 2
#' @param outdir A character(1) vector, a path with write permission for storing
#'   InPAS analysis results. If it doesn't exist, it will be created.
#' @param background_coverage_threshold  background coverage cut off value. for
#'   each group, more than half of the long form should greater than
#'   background_coverage_threshold. for both group, at least in one group, more
#'   than half of the short form should greater than
#'   background_coverage_threshold.
#' @param P.Value_cutoff cutoff of P value
#' @param adj.P.Val_cutoff  cutoff of adjust P value
#' @param dPDUI_cutoff  cutoff of dPDUI
#' @param PDUI_logFC_cutoff cutoff of PDUI log2 transformed fold change
#'
#' @return A data frame converted from an object of
#'    [GenomicRanges::GRanges-class].
#' @seealso [test_dPDUI()]
#' @export
#' @author Jianhong Ou, Haibo Liu
#' @examples
#' library(limma)
#' path <- system.file("extdata", package = "InPAS")
#' load(file.path(path, "eset.MAQC.rda"))
#' tags <- colnames(eset@PDUI)
#' g <- factor(gsub("\\..*$", "", tags))
#' design <- model.matrix(~ -1 + g)
#' colnames(design) <- c("Brain", "UHR")
#' contrast.matrix <- makeContrasts(
#'   contrasts = "Brain-UHR",
#'   levels = design
#' )
#' res <- test_dPDUI(
#'   eset = eset,
#'   method = "limma",
#'   normalize = "none",
#'   design = design,
#'   contrast.matrix = contrast.matrix
#' )
#' filter_testOut(res,
#'   gp1 = c("Brain.auto", "Brain.phiX"),
#'   gp2 = c("UHR.auto", "UHR.phiX"),
#'   background_coverage_threshold = 2,
#'   P.Value_cutoff = 0.05,
#'   adj.P.Val_cutoff = 0.05,
#'   dPDUI_cutoff = 0.3,
#'   PDUI_logFC_cutoff = .59
#' )
filter_testOut <- function(res,
                           gp1,
                           gp2,
                           outdir = getInPASOutputDirectory(),
                           background_coverage_threshold = 2,
                           P.Value_cutoff = 0.05,
                           adj.P.Val_cutoff = 0.05,
                           dPDUI_cutoff = 0.2,
                           PDUI_logFC_cutoff = log2(1.5)) {
  if (missing(res) || !is(res, "UTR3eSet")) {
    stop("res is required and must be an object of UTR3eSet")
  }
  if (!is.character(outdir) || length(outdir) != 1) {
    stop("An explicit output directory is required")
  } else {
    outdir <- file.path(outdir, "010.filtered.dPDUI")
    if (!dir.exists(outdir)) {
      dir.create(outdir,
        recursive = TRUE,
        showWarnings = FALSE
      )
    }
    outdir <- normalizePath(outdir)
  }
  if (missing(gp1) || missing(gp2)) {
    testRes <- res$testRes
    testRes <- testRes[!(is.na(testRes[, "P.Value"]) |
      is.na(testRes[, "adj.P.Val"])), ]
    if (!"dPDUI" %in% colnames(testRes)) {
      message("dPDUI_cutoff will be ignored")
    } else {
      testRes <- testRes[abs(testRes[, "dPDUI"]) >=
        dPDUI_cutoff, , drop = FALSE]
    }
    if (!missing(PDUI_logFC_cutoff)) {
      if (!"logFC" %in% colnames(testRes)) {
        message("PDUI_logFC_cutoff will be ignored")
      } else {
        testRes <- testRes[abs(testRes[, "logFC"]) >=
          PDUI_logFC_cutoff, , drop = FALSE]
      }
    }
    testRes <- testRes[testRes[, "adj.P.Val"] <= adj.P.Val_cutoff &
      testRes[, "P.Value"] <= P.Value_cutoff, , drop = FALSE]
    testRes <- testRes[!is.na(rownames(testRes)), ]
    if (nrow(testRes) == 0) {
      return(NULL)
    }
    res <- res$usage[match(rownames(testRes), res$usage$transcript)]
    mcols(res) <- cbind(as.data.frame(mcols(res)), testRes)
    return(res)
  }

  ## In At least one group, more than half of the long/short form
  ## should be greater than background_coverage_threshold
  coln <- colnames(res$short)
  if (!all(c(gp1, gp2) %in% coln)) {
    stop("gp1 and gp2 must be the tags of samples (colnames of res$short)")
  }
  short <- res$short
  long <- res$long
  short.abg <- short > background_coverage_threshold
  long.abg <- long > background_coverage_threshold
  short.abg.gp1 <- short.abg[, gp1, drop = FALSE]
  short.abg.gp2 <- short.abg[, gp2, drop = FALSE]
  long.abg.gp1 <- long.abg[, gp1, drop = FALSE]
  long.abg.gp2 <- long.abg[, gp2, drop = FALSE]
  halfLgp1 <- ceiling(length(gp1) / 2)
  halfLgp2 <- ceiling(length(gp2) / 2)
  short.abg.gp1 <- rowSums(short.abg.gp1)
  short.abg.gp2 <- rowSums(short.abg.gp2)
  long.abg.gp1 <- rowSums(long.abg.gp1)
  long.abg.gp2 <- rowSums(long.abg.gp2)
  long.abg <- long.abg.gp1 >= halfLgp1 | long.abg.gp2 >= halfLgp2
  short.abg <- short.abg.gp1 >= halfLgp1 | short.abg.gp2 >= halfLgp2
  abg.gp1 <- long.abg.gp1 >= halfLgp1 | short.abg.gp1 >= halfLgp1
  abg.gp2 <- long.abg.gp2 >= halfLgp2 | short.abg.gp2 >= halfLgp2
  abg <- abg.gp1 & abg.gp2 & long.abg & short.abg

  PDUI.gp1 <- res$PDUI[, gp1, drop = FALSE]
  PDUI.gp2 <- res$PDUI[, gp2, drop = FALSE]
  PDUI.gp1 <- rowMeans(PDUI.gp1)
  PDUI.gp2 <- rowMeans(PDUI.gp2)
  if (!"dPDUI" %in% colnames(res$testRes)) {
    message("dPDUI is calculated by gp2 - gp1.")
    dPDUI <- PDUI.gp2 - PDUI.gp1
  } else {
    dPDUI <- res$testRes[, "dPDUI"]
  }
  adPDUI <- abs(dPDUI) >= dPDUI_cutoff

  if (!missing(PDUI_logFC_cutoff)) {
    if (!"logFC" %in% colnames(res$testRes)) {
      logFC <- log2(PDUI.gp2 + .Machine$double.xmin) -
        log2(PDUI.gp1 + .Machine$double.xmin)
    } else {
      logFC <- res$testRes[, "logFC"]
    }
    alFC <- abs(logFC) >= PDUI_logFC_cutoff
  } else {
    alFC <- rep(TRUE, length(abg))
  }

  res <- as(res, "GRanges")
  res$dPDUI <- dPDUI
  res$PASS <- res$adj.P.Val <= adj.P.Val_cutoff &
    res$P.Value <= P.Value_cutoff &
    abg & adPDUI & alFC
  res <- data.frame(sort(res))
  res <- res[, !colnames(res) %in% c(
    "width", "annotatedProximalCP",
    "truncated", "fit_value",
    "feature", "exon"
  )]
  saveRDS(res, file = file.path(outdir, "filtered.dPDUI.RDS"))
  res
}

#' Estimate the CP sites for UTRs on a given chromosome
#'
#' Estimate the CP sites for UTRs on a given chromosome
#'
#' @param seqname A character(1) vector, specifying a chromososome/scaffold name
#' @param sqlite_db A path to the SQLite database for InPAS, i.e. the output of
#'   [setup_sqlitedb()].
#' @param genome A [BSgenome::BSgenome-class] object
#' @param MINSIZE A integer(1) vector, specifying the minimal length in bp of a
#'   short/proximal 3' UTR. Default, 10
#' @param window_size An integer(1) vector, the window size for novel distal or
#'   proximal CP site searching. default: 200.
#' @param search_point_START A integer(1) vector, starting point relative to
#'   the 5' extremity of 3' UTRs for searching for proximal CP sites
#' @param search_point_END A integer(1) vector, ending point relative to the 3'
#'   extremity of 3' UTRs for searching for proximal CP sites
#' @param cutEnd An integer(1) vector a numeric(1) vector. What percentage or
#'   how many nucleotides should be removed from 5' extremities before searching
#'   for proximal CP sites? It can be a decimal between 0, and 1, or an integer
#'   greater than 1. 0.1 means 10 percent, 25 means cut first 25 bases
#' @param filter.last A logical(1), whether to filter out the last valley, which
#'   is likely the 3' end of the longer 3' UTR if no novel distal CP site is
#'   detected and the 3' end excluded by setting cutEnd/search_point_END is small.
#' @param adjust_distal_polyA_end A logical(1) vector. If true, distal CP sites
#'   are subject to adjustment by the Naive Bayes classifier from the
#'   [cleanUpdTSeq::cleanUpdTSeq-package]
#' @param long_coverage_threshold An integer(1) vector, specifying the cutoff
#'   threshold of coverage for the terminal of long form 3' UTRs. If the coverage
#'   of first 100 nucleotides is lower than coverage_threshold, that transcript
#'   will be not considered for further analysis. Default, 2.
#' @param PolyA_PWM  An R object for a position weight matrix (PWM) for a hexamer
#'   polyadenylation signal (PAS), such as AAUAAA.
#' @param classifier An R object for Naive Bayes classifier model, like the one
#'   in the cleanUpdTSeq package.
#' @param classifier_cutoff A numeric(1) vector. A cutoff of probability that a
#'   site is classified as true CP sites. The value should be between 0.5 and 1.
#'   Default, 0.8.
#' @param shift_range An integer(1) vector, specifying a shift range for
#'   adjusting the proximal and distal CP sites. Default, 50. It determines the
#'   range flanking the candidate CP sites to search the most likely real
#'   CP sites.
#' @param step An integer (1) vector, specifying the step size used for adjusting
#'   the proximal or distal CP sites using the Naive Bayes classifier from the
#'   cleanUpdTSeq package. Default 1. It can be in the range of 1 to 10.
#' @param outdir A character(1) vector, a path with write permission for storing
#'   the CP sites. If it doesn't exist, it will be created.
#' @param future.chunk.size The average number of elements per future
#'   ("chunk"). If Inf, then all elements are processed in a single future.
#'   If NULL, then argument future.scheduling = 1 is used by default. Users can
#'   set future.chunk.size = total number of elements/number of cores set for
#'   the backend. See the future.apply package for details. Default, 50. This
#'   parameter is used to split the candidate 3' UTRs for alternative SP sites
#'   search.
#' @param silence A logical(1), indicating whether progress is reported or not.
#'   By default, FALSE
#' @param mc.cores An integer(1), number of cores for making multicore clusters
#'   or socket clusters using \pkg{batchtools}, and for [parallel::mclapply()]
#' @param cluster_type A character (1) vector, indicating the type of cluster
#'   job management systems. Options are "interactive","multicore", "torque",
#'   "slurm", "sge", "lsf", "openlava", and "socket". see
#'   \href{https://mllg.github.io/batchtools/articles/batchtools.html}{batchtools vignette}
#' @param template_file A charcter(1) vector, indicating the template file for
#'   job submitting scripts when cluster_type is set to "torque", "slurm",
#'   "sge", "lsf", or "openlava".
#' @param resources A named list specifying the computing resources when
#'   cluster_type is set to "torque", "slurm", "sge", "lsf", or "openlava". See
#'   \href{https://mllg.github.io/batchtools/articles/batchtools.html}{batchtools vignette}
#' @param DIST2ANNOAPAP An integer, specifying a cutoff for annotate MSE valleys
#'   with known proximal APAs in a given downstream distance. Default is 500.
#' @param DIST2END An integer, specifying a cutoff of the distance between last
#'   valley and the end of the 3' UTR (where MSE of the last base is calculated).
#'   If the last valley is closer to the end than the specified distance, it will
#'   not be considered because it is very likely due to RNA coverage decay at the
#'   end of mRNA. Default is 1200. User can consider a value between 1000 and 
#'   1500, depending on the library preparation procedures: RNA fragmentation and
#'   size selection.
#' @param output.all A logical(1), indicating whether to output entries with only 
#'   single CP site for a 3' UTR. Default, FALSE.
#' 
#' @return An object of [GenomicRanges::GRanges-class] containing distal and
#'   proximal CP site information for each 3' UTR if detected.
#' @seealso [search_proximalCPs()], [adjust_proximalCPs()],
#'   [adjust_proximalCPsByPWM()], [adjust_proximalCPsByNBC()],
#'   [get_PAscore()], [get_PAscore2()]
#' @import GenomicRanges
#' @importFrom batchtools makeRegistry batchMap submitJobs waitForJobs
#'   reduceResultsList makeClusterFunctionsInteractive makeClusterFunctionsLSF
#'   makeClusterFunctionsMulticore makeClusterFunctionsOpenLava
#'   makeClusterFunctionsSGE makeClusterFunctionsSlurm
#'   makeClusterFunctionsSocket makeClusterFunctionsTORQUE
#' @importFrom BSgenome getSeq matchPWM
#' @importFrom parallelly availableCores
#' @importFrom future.apply future_mapply future_lapply
#' @export
#' @author Jianhong Ou, Haibo Liu
#'
#' @examples
#' if (interactive()) {
#'   library(BSgenome.Mmusculus.UCSC.mm10)
#'   library(TxDb.Mmusculus.UCSC.mm10.knownGene)
#'   genome <- BSgenome.Mmusculus.UCSC.mm10
#'   TxDb <- TxDb.Mmusculus.UCSC.mm10.knownGene
#'
#'   ## load UTR3 annotation and convert it into a GRangesList
#'   data(utr3.mm10)
#'   utr3 <- split(utr3.mm10, seqnames(utr3.mm10), drop = TRUE)
#'
#'   bedgraphs <- system.file("extdata", c(
#'     "Baf3.extract.bedgraph",
#'     "UM15.extract.bedgraph"
#'   ),
#'   package = "InPAS"
#'   )
#'   tags <- c("Baf3", "UM15")
#'   metadata <- data.frame(
#'     tag = tags,
#'     condition = c("Baf3", "UM15"),
#'     bedgraph_file = bedgraphs
#'   )
#'   outdir <- tempdir()
#'   write.table(metadata,
#'     file = file.path(outdir, "metadata.txt"),
#'     sep = "\t", quote = FALSE, row.names = FALSE
#'   )
#'
#'   sqlite_db <- setup_sqlitedb(metadata = file.path(
#'     outdir,
#'     "metadata.txt"
#'   ), outdir)
#'   addLockName(filename = tempfile())
#'   coverage <- list()
#'   for (i in seq_along(bedgraphs)) {
#'     coverage[[tags[i]]] <- get_ssRleCov(
#'       bedgraph = bedgraphs[i],
#'       tag = tags[i],
#'       genome = genome,
#'       sqlite_db = sqlite_db,
#'       outdir = outdir,
#'       chr2exclude = "chrM"
#'     )
#'   }
#'   data4CPsSearch <- setup_CPsSearch(sqlite_db,
#'     genome,
#'     chr.utr3 = utr3[["chr6"]],
#'     seqname = "chr6",
#'     background = "10K",
#'     TxDb = TxDb,
#'     hugeData = TRUE,
#'     outdir = outdir,
#'     minZ = 2,
#'     cutStart = 10,
#'     MINSIZE = 10,
#'     coverage_threshold = 5
#'   )
#'   ## polyA_PWM
#'   load(system.file("extdata", "polyA.rda", package = "InPAS"))
#'
#'   ## load the Naive Bayes classifier model from the cleanUpdTSeq package
#'   library(cleanUpdTSeq)
#'   data(classifier)
#'   ## the following setting just for demo.
#'   if (.Platform$OS.type == "window") {
#'     plan(multisession)
#'   } else {
#'     plan(multicore)
#'   }
#'   CPs <- search_CPs(
#'     seqname = "chr6",
#'     sqlite_db = sqlite_db,
#'     genome = genome,
#'     MINSIZE = 10,
#'     window_size = 100,
#'     search_point_START = 50,
#'     search_point_END = NA,
#'     cutEnd = 0,
#'     filter.last = TRUE,
#'     adjust_distal_polyA_end = TRUE,
#'     long_coverage_threshold = 2,
#'     PolyA_PWM = pwm,
#'     classifier = classifier,
#'     classifier_cutoff = 0.8,
#'     shift_range = 100,
#'     step = 5,
#'     outdir = outdir
#'   )
#' }
search_CPs <- function(seqname,
                       sqlite_db,
                       genome = getInPASGenome(),
                       MINSIZE = 10,
                       window_size = 200,
                       search_point_START = 100,
                       search_point_END = NA,
                       cutEnd = NA,
                       filter.last = TRUE,
                       adjust_distal_polyA_end = FALSE,
                       long_coverage_threshold = 2,
                       PolyA_PWM = NA,
                       classifier = NA,
                       classifier_cutoff = 0.8,
                       shift_range = 100,
                       step = 2,
                       outdir = getInPASOutputDirectory(),
                       silence = FALSE,
                       cluster_type = c(
                         "interactive", "multicore",
                         "torque", "slurm", "sge",
                         "lsf", "openlava", "socket"
                       ),
                       template_file = NULL,
                       mc.cores = 1,
                       future.chunk.size = 50,
                       resources = list(
                         walltime = 3600 * 8, ncpus = 4,
                         mpp = 1024 * 4, queue = "long",
                         memory = 4 * 4 * 1024
                       ),
                       DIST2ANNOAPAP = 500,
                       DIST2END = 1000,
                       output.all = FALSE) {
  if (!is.null(mc.cores) && !is.numeric(mc.cores)) {
    stop("mc.cores must be an integer(1)")
  } else if (.Platform$OS.type == "windows") {
    mc.cores <- 1
  } else if (is.null(mc.cores)) {
    mc.cores <- availableCores() - 1
  } else {
    mc.cores <- min(availableCores() - 1, mc.cores)
  }

  if (!is.na(PolyA_PWM)[1]) {
    if (!is(PolyA_PWM, "matrix")) stop("PolyA_PWM must be matrix")
    if (any(rownames(PolyA_PWM) != c("A", "C", "G", "T"))) {
      stop("rownames of PolyA_PWM must be c('A', 'C', 'G', 'T')")
    }
  }

  if (!is.na(PolyA_PWM) && !is.na(classifier)) {
    stop("PolyA_PWM and classifier can't be set at the same time for adjusting!")
  }

  if (missing(genome)) {
    stop("genome is required.")
  }
  if (!is(genome, "BSgenome")) {
    stop("genome must be an object of BSgenome.")
  }

  if (missing(outdir)) {
    stop("An explicit output directory is required")
  } else {
    outdir <- file.path(outdir, "006.CPsites.out")
    if (!dir.exists(outdir)) {
      dir.create(outdir,
        recursive = TRUE,
        showWarnings = TRUE
      )
    }
    outdir <- normalizePath(outdir)
  }
  lock_filename <- getLockName()
  if (!file.exists(lock_filename)) {
    stop(
      "lock_filename must be an existing file.",
      "Please call addLockName() first!"
    )
  }
  file_lock <- flock::lock(lock_filename)
  db_conn <- dbConnect(
    drv = RSQLite::SQLite(),
    dbname = sqlite_db
  )
  utr3_coverage <- dbReadTable(db_conn, "utr3_total_coverage")
  dbDisconnect(db_conn)
  flock::unlock(file_lock)

  chr.cov <- utr3_coverage$coverage_file[utr3_coverage$chr == seqname]

  if (length(chr.cov) != 1) {
    message("The seqname is not included in the UTR3TotalCov")
    CPsites <- GRanges()
    return(CPsites)
  }

  ## load CPsSearch_data file, "seqname_data4CPsSearch.RDS", for chr = seqname
  chr.cov <- readRDS(file = chr.cov)
  if (!is.list(chr.cov)) {
    stop(
      "Something wrong when loading big data.\n",
      "Maybe the data prepared for CP site search is broken!"
    )
  }

  curr_UTR <- chr.cov$chr.utr3
  chr.cov.merge <- chr.cov$chr.cov.merge
  conn_next_utr3 <- chr.cov$conn_next_utr3
  depth.weight <- chr.cov$depth.weight
  background <- chr.cov$background
  z2s <- chr.cov$z2s

  get_CPsites <- function(seqname,
                          chr.cov.merge,
                          conn_next_utr3,
                          curr_UTR,
                          depth.weight,
                          background,
                          z2s,
                          window_size,
                          long_coverage_threshold,
                          adjust_distal_polyA_end,
                          classifier,
                          classifier_cutoff,
                          shift_range,
                          genome,
                          step,
                          MINSIZE,
                          search_point_START,
                          search_point_END,
                          cutEnd,
                          filter.last,
                          PolyA_PWM,
                          outdir,
                          silence,
                          DIST2ANNOAPAP,
                          DIST2END) {
    ## Step 1: search distal CP sites
    if (!silence) {
      message(
        "chromsome ", seqname,
        " distal searching starts at ", date(), ".\n"
      )
    }
    chr.abun <- InPAS:::search_distalCPs(chr.cov.merge,
      conn_next_utr3,
      curr_UTR,
      window_size = window_size,
      depth.weight,
      long_coverage_threshold =
        long_coverage_threshold,
      background,
      z2s
    )

    if (!silence) {
      message(
        "chromsome ", seqname, " distal searching done at ",
        date(), ".\n"
      )
    }
    ## Step 2: search proximal CP sites
    if (!silence) {
        message(
            "chromsome ", seqname,
            " proximal searching starts at ", date(), ".\n"
        )
    }
    chr.abun <- InPAS:::search_proximalCPs(
      chr.abun, curr_UTR,
      window_size, MINSIZE,
      cutEnd, search_point_START,
      search_point_END,
      filter.last,
      DIST2END
    )

    if (!silence) {
      message(
        "chromsome ", seqname,
        " proximal searching  done at ", date(), ".\n"
      )
    }
    ## Step 3: adjust distal CP sites
    if (!silence) {
      message(
        "chromsome ", seqname, " distal adjusting starts at ",
        date(), ".\n"
      )
    }
    if (adjust_distal_polyA_end) {
      chr.abun <- InPAS:::adjust_distalCPs(
        chr.abun,
        classifier,
        classifier_cutoff,
        shift_range,
        genome,
        seqname,
        step
      )
    }
    if (!silence) {
      message(
        "chromsome ", seqname,
        " distal adjusting done at ", date(), ".\n"
      )
    }
    ## Step 4: adjust proximal CP sites
    if (!silence) {
      message(
        "chromsome ", seqname,
        " proximal adjusting starts at ", date(), ".\n"
      )
    }
    chr.abun <- InPAS:::adjust_proximalCPs(
      chr.abun, PolyA_PWM,
      genome, classifier,
      classifier_cutoff,
      shift_range,
      search_point_START,
      step,
      DIST2ANNOAPAP
    )
    if (!silence) {
      message(
        "chromsome ", seqname,
        " proximal adjusting done at ", date(), ".\n"
      )
    }
    chr.abun
  }

  if (.Platform$OS.type == "windows") {
    chr.abun <- get_CPsites(
      seqname,
      chr.cov.merge,
      conn_next_utr3,
      curr_UTR,
      depth.weight,
      background,
      z2s,
      window_size,
      long_coverage_threshold,
      adjust_distal_polyA_end,
      classifier,
      classifier_cutoff,
      shift_range,
      genome,
      step,
      MINSIZE,
      search_point_START,
      search_point_END,
      cutEnd,
      filter.last,
      PolyA_PWM,
      outdir,
      silence,
      DIST2ANNOAPAP,
      DIST2END
    )
    ## save intermediate data before polishing
    filename <- file.path(outdir, paste0(seqname, 
                                         "_CPsites.no.polishing.RDS"))
    saveRDS(chr.abun, file = filename)

    ## polishing
    chr.abun <- polish_CPs(chr.abun, 
                           output.all = output.all,
                           DIST2END = DIST2END)
  } else {
    file.dir <- paste(outdir, seqname, sep = "_")
    
    ## remove existing directory
    if (dir.exists(file.dir))
    {
        unlink(file.dir, recursive = TRUE, force = TRUE)
    }
    reg <- makeRegistry(
      file.dir = file.dir,
      conf.file = NA,
      packages = "InPAS",
      seed = 1
    )
    cluster_type <- match.arg(cluster_type)

    if (cluster_type %in% c("lsf", "sge", "slurm", 
                            "openlava", "torgue") &&
      !file.exists(template_file)) {
      stop("template_file doen't exist")
    }

    if (cluster_type == "interactive") {
      reg$cluster.functions <- makeClusterFunctionsInteractive(
        external = FALSE,
        write.logs = TRUE,
        fs.latency = 0
      )
    } else if (cluster_type == "lsf") {
      reg$cluster.functions <- makeClusterFunctionsLSF(
        template = template_file,
        scheduler.latency = 1,
        fs.latency = 65
      )
    } else if (cluster_type == "multicore") {
      reg$cluster.functions <-
        makeClusterFunctionsMulticore(
          ncpus = mc.cores,
          fs.latency = 0
        )
    } else if (cluster_type == "socket") {
      reg$cluster.functions <-
        makeClusterFunctionsSocket(
          ncpus = mc.cores,
          fs.latency = 65
        )
    } else if (cluster_type == "openlava") {
      reg$cluster.functions <- makeClusterFunctionsOpenLava(
        template = template_file,
        scheduler.latency = 1,
        fs.latency = 65
      )
    } else if (cluster_type == "sge") {
      reg$cluster.functions <- makeClusterFunctionsSGE(
        template = template_file,
        nodename = "localhost",
        scheduler.latency = 1,
        fs.latency = 65
      )
    } else if (cluster_type == "slurm") {
      reg$cluster.functions <- makeClusterFunctionsSlurm(
        template = template_file,
        array.jobs = TRUE,
        nodename = "localhost",
        scheduler.latency = 1,
        fs.latency = 65
      )
    } else if (cluster_type == "torque") {
      reg$cluster.functions <- makeClusterFunctionsTORQUE(
        template = template_file,
        scheduler.latency = 1,
        fs.latency = 65
      )
    }
    x <- ceiling(seq_along(curr_UTR) / future.chunk.size)
    curr_UTR <- split(curr_UTR, x)
    curr_UTR <- as.list(curr_UTR)
    conn_next_utr3 <- split(conn_next_utr3, x)
    chr.cov.merge <- split(chr.cov.merge, x)

    batchMap(
      fun = get_CPsites,
      args = list(
        chr.cov.merge = chr.cov.merge,
        conn_next_utr3 = conn_next_utr3,
        curr_UTR = curr_UTR
      ),
      more.args = list(
        seqname = seqname,
        depth.weight = depth.weight,
        background = background,
        z2s = z2s,
        window_size = window_size,
        long_coverage_threshold = long_coverage_threshold,
        adjust_distal_polyA_end = adjust_distal_polyA_end,
        classifier = classifier,
        classifier_cutoff = classifier_cutoff,
        shift_range = shift_range,
        genome = genome,
        step = step,
        MINSIZE = MINSIZE,
        search_point_START = search_point_START,
        search_point_END = search_point_END,
        cutEnd = cutEnd,
        filter.last = filter.last,
        PolyA_PWM = PolyA_PWM,
        outdir = outdir,
        silence = silence,
        DIST2ANNOAPAP = DIST2ANNOAPAP,
        DIST2END = DIST2END
      )
    )

    ## start job
    submitJobs(resources = resources)
    while (!waitForJobs(sleep = 120, timeout = Inf, 
                        stop.on.error = TRUE)) {
      Sys.sleep(120)
    }
    if (waitForJobs(sleep = 120, timeout = Inf,
                    stop.on.error = TRUE)) {
      chr.abun <- reduceResultsList()
      ## save intermediate data before polishing
      filename <- file.path(outdir, 
                            paste0(seqname, "_CPsites.non.polishing.RDS"))
      .collapse_list(dCP.list = chr.abun, filename = filename)
      ## polish
      chr.abun <- do.call("rbind", lapply(chr.abun, polish_CPs, 
                                          output.all = output.all,
                                          DIST2END = DIST2END))
      
      ## delete registry afterwards
      unlink(reg$file.dir, recursive = TRUE, force = TRUE)
    }
  }
  CPsites <- NULL
  if (!is.null(chr.abun)) {
      ## convert to GRanges
      CPsites <- makeGRangesFromDataFrame(chr.abun,
                                      keep.extra.columns = TRUE,
                                      ignore.strand = FALSE,
                                      seqinfo = NULL,
                                      seqnames.field = "seqnames",
                                      start.field = "start",
                                      end.field = "end",
                                      strand.field = "strand",
                                      starts.in.df.are.0based = FALSE)
   } 
  ## save chromosome-wise CP sites
  if (!is.null(CPsites)) {
    filename <- file.path(outdir, paste0(seqname, "_CPsites.RDS"))
    saveRDS(CPsites, file = filename)

    tryCatch(
      {
        file_lock <- flock::lock(lock_filename)
        db_conn <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
        res <- dbSendStatement(
          db_conn,
          paste0("DELETE FROM CPsites WHERE chr = '", seqname, "';")
        )
        dbClearResult(res)
        res <- dbSendStatement(
          db_conn,
          paste0("INSERT INTO CPsites (chr, cpsites_file)
                  VALUES ('", seqname, "','", filename, "');")
        )
        dbClearResult(res)
      },
      error = function(e) {
        print(paste(conditionMessage(e)))
      },
      finally = {
        dbDisconnect(db_conn)
        unlock(file_lock)
      }
    )
  }
  CPsites
}

## helper function to simplify the output of reduceResultsList()
.collapse_list <- function(dCP.list, filename) {
    dCPs <- do.call(rbind, lapply(dCP.list, function(x){
        x$dCPs
    }))
    chr.cov.merge <- do.call(c, lapply(dCP.list, function(x){
        x$chr.cov.merge
    }))
    final.utr3 <- do.call(c, lapply(dCP.list, function(x){
        x$final.utr3
    }))
    saved.id <- do.call(c, lapply(dCP.list, function(x){
        x$saved.id
    }))
    flag <- do.call(c, lapply(dCP.list, function(x){
        x$flag
    }))
    fit_value <- do.call(c, lapply(dCP.list, function(x){
        x$fit_value
    }))
    Predicted_Proximal_APA <- do.call(c, lapply(dCP.list, function(x){
        x$Predicted_Proximal_APA
    }))
    fit_value_min <- do.call(c, lapply(dCP.list, function(x){
        x$fit_value_min
    }))
    chr_dCPs <- list(dCPs = dCPs,
                     chr.cov.merge = chr.cov.merge,
                     final.utr3 = final.utr3,
                     saved.id = saved.id,
                     flag  = flag,
                     fit_value = fit_value,
                     Predicted_Proximal_APA = Predicted_Proximal_APA,
                     fit_value_min = fit_value_min)
    saveRDS(chr_dCPs, file = filename)
}

#' helper function to calculate chromosome/scaffold level GC content
#'
#' @param genome an object of [BSgenome::BSgenome-class]
#' @param seqname a character(1) vector, the chromosome/scaffold's name
#' @param nonATCGExclude a logical(1) vector, whether nucleotides other than A,
#'   T, C, and G should be excluded when GC content is calculated
#'
#' @return a numeric(1) vector, containing the chromosome/scaffold -specific GC
#'   content in the range of 0 to 1
#' @importFrom Biostrings alphabetFrequency
#' @keywords internal
#' @author Haibo Liu
#'
#' @examples
#' \dontrun{
#' library(BSgenome.Mmusculus.UCSC.mm10)
#' genome <- BSgenome.Mmusculus.UCSC.mm10
#' InPAS:::gcContents(genome, "chr1")
#' }
#'
gcContents <- function(genome, seqname, nonATCGExclude = TRUE) {
  if (!is(genome, "BSgenome")) {
    stop("Genome must be a BSgenome object!")
  }
  if (!seqname %in% seqnames(genome)) {
    stop("seqname doesn't appear in the genome!")
  }
  freq <- alphabetFrequency(genome[[seqname]], as.prob = FALSE)

  if (nonATCGExclude) {
    gc <- sum(freq[c("G", "C")]) / sum(freq[c("A", "T", "G", "C")])
  } else {
    gc <- sum(freq[c("G", "C")]) / sum(freq)
  }
  gc
}

#' Calculate weights for GC composition
#'
#' Calculate read weights for GC composition-based coverage correction
#'
#' @param genome An object of [BSgenome::BSgenome-class]
#' @param seqnames a character(n) vector, the chromosome/scaffolds' names
#'  in the same forms of seqnames in the BSgenome
#' @param window size of a sliding window, which optimally is set to the read
#'   length
#' @param future.chunk.size The average number of elements per future
#'   ("chunk"). If Inf, then all elements are processed in a single future.
#'   If NULL, then argument future.scheduling = 1 is used by default. Users can
#'   set future.chunk.size = total number of elements/number of cores set for
#'   the backend. See the future.apply package for details.
#' @importFrom Biostrings alphabetFrequency toString
#'   letterFrequencyInSlidingView DNAString
#' @return A list of numeric vectors containing the weight (scaffold-level GC\%
#'   / GC\% per sliding window) for GC composition-based correction for each
#'   chromosome/scaffold.
#' @importFrom future.apply future_lapply
#' @author Jianhong Ou, Haibo Liu
#' @keywords internal
#' @references Cheung et al. Systematic bias in high-throughput sequencing data
#'   and its correction by BEADS. Nucleic Acids Res. 2011 Aug;39(15):e103.
#' @examples
#' \dontrun{
#' library(BSgenome.Mmusculus.UCSC.mm10)
#' genome <- BSgenome.Mmusculus.UCSC.mm10
#' InPAS:::gcComp(genome, "chr1")
#' }
#'
gcComp <- function(genome, seqnames, window = 50,
                   future.chunk.size = NULL) {
  fref <- sapply(
    seqnames,
    function(seqname) {
      gcContents(genome, seqname)
    }
  )

  win_size <- floor(window / 2)

  ## helper function
  window_gc <- function(seqname) {
    dna <- toString(genome[[seqname]])
    dna <- paste0(
      dna,
      paste(rep("N", win_size - 1), collapse = "")
    )
    window_gc <-
      letterFrequencyInSlidingView(DNAString(dna),
        view.width = win_size,
        letters = "CG",
        OR = "|",
        as.prob = TRUE
      )

    ## seqname-level GC% / per-window GC%
    ## what if window_gc = 0?
    wk <- fref[seqname] / window_gc[, 1]
  }
  fdat <- future_lapply(seqnames, window_gc,
    future.chunk.size = future.chunk.size,
    future.stdout = NA
  )
  fdat
}

#' Calculate weights for mappability-base coverage correction
#'
#' Calculate weights for mappability-base coverage correction
#'
#' @description mappability is calculated by using
#' \href{http://algorithms.cnag.cat/wiki/Man:gem-mappability}{GEM}
#'  with the following command lines:
#' PATH=$PATH:~/bin/GEM-binaries-Linux-x86_64-core_i3-20130406-045632/bin
#' ./gem-indexer -i genome.fa -o mm10.index.gem
#' ./gem-mappability -I mm10.index.gem.gem -l 100 -o mm10.mappability
#' ./gem-2-wig -I mm10.index.gem.gem -i mm10.mappability -o mm10.mappability.wig
#'
#' @param mi A numeric vector of mappability along per
#' chromosome/scaffold
#'
#' @return A numeric vector of weights for mappability-based
#' coverage correction
#' @keywords internal
#' @author Jianhong Ou
#' @references Derrien et al. Fast computation and applications of genome
#'   mappability. PLoS One. 2012;7(1):e30377. doi: 10.1371/journal.pone.0030377.
#'

mapComp <- function(mi) {
  max(mi) / mi
}

#' Adjust the proximal CP sites
#'
#' Adjust the proximal CP sites by PolyA PWM and cleanUpdTSeq. A few candidate
#' sites, which are ranked by MSE from low to high, are used as input for
#' adjusting. The final sites are the one with best score as PA sites, which are
#' not necessary from the lowest MSE sites.
#'
#' @param CPs the outputs of [search_proximalCPs()]
#' @param PolyA_PWM PolyA position weight matrix
#' @param genome a [BSgenome::BSgenome-class] object
#' @param classifier cleanUpdTSeq classifier
#' @param classifier_cutoff cutoff value of the classifier
#' @param shift_range the searching range for the better CP sites
#' @param search_point_START just in case there is no better CP sites
#' @param step An integer, specifying an adjusting step, default 1, means 
#'   adjusting by each base by cleanUpdTSeq.
#' @param DIST2ANNOAPAP An integer, specifying a cutoff for annotate MSE valleys
#'   with known proximal APAs in a given downstream distance. Default is 1500.
#' @return keep same as [search_proximalCPs()], which can be handled by
#'   [polish_CPs()].
#' @seealso [search_proximalCPs()], [polish_CPs()], [adjust_proximalCPsByPWM()],
#'   [adjust_proximalCPsByNBC()], [get_PAscore()],[get_PAscore2()]
#' @keywords internal
#' @author Jianhong Ou

adjust_proximalCPs <- function(CPs,
                               PolyA_PWM,
                               genome,
                               classifier,
                               classifier_cutoff,
                               shift_range,
                               search_point_START,
                               step = 1,
                               DIST2ANNOAPAP = 1000) {
  dCPs <- CPs$dCPs
  seqnames <- as.character(dCPs$seqnames)
  strands <- as.character(dCPs$strand)
  starts <- lapply(
      CPs$chr.cov.merge,
      function(.ele) {
          as.numeric(gsub("^.*_SEP_", "", rownames(.ele)))
      })
    
  # The line below is not correct. Don't reverse the start (By Haibo Liu).
  # See "pos <- if (strand == "+") start + idx - 1 else start - idx + 1" in "15.
  # adjust_proximalCPs.R"
  # starts[strands == "-"] <- lapply(starts[strands == "-"], rev)
  starts <- sapply(starts, `[`, 1)

  ## to be conservative, replace predicted proximal CP sites with the known CP
  ## sites within the range of 200 bp.
  saved.id <- CPs$saved.id ## list
  Predicted_Proximal_APA <-
    mapply(function(pos, known_proximal, start, strand) {
      anno.info <- list(annotated = FALSE, site = pos)
      if (!all(is.na(known_proximal))) {
        if (!all(is.na(pos))) {
          pos <- {
            if (strand == "+") {
              start + pos - 1
            } else {
              start - pos + 1
            }
          }
          annotated.sites <- vector("numeric")
          for (i in seq_along(pos)) {
            dist <- known_proximal - pos[i]
            if (strand == "+") {
              dist <- dist[dist > 0]
              if (length(dist) > 0 && any(dist <= DIST2ANNOAPAP)) {
                annotated.sites[i] <- known_proximal[dist == min(dist)][1]
              }
            } else {
              dist <- dist[dist < 0]
              if (length(dist) > 0 && any(dist >= -DIST2ANNOAPAP)) {
                annotated.sites[i] <- known_proximal[dist == max(dist)][1]
              }
            }
          }
          if (length(annotated.sites) > 0) {
            anno.info$annotated <- TRUE
            anno.info$site <- annotated.sites[1]
          } 
        } 
      }
      anno.info
    }, CPs$Predicted_Proximal_APA,
    saved.id, starts, strands,
    SIMPLIFY = FALSE
    )

  annotated_proximal_apa_flag <-
    unlist(lapply(Predicted_Proximal_APA, function(x) {
      x[[1]]
    }))

  annotated_proximal_apa_pos <- lapply(Predicted_Proximal_APA, 
    function(x) {
       x[[2]]
  })

  dCPs$Predicted_Proximal_APA_Type <- NA_character_
  dCPs$Predicted_Proximal_APA[annotated_proximal_apa_flag] <-
    annotated_proximal_apa_pos[annotated_proximal_apa_flag]
  dCPs$Predicted_Proximal_APA_Type[annotated_proximal_apa_flag] <-
    "Known proximal APA"

  ## why do adjustment for all candidate sites? not necessary
  ## should be resolved
  ## By Haibo, only adjusted not annotated proximal CPs
  CPs$Predicted_Proximal_APA[annotated_proximal_apa_flag] <- NA
  CPs$fit_value_min <- vector("list", length(CPs$fit_value))
  CPs$fit_value_min <- lapply(
      CPs$fit_value,
      function(x) {
              if (!is.null(x)) {
                x <- min(x[!is.na(x) & x != 0])
              } else {NA}
      })

  idx.list <- CPs$Predicted_Proximal_APA
  
  if (is(classifier, "PASclassifier")) {
    cov_diff.list <- CPs$fit_value
    idx.list <- InPAS:::adjust_proximalCPsByNBC(
      idx.list, cov_diff.list,
      seqnames, starts, strands,
      genome,
      classifier,
      classifier_cutoff,
      shift_range,
      search_point_START,
      step = step
    )
  } else if (is(PolyA_PWM, "matrix")) {
    ## improvement needed here because only test if one sequence around position
    ## a hit by PWM matrix with score  > 70%
    idx.list <- InPAS:::adjust_proximalCPsByPWM(
      idx.list, PolyA_PWM, seqnames, starts,
      strands, genome, shift_range,
      search_point_START
    )
  }

  ## relative coordinates of CP sites
  flag <- CPs$flag
  CPs$dCPs <- dCPs
  CPs$flag <- flag & !annotated_proximal_apa_flag
  ## if not a valid APA after adjustment, keep the pre-adjustment APA instead
  ## This is more robust.
  CPs$Predicted_Proximal_APA[flag] <- ifelse(is.na(idx.list[flag]), 
                                             CPs$Predicted_Proximal_APA[flag], 
                                             idx.list[flag])
  CPs
}

#' A package for identifying novel Alternative PolyAdenylation
#' Sites (PAS) based on RNA-seq data
#'
#' The InPAS package provides three categories of important functions:
#' parse_TxDb, extract_UTR3Anno, get_ssRleCov, assemble_allCov,
#' get_UTR3eSet, test_dPDUI, run_singleSampleAnalysis,
#' run_singleGroupAnalysis, run_limmaAnalysis, filter_testOut,
#' get_usage4plot, setup_GSEA, run_coverageQC
#'
#' @section functions for retrieving 3' UTR annotation: parse_TxDb,
#'   extract_UTR3Anno, get_lastCDSUTR3
#' @section functions for processing read coverage data: assemble_allCov,
#'   get_ssRleCov, run_coverageQC, setup_parCPsSearch
#' @section  functions for alternative polyadenylation site analysis:
#'    test_dPDUI, run_singleSampleAnalysis, run_singleGroupAnalysis,
#'   run_limmaAnalysis, filter_testOut, get_usage4plot
#'
#' @docType package
#' @name InPAS
globalVariables(c(
  ".", "Predicted_Proximal_APA", "X2",
  "X3", "dup.group", "end.utr3.last",
  "exon_name", "exon_rank", "feature",
  "gene", "start.utr3.last", "transcript",
  "truncated", "tx_name", "Coverage",
  "value", "tx_id"
))

#' adjust the proximal CP sites by using Naive Bayes classifier from cleanUpdTSeq
#'
#' adjust the proximal CP sites by using Naive Bayes classifier from cleanUpdTSeq
#'
#' @param idx.list the offset of positions of CP sites
#' @param cov_diff.list  the MSE values
#' @param seqnames a character(n) vector, the chromosome/scaffolds' names
#' @param starts starts
#' @param strands strands
#' @param genome a [BSgenome::BSgenome-class] object
#' @param classifier cleanUpdTSeq classifier
#' @param classifier_cutoff  cutoff value of the classifier
#' @param shift_range the searching range for the better CP sites
#' @param search_point_START just in case there is no better CP sites
#' @param step adjusting step, default 1, means adjust by each base by
#'   cleanUpdTSeq.
#' @return the offset of positions of CP sites after filter
#' @details the step for calculating is 10, can not do every base base it is
#'   really very slow.
#' @keywords internal
#' @author Jianhong Ou
#' @seealso [adjust_proximalCPsByPWM()], [get_PAscore2()]
#'

adjust_proximalCPsByNBC <- function(idx.list,
                                    cov_diff.list,
                                    seqnames,
                                    starts,
                                    strands,
                                    genome,
                                    classifier,
                                    classifier_cutoff,
                                    shift_range,
                                    search_point_START,
                                    step = 1) {
  idx.len <- sapply(idx.list, length)
  offsite <- 10^nchar(as.character(max(idx.len) * ceiling(shift_range / step)))
  pos.matrix <- mapply(function(idx, start, strand, cov_diff, ID) {
    if (length(idx) == 0 || is.na(idx[1])) {
      return(NULL)
    }
    idx.gp <- 1:length(idx)
    if (shift_range > step) {
      #idx_lo <- idx - shift_range
      #idx_up <- idx + shift_range
      idx_lo <- idx 
      idx_up <- idx + 2 * shift_range
      idx <- mapply(function(a, b, c) {
        unique(sort(c(seq(a, b, by = step), c)))
      }, idx_lo, idx_up, idx,
      SIMPLIFY = FALSE
      )

      idx.gp <- rep(1:length(idx_lo), sapply(idx, length))
      idx <- as.integer(unlist(idx))
      idx <- cbind(idx, idx.gp)
      idx <- idx[idx[, 1] >= search_point_START &
        idx[, 1] < length(cov_diff), , drop = FALSE]
      idx <- idx[!duplicated(idx[, 1]), , drop = FALSE]
      idx.gp <- idx[, 2]
      idx <- idx[, 1]
    }
    if (length(idx) > 0) {
      pos <- if (strand == "+") start + idx - 1 else start - idx + 1
      cbind(pos, idx, idx.gp, ID)
    } else {
      NULL
    }
  }, idx.list, starts, strands, cov_diff.list,
  1:length(idx.list),
  SIMPLIFY = FALSE
  )
  pos.matrix <- do.call(rbind, pos.matrix)

  if (is(pos.matrix, "matrix") && nrow(pos.matrix) > 0) {
    idx <- InPAS:::get_PAscore2(
      seqnames[pos.matrix[, "ID"]],
      pos.matrix[, "pos"],
      strands[pos.matrix[, "ID"]],
      pos.matrix[, "idx"],
      pos.matrix[, "ID"] * offsite + pos.matrix[, "idx.gp"],
      genome, classifier,
      classifier_cutoff
    )
    if (!is.null(idx)) {
      idx$ID <- floor(idx$idx.gp / offsite)
      ## only return the top one per 3' UTR
      idx <- idx[!duplicated(idx$ID), ]
      IDs <- unique(pos.matrix[, "ID"])
      idx.idx <- idx$idx[match(IDs, idx$ID)]
      idx.idx[is.na(idx.idx)] <- sapply(idx.list[IDs[is.na(idx.idx)]], `[`, 1)
      idx.list[IDs] <- idx.idx
    } 
  }
  idx.list
}

#' Visualization of MSE profiles, 3' UTR coverage and minimal MSE distribution
#'
#' @param CPs A list, output from [search_proximalCPs()] or [adjust_distalCPs()] 
#'   or [adjust_proximalCPs()]
#' @param outdir A character(1) vector, specifying the output directory
#' @param MSE.plot A character(1) vector, specifying a PDF file name for 
#'   outputting plots of MSE profiles. No directory path is allowed.
#' @param coverage.plot A character(1) vector, specifying a PDF file name for
#'   outputting per-sample coverage profiles. No directory path is allowed.
#' @param min.MSE.to.end.distr.plot A character(1) vector, specifying a PDF 
#'   file name for outputting histograms showing minimal MSE distribution 
#'   relative to longer 3' UTR end. No directory path is allowed.
#' @importFrom grDevices dev.off pdf rainbow
#' @importFrom graphics hist legend
#' @importFrom stats density 
#' @export
find_minMSEDistr <- function(CPs, outdir = NULL, 
                             MSE.plot = "MSE.pdf",
                             coverage.plot = "coverage.pdf",
                             min.MSE.to.end.distr.plot = 
                                 "min.MSE.to.end.distr.pdf")
{
    if (is.null(CPs[["chr.cov.merge"]]) || 
        is.null(CPs[["fit_value"]]))
    {
        stop("CPs is not a valid list.\n", 
             "per-sample coverage data and fitted values, MSEs\n",
             "should be stored in CPs!")
    }
    if (is.null(outdir)) 
    {
        stop("outdir is needed!")
    }
    if (!dir.exists(outdir))
    {
        dir.create(outdir, recursive = TRUE)
    }
    
    files <- c(MSE.plot, coverage.plot, min.MSE.to.end.distr.plot)
    if (!all(grepl("\\.pdf$", files)) || 
        any(grepl("/", files)) ||
        !all(file.create(file.path(outdir, files))))
    {
        stop("valid .pdf file names for outputting plots of MSE profiles,\n",
             "per-sample read coverage across 3' UTRs, and distribution of\n",
             "minimal non-zero MSE to longer 3 'UTR ends are needed!")
    }
    
    fit_value <- CPs$fit_value
    chr.cov.merge <- CPs$chr.cov.merge
    flag <- !unlist(lapply(fit_value, is.null))
    
    ## plot MSE profiles
    pdf(file.path(outdir, MSE.plot), height = 5, width = 15)
    null <- mapply(function(x, y){
        plot(x, main = y,
             type = "l",
             xlab = "Relative distance to start of 3' UTR",
             ylab = "MSE")
    }, fit_value[flag], names(fit_value[flag]))
    dev.off()
    
    ## plot coverage profiles
    pdf(file.path(outdir, coverage.plot), height = 5, width =15)
    null <- mapply(function(x, y)
    {
        color <- rainbow(ncol(x))
        plot(x[, 1], main = y, 
             xlab = "Relative distance to start of 3' UTR",
             ylab = "Coverage",
             type = "l",
             col = color[1],
             ylim = c(min(pmin(x)), max(pmax(x))))
        if (ncol(x) > 1)
        {
            for (i in 2:ncol(x))
            {
                lines(1:nrow(x), x[,i], col  = color[i])
            }
        }
        legend("topright", legend=colnames(x),
               col=color, lty=1, cex=0.8,
               title="Condition", 
               text.font=4)
    }, chr.cov.merge[flag], names(chr.cov.merge[flag]))
    dev.off()
    
    ## plot minMSE distribution
    rel_dist <- unlist(lapply(fit_value[flag], function(.x) {
        length(.x) - which(.x != 0 & .x== min(.x[.x !=0]))
    }))
    
    pdf(file.path(outdir, min.MSE.to.end.distr.plot), 
        height = 6, width = 10)
    hist(rel_dist, freq = FALSE, 
         breaks = 100, xlim = c(0, 2500),
         xlab = "Relative distance to end of 3' UTR",
         ylab = "Density")
    lines(density(rel_dist), xlim = c(0, 2500),
          col = "red")
    dev.off()
}

#' prepare 3' UTR coverage data for usage test
#'
#' generate a UTR3eSet object with PDUI information for statistic tests
#'
#' @param sqlite_db A path to the SQLite database for InPAS, i.e. the output of
#'   [setup_sqlitedb()].
#' @param normalize A character(1) vector, spcifying the normalization method.
#'   It can be "none", "quantiles", "quantiles.robust", "mean", or "median"
#' @param ... parameter can be passed into
#'   [preprocessCore::normalize.quantiles.robust()]
#' @param singleSample A logical(1) vector, indicating whether data is prepared
#'   for analysis in a singleSample mode? Default, FALSE
#'
#' @return An object of [UTR3eSet-class] which contains following elements:
#'   usage: an [GenomicRanges::GRanges-class] object with CP sites info. PDUI: a
#'   matrix of PDUI PDUI.log2: log2 transformed PDUI matrix short: a matrix of
#'   usage of short form long: a matrix of usage of long form if singleSample is
#'   TRUE, one more element, signals, will be included.
#' @export
#' @import GenomicRanges
#' @importFrom preprocessCore colSummarizeAvg colSummarizeMedian
#'   normalize.quantiles normalize.quantiles.robust
#' @author Jianhong Ou, Haibo Liu
#'
#' @examples
#' if (interactive()) {
#'   library(BSgenome.Mmusculus.UCSC.mm10)
#'   library(TxDb.Mmusculus.UCSC.mm10.knownGene)
#'   genome <- BSgenome.Mmusculus.UCSC.mm10
#'   TxDb <- TxDb.Mmusculus.UCSC.mm10.knownGene
#'
#'   ## load UTR3 annotation and convert it into a GRangesList
#'   data(utr3.mm10)
#'   utr3 <- split(utr3.mm10, seqnames(utr3.mm10), drop = TRUE)
#'
#'   bedgraphs <- system.file("extdata", c(
#'     "Baf3.extract.bedgraph",
#'     "UM15.extract.bedgraph"
#'   ),
#'   package = "InPAS"
#'   )
#'   tags <- c("Baf3", "UM15")
#'   metadata <- data.frame(
#'     tag = tags,
#'     condition = c("Baf3", "UM15"),
#'     bedgraph_file = bedgraphs
#'   )
#'   outdir <- tempdir()
#'   write.table(metadata,
#'     file = file.path(outdir, "metadata.txt"),
#'     sep = "\t", quote = FALSE, row.names = FALSE
#'   )
#'
#'   sqlite_db <- setup_sqlitedb(metadata = file.path(
#'     outdir,
#'     "metadata.txt"
#'   ), outdir)
#'   addLockName(filename = tempfile())
#'   coverage <- list()
#'   for (i in seq_along(bedgraphs)) {
#'     coverage[[tags[i]]] <- get_ssRleCov(
#'       bedgraph = bedgraphs[i],
#'       tag = tags[i],
#'       genome = genome,
#'       sqlite_db = sqlite_db,
#'       outdir = outdir,
#'       chr2exclude = "chrM"
#'     )
#'   }
#'
#'   data4CPsSearch <- setup_CPsSearch(sqlite_db,
#'     genome,
#'     chr.utr3 = utr3[["chr6"]],
#'     seqname = "chr6",
#'     background = "10K",
#'     TxDb = TxDb,
#'     hugeData = TRUE,
#'     outdir = outdir,
#'     minZ = 2,
#'     cutStart = 10,
#'     MINSIZE = 10,
#'     coverage_threshold = 5
#'   )
#'   ## polyA_PWM
#'   load(system.file("extdata", "polyA.rda", package = "InPAS"))
#'
#'   ## load the Naive Bayes classifier model from the cleanUpdTSeq package
#'   library(cleanUpdTSeq)
#'   data(classifier)
#'
#'   CPs <- search_CPs(
#'     seqname = "chr6",
#'     sqlite_db = sqlite_db,
#'     genome = genome,
#'     MINSIZE = 10,
#'     window_size = 100,
#'     search_point_START = 50,
#'     search_point_END = NA,
#'     cutEnd = 0,
#'     adjust_distal_polyA_end = TRUE,
#'     long_coverage_threshold = 2,
#'     PolyA_PWM = pwm,
#'     classifier = classifier,
#'     classifier_cutoff = 0.8,
#'     shift_range = 100,
#'     step = 5,
#'     outdir = outdir
#'   )
#'   utr3_cds_cov <- get_regionCov(
#'     chr.utr3 = utr3[["chr6"]],
#'     sqlite_db,
#'     outdir,
#'     phmm = FALSE
#'   )
#'   eSet <- get_UTR3eSet(sqlite_db,
#'     normalize = "none",
#'     singleSample = FALSE
#'   )
#'   test_out <- test_dPDUI(
#'     eset = eSet,
#'     method = "fisher.exact",
#'     normalize = "none",
#'     sqlite_db = sqlite_db
#'   )
#' }
get_UTR3eSet <- function(sqlite_db,
                         normalize = c(
                           "none", "quantiles",
                           "quantiles.robust",
                           "mean", "median"
                         ),
                         ...,
                         singleSample = FALSE) {
  if (missing(sqlite_db) || length(sqlite_db) != 1 || !file.exists(sqlite_db)) {
    stop("sqlite_db, a path to the SQLite database is required!")
  }
  if (!is.logical(singleSample) || length(singleSample) != 1) {
    stop("singleSample must be a logical(1) vector")
  }
  db_conn <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
  utr3_cov <- dbReadTable(db_conn, "utr3cds_coverage")
  dbDisconnect(db_conn)
  if (nrow(utr3_cov) < 1) {
    stop("Coverage data for UTR3 and last CDSs is not available")
  }

  ## load the coverage object for UTR3 and last CDSs
  UTR3_CDS.cov <- lapply(utr3_cov$coverage_file, function(.x) {
    readRDS(.x)
  })
  UTR3_CDS.cov <- unlist(GRangesList(UTR3_CDS.cov))

  normalize <- match.arg(
    arg = normalize,
    choices = c(
      "none", "quantiles",
      "quantiles.robust",
      "mean", "median"
    )
  )

  if ((!singleSample) && "data2" %in% colnames(mcols(UTR3_CDS.cov))) {
    message("Single sample mode is on")
    singleSample <- TRUE
  }
  UTRusage <- UTR3_CDS.cov[!is.na(UTR3_CDS.cov$source)]
  UTRusage <- split(UTRusage, UTRusage$transcript)
  UTRusage <- UTRusage[sapply(UTRusage, length) == 2]
  UTRusage <- unlist(UTRusage, use.names = FALSE)
  UTRusage.total <- UTRusage[UTRusage$source == "short"]
  UTRusage.long <- UTRusage[UTRusage$source == "long"]
  UTRusage.total <- UTRusage.total[!duplicated(UTRusage.total$transcript)]
  UTRusage.long <- UTRusage.long[match(
    UTRusage.total$transcript,
    UTRusage.long$transcript
  )]
  PDUItable <- UTRusage.total
  PDUItable$data <- NULL
  start(PDUItable)[as.character(strand(PDUItable)) == "-"] <-
    PDUItable$Predicted_Distal_APA[as.character(strand(PDUItable)) == "-"]
  end(PDUItable)[as.character(strand(PDUItable)) == "+"] <-
    PDUItable$Predicted_Distal_APA[as.character(strand(PDUItable)) == "+"]

  UTRusage.total.data <- do.call(rbind, UTRusage.total$data)
  UTRusage.long.data <- do.call(rbind, UTRusage.long$data)
  UTRusage.short.data <- UTRusage.total.data - UTRusage.long.data
  lt0 <- apply(UTRusage.short.data, 1, function(.ele) any(.ele < 0))
  if (any(lt0)) {
    CDSusage <-
      UTR3_CDS.cov[UTR3_CDS.cov$feature == "CDS" &
                     UTR3_CDS.cov$transcript %in% 
                     unique(PDUItable$transcript[lt0])]
    CDSusage.data <- do.call(rbind, CDSusage$data)
    rownames(CDSusage.data) <- CDSusage$transcript
    idx <- match(PDUItable$transcript[lt0], CDSusage$transcript)

    ## why this is reasonable?
    UTRusage.short.data[lt0[!is.na(idx)]] <-
      CDSusage.data[idx[!is.na(idx)], ] -
      UTRusage.long.data[lt0[!is.na(idx)]]
    UTRusage.short.data[UTRusage.short.data < 0] <- 0
  }

  ## normalization?
  normalize.foo <- function(exprs, FUN) {
    avgs <- FUN(exprs)$Estimates
    scaling.factors <- avgs / avgs[1]
    scaling.factors <- matrix(rep(scaling.factors, nrow(exprs)),
      ncol = length(scaling.factors), byrow = TRUE
    )
    exprs <- exprs / scaling.factors
  }
  normalize.mean <- function(exprs) {
    normalize.foo(exprs, colSummarizeAvg)
  }
  normalize.median <- function(exprs) {
    normalize.foo(exprs, colSummarizeMedian)
  }
  if (normalize != "none") {
    UTRusage.long.short.data <- rbind(
      UTRusage.long.data,
      UTRusage.short.data
    )
    UTRusage.long.short.data <-
      switch(normalize,
        quantile = normalize.quantiles(UTRusage.long.short.data),
        quantile.robust =
          normalize.quantiles.robust(UTRusage.long.short.data, ...),
        mean = normalize.mean(UTRusage.long.short.data),
        median = normalize.median(UTRusage.long.short.data),
        UTRusage.long.short.data
      )
    ## suppose the output should be same order
    UTRusage.long.data <-
      UTRusage.long.short.data[1:nrow(UTRusage.long.data), , drop = FALSE]
    UTRusage.short.data <-
      UTRusage.long.short.data[-(1:nrow(UTRusage.long.data)), ,
        drop = FALSE
      ]
  }

  UTRusage.PDUI <-
    UTRusage.long.data / (UTRusage.long.data + UTRusage.short.data)
  UTRusage.PDUI.log2 <- log2(UTRusage.PDUI + .Machine$double.xmin)
  rownames(UTRusage.PDUI) <-
    rownames(UTRusage.PDUI.log2) <-
    rownames(UTRusage.long.data) <-
    rownames(UTRusage.short.data) <- PDUItable$transcript
  PDUItable$source <- NULL
  if (singleSample) {
    signals.short <- UTRusage.total$data2
    signals.long <- UTRusage.long$data2

    ## ??
    cut50 <- function(x, y) {
      z <- c(x, y)
      if (length(z) > 50) {
        xat <- floor(50 * length(x) / length(z))
        z <- tapply(z, cut(1:length(z), 50), mean)
      } else {
        xat <- length(x)
      }
      c(xat, z)
    }
    signals <- mapply(cut50, signals.short,
      signals.long,
      SIMPLIFY = FALSE
    )
    names(signals) <- UTRusage.total$transcript
    new("UTR3eSet",
      usage = PDUItable,
      PDUI = UTRusage.PDUI,
      PDUI.log2 = UTRusage.PDUI.log2,
      short = UTRusage.short.data,
      long = UTRusage.long.data,
      signals = signals
    )
  } else {
    new("UTR3eSet",
      usage = PDUItable,
      PDUI = UTRusage.PDUI,
      PDUI.log2 = UTRusage.PDUI.log2,
      short = UTRusage.short.data,
      long = UTRusage.long.data
    )
  }
}

#' Get sequence lengths for chromosomes/scaffolds
#'
#' Get sequence lengths for chromosomes/scaffolds from a
#'   [BSgenome::BSgenome-class] object
#'
#' @param genome An object of [BSgenome::BSgenome-class]
#' @param chr2exclude A character vector, NA or NULL, specifying chromosomes or
#'   scaffolds to be excluded for InPAS analysis. `chrM` and alternative scaffolds
#'   representing different haplotypes should be excluded.
#'
#' @return A named numeric vector containing lengths per seqname, with the
#'   seqnames as the names
#' @seealso [Seqinfo::Seqinfo-class]
#' @keywords internal
#' @author Jianhong Ou, Haibo Liu
#' @examples
#' library(BSgenome.Mmusculus.UCSC.mm10)
#' genome <- BSgenome.Mmusculus.UCSC.mm10
#' InPAS:::get_seqLen(
#'   genome = genome,
#'   chr2exclude = "chrM"
#' )
get_seqLen <- function(genome = getInPASGenome(),
                       chr2exclude = getChr2Exclude()) {
  if (!is(genome, "BSgenome")) {
    stop("genome must be an object of BSgenome class")
  }
  if (!is.null(chr2exclude) && !is.character(chr2exclude)) {
    stop("chr2Exclude must be NULL or a character vector")
  }
  len <- seqlengths(genome)
  seqnames <- trim_seqnames(genome, chr2exclude)
  len <- len[seqnames]
  len
}

---
title: "InPAS Vignette"
author: "Jianhong Ou, Haibo Liu, Sungmi Park, Michael Green, Lihua Julie Zhu"
date: "`r Sys.Date()`"
package: "`r pkg_ver('InPAS')`"
bibliography: ref.bib
csl: nature.csl
abstract: >
   Alternative polyadenylation (APA) is one of the important post-transcriptional
   regulation mechanisms which occurs in most mammalian genes. InPAS facilitates 
   the discovery of novel APA sites and the differential usage of APA sites from 
   RNA-Seq data. It leverages cleanUpdTSeq[@sheppard2013accurate] to fine tune
   identified APA sites by removing false sites.
vignette: >
  %\VignetteIndexEntry{InPAS Vignette}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
output:
  BiocStyle::html_document
---

# Introduction

Alternative polyadenylation (APA) is one of the most important post-transcriptional regulation mechanisms which is prevalent in Eukaryotes. Like alternative splicing, APA can increase transcriptome diversity. In addition, it defines 3' UTR and results in altered expression of the gene. It is a tightly controlled process and mis-regulation of APA can affect many biological processed, such as uncontrolled cell cycle and growth. Although several high throughput sequencing methods have been developed, there are still limited data dedicated to identifying APA events.

However, massive RNA-seq datasets, which were originally created to quantify genome-wide gene expression, are available in public databases such as GEO and TCGA. These RNA-seq datasets also contain information of genome-wide APA. Thus, we developed the InPAS package for identifying APA from the conventional RNA-seq data.  

The major procedures in InPAS workflow are as follows:

- Extract genome-wide 3' UTR annotation from known genome annotation 
- Set up a SQLite database for storing experimental metadata and tracking intermediate files generated during analysis
- Convert genome-wide read coverage per sample from a BEDGraph file to a run-length encoding (Rle) format  
- Identify putative cleavage and polyadenylation (CP) site for each gene based on the read coverage profile along 3' UTR regions and optionally remove potential false positive CP sites due to technical artifacts by using the Naive Bayes classifier (NBC) model from the cleanUpdTseq package or by using the polyadenylation scores by matching the position-weight matrix (PWM) for the hexamer polyadenylation signal (AAUAAA and the like) 
- Estimate usage of proximal and distal CP sites based on read coverage along the short and long 3' UTRs  
- Identify differential usage of proximal and distal CP sites between different conditions leveraging different statistical models according to the experimental design  

In addition, the InPAS package also provide functions to perform quality control over RNA-seq data coverage, visualize differential usage of proximal and distal CP sites for genes of interest, and prepare essential files for gene set enrichment analysis (GSEA) to reveal biological insights from genes with alternative CP sites.  

# How to run InPAS 
First, load the required packages, including InPAS, and species-specific genome and genome annotation database: BSgenome, TxDb and EnsDb.

```{r load_package}
logger <- file(tempfile(), open = "wt")
sink(logger, type="message")
suppressPackageStartupMessages({
library(InPAS)
library(BSgenome.Mmusculus.UCSC.mm10)
library(BSgenome.Hsapiens.UCSC.hg19)
library(TxDb.Mmusculus.UCSC.mm10.knownGene)
library(EnsDb.Hsapiens.v86)
library(EnsDb.Mmusculus.v79)
library(cleanUpdTSeq)
library(RSQLite)
library(future.apply)
})
```
## Step 1: set up a SQLite database
Seven tables are created in the database. Table "metadata" stores  the metadata, including information for tag (sample name), condition (experimental treatment group), bedgraph_file (paths to BEDGraph files), and depth (whole genome coverage depth) which is initially set to zeros and later updated during analysis. Tables "sample_coverage", "chromosome_coverage", "total_coverage", "utr3_total_coverage", "CPsites", and "utr3cds_coverage" store names of intermediate files and the chromosome and tag (sample name) relevant to the files.   

```{r setup_sqlitedb}
plan(sequential)
data_dir <- system.file("extdata", package = "InPAS")
bedgraphs <- c(file.path(data_dir, "Baf3.extract.bedgraph"), 
               file.path(data_dir, "UM15.extract.bedgraph"))
hugeData <- FALSE
genome <- BSgenome.Mmusculus.UCSC.mm10

tags <- c("Baf3", "UM15")
metadata <- data.frame(tag = tags, 
                      condition = c("Baf3", "UM15"),
                      bedgraph_file = bedgraphs)

## In reality, don't use a temporary directory for your analysis. Instead, use a
## persistent directory to save your analysis output.
outdir = tempdir()
write.table(metadata, file = file.path(outdir =outdir, "metadata.txt"), 
            sep = "\t", quote = FALSE, row.names = FALSE)
    
sqlite_db <- setup_sqlitedb(metadata = file.path(outdir = outdir, 
                                                 "metadata.txt"),
                           outdir = outdir)

## check the database
db_conn <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
dbListTables(db_conn)
dbReadTable(db_conn, "metadata")
dbDisconnect(db_conn)
```

## Step 2: Extracting 3' UTR annotation  
3' UTR annotation, including start and end coordinates, and strand information of 3' UTRs, last CDS and the gaps between 3' extremities of 3' UTRs and immediate downstream exons, is extracted using the function `extract_UTR3Anno` from genome annotation databases: a TxDb database and an Ensembldb database for a species of interest. For demonstration, the following snippet of R scripts shows how to extract 3' UTR annotation from a abridged TxDb for a human reference genome (hg19). In reality, users should use a TxDb for the most reliable genome annotation of the PRIMARY reference genome assembly (NOT including the alternative patches) used for RNA-seq read alignment. If a TxDb is not available for the species of interest, users can build one using the function makeTxDbFromUCSC, makeTxDbFromBiomart, makeTxDbFromEnsembl, or makeTxDbFromGFF from the GenomicFeatures
package, depending on the sources of the genome annotation file.  

```{r extract_annotation}
samplefile <- system.file("extdata", 
                          "hg19_knownGene_sample.sqlite",
            package="GenomicFeatures")
TxDb <- loadDb(samplefile)
seqnames <- seqnames(BSgenome.Hsapiens.UCSC.hg19)

# exclude mitochondrial genome and alternative haplotypes
chr2exclude <- c("chrM", "chrMT", seqnames[grepl("_(hap\\d+|fix|alt)$", seqnames, perl = TRUE)])

# set up global variables for InPAS analysis
set_globals(genome = BSgenome.Hsapiens.UCSC.hg19,
            TxDb = TxDb,
            EnsDb = EnsDb.Hsapiens.v86,
            outdir = tempdir(),
            chr2exclude = chr2exclude,
            lockfile = tempfile())
utr3_anno <- 
  extract_UTR3Anno(sqlite_db = sqlite_db,
                   TxDb = getInPASTxDb(),
                   edb = getInPASEnsDb(),
                   genome = getInPASGenome(),
                   outdir = getInPASOutputDirectory(),
                   chr2exclude = getChr2Exclude())

head(utr3_anno$chr1)
```
This vignette will use the prepared 3' UTR annotation for the mouse reference genome mm10 for subsequent demonstration

```{r load_anno}
## set global variables for mouse InPAS analysis
set_globals(genome = BSgenome.Mmusculus.UCSC.mm10,
            TxDb = TxDb.Mmusculus.UCSC.mm10.knownGene,
            EnsDb = EnsDb.Mmusculus.v79,
            outdir = tempdir(),
            chr2exclude = "chrM",
            lockfile = tempfile())

tx <- parse_TxDb(sqlite_db = sqlite_db,
                 TxDb = getInPASTxDb(),
                 edb = getInPASEnsDb(),
                 genome = getInPASGenome(),
                 outdir = getInPASOutputDirectory(),
                 chr2exclude = getChr2Exclude())

# load R object: utr3.mm10
data(utr3.mm10)

## convert the GRanges into GRangesList for the 3' UTR annotation
utr3.mm10 <- split(utr3.mm10, seqnames(utr3.mm10), 
                   drop = TRUE)
```

## Step 3: reformatting coverage data  
Before this step, genome coverage in the BEDGraph format should be prepared from BAM files resulted from RNA-seq data alignment using the `genomecov` command in the BEDTools suite. BAM files can be filtered to remove multi-mapping alignments, alignments with low mapping quality and so on. Commands for reference are as follows:

```{sh eval = FALSE}
## for single end RNA-seq data aligned with STAR
## -q 255, unique mapping
samtools view -bu -h -q 255 /path/to/XXX.SE.bam | \
    bedtools genomecov -ibam  - -bga -split  > XXX.SE.uniq.bedgraph

## for paired-end RNA-seq data aligned with STAR
samtools view -bu -h -q 255 /path/to/XXX.PE.bam | \
    bedtools genomecov -ibam  - -bga -split  > XXX.PE.uniq.bedgraph
```

The genome coverage data in the BEDGraph formatis converted into R objects of Rle-class using the `get_ssRleCov` function for each chromosome of each sample. Rle objects for each individual chromosome are save to `outdir`. The filename, tag (sample name), and chromosome name are save to Table "sample_coverage". Subsequently, chromosome-specific Rle objects for all samples are assemble together into a two-level list of Rle objects, with level 1 being the chromosome name and level 2 being Rle for each tag (sample name). Notably, the sample BEDGraph files used here only contain coverage data for "chr6" of the mouse reference genome mm10.

```{r format_coverage}
coverage <- list()
for (i in seq_along(bedgraphs)){
coverage[[tags[i]]] <- get_ssRleCov(bedgraph = bedgraphs[i],
                                    tag = tags[i],
                                    genome = genome,
                                    sqlite_db = sqlite_db,
                                    outdir = outdir,
                                    chr2exclude = getChr2Exclude())
}
coverage <- assemble_allCov(sqlite_db,
                            seqname = "chr6",
                            outdir, 
                            genome = getInPASGenome())
```

At this point, users can check the data quality in terms of coverage for all and expressed genes and 3' UTRs using `run_coverageQC`. This function output summarized coverage metrics: gene.coverage.rate, expressed.gene.coverage.rate, UTR3.coverage.rate, and UTR3.expressed.gene.subset.coverage.rate. The coverage rate of quality data should be greater than 0.75 for 3' UTRs of expressed genes.

```{r coverage_QC}
if (.Platform$OS.type == "windows")
{
  plan(multisession)
} else {
  plan(multicore)
}
run_coverageQC(sqlite_db, 
               TxDb = getInPASTxDb(), 
               edb = getInPASEnsDb(), 
               genome = getInPASGenome(),
               chr2exclude = getChr2Exclude(),
               which = GRanges("chr6",
               ranges = IRanges(98013000, 140678000)))
plan(sequential)
```
## Step 4: Identifying potential CP sites  
depth weight, Z-score cutoff thresholds, and  total coverage along 3' UTRs merged across biological replicates within each condition (huge data) or individual sample (non-huge data) are returned by the `setup_CPsSearch` function. Potential novel CP sites are identified for each chromosome using the `search_CPs` function. These potential CP sites can be filtered and/or adjusted using the Naive Bayes classifier provided by _cleanUpdTseq_ and/or by using the polyadenylation scores by simply matching the position-weight matrix (PWM) for the hexamer polyadenylation signal (AAUAAA and the like). 

```{r search_CPs}
## load the Naive Bayes classifier model for classify CP sites from the 
## cleanUpdTseq package
data(classifier)

prepared_data <- setup_CPsSearch(sqlite_db,
                                 genome = getInPASGenome(), 
                                 chr.utr3 = utr3.mm10$chr6,
                                 seqname = "chr6",
                                 background = "10K",
                                 TxDb = getInPASTxDb(),
                                 hugeData = TRUE,
                                 outdir = outdir,
                                 silence = TRUE,
                                 coverage_threshold = 5)

CPsites <- search_CPs(seqname = "chr6",
                       sqlite_db = sqlite_db,
                       genome = getInPASGenome(),
                       MINSIZE = 10, 
                       window_size = 100,
                       search_point_START = 50,
                       search_point_END = NA,
                       cutEnd = 0,
                       filter.last = TRUE,
                       adjust_distal_polyA_end = TRUE,
                       long_coverage_threshold = 2,
                       PolyA_PWM = NA, 
                       classifier = classifier,
                       classifier_cutoff = 0.8,
                       shift_range = 50,
                       step = 5,
                       outdir = outdir, 
                       silence = TRUE)
```

## Step 5: Estimate usage of proximal and distal CP sites  
Estimate usage of proximal and distal CP sites based on read coverage along the short and long 3' UTRs  


```{r estimate_PDUI}
utr3_cds_cov <- get_regionCov(chr.utr3 = utr3.mm10[["chr6"]],
                              sqlite_db,
                              outdir,
                              phmm = FALSE)

eSet <- get_UTR3eSet(sqlite_db,
                     normalize ="none", 
                     singleSample = FALSE)
```
## Step 6. identifying differential PDUI events
InPAS provides the function `test_dPDUI` to identify differential usage of proximal and distal CP sites between different conditions leveraging different statistical models according to the experimental design. InPAS offers statistical methods for single sample differential PDUI analysis, and single group analysis. Additionally, InPAS provides Fisher exact test for two-group unreplicated design, and empirical Bayes linear model leveraging the limma package for more complex design. The test results can be further filtered using the `filter_testOut` function based on the fraction samples within each condition with coverage data for the identified differential PDUI events, and/or cutoffs of nominal p-values, adjusted p-values or log2 (fold change). 

```{r dPDUI_test}
test_out <- test_dPDUI(eset = eSet, 
                       method = "fisher.exact",
                       normalize = "none",
                       sqlite_db = sqlite_db)
```
```{r filter_dPDUI}
filter_out <- filter_testOut(res = test_out,
                             gp1 = "Baf3",
                             gp2 = "UM15",
                             background_coverage_threshold = 2,
                             P.Value_cutoff = 0.05,
                             adj.P.Val_cutoff = 0.05,
                             dPDUI_cutoff = 0.3,
                             PDUI_logFC_cutoff = 0.59)
```
## Step 7. Visualizing dPDUI events and preparing files for GSEA  
InPAS package also provide functions, `get_usage4plot`, `plot_utr3Usage`, and `setup_GSEA`, to visualize differential usage of proximal and distal CP sites for genes of interest, and prepare essential files for gene set enrichment analysis (GSEA) to reveal biological insights from genes with alternative CP sites.

```{r visualization}
## Visualize dPDUI events                       
gr <- GRanges("chr6", IRanges(128846245, 128850081), strand = "-")
names(gr) <- "128846245-128850081"
data4plot <- get_usage4plot(gr, 
                            proximalSites = 128849130, 
                            sqlite_db,
                            hugeData = TRUE) 

plot_utr3Usage(usage_data = data4plot, 
               vline_color = "purple", 
               vline_type = "dashed")
```

```{r setup_GSEA}
## prepare a rank file for GSEA
setup_GSEA(eset = test_out,
           groupList= list(Baf3 = "Baf3", UM15 ="UM15"),
           outdir = outdir,
           preranked = TRUE,
           rankBy = "logFC",
           rnkFilename = "InPAS.rnk")
```

# Session Info
```{r sessionInfo, results='asis'}
sessionInfo()
sink(type="message")
close(logger)
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/15.get_PAscore.R
\name{get_PAscore}
\alias{get_PAscore}
\title{Calculate the CP score}
\usage{
get_PAscore(seqname, pos, str, idx, PWM, genome, ups = 50, dws = 50)
}
\arguments{
\item{seqname}{a character(n) vector, the chromosome/scaffold' name}

\item{pos}{genomic positions}

\item{str}{DNA strand}

\item{idx}{offset position}

\item{PWM}{An R object for a position weight matrix (PWM) for a hexamer
polyadenylation signal (PAS), such as AAUAAA.}

\item{genome}{an object of \link[BSgenome:BSgenome-class]{BSgenome::BSgenome}}

\item{ups}{the number of upstream bases for PAS search.}

\item{dws}{the number of downstream bases for PAS search.}
}
\value{
A list containing offset positions after PA score-based filtering
}
\description{
Calculate the CP score by using PWM of polyadenylation signal with sequence
around given position
}
\seealso{
\code{\link[=get_PAscore2]{get_PAscore2()}}
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/23.run_limmaAnalysis.R
\name{run_limmaAnalysis}
\alias{run_limmaAnalysis}
\title{use limma to analyze the PDUI}
\usage{
run_limmaAnalysis(
  UTR3eset,
  design,
  contrast.matrix,
  coef = 1,
  robust = FALSE,
  ...
)
}
\arguments{
\item{UTR3eset}{An object of \linkS4class{UTR3eSet}, output of \code{\link[=get_UTR3eSet]{get_UTR3eSet()}}}

\item{design}{A design matrix of the experiment, with rows corresponding to
arrays and columns to coefficients to be estimated. Defaults to the unit
vector meaning that the arrays are treated as replicates. see
\code{\link[stats:model.matrix]{stats::model.matrix()}}}

\item{contrast.matrix}{A numeric matrix with rows corresponding to coefficients
in fit and columns containing contrasts. May be a vector if there is only
one contrast. see \code{\link[limma:makeContrasts]{limma::makeContrasts()}}}

\item{coef}{An integer(1) vector specifying which coefficient or a character(1)
vector specifying which contrast of the linear model is to test. see more
\code{\link[limma:toptable]{limma::topTable()}}. Default, 1.}

\item{robust}{A logical(1) vector,indicating whether the estimation of the
empirical Bayes prior parameters be robustified against outlier sample
variances?}

\item{...}{other arguments which are passed to \code{\link[limma:lmFit]{limma::lmFit()}}}
}
\value{
fit results of eBayes by limma. It is an object of class
\link[limma:marraylm]{limma::MArrayLM} containing everything found by fit. see
\code{\link[limma:ebayes]{limma::eBayes()}}
}
\description{
use limma to analyze the PDUI
}
\seealso{
\code{\link[=run_singleSampleAnalysis]{run_singleSampleAnalysis()}}, \code{\link[=run_singleGroupAnalysis]{run_singleGroupAnalysis()}}, \code{\link[=run_fisherExactTest]{run_fisherExactTest()}}
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/10.get_UTR3TotalCov.R
\name{fft.smooth}
\alias{fft.smooth}
\title{Smoothing using Fast Discrete Fourier Transform}
\usage{
fft.smooth(sn, p)
}
\arguments{
\item{sn}{a real or complex array containing the values to be transformed.
see \code{\link[stats:fft]{stats::fft()}}}

\item{p}{An integer(1), fft smoothing power}
}
\value{
a numeric vector, the real part of inverse fft-transformed signal
}
\description{
Smoothing using Fast Discrete Fourier Transform
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.set_globals.R
\name{getInPASEnsDb}
\alias{getInPASEnsDb}
\title{Get the globally defined EnsDb.}
\usage{
getInPASEnsDb()
}
\value{
An object of \link[ensembldb:EnsDb-class]{ensembldb::EnsDb}
}
\description{
Get the globally defined EnsDb.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/18.get_UTR3CDS.R
\name{get_UTR3CDS}
\alias{get_UTR3CDS}
\title{Get 3' UTRs and their last CDS regions based on CP sites}
\usage{
get_UTR3CDS(
  sqlite_db,
  chr.utr3,
  outdir = getInPASOutputDirectory(),
  min.length.diff = 200
)
}
\arguments{
\item{sqlite_db}{A path to the SQLite database for InPAS, i.e. the output of
setup_sqlitedb().}

\item{chr.utr3}{An object of \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges}, specifying UTR3
GRanges for a chromosome. It must be one element of an output of
\code{\link[=extract_UTR3Anno]{extract_UTR3Anno()}}.}

\item{outdir}{A character(1) vector, a path with write permission for storing
InPAS analysis results. If it doesn't exist, it will be created.}

\item{min.length.diff}{An integer(1) vector, specifying minimal length
difference between proximal and distal APA sites which should be met to be
considered for differential APA analysis. Default is 200 bp.}
}
\value{
An object of \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges} containing GRanges for
UTRs with alternative CP sites and the corresponding last CDSs.
}
\description{
Get 3' UTRs and their last CDS regions based on CP sites
}
\author{
Jianhong Ou, Haibo Liu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/24.filter_testOut.R
\name{filter_testOut}
\alias{filter_testOut}
\title{filter 3' UTR usage test results}
\usage{
filter_testOut(
  res,
  gp1,
  gp2,
  outdir = getInPASOutputDirectory(),
  background_coverage_threshold = 2,
  P.Value_cutoff = 0.05,
  adj.P.Val_cutoff = 0.05,
  dPDUI_cutoff = 0.2,
  PDUI_logFC_cutoff = log2(1.5)
)
}
\arguments{
\item{res}{a \linkS4class{UTR3eSet} object, output of \code{\link[=test_dPDUI]{test_dPDUI()}}}

\item{gp1}{tag names involved in group 1. gp1 and gp2 are used for filtering
purpose if both are specified; otherwise only other specified thresholds
are used for filtering.}

\item{gp2}{tag names involved in group 2}

\item{outdir}{A character(1) vector, a path with write permission for storing
InPAS analysis results. If it doesn't exist, it will be created.}

\item{background_coverage_threshold}{background coverage cut off value. for
each group, more than half of the long form should greater than
background_coverage_threshold. for both group, at least in one group, more
than half of the short form should greater than
background_coverage_threshold.}

\item{P.Value_cutoff}{cutoff of P value}

\item{adj.P.Val_cutoff}{cutoff of adjust P value}

\item{dPDUI_cutoff}{cutoff of dPDUI}

\item{PDUI_logFC_cutoff}{cutoff of PDUI log2 transformed fold change}
}
\value{
A data frame converted from an object of
\link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges}.
}
\description{
filter results of \code{\link[=test_dPDUI]{test_dPDUI()}}
}
\examples{
library(limma)
path <- system.file("extdata", package = "InPAS")
load(file.path(path, "eset.MAQC.rda"))
tags <- colnames(eset@PDUI)
g <- factor(gsub("\\\\..*$", "", tags))
design <- model.matrix(~ -1 + g)
colnames(design) <- c("Brain", "UHR")
contrast.matrix <- makeContrasts(
  contrasts = "Brain-UHR",
  levels = design
)
res <- test_dPDUI(
  eset = eset,
  method = "limma",
  normalize = "none",
  design = design,
  contrast.matrix = contrast.matrix
)
filter_testOut(res,
  gp1 = c("Brain.auto", "Brain.phiX"),
  gp2 = c("UHR.auto", "UHR.phiX"),
  background_coverage_threshold = 2,
  P.Value_cutoff = 0.05,
  adj.P.Val_cutoff = 0.05,
  dPDUI_cutoff = 0.3,
  PDUI_logFC_cutoff = .59
)
}
\seealso{
\code{\link[=test_dPDUI]{test_dPDUI()}}
}
\author{
Jianhong Ou, Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.set_globals.R
\name{addLockName}
\alias{addLockName}
\title{Add a filename for locking a SQLite database}
\usage{
addLockName(filename = NULL)
}
\arguments{
\item{filename}{A character(1) vector, specifyong a path to a file for locking.}
}
\description{
Add a filename for locking a SQLite database
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/14.get_PAscore2.R
\name{get_PAscore2}
\alias{get_PAscore2}
\title{calculate the CP score}
\usage{
get_PAscore2(
  seqname,
  pos,
  str,
  idx,
  idx.gp,
  genome,
  classifier,
  classifier_cutoff
)
}
\arguments{
\item{seqname}{a character(1) vector, the chromosome/scaffold's name}

\item{pos}{genomic positions}

\item{str}{DNA strand}

\item{idx}{offset position}

\item{idx.gp}{group number of the offset position}

\item{genome}{an object of \link[BSgenome:BSgenome-class]{BSgenome::BSgenome}}

\item{classifier}{An R object for Naive Bayes classifier model, like the one
in the cleanUpdTSeq package.}

\item{classifier_cutoff}{A numeric(1) vector. A cutoff of probability that a
site is classified as true CP sites. The value should be between 0.5 and 1.
Default, 0.8.}
}
\value{
a data frame or NULL
}
\description{
calculate CP score by cleanUpdTSeq
}
\seealso{
\code{\link[=get_PAscore]{get_PAscore()}}
}
\author{
Jianhong Ou, Haibo Liu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/10.get_UTR3TotalCov.R
\name{get_UTR3TotalCov}
\alias{get_UTR3TotalCov}
\title{extract coverage of 3' UTR for CP sites prediction}
\usage{
get_UTR3TotalCov(
  chr.utr3,
  chr.totalCov,
  gcCompensation = NA,
  mappabilityCompensation = NA,
  FFT = FALSE,
  fft.sm.power = 20
)
}
\arguments{
\item{chr.utr3}{An object of \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges}. It must be an
element of the output of \code{\link[=extract_UTR3Anno]{extract_UTR3Anno()}} for a given chromosome.}

\item{chr.totalCov}{total coverage for each condition of a given chromosome. It
must be an output of \code{\link[=get_totalCov]{get_totalCov()}}}

\item{mappabilityCompensation}{mappability compensation vector. Not support
yet.}

\item{FFT}{Use FFT smooth or not.}

\item{fft.sm.power}{the cut-off frequency of FFT smooth.}

\item{gcCompensationensation}{GC compensation vector. Not support yet.}
}
\value{
path to a file storing the UTR3 total coverage for a given
chromosome/scaffold
}
\description{
extract 3' UTR coverage from totalCov according to the
\link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges} object utr3.
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.set_globals.R
\name{getInPASOutputDirectory}
\alias{getInPASOutputDirectory}
\title{Get the path to a output directory for InPAS analysis}
\usage{
getInPASOutputDirectory()
}
\value{
a normalized path to a output directory for InPAS analysis
}
\description{
Get the path to a output directory for InPAS analysis
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.set_globals.R
\name{addInPASOutputDirectory}
\alias{addInPASOutputDirectory}
\title{Add a globally defined output directory to some InPAS functions.}
\usage{
addInPASOutputDirectory(outdir = NULL)
}
\arguments{
\item{outdir}{A character(1) vector, a path with write permission for storing
InPAS analysis results. If it doesn't exist, it will be created.}
}
\description{
Add a globally defined output directory to some InPAS functions.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/10.get_UTR3TotalCov.R
\name{compensation}
\alias{compensation}
\title{Compensate the coverage with GC-content or mappability}
\usage{
compensation(view, comp, start, end)
}
\arguments{
\item{view}{A list of view object}

\item{comp}{A numeric vector of weight for GC composition or mappability}

\item{start}{An integer vector, starting coordinates}

\item{end}{An integer vector, end coordinates}
}
\value{
a list of GC composition or mappability corrected coverage
}
\description{
Compensate the coverage with GC-content or mappability
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/21.get_UTR3eSet.R
\name{get_UTR3eSet}
\alias{get_UTR3eSet}
\title{prepare 3' UTR coverage data for usage test}
\usage{
get_UTR3eSet(
  sqlite_db,
  normalize = c("none", "quantiles", "quantiles.robust", "mean", "median"),
  ...,
  singleSample = FALSE
)
}
\arguments{
\item{sqlite_db}{A path to the SQLite database for InPAS, i.e. the output of
\code{\link[=setup_sqlitedb]{setup_sqlitedb()}}.}

\item{normalize}{A character(1) vector, spcifying the normalization method.
It can be "none", "quantiles", "quantiles.robust", "mean", or "median"}

\item{...}{parameter can be passed into
\code{\link[preprocessCore:normalize.quantiles.robust]{preprocessCore::normalize.quantiles.robust()}}}

\item{singleSample}{A logical(1) vector, indicating whether data is prepared
for analysis in a singleSample mode? Default, FALSE}
}
\value{
An object of \linkS4class{UTR3eSet} which contains following elements:
usage: an \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges} object with CP sites info. PDUI: a
matrix of PDUI PDUI.log2: log2 transformed PDUI matrix short: a matrix of
usage of short form long: a matrix of usage of long form if singleSample is
TRUE, one more element, signals, will be included.
}
\description{
generate a UTR3eSet object with PDUI information for statistic tests
}
\examples{
if (interactive()) {
  library(BSgenome.Mmusculus.UCSC.mm10)
  library(TxDb.Mmusculus.UCSC.mm10.knownGene)
  genome <- BSgenome.Mmusculus.UCSC.mm10
  TxDb <- TxDb.Mmusculus.UCSC.mm10.knownGene

  ## load UTR3 annotation and convert it into a GRangesList
  data(utr3.mm10)
  utr3 <- split(utr3.mm10, seqnames(utr3.mm10), drop = TRUE)

  bedgraphs <- system.file("extdata", c(
    "Baf3.extract.bedgraph",
    "UM15.extract.bedgraph"
  ),
  package = "InPAS"
  )
  tags <- c("Baf3", "UM15")
  metadata <- data.frame(
    tag = tags,
    condition = c("Baf3", "UM15"),
    bedgraph_file = bedgraphs
  )
  outdir <- tempdir()
  write.table(metadata,
    file = file.path(outdir, "metadata.txt"),
    sep = "\t", quote = FALSE, row.names = FALSE
  )

  sqlite_db <- setup_sqlitedb(metadata = file.path(
    outdir,
    "metadata.txt"
  ), outdir)
  addLockName(filename = tempfile())
  coverage <- list()
  for (i in seq_along(bedgraphs)) {
    coverage[[tags[i]]] <- get_ssRleCov(
      bedgraph = bedgraphs[i],
      tag = tags[i],
      genome = genome,
      sqlite_db = sqlite_db,
      outdir = outdir,
      chr2exclude = "chrM"
    )
  }

  data4CPsSearch <- setup_CPsSearch(sqlite_db,
    genome,
    chr.utr3 = utr3[["chr6"]],
    seqname = "chr6",
    background = "10K",
    TxDb = TxDb,
    hugeData = TRUE,
    outdir = outdir,
    minZ = 2,
    cutStart = 10,
    MINSIZE = 10,
    coverage_threshold = 5
  )
  ## polyA_PWM
  load(system.file("extdata", "polyA.rda", package = "InPAS"))

  ## load the Naive Bayes classifier model from the cleanUpdTSeq package
  library(cleanUpdTSeq)
  data(classifier)

  CPs <- search_CPs(
    seqname = "chr6",
    sqlite_db = sqlite_db,
    genome = genome,
    MINSIZE = 10,
    window_size = 100,
    search_point_START = 50,
    search_point_END = NA,
    cutEnd = 0,
    adjust_distal_polyA_end = TRUE,
    long_coverage_threshold = 2,
    PolyA_PWM = pwm,
    classifier = classifier,
    classifier_cutoff = 0.8,
    shift_range = 100,
    step = 5,
    outdir = outdir
  )
  utr3_cds_cov <- get_regionCov(
    chr.utr3 = utr3[["chr6"]],
    sqlite_db,
    outdir,
    phmm = FALSE
  )
  eSet <- get_UTR3eSet(sqlite_db,
    normalize = "none",
    singleSample = FALSE
  )
  test_out <- test_dPDUI(
    eset = eSet,
    method = "fisher.exact",
    normalize = "none",
    sqlite_db = sqlite_db
  )
}
}
\author{
Jianhong Ou, Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/25.setup_GSEA.R
\name{setup_GSEA}
\alias{setup_GSEA}
\title{prepare files for GSEA analysis}
\usage{
setup_GSEA(
  eset,
  groupList,
  outdir = getInPASOutputDirectory(),
  preranked = TRUE,
  rankBy = c("logFC", "P.value"),
  rnkFilename = "InPAS.rnk",
  chipFilename = "InPAS.chip",
  dataFilename = "dPDUI.txt",
  PhenFilename = "group.cls"
)
}
\arguments{
\item{eset}{A \linkS4class{UTR3eSet} object, output of \code{\link[=test_dPDUI]{test_dPDUI()}}}

\item{groupList}{A list of grouped sample tag names, with the group names as
the list's name, such as list(groupA = c("sample_1", "sample_2",
"sample_3"), groupB = c("sample_4", "sample_5", "sample_6"))}

\item{outdir}{A character(1) vector, a path with write permission for storing
InPAS analysis results. If it doesn't exist, it will be created.}

\item{preranked}{A logical(1) vector, out preranked or not}

\item{rankBy}{A character(1) vector, indicating how the gene list is ranked.
It can be "logFC" or "P.value".}

\item{rnkFilename}{A character(1) vector, specifying a filename for the
preranked file}

\item{chipFilename}{A character(1) vector, specifying a filename for the
chip file}

\item{dataFilename}{A character(1) vector, specifying a filename for the
dataset file}

\item{PhenFilename}{A character(1) vector, specifying a filename for the
file containing samples' phenotype labels}
}
\description{
output the log2 transformed delta PDUI txt file, chip file, rank file and
phynotype label file for GSEA analysis
}
\examples{
library(limma)
path <- system.file("extdata", package = "InPAS")
load(file.path(path, "eset.MAQC.rda"))
tags <- colnames(eset@PDUI)
g <- factor(gsub("\\\\..*$", "", tags))
design <- model.matrix(~ -1 + g)
colnames(design) <- c("Brain", "UHR")
contrast.matrix <- makeContrasts(
  contrasts = "Brain-UHR",
  levels = design
)
res <- test_dPDUI(
  eset = eset,
  method = "limma",
  normalize = "none",
  design = design,
  contrast.matrix = contrast.matrix
)
gp1 <- c("Brain.auto", "Brain.phiX")
gp2 <- c("UHR.auto", "UHR.phiX")
groupList <- list(Brain = gp1, UHR = gp2)
setup_GSEA(res,
  groupList = groupList,
  outdir = tempdir(),
  preranked = TRUE,
  rankBy = "P.value"
)
}
\seealso{
data formats for GSEA.
\url{https://software.broadinstitute.org/cancer/software/gsea/wiki/index.php/Data_formats}
}
\author{
Jianhong Ou, Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.set_globals.R
\name{getInPASTxDb}
\alias{getInPASTxDb}
\title{Get the globally defined TxDb.}
\usage{
getInPASTxDb()
}
\value{
An object of \link[GenomicFeatures:TxDb-class]{GenomicFeatures::TxDb}
}
\description{
Get the globally defined TxDb.
}
\examples{
library("TxDb.Hsapiens.UCSC.hg19.knownGene")
addInPASTxDb(TxDb = TxDb.Hsapiens.UCSC.hg19.knownGene)
getInPASTxDb()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/11.setup_CPsSearch.R
\name{setup_parCPsSearch}
\alias{setup_parCPsSearch}
\title{Prepare data for predicting cleavage and polyadenylation (CP) sites using
parallel computing}
\usage{
setup_parCPsSearch(
  sqlite_db,
  genome = getInPASGenome(),
  utr3,
  seqnames,
  background = c("same_as_long_coverage_threshold", "1K", "5K", "10K", "50K"),
  TxDb = getInPASTxDb(),
  future.chunk.size = 1,
  chr2exclude = getChr2Exclude(),
  hugeData = TRUE,
  outdir = getInPASOutputDirectory(),
  silence = FALSE,
  minZ = 2,
  cutStart = 10,
  MINSIZE = 10,
  coverage_threshold = 5
)
}
\arguments{
\item{sqlite_db}{A path to the SQLite database for InPAS, i.e. the output of
\code{\link[=setup_sqlitedb]{setup_sqlitedb()}}.}

\item{genome}{An object of \link[BSgenome:BSgenome-class]{BSgenome::BSgenome}}

\item{utr3}{An object of \link[GenomicRanges:GRangesList-class]{GenomicRanges::GRangesList}, the output of
\code{\link[=extract_UTR3Anno]{extract_UTR3Anno()}}}

\item{seqnames}{A character(1), the names of all chromosomes/scaffolds with
both coverage and 3' UTR annotation. Users can get this by calling the
get_chromosomes().}

\item{background}{A character(1) vector, the range for calculating cutoff
threshold of local background. It can be "same_as_long_coverage_threshold",
"1K", "5K","10K", or "50K".}

\item{TxDb}{an object of \link[GenomicFeatures:TxDb-class]{GenomicFeatures::TxDb}}

\item{future.chunk.size}{The average number of elements per future
("chunk"). If Inf, then all elements are processed in a single future.
If NULL, then argument future.scheduling = 1 is used by default. Users can
set future.chunk.size = total number of elements/number of cores set for
the backend. See the future.apply package for details.}

\item{chr2exclude}{A character vector, NA or NULL, specifying chromosomes or
scaffolds to be excluded for InPAS analysis. \code{chrM} and alternative scaffolds
representing different haplotypes should be excluded.}

\item{hugeData}{A logical(1) vector, indicating whether it is huge data}

\item{outdir}{A character(1) vector, a path with write permission for storing
InPAS analysis results. If it doesn't exist, it will be created.}

\item{silence}{report progress or not. By default it doesn't report progress.}

\item{minZ}{A numeric(1), a Z score cutoff value}

\item{cutStart}{An integer(1) vector a numeric(1) vector. What percentage or
how many nucleotides should be removed from 5' extremities before searching
for CP sites? It can be a decimal between 0, and 1, or an integer greater
than 1. 0.1 means 10 percent, 25 means cut first 25 bases}

\item{MINSIZE}{A integer(1) vector, specifying the minimal length in bp of a
short/proximal 3' UTR. Default, 10}

\item{coverage_threshold}{An integer(1) vector, specifying the cutoff
threshold of coverage for first 100 nucleotides. If the coverage of first
100 nucleotides is lower than coverage_threshold, that transcript will be
not considered for further analysis. Default, 5.}
}
\value{
A list of list as described below:
\describe{\item{background}{The type of methods for background
coverage calculation}
\item{z2s}{Z-score cutoff thresholds for each 3' UTRs}
\item{depth.weight}{A named vector containing depth weight}
\item{chr.cov.merge}{A list of matrice storing condition/sample-
specific coverage for 3' UTR and next.exon.gap (if exist)}
\item{conn_next_utr3}{A logical vector, indicating whether a 3'UTR
has a convergent 3' UTR of its downstream transcript}
\item{chr.utr3}{A GRangesList, storing extracted 3' UTR annotation
of transcript on a given chr}
}
}
\description{
Prepare data for predicting cleavage and polyadenylation (CP) sites using
parallel computing
}
\author{
Jianhong Ou, Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/04.get_chromosomes.R
\name{get_chromosomes}
\alias{get_chromosomes}
\title{Identify chromosomes/scaffolds for CP site discovery}
\usage{
get_chromosomes(utr3, sqlite_db)
}
\arguments{
\item{utr3}{An object of \link[GenomicRanges:GRangesList-class]{GenomicRanges::GRangesList}. An output of
\code{\link[=extract_UTR3Anno]{extract_UTR3Anno()}}.}

\item{sqlite_db}{A path to the SQLite database for InPAS, i.e. the output of
\code{\link[=setup_sqlitedb]{setup_sqlitedb()}}.}
}
\value{
A vector of characters, containing names of chromosomes/scaffolds
for CP site discovery
}
\description{
Identify chromosomes/scaffolds which have both coverage and annotated
3' utr3 for CP site discovery
}
\examples{
library(BSgenome.Mmusculus.UCSC.mm10)
genome <- BSgenome.Mmusculus.UCSC.mm10
data(utr3.mm10)
utr3 <- split(utr3.mm10, seqnames(utr3.mm10), drop = TRUE)
bedgraphs <- system.file("extdata", c(
  "Baf3.extract.bedgraph",
  "UM15.extract.bedgraph"
),
package = "InPAS"
)
tags <- c("Baf3", "UM15")
metadata <- data.frame(
  tag = tags,
  condition = c("Baf3", "UM15"),
  bedgraph_file = bedgraphs
)
outdir <- tempdir()
write.table(metadata,
  file = file.path(outdir, "metadata.txt"),
  sep = "\t", quote = FALSE, row.names = FALSE
)

sqlite_db <- setup_sqlitedb(
  metadata = file.path(
    outdir,
    "metadata.txt"
  ),
  outdir
)
addLockName(filename = tempfile())
coverage <- list()
for (i in seq_along(bedgraphs)) {
      coverage[[tags[i]]] <- get_ssRleCov(
      bedgraph = bedgraphs[i],
      tag = tags[i],
      genome = genome,
      sqlite_db = sqlite_db,
      outdir = outdir,
      chr2exclude = "chrM"
    )
}
get_chromosomes(utr3, sqlite_db)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/11.setup_CPsSearch.R
\name{setup_CPsSearch}
\alias{setup_CPsSearch}
\title{prepare data for predicting cleavage and polyadenylation (CP) sites}
\usage{
setup_CPsSearch(
  sqlite_db,
  genome = getInPASGenome(),
  chr.utr3,
  seqname,
  background = c("same_as_long_coverage_threshold", "1K", "5K", "10K", "50K"),
  TxDb = getInPASTxDb(),
  hugeData = TRUE,
  outdir = getInPASOutputDirectory(),
  silence = FALSE,
  minZ = 2,
  cutStart = 10,
  MINSIZE = 10,
  coverage_threshold = 5
)
}
\arguments{
\item{sqlite_db}{A path to the SQLite database for InPAS, i.e. the output of
\code{\link[=setup_sqlitedb]{setup_sqlitedb()}}.}

\item{genome}{An object of \link[BSgenome:BSgenome-class]{BSgenome::BSgenome}}

\item{chr.utr3}{An object of \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges}, an element of the
output of \code{\link[=extract_UTR3Anno]{extract_UTR3Anno()}}}

\item{seqname}{A character(1), the name of a chromosome/scaffold}

\item{background}{A character(1) vector, the range for calculating cutoff
threshold of local background. It can be "same_as_long_coverage_threshold",
"1K", "5K","10K", or "50K".}

\item{TxDb}{an object of \link[GenomicFeatures:TxDb-class]{GenomicFeatures::TxDb}}

\item{hugeData}{A logical(1) vector, indicating whether it is huge data}

\item{outdir}{A character(1) vector, a path with write permission for storing
InPAS analysis results. If it doesn't exist, it will be created.}

\item{silence}{report progress or not. By default it doesn't report progress.}

\item{minZ}{A numeric(1), a Z score cutoff value}

\item{cutStart}{An integer(1) vector a numeric(1) vector. What percentage or
how many nucleotides should be removed from 5' extremities before searching
for CP sites? It can be a decimal between 0, and 1, or an integer greater
than 1. 0.1 means 10 percent, 25 means cut first 25 bases}

\item{MINSIZE}{A integer(1) vector, specifying the minimal length in bp of a
short/proximal 3' UTR. Default, 10}

\item{coverage_threshold}{An integer(1) vector, specifying the cutoff
threshold of coverage for first 100 nucleotides. If the coverage of first
100 nucleotides is lower than coverage_threshold, that transcript will be
not considered for further analysis. Default, 5.}
}
\value{
A file storing a list as described below:
\describe{\item{background}{The type of methods for background
coverage calculation}
\item{z2s}{Z-score cutoff thresholds for each 3' UTRs}
\item{depth.weight}{A named vector containing depth weight}
\item{chr.cov.merge}{A matrix storing condition/sample-specific
coverage for 3' UTR and next.exon.gap (if exist)}
\item{conn_next_utr3}{A logical vector, indicating whether a 3'UTR
has a convergent 3' UTR of its downstream transcript}
\item{chr.utr3}{A GRangesList, storing extracted 3' UTR annotation
of transcript on a given chr}
}
}
\description{
prepare data for predicting cleavage and polyadenylation (CP) sites
}
\examples{
if (interactive()) {
  library(BSgenome.Mmusculus.UCSC.mm10)
  library("TxDb.Mmusculus.UCSC.mm10.knownGene")
  genome <- BSgenome.Mmusculus.UCSC.mm10
  TxDb <- TxDb.Mmusculus.UCSC.mm10.knownGene

  ## load UTR3 annotation and convert it into a GRangesList
  data(utr3.mm10)
  utr3 <- split(utr3.mm10, seqnames(utr3.mm10), drop = TRUE)

  bedgraphs <- system.file("extdata", c(
    "Baf3.extract.bedgraph",
    "UM15.extract.bedgraph"
  ),
  package = "InPAS"
  )
  tags <- c("Baf3", "UM15")
  metadata <- data.frame(
    tag = tags,
    condition = c("Baf3", "UM15"),
    bedgraph_file = bedgraphs
  )
  outdir <- tempdir()
  write.table(metadata,
    file = file.path(outdir, "metadata.txt"),
    sep = "\t", quote = FALSE, row.names = FALSE
  )

  sqlite_db <- setup_sqlitedb(
    metadata = file.path(
      outdir,
      "metadata.txt"
    ),
    outdir
  )
  addLockName(filename = tempfile())
  coverage <- list()
  for (i in seq_along(bedgraphs)) {
    coverage[[tags[i]]] <- get_ssRleCov(
      bedgraph = bedgraphs[i],
      tag = tags[i],
      genome = genome,
      sqlite_db = sqlite_db,
      outdir = outdir,
      chr2exclude = "chrM"
    )
  }
  data4CPsitesSearch <- setup_CPsSearch(sqlite_db,
    genome,
    chr.utr3 = utr3[["chr6"]],
    seqname = "chr6",
    background = "10K",
    TxDb = TxDb,
    hugeData = TRUE,
    outdir = outdir
  )
}
}
\author{
Jianhong Ou, Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/27.plot_utr3Usage.R
\name{plot_utr3Usage}
\alias{plot_utr3Usage}
\title{Visualize the dPDUI events using ggplot2}
\usage{
plot_utr3Usage(usage_data, vline_color = "purple", vline_type = "dashed")
}
\arguments{
\item{usage_data}{An object of \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges}, an output from
\code{\link[=get_usage4plot]{get_usage4plot()}}.}

\item{vline_color}{color for vertical line showing position of predicated
proximal CP site. Default, purple.}

\item{vline_type}{line type for vertical line showing position of predicated
proximal CP site. Default, dashed. See \href{https://cran.r-project.org/web/packages/ggplot2/vignettes/ggplot2-specs.html}{ggplot2 linetype}.}
}
\value{
A ggplot object for refined plotting
}
\description{
Visualize the dPDUI events by plotting the MSE, and total coverage per group
along 3' UTR regions with dPDUI using \code{\link[ggplot2:geom_path]{ggplot2::geom_line ()}}.
}
\seealso{
For example, see \code{\link[=get_usage4plot]{get_usage4plot()}}.
}
\author{
Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/17.polish_CPs.R
\name{polish_CPs}
\alias{polish_CPs}
\title{polish the searching results of CP sites}
\usage{
polish_CPs(CPs, output.all, DIST2END = 200)
}
\arguments{
\item{CPs}{output of \code{\link[=search_proximalCPs]{search_proximalCPs()}} or \code{\link[=adjust_proximalCPs]{adjust_proximalCPs()}}}

\item{output.all}{A logical(1), indicating whether to output entries with only
single CP site for a 3' UTR.}

\item{DIST2END}{An integer(1) vector, specifying minimal length
difference between proximal and distal APA sites which should be met to be
considered for outputted if \emph{output.all} is set to TRUE. Default is 200 bp.}
}
\value{
a data.frame with columns: "fit_value", "Predicted_Proximal_APA",
"Predicted_Distal_APA", "utr3start", "utr3end", "Predicted_Distal_APA_type"
}
\description{
remove the multiple positions of CP sites for the same 3' UTRs and only keep
the best CP sites for proximal and distal.
}
\seealso{
\code{\link[=adjust_proximalCPs]{adjust_proximalCPs()}}, \code{\link[=adjust_proximalCPsByPWM]{adjust_proximalCPsByPWM()}},
\code{\link[=adjust_proximalCPsByNBC]{adjust_proximalCPsByNBC()}}, \code{\link[=get_PAscore2]{get_PAscore2()}}
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.trim_seqnames.R
\name{trim_seqnames}
\alias{trim_seqnames}
\title{Filter sequence names from a BSgenome object}
\usage{
trim_seqnames(genome = getInPASGenome(), chr2exclude = getChr2Exclude())
}
\arguments{
\item{genome}{An object of \link[BSgenome:BSgenome-class]{BSgenome::BSgenome}}

\item{chr2exclude}{A character vector, NA or NULL, specifying chromosomes or
scaffolds to be excluded for InPAS analysis. \code{chrM} and alternative scaffolds
representing different haplotypes should be excluded.}
}
\value{
An character vector containing filtered seqnames
}
\description{
Filter sequence names for scaffolds from a BSgenome object so that only
chromosome-level seqnames are kept.
}
\author{
Jianhong Ou, Haibo Liu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/15.find_valleyBySpline.R
\name{find_valleyBySpline}
\alias{find_valleyBySpline}
\title{Find major valleys after spline smoothing}
\usage{
find_valleyBySpline(
  x,
  ss,
  se = length(x),
  nknots = ceiling((se - ss + 1)/1000 * 10),
  n = -1,
  min.dist = 200,
  filter.last = TRUE,
  DIST2END = 1200,
  plot = FALSE
)
}
\arguments{
\item{x}{A vector of numeric(n), containing MSEs for a given range}

\item{ss}{An positive integer, search start site relative to the leftmost base}

\item{se}{An positive integer, search end site relative to the leftmost base}

\item{nknots}{An positive integer, the number of knots for smoothing using
spline\code{\link[stats:smooth.spline]{stats::smooth.spline()}}. By default, set to 10 knots per kb.}

\item{n}{An integer, specifying the number of location where MSE are local
minima (candidate CP sites). If set to -1, return all candidate CP sites.}

\item{min.dist}{An integer, minimal distance allowed between two adjacent
candidate CP sites otherwise collapsed by selecting the one with lower MSE.}

\item{filter.last}{A logical(1), whether to filter out the last valley, which
is likely the 3' end of the longer 3' UTR if no novel distal CP site is
detected and the 3' end excluded by setting cutEnd/search_point_END is small.}

\item{DIST2END}{An integer, specifying a cutoff of the distance between last valley
and the end of the 3' UTR (where MSE of the last base is calculated). If
the last valley is closer to the end than the specified distance, it will be
not be considered because it is very likely due to RNA coverage decay at the
end of mRNA. Default is 1200. User can consider a value between 1000 and
1500, depending on the library preparation procedures: RNA fragmentation and
size selection.}

\item{plot}{A logical(1), whether to plot the MSE profile and the candidate
valleys.}
}
\value{
A vector of integer.
}
\description{
Find major valleys after spline smoothing
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.set_globals.R
\name{getInPASGenome}
\alias{getInPASGenome}
\title{Get the globally defined genome}
\usage{
getInPASGenome()
}
\description{
This function will retrieve the genome that is currently in use by InPAS.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/05.assemble_allCov.R
\name{assemble_allCov}
\alias{assemble_allCov}
\title{Assemble coverage files for a given chromosome for all samples}
\usage{
assemble_allCov(
  sqlite_db,
  seqname,
  outdir = getInPASOutputDirectory(),
  genome = getInPASGenome()
)
}
\arguments{
\item{sqlite_db}{A path to the SQLite database for InPAS, i.e.
the output of setup_sqlitedb()}

\item{seqname}{A character(1) vector, the name of a chromosome/scaffold}

\item{outdir}{A character(1) vector, a path with write permission for storing
InPAS analysis results. If it doesn't exist, it will be created.}

\item{genome}{An object of \link[BSgenome:BSgenome-class]{BSgenome::BSgenome}}
}
\value{
A list of paths to per-chromosome coverage files of all samples.
\itemize{\item seqname, chromosome/scaffold name
\itemize{
\item  tag1, name tag for sample1
\item  tag2, name tag for sample2
\item  tagN, name tag for sampleN
}
}
}
\description{
Process individual sample-chromosome-specific coverage files in an
experiment into a file containing a list of chromosome-specific Rle
coverage of all samples
}
\examples{
if (interactive()) {
  library(BSgenome.Mmusculus.UCSC.mm10)
  genome <- BSgenome.Mmusculus.UCSC.mm10
  bedgraphs <- system.file("extdata", c(
    "Baf3.extract.bedgraph",
    "UM15.extract.bedgraph"
  ),
  package = "InPAS"
  )
  tags <- c("Baf3", "UM15")
  metadata <- data.frame(
    tag = tags,
    condition = c("Baf3", "UM15"),
    bedgraph_file = bedgraphs
  )
  outdir <- tempdir()
  write.table(metadata,
    file = file.path(outdir, "metadata.txt"),
    sep = "\t", quote = FALSE, row.names = FALSE
  )

  sqlite_db <- setup_sqlitedb(
    metadata = file.path(
      outdir,
      "metadata.txt"
    ),
    outdir
  )
  coverage <- list()
  addLockName(filename = tempfile())
  for (i in seq_along(bedgraphs)) {
    coverage[[tags[i]]] <- get_ssRleCov(
      bedgraph = bedgraphs[i],
      tag = tags[i],
      genome = genome,
      sqlite_db = sqlite_db,
      outdir = outdir,
      chr2exclude = "chrM"
    )
  }
  chr_coverage <- assemble_allCov(sqlite_db,
    seqname = "chr6",
    outdir = outdir,
    genome = genome
  )
}
}
\author{
Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/18.get_UTR3region.R
\name{get_UTR3region}
\alias{get_UTR3region}
\title{extract long and short 3UTR region}
\usage{
get_UTR3region(.grs)
}
\arguments{
\item{.grs}{output of \code{\link[=search_CPs]{search_CPs()}}}
}
\value{
A \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges} object with short form and long 3' UTR forms
}
\description{
extract long and short 3UTR region
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.data.R
\docType{data}
\name{utr3.mm10}
\alias{utr3.mm10}
\title{Annotation of 3' UTRs for mouse (mm10)}
\format{
An object of \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges} with 7 metadata columns
\describe{
\item{feature}{feature type, utr3, CDS, next.exon.gap}
\item{annotatedProximalCP}{candidate proximal CPsites}
\item{exon}{exon ID}
\item{transcript}{transcript ID}
\item{gene}{gene ID}
\item{symbol}{gene symbol}
\item{truncated}{whether the 3' UTR is trucated}
}
}
\usage{
utr3.mm10
}
\description{
A dataset containing the annotation of the 3' UTRs of the mouse
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/19.get_regionCov.R
\name{get_regionCov}
\alias{get_regionCov}
\title{Get coverage for 3' UTR and last CDS regions on a single chromosome}
\usage{
get_regionCov(
  chr.utr3,
  sqlite_db,
  outdir = getInPASOutputDirectory(),
  phmm = FALSE,
  min.length.diff = 200
)
}
\arguments{
\item{chr.utr3}{An object of \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges}, one element of an output of \code{\link[=extract_UTR3Anno]{extract_UTR3Anno()}}}

\item{sqlite_db}{A path to the SQLite database for InPAS, i.e. the output of
\code{\link[=setup_sqlitedb]{setup_sqlitedb()}}.}

\item{outdir}{A character(1) vector, a path with write permission for storing
InPAS analysis results. If it doesn't exist, it will be created.}

\item{phmm}{A logical(1) vector, indicating whether data should be
prepared for singleSample analysis? By default, FALSE}

\item{min.length.diff}{An integer(1) vector, specifying minimal length
difference between proximal and distal APA sites which should be met to be
considered for differential APA analysis. Default is 200 bp.}
}
\value{
coverage view in GRanges
}
\description{
Get coverage for 3' UTR and last CDS regions on a single chromosome
}
\author{
Jianhong Ou, Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/15.calculate_mse.R
\name{calculate_mse}
\alias{calculate_mse}
\title{Calculate mean squared errors (MSE)}
\usage{
calculate_mse(.ele, search_point_START, search_point_END)
}
\arguments{
\item{.ele}{A numeric vector, storing 3' UTR coverage for a give sample or
collapsed 3' UTR coverage for a given condition}

\item{search_point_START}{An integer, specifying the start position to
calculate MSE}

\item{search_point_END}{An integer, specifying end position to calculate MSE}
}
\value{
a vector of numeric, containing mean squared errors for each searched
site when which is assumed as a bisection site (i.e. potential CP site).
}
\description{
Calculate mean squared errors (MSE) for each searched site which is assumed
bisection site (i.e. potential CP site).
}
\author{
Jianhong Ou, Haibo Liu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/22.test_dPDUI.R
\name{test_dPDUI}
\alias{test_dPDUI}
\title{do test for dPDUI}
\usage{
test_dPDUI(
  eset,
  sqlite_db,
  outdir = getInPASOutputDirectory(),
  method = c("limma", "fisher.exact", "singleSample", "singleGroup"),
  normalize = c("none", "quantiles", "quantiles.robust", "mean", "median"),
  design,
  contrast.matrix,
  coef = 1,
  robust = FALSE,
  ...
)
}
\arguments{
\item{eset}{An object of \linkS4class{UTR3eSet}. It is an output of
\code{\link[=get_UTR3eSet]{get_UTR3eSet()}}}

\item{sqlite_db}{A path to the SQLite database for InPAS, i.e. the output of
setup_sqlitedb().}

\item{outdir}{A character(1) vector, a path with write permission for storing
InPAS analysis results. If it doesn't exist, it will be created.}

\item{method}{A character(1), indicating the method for testing dPDUI. It can
be "limma", "fisher.exact", "singleSample", or "singleGroup"}

\item{normalize}{A character(1), indicating the normalization method. It can
be "none", "quantiles", "quantiles.robust", "mean", or "median"}

\item{design}{a design matrix of the experiment, with rows corresponding to
samples and columns to coefficients to be estimated. Defaults to the unit
vector meaning that the samples are treated as replicates. see
\code{\link[stats:model.matrix]{stats::model.matrix()}}. Required for limma-based analysis.}

\item{contrast.matrix}{a numeric matrix with rows corresponding to
coefficients in fit and columns containing contrasts. May be a vector if
there is only one contrast. see \code{\link[limma:makeContrasts]{limma::makeContrasts()}}. Required for
limma-based analysis.}

\item{coef}{column number or column name specifying which coefficient or
contrast of the linear model is of interest. see more \code{\link[limma:toptable]{limma::topTable()}}.
default value: 1}

\item{robust}{A logical(1) vector, indicating whether the estimation of the empirical Bayes prior
parameters should be robustified against outlier sample variances.}

\item{...}{other arguments are passed to lmFit}
}
\value{
An object of \linkS4class{UTR3eSet}, with the last element \code{testRes} containing the test results in a matrix.
}
\description{
do test for dPDUI
}
\details{
if method is "limma", design matrix and contrast is required. if
method is "fisher.exact", gp1 and gp2 is required.
}
\examples{
library(limma)
path <- system.file("extdata", package = "InPAS")
load(file.path(path, "eset.MAQC.rda"))
tags <- colnames(eset@PDUI)
g <- factor(gsub("\\\\..*$", "", tags))
design <- model.matrix(~ -1 + g)
colnames(design) <- c("Brain", "UHR")
contrast.matrix <- makeContrasts(
  contrasts = "Brain-UHR",
  levels = design
)
res <- test_dPDUI(
  eset = eset,
  sqlite_db,
  method = "limma",
  normalize = "none",
  design = design,
  contrast.matrix = contrast.matrix
)
}
\seealso{
\code{\link[=run_singleSampleAnalysis]{run_singleSampleAnalysis()}}, \code{\link[=run_singleGroupAnalysis]{run_singleGroupAnalysis()}},
\code{\link[=run_fisherExactTest]{run_fisherExactTest()}}, \code{\link[=run_limmaAnalysis]{run_limmaAnalysis()}}
}
\author{
Jianhong Ou, Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.setup_sqlitedb.R
\name{setup_sqlitedb}
\alias{setup_sqlitedb}
\title{Create an SQLite database for storing metadata and paths to coverage files}
\usage{
setup_sqlitedb(metadata, outdir = getInPASOutputDirectory())
}
\arguments{
\item{metadata}{A path to a tab-delimited file, with columns "tag", "condition",
and "bedgraph_file", storing a unique name tag for each sample, a condition
name for each sample, such as "treatment" and "control", and a path to the
bedgraph file for each sample}

\item{outdir}{A character(1) vector, a path with write permission for storing
InPAS analysis results. If it doesn't exist, it will be created.}
}
\value{
A character(1) vector, the path to the SQLite database
}
\description{
Create an SQLite database with five tables, "metadata","sample_coverage",
"chromosome_coverage", "CPsites", and "utr3_coverage", for storing metadata
(sample tag, condition, paths to bedgraph files, and sample total read
coverage), sample-then-chromosome-oriented coverage files (sample tag,
chromosome, paths to bedgraph files for each chromosome), and paths to
chromosome-then-sample-oriented coverage files (chromosome, paths to
bedgraph files for each chromosome), CP sites on each chromosome (chromosome,
paths to cpsite files), read coverage for 3' UTR and last CDS regions on each
chromosome (chromosome, paths to utr3 coverage file), respectively
}
\examples{
if (interactive()) {
  bedgraphs <- system.file("extdata", c(
    "Baf3.extract.bedgraph",
    "UM15.extract.bedgraph"
  ),
  package = "InPAS"
  )
  tags <- c("Baf3", "UM15")
  metadata <- data.frame(
    tag = tags,
    condition = c("Baf3", "UM15"),
    bedgraph_file = bedgraphs
  )
  outdir <- tempdir()
  write.table(metadata,
    file = file.path(outdir, "metadata.txt"),
    sep = "\t", quote = FALSE, row.names = FALSE
  )
  sqlite_db <- setup_sqlitedb(
    metadata =
      file.path(outdir, "metadata.txt"),
    outdir
  )
}
}
\author{
Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/12.search_CPs.R
\name{search_CPs}
\alias{search_CPs}
\title{Estimate the CP sites for UTRs on a given chromosome}
\usage{
search_CPs(
  seqname,
  sqlite_db,
  genome = getInPASGenome(),
  MINSIZE = 10,
  window_size = 200,
  search_point_START = 100,
  search_point_END = NA,
  cutEnd = NA,
  filter.last = TRUE,
  adjust_distal_polyA_end = FALSE,
  long_coverage_threshold = 2,
  PolyA_PWM = NA,
  classifier = NA,
  classifier_cutoff = 0.8,
  shift_range = 100,
  step = 2,
  outdir = getInPASOutputDirectory(),
  silence = FALSE,
  cluster_type = c("interactive", "multicore", "torque", "slurm", "sge", "lsf",
    "openlava", "socket"),
  template_file = NULL,
  mc.cores = 1,
  future.chunk.size = 50,
  resources = list(walltime = 3600 * 8, ncpus = 4, mpp = 1024 * 4, queue = "long", memory
    = 4 * 4 * 1024),
  DIST2ANNOAPAP = 500,
  DIST2END = 1000,
  output.all = FALSE
)
}
\arguments{
\item{seqname}{A character(1) vector, specifying a chromososome/scaffold name}

\item{sqlite_db}{A path to the SQLite database for InPAS, i.e. the output of
\code{\link[=setup_sqlitedb]{setup_sqlitedb()}}.}

\item{genome}{A \link[BSgenome:BSgenome-class]{BSgenome::BSgenome} object}

\item{MINSIZE}{A integer(1) vector, specifying the minimal length in bp of a
short/proximal 3' UTR. Default, 10}

\item{window_size}{An integer(1) vector, the window size for novel distal or
proximal CP site searching. default: 200.}

\item{search_point_START}{A integer(1) vector, starting point relative to
the 5' extremity of 3' UTRs for searching for proximal CP sites}

\item{search_point_END}{A integer(1) vector, ending point relative to the 3'
extremity of 3' UTRs for searching for proximal CP sites}

\item{cutEnd}{An integer(1) vector a numeric(1) vector. What percentage or
how many nucleotides should be removed from 5' extremities before searching
for proximal CP sites? It can be a decimal between 0, and 1, or an integer
greater than 1. 0.1 means 10 percent, 25 means cut first 25 bases}

\item{filter.last}{A logical(1), whether to filter out the last valley, which
is likely the 3' end of the longer 3' UTR if no novel distal CP site is
detected and the 3' end excluded by setting cutEnd/search_point_END is small.}

\item{adjust_distal_polyA_end}{A logical(1) vector. If true, distal CP sites
are subject to adjustment by the Naive Bayes classifier from the
\link[cleanUpdTSeq:cleanUpdTSeq]{cleanUpdTSeq::cleanUpdTSeq-package}}

\item{long_coverage_threshold}{An integer(1) vector, specifying the cutoff
threshold of coverage for the terminal of long form 3' UTRs. If the coverage
of first 100 nucleotides is lower than coverage_threshold, that transcript
will be not considered for further analysis. Default, 2.}

\item{PolyA_PWM}{An R object for a position weight matrix (PWM) for a hexamer
polyadenylation signal (PAS), such as AAUAAA.}

\item{classifier}{An R object for Naive Bayes classifier model, like the one
in the cleanUpdTSeq package.}

\item{classifier_cutoff}{A numeric(1) vector. A cutoff of probability that a
site is classified as true CP sites. The value should be between 0.5 and 1.
Default, 0.8.}

\item{shift_range}{An integer(1) vector, specifying a shift range for
adjusting the proximal and distal CP sites. Default, 50. It determines the
range flanking the candidate CP sites to search the most likely real
CP sites.}

\item{step}{An integer (1) vector, specifying the step size used for adjusting
the proximal or distal CP sites using the Naive Bayes classifier from the
cleanUpdTSeq package. Default 1. It can be in the range of 1 to 10.}

\item{outdir}{A character(1) vector, a path with write permission for storing
the CP sites. If it doesn't exist, it will be created.}

\item{silence}{A logical(1), indicating whether progress is reported or not.
By default, FALSE}

\item{cluster_type}{A character (1) vector, indicating the type of cluster
job management systems. Options are "interactive","multicore", "torque",
"slurm", "sge", "lsf", "openlava", and "socket". see
\href{https://mllg.github.io/batchtools/articles/batchtools.html}{batchtools vignette}}

\item{template_file}{A charcter(1) vector, indicating the template file for
job submitting scripts when cluster_type is set to "torque", "slurm",
"sge", "lsf", or "openlava".}

\item{mc.cores}{An integer(1), number of cores for making multicore clusters
or socket clusters using \pkg{batchtools}, and for \code{\link[parallel:mclapply]{parallel::mclapply()}}}

\item{future.chunk.size}{The average number of elements per future
("chunk"). If Inf, then all elements are processed in a single future.
If NULL, then argument future.scheduling = 1 is used by default. Users can
set future.chunk.size = total number of elements/number of cores set for
the backend. See the future.apply package for details. Default, 50. This
parameter is used to split the candidate 3' UTRs for alternative SP sites
search.}

\item{resources}{A named list specifying the computing resources when
cluster_type is set to "torque", "slurm", "sge", "lsf", or "openlava". See
\href{https://mllg.github.io/batchtools/articles/batchtools.html}{batchtools vignette}}

\item{DIST2ANNOAPAP}{An integer, specifying a cutoff for annotate MSE valleys
with known proximal APAs in a given downstream distance. Default is 500.}

\item{DIST2END}{An integer, specifying a cutoff of the distance between last
valley and the end of the 3' UTR (where MSE of the last base is calculated).
If the last valley is closer to the end than the specified distance, it will
not be considered because it is very likely due to RNA coverage decay at the
end of mRNA. Default is 1200. User can consider a value between 1000 and
1500, depending on the library preparation procedures: RNA fragmentation and
size selection.}

\item{output.all}{A logical(1), indicating whether to output entries with only
single CP site for a 3' UTR. Default, FALSE.}
}
\value{
An object of \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges} containing distal and
proximal CP site information for each 3' UTR if detected.
}
\description{
Estimate the CP sites for UTRs on a given chromosome
}
\examples{
if (interactive()) {
  library(BSgenome.Mmusculus.UCSC.mm10)
  library(TxDb.Mmusculus.UCSC.mm10.knownGene)
  genome <- BSgenome.Mmusculus.UCSC.mm10
  TxDb <- TxDb.Mmusculus.UCSC.mm10.knownGene

  ## load UTR3 annotation and convert it into a GRangesList
  data(utr3.mm10)
  utr3 <- split(utr3.mm10, seqnames(utr3.mm10), drop = TRUE)

  bedgraphs <- system.file("extdata", c(
    "Baf3.extract.bedgraph",
    "UM15.extract.bedgraph"
  ),
  package = "InPAS"
  )
  tags <- c("Baf3", "UM15")
  metadata <- data.frame(
    tag = tags,
    condition = c("Baf3", "UM15"),
    bedgraph_file = bedgraphs
  )
  outdir <- tempdir()
  write.table(metadata,
    file = file.path(outdir, "metadata.txt"),
    sep = "\t", quote = FALSE, row.names = FALSE
  )

  sqlite_db <- setup_sqlitedb(metadata = file.path(
    outdir,
    "metadata.txt"
  ), outdir)
  addLockName(filename = tempfile())
  coverage <- list()
  for (i in seq_along(bedgraphs)) {
    coverage[[tags[i]]] <- get_ssRleCov(
      bedgraph = bedgraphs[i],
      tag = tags[i],
      genome = genome,
      sqlite_db = sqlite_db,
      outdir = outdir,
      chr2exclude = "chrM"
    )
  }
  data4CPsSearch <- setup_CPsSearch(sqlite_db,
    genome,
    chr.utr3 = utr3[["chr6"]],
    seqname = "chr6",
    background = "10K",
    TxDb = TxDb,
    hugeData = TRUE,
    outdir = outdir,
    minZ = 2,
    cutStart = 10,
    MINSIZE = 10,
    coverage_threshold = 5
  )
  ## polyA_PWM
  load(system.file("extdata", "polyA.rda", package = "InPAS"))

  ## load the Naive Bayes classifier model from the cleanUpdTSeq package
  library(cleanUpdTSeq)
  data(classifier)
  ## the following setting just for demo.
  if (.Platform$OS.type == "window") {
    plan(multisession)
  } else {
    plan(multicore)
  }
  CPs <- search_CPs(
    seqname = "chr6",
    sqlite_db = sqlite_db,
    genome = genome,
    MINSIZE = 10,
    window_size = 100,
    search_point_START = 50,
    search_point_END = NA,
    cutEnd = 0,
    filter.last = TRUE,
    adjust_distal_polyA_end = TRUE,
    long_coverage_threshold = 2,
    PolyA_PWM = pwm,
    classifier = classifier,
    classifier_cutoff = 0.8,
    shift_range = 100,
    step = 5,
    outdir = outdir
  )
}
}
\seealso{
\code{\link[=search_proximalCPs]{search_proximalCPs()}}, \code{\link[=adjust_proximalCPs]{adjust_proximalCPs()}},
\code{\link[=adjust_proximalCPsByPWM]{adjust_proximalCPsByPWM()}}, \code{\link[=adjust_proximalCPsByNBC]{adjust_proximalCPsByNBC()}},
\code{\link[=get_PAscore]{get_PAscore()}}, \code{\link[=get_PAscore2]{get_PAscore2()}}
}
\author{
Jianhong Ou, Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.get_GCandMappability.R
\name{gcComp}
\alias{gcComp}
\title{Calculate weights for GC composition}
\usage{
gcComp(genome, seqnames, window = 50, future.chunk.size = NULL)
}
\arguments{
\item{genome}{An object of \link[BSgenome:BSgenome-class]{BSgenome::BSgenome}}

\item{seqnames}{a character(n) vector, the chromosome/scaffolds' names
in the same forms of seqnames in the BSgenome}

\item{window}{size of a sliding window, which optimally is set to the read
length}

\item{future.chunk.size}{The average number of elements per future
("chunk"). If Inf, then all elements are processed in a single future.
If NULL, then argument future.scheduling = 1 is used by default. Users can
set future.chunk.size = total number of elements/number of cores set for
the backend. See the future.apply package for details.}
}
\value{
A list of numeric vectors containing the weight (scaffold-level GC\\%
/ GC\\% per sliding window) for GC composition-based correction for each
chromosome/scaffold.
}
\description{
Calculate read weights for GC composition-based coverage correction
}
\examples{
\dontrun{
library(BSgenome.Mmusculus.UCSC.mm10)
genome <- BSgenome.Mmusculus.UCSC.mm10
InPAS:::gcComp(genome, "chr1")
}

}
\references{
Cheung et al. Systematic bias in high-throughput sequencing data
and its correction by BEADS. Nucleic Acids Res. 2011 Aug;39(15):e103.
}
\author{
Jianhong Ou, Haibo Liu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.get_seqLen.R
\name{get_seqLen}
\alias{get_seqLen}
\title{Get sequence lengths for chromosomes/scaffolds}
\usage{
get_seqLen(genome = getInPASGenome(), chr2exclude = getChr2Exclude())
}
\arguments{
\item{genome}{An object of \link[BSgenome:BSgenome-class]{BSgenome::BSgenome}}

\item{chr2exclude}{A character vector, NA or NULL, specifying chromosomes or
scaffolds to be excluded for InPAS analysis. \code{chrM} and alternative scaffolds
representing different haplotypes should be excluded.}
}
\value{
A named numeric vector containing lengths per seqname, with the
seqnames as the names
}
\description{
Get sequence lengths for chromosomes/scaffolds from a
\link[BSgenome:BSgenome-class]{BSgenome::BSgenome} object
}
\examples{
library(BSgenome.Mmusculus.UCSC.mm10)
genome <- BSgenome.Mmusculus.UCSC.mm10
InPAS:::get_seqLen(
  genome = genome,
  chr2exclude = "chrM"
)
}
\seealso{
\link[Seqinfo:Seqinfo-class]{Seqinfo::Seqinfo}
}
\author{
Jianhong Ou, Haibo Liu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.setup_sqlitedb.R
\name{getInPASSQLiteDb}
\alias{getInPASSQLiteDb}
\title{Get the path to an SQLite database}
\usage{
getInPASSQLiteDb()
}
\value{
A path to an SQLite database
}
\description{
Get the path to an SQLite database
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.set_globals.R
\name{.onAttach}
\alias{.onAttach}
\title{A function called upon a package is attached to the search path}
\usage{
.onAttach(libname, pkgname)
}
\arguments{
\item{libname}{library name}

\item{pkgname}{package name}
}
\description{
A function called upon a package is attached to the search path
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/09.get_zScoreCutoff.R
\name{get_zScoreCutoff}
\alias{get_zScoreCutoff}
\title{Calculate local background cutoff value}
\usage{
get_zScoreCutoff(
  background,
  chr.introns,
  chr.totalCov,
  chr.utr3,
  seqname,
  z = 2
)
}
\arguments{
\item{background}{A character(1) vector, indicating how background coverage
is defined.}

\item{chr.introns}{An object of \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges} for introns
of a give chromosome/scaffold}

\item{chr.totalCov}{total coverage for a given chromosome/scaffold, an output
from \code{\link[=get_totalCov]{get_totalCov()}} for a given chromosome/scaffold}

\item{chr.utr3}{An object of \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges}, an element of
the output of \code{\link[=extract_UTR3Anno]{extract_UTR3Anno()}} for a given chromosome/scaffold}

\item{seqname}{A character(1), the name of a chromosome/scaffold}

\item{z}{Z score cutoff value}
}
\value{
A named numeric vector containing local background Z-score cutoff
values. The names are GRanges's name for 3' UTRs.
}
\description{
calculate local background z-score cutoff
}
\author{
Jianhong Ou, Haibo Liu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/07.get_depthWeight.R
\name{get_depthWeight}
\alias{get_depthWeight}
\title{Calculate the depth weight for each sample or each experimental condition}
\usage{
get_depthWeight(metadata, hugeData)
}
\arguments{
\item{metadata}{A data frame containing the metadata for a RNA-seq experiment,
which can be extract from the SQLite database set up by \code{\link[=setup_sqlitedb]{setup_sqlitedb()}}}

\item{hugeData}{A logical(1), indicating whether it is huge data}
}
\value{
A named numeric vector containing depth weight for each sample for
non-hugeData, or depth weight for each condition if hugeData.
}
\description{
Calculate the depth weight for each sample of non-hugeData or each
experimental condition for hugeData: depth/mean(depth)
}
\author{
Jianhong Ou, Haibo Liu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/26.get_usage4plot.R
\name{get_usage4plot}
\alias{get_usage4plot}
\title{prepare coverage data and fitting data for plot}
\usage{
get_usage4plot(gr, proximalSites, sqlite_db, hugeData)
}
\arguments{
\item{gr}{An object of \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges}}

\item{proximalSites}{An integer(n) vector, specifying the coordinates of
proximal CP sites. Each of the proximal sites must match one entry in the
GRanges object, \code{gr}.}

\item{sqlite_db}{A path to the SQLite database for InPAS, i.e. the output of
\code{\link[=setup_sqlitedb]{setup_sqlitedb()}}.}

\item{hugeData}{A logical(1), indicating whether it is huge data}
}
\value{
An object of \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges} with metadata:
\item{dat}{A data.frame, first column is the position, the other columns are
Coverage and value}
\item{offset}{offset from the start of 3' UTR}
}
\description{
prepare coverage data and fitting data for plot
}
\examples{
library(BSgenome.Mmusculus.UCSC.mm10)
library(TxDb.Mmusculus.UCSC.mm10.knownGene)
genome <- BSgenome.Mmusculus.UCSC.mm10
TxDb <- TxDb.Mmusculus.UCSC.mm10.knownGene

## load UTR3 annotation and convert it into a GRangesList
data(utr3.mm10)
utr3 <- split(utr3.mm10, seqnames(utr3.mm10), drop = TRUE)

bedgraphs <- system.file("extdata", c(
  "Baf3.extract.bedgraph",
  "UM15.extract.bedgraph"
),
package = "InPAS"
)
tags <- c("Baf3", "UM15")
metadata <- data.frame(
  tag = tags,
  condition = c("baf", "UM15"),
  bedgraph_file = bedgraphs
)
outdir <- tempdir()
write.table(metadata,
  file = file.path(outdir, "metadata.txt"),
  sep = "\t", quote = FALSE, row.names = FALSE
)

sqlite_db <- setup_sqlitedb(
  metadata = file.path(
    outdir,
    "metadata.txt"
  ),
  outdir
)
addLockName(filename = tempfile())
coverage <- list()
for (i in seq_along(bedgraphs)) {
  coverage[[tags[i]]] <- get_ssRleCov(
    bedgraph = bedgraphs[i],
    tag = tags[i],
    genome = genome,
    sqlite_db = sqlite_db,
    outdir = outdir,
    chr2exclude = "chrM"
  )
}
data4CPsSearch <- setup_CPsSearch(sqlite_db,
  genome,
  chr.utr3 = utr3[["chr6"]],
  seqname = "chr6",
  background = "10K",
  TxDb = TxDb,
  hugeData = TRUE,
  outdir = outdir
)

gr <- GRanges("chr6", IRanges(128846245, 128850081), strand = "-")
names(gr) <- "chr6:128846245-128850081"
data4plot <- get_usage4plot(gr,
  proximalSites = 128849148,
  sqlite_db,
  hugeData = TRUE
)
plot_utr3Usage(
  usage_data = data4plot,
  vline_color = "purple",
  vline_type = "dashed"
)
}
\author{
Jianhong Ou, Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/15.adjust_proximalCPsByNBC.R
\name{adjust_proximalCPsByNBC}
\alias{adjust_proximalCPsByNBC}
\title{adjust the proximal CP sites by using Naive Bayes classifier from cleanUpdTSeq}
\usage{
adjust_proximalCPsByNBC(
  idx.list,
  cov_diff.list,
  seqnames,
  starts,
  strands,
  genome,
  classifier,
  classifier_cutoff,
  shift_range,
  search_point_START,
  step = 1
)
}
\arguments{
\item{idx.list}{the offset of positions of CP sites}

\item{cov_diff.list}{the MSE values}

\item{seqnames}{a character(n) vector, the chromosome/scaffolds' names}

\item{starts}{starts}

\item{strands}{strands}

\item{genome}{a \link[BSgenome:BSgenome-class]{BSgenome::BSgenome} object}

\item{classifier}{cleanUpdTSeq classifier}

\item{classifier_cutoff}{cutoff value of the classifier}

\item{shift_range}{the searching range for the better CP sites}

\item{search_point_START}{just in case there is no better CP sites}

\item{step}{adjusting step, default 1, means adjust by each base by
cleanUpdTSeq.}
}
\value{
the offset of positions of CP sites after filter
}
\description{
adjust the proximal CP sites by using Naive Bayes classifier from cleanUpdTSeq
}
\details{
the step for calculating is 10, can not do every base base it is
really very slow.
}
\seealso{
\code{\link[=adjust_proximalCPsByPWM]{adjust_proximalCPsByPWM()}}, \code{\link[=get_PAscore2]{get_PAscore2()}}
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/23.run_singleSampleAnalysis.R
\name{run_singleSampleAnalysis}
\alias{run_singleSampleAnalysis}
\title{do APA analysis for a single sample}
\usage{
run_singleSampleAnalysis(UTR3eset)
}
\arguments{
\item{UTR3eset}{the output of \code{\link[=get_UTR3eSet]{get_UTR3eSet()}}}
}
\value{
a matrix containing test results
}
\description{
do APA event analysis for a single sample Using Poisson Hidden
Markov models
}
\details{
the test will be performed by comparing a two-state versus an
one-state Poisson Hidden Markov models.
}
\examples{
path <- system.file("extdata", package = "InPAS")
load(file.path(path, "eset.MAQC.rda"))
res <- InPAS:::run_singleSampleAnalysis(eset)
}
\seealso{
\linkS4class{UTR3eSet}, \code{\link[=get_UTR3eSet]{get_UTR3eSet()}}, \code{\link[depmixS4:depmix]{depmixS4::depmix()}}
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/14.adjust_distalCPs.R
\name{adjust_distalCPs}
\alias{adjust_distalCPs}
\title{Adjust distal CP sites by the cleanUpdTSeq algorithm}
\usage{
adjust_distalCPs(
  distalCPs,
  classifier,
  classifier_cutoff,
  shift_range,
  genome,
  seqname,
  step = 1
)
}
\arguments{
\item{distalCPs}{the output of \code{\link[=search_distalCPs]{search_distalCPs()}}}

\item{classifier}{An R object for Naive Bayes classifier model, like the one
in the cleanUpdTSeq package.}

\item{classifier_cutoff}{A numeric(1) vector. A cutoff of probability that a
site is classified as true CP sites. The value should be between 0.5 and 1.
Default, 0.8.}

\item{shift_range}{An integer(1) vector, specifying a shift range for
adjusting the proximal and distal CP sites. Default, 50. It determines the
range flanking the candidate CP sites to search the most likely CP sites.}

\item{genome}{a \link[BSgenome:BSgenome-class]{BSgenome::BSgenome} object}

\item{seqname}{A character(1) vector, specifying a chromososome/scaffold name}

\item{step}{An integer (1) vector, specifying the step size used for adjusting
the proximal or distal CP sites using the Naive Bayes classifier from the
cleanUpdTSeq package. Default 1. It can be in the range of 1 to 5.}
}
\description{
Adjust distal CP sites by the cleanUpdTSeq algorithm
}
\seealso{
\code{\link[=search_proximalCPs]{search_proximalCPs()}}, \code{\link[=get_PAscore2]{get_PAscore2()}}
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.get_GCandMappability.R
\name{mapComp}
\alias{mapComp}
\title{Calculate weights for mappability-base coverage correction}
\usage{
mapComp(mi)
}
\arguments{
\item{mi}{A numeric vector of mappability along per
chromosome/scaffold}
}
\value{
A numeric vector of weights for mappability-based
coverage correction
}
\description{
mappability is calculated by using
\href{http://algorithms.cnag.cat/wiki/Man:gem-mappability}{GEM}
with the following command lines:
PATH=$PATH:~/bin/GEM-binaries-Linux-x86_64-core_i3-20130406-045632/bin
./gem-indexer -i genome.fa -o mm10.index.gem
./gem-mappability -I mm10.index.gem.gem -l 100 -o mm10.mappability
./gem-2-wig -I mm10.index.gem.gem -i mm10.mappability -o mm10.mappability.wig
}
\details{
Calculate weights for mappability-base coverage correction
}
\references{
Derrien et al. Fast computation and applications of genome
mappability. PLoS One. 2012;7(1):e30377. doi: 10.1371/journal.pone.0030377.
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/15.adjust_proximalCPs.R
\name{adjust_proximalCPs}
\alias{adjust_proximalCPs}
\title{Adjust the proximal CP sites}
\usage{
adjust_proximalCPs(
  CPs,
  PolyA_PWM,
  genome,
  classifier,
  classifier_cutoff,
  shift_range,
  search_point_START,
  step = 1,
  DIST2ANNOAPAP = 1000
)
}
\arguments{
\item{CPs}{the outputs of \code{\link[=search_proximalCPs]{search_proximalCPs()}}}

\item{PolyA_PWM}{PolyA position weight matrix}

\item{genome}{a \link[BSgenome:BSgenome-class]{BSgenome::BSgenome} object}

\item{classifier}{cleanUpdTSeq classifier}

\item{classifier_cutoff}{cutoff value of the classifier}

\item{shift_range}{the searching range for the better CP sites}

\item{search_point_START}{just in case there is no better CP sites}

\item{step}{An integer, specifying an adjusting step, default 1, means
adjusting by each base by cleanUpdTSeq.}

\item{DIST2ANNOAPAP}{An integer, specifying a cutoff for annotate MSE valleys
with known proximal APAs in a given downstream distance. Default is 1500.}
}
\value{
keep same as \code{\link[=search_proximalCPs]{search_proximalCPs()}}, which can be handled by
\code{\link[=polish_CPs]{polish_CPs()}}.
}
\description{
Adjust the proximal CP sites by PolyA PWM and cleanUpdTSeq. A few candidate
sites, which are ranked by MSE from low to high, are used as input for
adjusting. The final sites are the one with best score as PA sites, which are
not necessary from the lowest MSE sites.
}
\seealso{
\code{\link[=search_proximalCPs]{search_proximalCPs()}}, \code{\link[=polish_CPs]{polish_CPs()}}, \code{\link[=adjust_proximalCPsByPWM]{adjust_proximalCPsByPWM()}},
\code{\link[=adjust_proximalCPsByNBC]{adjust_proximalCPsByNBC()}}, \code{\link[=get_PAscore]{get_PAscore()}},\code{\link[=get_PAscore2]{get_PAscore2()}}
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.set_globals.R
\name{addInPASGenome}
\alias{addInPASGenome}
\title{Add a globally defined genome to all InPAS functions.}
\usage{
addInPASGenome(genome = NULL)
}
\arguments{
\item{genome}{A BSgenome object indicating the default genome to be
used for all InPAS functions. This value is stored as a global environment
variable. This can be overwritten on a per-function basis using the given
function's \code{genome} parameter.}
}
\description{
This function will set the genome across all InPAS functions.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.set_globals.R
\name{addInPASTxDb}
\alias{addInPASTxDb}
\title{Add a globally defined TxDb for InPAS functions.}
\usage{
addInPASTxDb(TxDb = NULL)
}
\arguments{
\item{TxDb}{An object of \link[GenomicFeatures:TxDb-class]{GenomicFeatures::TxDb}}
}
\description{
Add a globally defined TxDb for InPAS functions.
}
\examples{
library("TxDb.Hsapiens.UCSC.hg19.knownGene")
addInPASTxDb(TxDb = TxDb.Hsapiens.UCSC.hg19.knownGene)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/08.get_totalCov.R
\name{get_totalCov}
\alias{get_totalCov}
\title{Calculate the total coverage}
\usage{
get_totalCov(sqlite_db, chr.cov, seqname, metadata, outdir, hugeData)
}
\arguments{
\item{sqlite_db}{A path to the SQLite database for InPAS, i.e. the output of
\code{\link[=setup_sqlitedb]{setup_sqlitedb()}}.}

\item{chr.cov}{A list of Rle objects storing coverage per sample for a given
chromosome/scaffold}

\item{seqname}{A character(1), the chromosome/scaffold name}

\item{metadata}{A data frame containing the metadata for a RNA-seq experiment,
which can be extract from the SQLite database set up by \code{\link[=setup_sqlitedb]{setup_sqlitedb()}}}

\item{outdir}{A character(1) vector, a path with write permission for storing
InPAS analysis results. If it doesn't exist, it will be created.}

\item{hugeData}{A logical(1), indicating whether it is huge data}
}
\value{
A list containing pooled coverage data. For hugeData, coverage of
samples under each condition is merged chromosome by chromosome.
For non-hugeData, per-chromosome coverage of all samples are returned.
\describe{
\item{seqname}{chromosome/scaffold name}
\describe{
\item{condition1}{condition name 1}
\item{condition1}{condition name 2}
}
}
}
\description{
For hugeData, coverage of samples in each condition is merged chromosome
by chromosome. For non-hugeData, per-chromosome coverage of all samples
}
\author{
Haibo Liu, Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/16.find_minMSEDistr.R
\name{find_minMSEDistr}
\alias{find_minMSEDistr}
\title{Visualization of MSE profiles, 3' UTR coverage and minimal MSE distribution}
\usage{
find_minMSEDistr(
  CPs,
  outdir = NULL,
  MSE.plot = "MSE.pdf",
  coverage.plot = "coverage.pdf",
  min.MSE.to.end.distr.plot = "min.MSE.to.end.distr.pdf"
)
}
\arguments{
\item{CPs}{A list, output from \code{\link[=search_proximalCPs]{search_proximalCPs()}} or \code{\link[=adjust_distalCPs]{adjust_distalCPs()}}
or \code{\link[=adjust_proximalCPs]{adjust_proximalCPs()}}}

\item{outdir}{A character(1) vector, specifying the output directory}

\item{MSE.plot}{A character(1) vector, specifying a PDF file name for
outputting plots of MSE profiles. No directory path is allowed.}

\item{coverage.plot}{A character(1) vector, specifying a PDF file name for
outputting per-sample coverage profiles. No directory path is allowed.}

\item{min.MSE.to.end.distr.plot}{A character(1) vector, specifying a PDF
file name for outputting histograms showing minimal MSE distribution
relative to longer 3' UTR end. No directory path is allowed.}
}
\description{
Visualization of MSE profiles, 3' UTR coverage and minimal MSE distribution
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/02.extract_UTR3Anno.R
\name{extract_UTR3Anno}
\alias{extract_UTR3Anno}
\title{extract 3' UTR information from a \link[GenomicFeatures:TxDb-class]{GenomicFeatures::TxDb} object}
\usage{
extract_UTR3Anno(
  sqlite_db,
  TxDb = getInPASTxDb(),
  edb = getInPASEnsDb(),
  genome = getInPASGenome(),
  outdir = getInPASOutputDirectory(),
  chr2exclude = getChr2Exclude(),
  MAX_EXONS_GAP = 10000L
)
}
\arguments{
\item{sqlite_db}{A path to the SQLite database for InPAS, i.e. the output of
\code{\link[=setup_sqlitedb]{setup_sqlitedb()}}.}

\item{TxDb}{An object of \link[GenomicFeatures:TxDb-class]{GenomicFeatures::TxDb}}

\item{edb}{An object of \link[ensembldb:EnsDb-class]{ensembldb::EnsDb}}

\item{genome}{An object of \link[BSgenome:BSgenome-class]{BSgenome::BSgenome}}

\item{outdir}{A character(1) vector, a path with write permission for storing
InPAS analysis results. If it doesn't exist, it will be created.}

\item{chr2exclude}{A character vector, NA or NULL, specifying chromosomes or
scaffolds to be excluded for InPAS analysis. \code{chrM} and alternative scaffolds
representing different haplotypes should be excluded.}

\item{MAX_EXONS_GAP}{An integer(1) vector, maximal gap sizes between the last
known CP sites to a nearest downstream exon. Default is 10 kb for mammalian
genomes. For other species, user need to adjust this parameter.}
}
\value{
An object of \link[GenomicRanges:GRangesList-class]{GenomicRanges::GRangesList}, containing GRanges for
extracted 3' UTRs, and the corresponding last CDSs and next.exon.gap for
each chromosome/scaffold. Chromosome
}
\description{
extract 3' UTR information from a \link[GenomicFeatures:TxDb-class]{GenomicFeatures::TxDb} object. The
3'UTR is defined as the last 3'UTR fragment for each transcript and it will
be cut if there is any overlaps with other exons.
}
\details{
A good practice is to perform read alignment using a reference
genome from Ensembl/GenCode including only the primary assembly and build a
TxDb and EnsDb using the GTF/GFF files downloaded from the same source as
the reference genome, such as BioMart/Ensembl/GenCode. For instruction, see
Vignette of the GenomicFeatures. The UCSC reference genomes and their
annotation packages can be very cumbersome.
}
\examples{
library("EnsDb.Hsapiens.v86")
library("BSgenome.Hsapiens.UCSC.hg19")
library("GenomicFeatures")
## set a sqlite database
bedgraphs <- system.file("extdata", c(
  "Baf3.extract.bedgraph",
  "UM15.extract.bedgraph"
),
package = "InPAS"
)
tags <- c("Baf3", "UM15")
metadata <- data.frame(
  tag = tags,
  condition = c("Baf3", "UM15"),
  bedgraph_file = bedgraphs
)
outdir <- tempdir()

write.table(metadata,
  file = file.path(outdir, "metadata.txt"),
  sep = "\t", quote = FALSE, row.names = FALSE
)
sqlite_db <- setup_sqlitedb(
  metadata =
    file.path(outdir, "metadata.txt"),
  outdir
)

samplefile <- system.file("extdata",
  "hg19_knownGene_sample.sqlite",
  package = "GenomicFeatures"
)
TxDb <- loadDb(samplefile)
edb <- EnsDb.Hsapiens.v86
genome <- BSgenome.Hsapiens.UCSC.hg19
addInPASOutputDirectory(outdir)
seqnames <- seqnames(BSgenome.Hsapiens.UCSC.hg19)
chr2exclude <- c(
  "chrM", "chrMT",
  seqnames[grepl("_(hap\\\\d+|fix|alt)$",
    seqnames,
    perl = TRUE
  )]
)
utr3 <- extract_UTR3Anno(sqlite_db, TxDb, edb,
  genome = genome,
  chr2exclude = chr2exclude,
  outdir = tempdir(),
  MAX_EXONS_GAP = 10000L
)
}
\author{
Jianhong Ou, Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.set_globals.R
\name{addChr2Exclude}
\alias{addChr2Exclude}
\title{Add a globally-applied requirement for filtering out scaffolds from
all analysis}
\usage{
addChr2Exclude(chr2exclude = c("chrM", "MT", "Pltd", "chrPltd"))
}
\arguments{
\item{chr2exclude}{A character vector, NA or NULL, specifying chromosomes or
scaffolds to be excluded for InPAS analysis. \code{chrM} and alternative scaffolds
representing different haplotypes should be excluded.}
}
\description{
This function will set the default requirement of filtering out scaffolds
from all analysis.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/20.UTR3eSet-class.R
\docType{class}
\name{UTR3eSet-class}
\alias{UTR3eSet-class}
\alias{$,UTR3eSet-method}
\alias{$<-,UTR3eSet-method}
\alias{coerce,UTR3eSet,ExpressionSet-method}
\alias{coerce,UTR3eSet,GRanges-method}
\alias{show,UTR3eSet-method}
\title{UTR3eSet-class and its methods}
\description{
An object of class \linkS4class{UTR3eSet} representing the results of 3' UTR usage;
methods for constructing, showing, getting and setting attributes of objects;
methods for coercing object of other class to \linkS4class{UTR3eSet} objects.
}
\section{Objects from the Class}{

Objects can be created by calls of the form \code{new("UTR3eSet", ...)}

 Objects can be created by calls of the form
\code{new("UTR3eSet", ...)}.
}

\section{Slots}{

\describe{
\item{\code{usage}}{Object of class \code{"GRanges"}}
\item{\code{PDUI}}{Object of class \code{"matrix"}}
\item{\code{PDUI.log2}}{Object of class \code{"matrix"}}
\item{\code{short}}{Object of class \code{"matrix"}}
\item{\code{long}}{Object of class \code{"matrix"}}
\item{\code{signals}}{Object of class \code{"list"}}
\item{\code{testRes}}{Object of class \code{"matrix"}}
}
}

\section{UTR3eSet-class methods}{

\describe{
\item{$}{\code{signature(x = "UTR3eSet")}: ... }
\item{$<-}{\code{signature(x = "UTR3eSet")}: ... }
\item{coerce}{\code{signature(from = "UTR3eSet", to = "ExpressionSet")}: ... }
\item{coerce}{\code{signature(from = "UTR3eSet", to = "GRanges")}: ... }
\item{show}{\code{signature(object = "UTR3eSet")}: ... }
}
}

\seealso{
\code{GRanges}
}
\author{
Jianhong Ou
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/23.run_fisherExactTest.R
\name{run_fisherExactTest}
\alias{run_fisherExactTest}
\title{Run Fisher Exact Test for differential usage of 3' UTRs for a two-group experimental design}
\usage{
run_fisherExactTest(UTR3eset, gp1, gp2)
}
\arguments{
\item{UTR3eset}{An object of \linkS4class{UTR3eSet}, output of \code{\link[=get_UTR3eSet]{get_UTR3eSet()}}}

\item{gp1}{tag names of group 1}

\item{gp2}{tag names of group 2}
}
\value{
a matrix of test results
}
\description{
Run Fisher Exact Test for differential usage of 3' UTRs for a two-group experimental design
}
\seealso{
\code{\link[=run_singleSampleAnalysis]{run_singleSampleAnalysis()}} for a single-sample APA
analysis,\code{\link[=run_singleGroupAnalysis]{run_singleGroupAnalysis()}} for a single-group sample APA analysis,
\code{\link[=run_limmaAnalysis]{run_limmaAnalysis()}} for limma-based APA analysis of complex experimental
design
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.get_lastCDSUTR3.R
\name{get_lastCDSUTR3}
\alias{get_lastCDSUTR3}
\title{Extract the last unspliced region of each transcript}
\usage{
get_lastCDSUTR3(
  TxDb = getInPASTxDb(),
  genome = getInPASGenome(),
  chr2exclude = getChr2Exclude(),
  outdir = getInPASOutputDirectory(),
  MAX_EXONS_GAP = 10000
)
}
\arguments{
\item{TxDb}{An object of \link[GenomicFeatures:TxDb-class]{GenomicFeatures::TxDb}}

\item{genome}{An object of \link[BSgenome:BSgenome-class]{BSgenome::BSgenome}}

\item{chr2exclude}{A character vector, NA or NULL, specifying chromosomes or
scaffolds to be excluded for InPAS analysis. \code{chrM} and alternative scaffolds
representing different haplotypes should be excluded.}

\item{outdir}{A character(1) vector, a path with write permission for storing
InPAS analysis results. If it doesn't exist, it will be created.}

\item{MAX_EXONS_GAP}{An integer(1) vector, maximal gap sizes between the last
known CP sites to a nearest downstream exon. Default is 10 kb for mammalian
genomes. For other species, user need to adjust this parameter.}
}
\value{
A BED file with 6 columns: chr, chrStart, chrEnd, name, score, and
strand.
}
\description{
Extract the last unspliced region of each transcript from a TxDb. These
regions could be the last 3'UTR exon for transcripts whose 3' UTRs are
composed of multiple exons or last CDS regions and 3'UTRs for transcripts
whose 3'UTRs and last CDS regions are on the same single exon.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/03.get_ssRleCov.R
\name{get_ssRleCov}
\alias{get_ssRleCov}
\title{Get Rle coverage from a bedgraph file for a sample}
\usage{
get_ssRleCov(
  bedgraph,
  tag,
  genome = getInPASGenome(),
  sqlite_db,
  future.chunk.size = NULL,
  outdir = getInPASOutputDirectory(),
  chr2exclude = getChr2Exclude()
)
}
\arguments{
\item{bedgraph}{A path to a bedGraph file}

\item{tag}{A character(1) vector, a name tag used to label the bedgraph file.
It must match the tag specified in the metadata file used to setup the
SQLite database}

\item{genome}{an object \link[BSgenome:BSgenome-class]{BSgenome::BSgenome}. To make things easy, we
suggest users creating a \link[BSgenome:BSgenome-class]{BSgenome::BSgenome} instance from the
reference genome used for read alignment. For details, see the
documentation of \code{\link[BSgenome:AdvancedBSgenomeForge]{BSgenome::forgeBSgenomeDataPkg()}}.}

\item{sqlite_db}{A path to the SQLite database for InPAS, i.e. the output of
\code{\link[=setup_sqlitedb]{setup_sqlitedb()}}.}

\item{future.chunk.size}{The average number of elements per future
("chunk"). If Inf, then all elements are processed in a single future.
If NULL, then argument future.scheduling = 1 is used by default. Users can
set future.chunk.size = total number of elements/number of cores set for
the backend. See the future.apply package for details. You may adjust
this number based based on the available computing resource: CPUs and RAM.
This parameter affects the time for converting coverage from bedgraph to Rle.}

\item{outdir}{A character(1) vector, a path with write permission for storing
InPAS analysis results. If it doesn't exist, it will be created.}

\item{chr2exclude}{A character vector, NA or NULL, specifying chromosomes or
scaffolds to be excluded for InPAS analysis. \code{chrM} and alternative scaffolds
representing different haplotypes should be excluded.}
}
\value{
A data frame, as described below.
\describe{
\item{tag}{the sample tag}
\item{chr}{chromosome name}
\item{coverage_file}{path to Rle coverage files for each chromosome
per sample tag}
}
}
\description{
Get RLe coverage from a bedgraph file for a sample
}
\examples{
if (interactive()) {
  library(BSgenome.Mmusculus.UCSC.mm10)
  genome <- BSgenome.Mmusculus.UCSC.mm10
  bedgraphs <- system.file("extdata", c(
    "Baf3.extract.bedgraph",
    "UM15.extract.bedgraph"
  ),
  package = "InPAS"
  )
  tags <- c("Baf3", "UM15")
  metadata <- data.frame(
    tag = tags,
    condition = c("Baf3", "UM15"),
    bedgraph_file = bedgraphs
  )
  outdir <- tempdir()
  write.table(metadata,
    file = file.path(outdir, "metadata.txt"),
    sep = "\t", quote = FALSE, row.names = FALSE
  )

  sqlite_db <- setup_sqlitedb(
    metadata = file.path(
      outdir,
      "metadata.txt"
    ),
    outdir
  )
  addLockName()
  coverage_info <- get_ssRleCov(
    bedgraph = bedgraphs[1],
    tag = tags[1],
    genome = genome,
    sqlite_db = sqlite_db,
    outdir = outdir,
    chr2exclude = "chrM"
  )
  # check read coverage depth
  db_connect <- dbConnect(drv = RSQLite::SQLite(), dbname = sqlite_db)
  dbReadTable(db_connect, "metadata")
  dbDisconnect(db_connect)
}
}
\author{
Jianhong Ou, Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/01.parse_TxDb.R
\name{assign_feature}
\alias{assign_feature}
\title{Helper function to label the last component of a genomic feature for each
transcript}
\usage{
assign_feature(gr, feature_alt = "utr3")
}
\arguments{
\item{gr}{A tibble converted from an object of \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges}}

\item{feature_alt}{A character(1) vector, specifying the type of genomic
features, such as "CDS", "exon", "utr3", "utr5".}
}
\value{
An object of \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges}
}
\description{
Helper function to label the last component of a genomic feature for each
transcript
}
\author{
Haibo Liu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.get_GCandMappability.R
\name{gcContents}
\alias{gcContents}
\title{helper function to calculate chromosome/scaffold level GC content}
\usage{
gcContents(genome, seqname, nonATCGExclude = TRUE)
}
\arguments{
\item{genome}{an object of \link[BSgenome:BSgenome-class]{BSgenome::BSgenome}}

\item{seqname}{a character(1) vector, the chromosome/scaffold's name}

\item{nonATCGExclude}{a logical(1) vector, whether nucleotides other than A,
T, C, and G should be excluded when GC content is calculated}
}
\value{
a numeric(1) vector, containing the chromosome/scaffold -specific GC
content in the range of 0 to 1
}
\description{
helper function to calculate chromosome/scaffold level GC content
}
\examples{
\dontrun{
library(BSgenome.Mmusculus.UCSC.mm10)
genome <- BSgenome.Mmusculus.UCSC.mm10
InPAS:::gcContents(genome, "chr1")
}

}
\author{
Haibo Liu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/15.search_proximalCPs.R
\name{search_proximalCPs}
\alias{search_proximalCPs}
\title{search proximal CPsites}
\usage{
search_proximalCPs(
  CPs,
  curr_UTR,
  window_size,
  MINSIZE,
  cutEnd = NA,
  search_point_START,
  search_point_END = NA,
  filter.last = TRUE,
  DIST2END = 1000
)
}
\arguments{
\item{CPs}{output from \code{\link[=search_distalCPs]{search_distalCPs()}}}

\item{curr_UTR}{GRanges for current 3' UTR}

\item{window_size}{window size}

\item{MINSIZE}{MINSIZE for short form}

\item{cutEnd}{A numeric(1) between 0 and 1 or an integer(1) greater than 1,
specifying the percentage of or the number of nucleotides should be removed
from the end before search for proximal CP sites, 0.1 means 10 percent.
It is recommended to use an integer great than 1, such as 200, 400 or 600,
because read coverage at 3' extremities is determined by fragment size due
to RNA fragmentation and size selection during library construction.}

\item{search_point_START}{An integer, specifying the start position to
calculate MSE}

\item{search_point_END}{A numeric(1) between 0 and 1 or an integer(1) greater
than 1, specifying the percentage of or the number of nucleotides should not
be excluded from the end to calculate MSE.}

\item{filter.last}{A logical(1), whether to filter out the last valley, which
is likely the 3' end of the longer 3' UTR if no novel distal CP site is
detected and the 3' end excluded by setting cutEnd/search_point_END is small.}

\item{DIST2END}{An integer, specifying a cutoff of the distance between last valley
and the end of the 3' UTR (where MSE of the last base is calculated). If
the last valley is closer to the end than the specified distance, it will be
not be considered because it is very likely due to RNA coverage decay at the
end of mRNA. Default is 1200. User can consider a value between 1000 and
1500, depending on the library preparation procedures: RNA fragmentation and
size selection.}
}
\value{
a list
}
\description{
search proximal CPsites
}
\seealso{
\code{\link[=adjust_proximalCPs]{adjust_proximalCPs()}}, \code{\link[=polish_CPs]{polish_CPs()}},\code{\link[=adjust_proximalCPsByPWM]{adjust_proximalCPsByPWM()}},
\code{\link[=adjust_proximalCPsByNBC]{adjust_proximalCPsByNBC()}}, \code{\link[=get_PAscore]{get_PAscore()}}, \code{\link[=get_PAscore2]{get_PAscore2()}}
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/01.parse_TxDb.R
\name{parse_TxDb}
\alias{parse_TxDb}
\title{Extract gene models from a TxDb object}
\usage{
parse_TxDb(
  sqlite_db = NULL,
  TxDb = getInPASTxDb(),
  edb = getInPASEnsDb(),
  genome = getInPASGenome(),
  chr2exclude = getChr2Exclude(),
  outdir = getInPASOutputDirectory()
)
}
\arguments{
\item{sqlite_db}{A path to the SQLite database for InPAS, i.e. the output of
\code{\link[=setup_sqlitedb]{setup_sqlitedb()}}. It can be \code{NULL}.}

\item{TxDb}{An object of \link[GenomicFeatures:TxDb-class]{GenomicFeatures::TxDb}}

\item{edb}{An object of \link[ensembldb:EnsDb-class]{ensembldb::EnsDb}}

\item{genome}{An object of \link[BSgenome:BSgenome-class]{BSgenome::BSgenome}}

\item{chr2exclude}{A character vector, NA or NULL, specifying chromosomes or
scaffolds to be excluded for InPAS analysis. \code{chrM} and alternative scaffolds
representing different haplotypes should be excluded.}

\item{outdir}{A character(1) vector, a path with write permission for storing
InPAS analysis results. If it doesn't exist, it will be created.}
}
\value{
A \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges} object for gene models
}
\description{
Extract gene models from a TxDb object and annotate last 3' UTR exons and
the last CDSs
}
\details{
A good practice is to perform read alignment using a
reference genome from Ensembl/GenCode including only the primary
assembly and build a TxDb using the GTF/GFF files downloaded
from the same source as the reference genome, such as
BioMart/Ensembl/GenCode. For instruction, see Vignette of the
GenomicFeatures. The UCSC reference genomes and their
annotation can be very cumbersome.
}
\examples{
library("EnsDb.Hsapiens.v86")
library("BSgenome.Hsapiens.UCSC.hg19")
library("GenomicFeatures")

## set a sqlite database
bedgraphs <- system.file("extdata", c(
  "Baf3.extract.bedgraph",
  "UM15.extract.bedgraph"
),
package = "InPAS"
)
tags <- c("Baf3", "UM15")
metadata <- data.frame(
  tag = tags,
  condition = c("Baf3", "UM15"),
  bedgraph_file = bedgraphs
)
outdir <- tempdir()
write.table(metadata,
  file = file.path(outdir, "metadata.txt"),
  sep = "\t", quote = FALSE, row.names = FALSE
)
sqlite_db <- setup_sqlitedb(
  metadata =
    file.path(outdir, "metadata.txt"),
  outdir
)

samplefile <- system.file("extdata",
  "hg19_knownGene_sample.sqlite",
  package = "GenomicFeatures"
)
TxDb <- loadDb(samplefile)
edb <- EnsDb.Hsapiens.v86
genome <- BSgenome.Hsapiens.UCSC.hg19
seqnames <- seqnames(BSgenome.Hsapiens.UCSC.hg19)
chr2exclude <- c(
  "chrM", "chrMT",
  seqnames[grepl("_(hap\\\\d+|fix|alt)$",
    seqnames,
    perl = TRUE
  )]
)
parsed_Txdb <- parse_TxDb(sqlite_db, TxDb, edb, genome,
  chr2exclude = chr2exclude
)
}
\author{
Haibo Liu
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.set_globals.R
\name{addInPASEnsDb}
\alias{addInPASEnsDb}
\title{Add a globally defined EnsDb to some InPAS functions.}
\usage{
addInPASEnsDb(EnsDb = NULL)
}
\arguments{
\item{EnsDb}{An object of \link[ensembldb:EnsDb-class]{ensembldb::EnsDb}}
}
\description{
Add a globally defined EnsDb to some InPAS functions.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/13.search_distalCPs.R
\name{search_distalCPs}
\alias{search_distalCPs}
\title{search distal CP sites}
\usage{
search_distalCPs(
  chr.cov.merge,
  conn_next_utr3,
  curr_UTR,
  window_size,
  depth.weight,
  long_coverage_threshold,
  background,
  z2s
)
}
\arguments{
\item{chr.cov.merge}{merged coverage data for a given chromosome}

\item{conn_next_utr3}{A logical(1) vector, indicating whether joint to next
3UTR or not (used by \code{\link[=remove_convergentUTR3s]{remove_convergentUTR3s()}})}

\item{curr_UTR}{GRanges of 3' UTR for a given chromosome}

\item{window_size}{An integer(1) vector, the window size for novel distal or
proximal CP site searching. default: 100.}

\item{depth.weight}{A named vector. One element of an output of
\code{\link[=setup_CPsSearch]{setup_CPsSearch()}} for coverage depth weight, which is the output of
\code{\link[=get_depthWeight]{get_depthWeight()}}}

\item{long_coverage_threshold}{An integer(1) vector, specifying the cutoff
threshold of coverage for the terminal of long form 3' UTRs. If the coverage
of first 100 nucleotides is lower than coverage_threshold, that transcript
will be not considered for further analysis. Default, 2.}

\item{background}{A character(1) vector, the range for calculating cutoff
threshold of local background. It can be "same_as_long_coverage_threshold",
"1K", "5K","10K", or "50K".}

\item{z2s}{one element of an output of \code{\link[=setup_CPsSearch]{setup_CPsSearch()}} for Z-score cutoff
values, which is the output of \code{\link[=get_zScoreCutoff]{get_zScoreCutoff()}}}
}
\value{
a list
#' \itemize{\item dCPs, a data frame converted from GRanges
\item chr.cov.merge, depth-normalized sample/condition specific
coverage
\item next.exon.gap, all-in-one collapsed, refined next.exon.gap
coverage
\item annotated.utr3,all-in-one collapsed coverage for annotated
proximal UTRs
}
}
\description{
search distal CP sites
}
\seealso{
\code{\link[=get_PAscore2]{get_PAscore2()}}
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/14.remove_convergentUTR3s.R
\name{remove_convergentUTR3s}
\alias{remove_convergentUTR3s}
\title{remove the converging candidates 3' UTRs LIKE UTR3___UTR3}
\usage{
remove_convergentUTR3s(x)
}
\arguments{
\item{x}{the collapsed next.exon.gap coverage}
}
\value{
the collapsed next.exon.gap after removing the next 3UTR
}
\description{
some of the results is from connected two 3' UTRs. We want to remove them.
}
\details{
The algorithm need to be improved.
}
\author{
Jianhong Ou, Haibo Liu
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.InPAS-package.R
\docType{package}
\name{InPAS}
\alias{-package}
\alias{InPAS}
\title{A package for identifying novel Alternative PolyAdenylation
Sites (PAS) based on RNA-seq data}
\description{
The InPAS package provides three categories of important functions:
parse_TxDb, extract_UTR3Anno, get_ssRleCov, assemble_allCov,
get_UTR3eSet, test_dPDUI, run_singleSampleAnalysis,
run_singleGroupAnalysis, run_limmaAnalysis, filter_testOut,
get_usage4plot, setup_GSEA, run_coverageQC
}
\section{functions for retrieving 3' UTR annotation}{
 parse_TxDb,
extract_UTR3Anno, get_lastCDSUTR3
}

\section{functions for processing read coverage data}{
 assemble_allCov,
get_ssRleCov, run_coverageQC, setup_parCPsSearch
}

\section{functions for alternative polyadenylation site analysis}{

test_dPDUI, run_singleSampleAnalysis, run_singleGroupAnalysis,
run_limmaAnalysis, filter_testOut, get_usage4plot
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/23.run_singleGroupAnalysis.R
\name{run_singleGroupAnalysis}
\alias{run_singleGroupAnalysis}
\title{do analysis for single group samples}
\usage{
run_singleGroupAnalysis(UTR3eset)
}
\arguments{
\item{UTR3eset}{An object of \linkS4class{UTR3eSet}, output of \code{\link[=get_UTR3eSet]{get_UTR3eSet()}}}
}
\value{
a matrix of test results
}
\description{
do analysis for single group samples by ANOVA test
}
\examples{
path <- system.file("extdata", package = "InPAS")
load(file.path(path, "eset.MAQC.rda"))
res <- InPAS:::run_singleGroupAnalysis(eset)
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.set_globals.R
\name{getChr2Exclude}
\alias{getChr2Exclude}
\title{Get a globally-applied requirement for filtering scaffolds.}
\usage{
getChr2Exclude()
}
\description{
This function will get the default requirement of filtering scaffolds.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.set_globals.R
\name{getLockName}
\alias{getLockName}
\title{Get the path to a file for locking the SQLite database}
\usage{
getLockName()
}
\value{
A path to a file for locking
}
\description{
Get the path to a file for locking the SQLite database
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/15.adjust_proximalCPsByPWM.R
\name{adjust_proximalCPsByPWM}
\alias{adjust_proximalCPsByPWM}
\title{adjust the proximal CP sites by matching PWM}
\usage{
adjust_proximalCPsByPWM(
  idx,
  PolyA_PWM,
  seqnames,
  starts,
  strands,
  genome,
  shift_range,
  search_point_START
)
}
\arguments{
\item{idx}{the offset of positions of CP sites}

\item{PolyA_PWM}{polyA PWM}

\item{seqnames}{a character(n) vector, the chromosome/scaffolds' names}

\item{starts}{start position in the genome}

\item{strands}{strands}

\item{genome}{an \link[BSgenome:BSgenome-class]{BSgenome::BSgenome} object}

\item{shift_range}{the shift range of PWM hits}

\item{search_point_START}{Not use}
}
\value{
the offset of positions of CP sites after filter
}
\description{
adjust the proximal CP sites by polyA Position Weight Matrix. It only need
the PWM to get match in upstream or downstream shift_range nr.
}
\details{
the hits is searched by \code{\link[Biostrings:matchPWM]{Biostrings::matchPWM()}} and the cutoff is
70\\%
}
\seealso{
\code{\link[=adjust_proximalCPsByNBC]{adjust_proximalCPsByNBC()}}, \code{\link[=get_PAscore]{get_PAscore()}}
}
\author{
Jianhong Ou
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/00.set_globals.R
\name{set_globals}
\alias{set_globals}
\title{Set up global variables for an InPAS analysis}
\usage{
set_globals(
  genome = NULL,
  TxDb = NULL,
  EnsDb = NULL,
  outdir = NULL,
  chr2exclude = c("chrM", "MT", "Pltd", "chrPltd"),
  lockfile = tempfile(tmpdir = getInPASOutputDirectory())
)
}
\arguments{
\item{genome}{An object \link[BSgenome:BSgenome-class]{BSgenome::BSgenome}. To make things easy, we
suggest users creating a \link[BSgenome:BSgenome-class]{BSgenome::BSgenome} instance from the
reference genome used for read alignment. For details, see the
documentation of \code{\link[BSgenome:AdvancedBSgenomeForge]{BSgenome::forgeBSgenomeDataPkg()}}.}

\item{TxDb}{An object of \link[GenomicFeatures:TxDb-class]{GenomicFeatures::TxDb}}

\item{EnsDb}{An object of \link[ensembldb:EnsDb-class]{ensembldb::EnsDb}}

\item{outdir}{A character(1) vector, a path with write permission for storing
InPAS analysis results. If it doesn't exist, it will be created.}

\item{chr2exclude}{A character vector, NA or NULL, specifying chromosomes or
scaffolds to be excluded for InPAS analysis. \code{chrM} and alternative scaffolds
representing different haplotypes should be excluded.}

\item{lockfile}{A character(1) vector, specifying a file name used for
parallel writing to a SQLite database}
}
\description{
Set up global variables for an InPAS analysis
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/06.run_coverageQC.R
\name{run_coverageQC}
\alias{run_coverageQC}
\title{Quality control on read coverage over gene bodies and 3UTRs}
\usage{
run_coverageQC(
  sqlite_db,
  TxDb = getInPASTxDb(),
  edb = getInPASEnsDb(),
  genome = getInPASGenome(),
  cutoff_readsNum = 1,
  cutoff_expdGene_cvgRate = 0.1,
  cutoff_expdGene_sampleRate = 0.5,
  chr2exclude = getChr2Exclude(),
  which = NULL,
  future.chunk.size = 1,
  ...
)
}
\arguments{
\item{sqlite_db}{A path to the SQLite database for InPAS, i.e. the output of
\code{\link[=setup_sqlitedb]{setup_sqlitedb()}}.}

\item{TxDb}{An object of \link[GenomicFeatures:TxDb-class]{GenomicFeatures::TxDb}}

\item{edb}{An object of \link[ensembldb:EnsDb-class]{ensembldb::EnsDb}}

\item{genome}{An object of \link[BSgenome:BSgenome-class]{BSgenome::BSgenome}}

\item{cutoff_readsNum}{cutoff reads number. If the coverage in the location
is greater than cutoff_readsNum,the location will be treated as covered by
signal}

\item{cutoff_expdGene_cvgRate}{cutoff_expdGene_cvgRate and
cutoff_expdGene_sampleRate are  the  parameters used to calculate which
gene is expressed in all input dataset. cutoff_expdGene_cvgRateset the
cutoff value for the coverage rate of each gene;
cutoff_expdGene_sampleRateset the cutoff value for ratio of numbers of
expressed and all samples for each gene. for example, by default,
cutoff_expdGene_cvgRate=0.1 and cutoff_expdGene_sampleRate=0.5,suppose
there are 4 samples, for one gene, if the coverage rates by base are:0.05,
0.12, 0.2, 0.17, this gene will be count as expressed gene because
mean(c(0.05,0.12, 0.2, 0.17) > cutoff_expdGene_cvgRate) >
cutoff_expdGene_sampleRate if the coverage rates by base are: 0.05, 0.12,
0.07, 0.17, this gene will be count as un-expressed gene because
mean(c(0.05, 0.12, 0.07, 0.17) > cutoff_expdGene_cvgRate)<=
cutoff_expdGene_sampleRate}

\item{cutoff_expdGene_sampleRate}{See cutoff_expdGene_cvgRate}

\item{chr2exclude}{A character vector, NA or NULL, specifying chromosomes or
scaffolds to be excluded for InPAS analysis. \code{chrM} and alternative scaffolds
representing different haplotypes should be excluded.}

\item{which}{an object of \link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges} or NULL. If it is
not NULL, only the exons overlapping the given ranges are used. For fast
data quality control, set which to Granges for one or a few large
chromosomes.}

\item{future.chunk.size}{The average number of elements per future
("chunk"). If Inf, then all elements are processed in a single future.
If NULL, then argument future.scheduling = 1 is used by default. Users can
set future.chunk.size = total number of elements/number of cores set for
the backend. See the future.apply package for details.}

\item{...}{Not used yet}
}
\value{
A data frame as described below.
\describe{
\item{gene.coverage.rate}{overage per base for
all genes}
\item{expressed.gene.coverage.rate}{coverage per base for expressed
genes}
\item{UTR3.coverage.rate}{coverage per base for all 3'
UTRs}
\item{UTR3.expressed.gene.subset.coverage.rate}{coverage per base for 3'
UTRs of expressed genes}
\item{rownames}{the names of coverage}
}
}
\description{
Calculate coverage over gene bodies and 3UTRs. This function is used for
quality control of the coverage.The coverage rate can show the complexity of
RNA-seq library.
}
\examples{
if (interactive()) {
  library("BSgenome.Mmusculus.UCSC.mm10")
  library("TxDb.Mmusculus.UCSC.mm10.knownGene")
  library("EnsDb.Mmusculus.v79")

  genome <- BSgenome.Mmusculus.UCSC.mm10
  TxDb <- TxDb.Mmusculus.UCSC.mm10.knownGene
  edb <- EnsDb.Mmusculus.v79

  bedgraphs <- system.file("extdata", c(
    "Baf3.extract.bedgraph",
    "UM15.extract.bedgraph"
  ),
  package = "InPAS"
  )
  tags <- c("Baf3", "UM15")
  metadata <- data.frame(
    tag = tags,
    condition = c("Baf3", "UM15"),
    bedgraph_file = bedgraphs
  )
  outdir <- tempdir()
  write.table(metadata,
    file = file.path(outdir, "metadata.txt"),
    sep = "\t", quote = FALSE, row.names = FALSE
  )

  sqlite_db <- setup_sqlitedb(
    metadata = file.path(
      outdir,
      "metadata.txt"
    ),
    outdir
  )
  tx <- parse_TxDb(
    sqlite_db = sqlite_db,
    TxDb = TxDb,
    edb = edb,
    genome = genome,
    outdir = outdir,
    chr2exclude = "chrM"
  )
  addLockName(filename = tempfile())
  coverage <- list()
  for (i in seq_along(bedgraphs)) {
    coverage[[tags[i]]] <- get_ssRleCov(
      bedgraph = bedgraphs[i],
      tag = tags[i],
      genome = genome,
      sqlite_db = sqlite_db,
      outdir = outdir,
      chr2exclude = "chrM"
    )
  }
  chr_coverage <- assemble_allCov(sqlite_db,
    seqname = "chr6",
    outdir,
    genome
  )
  run_coverageQC(sqlite_db, TxDb, edb, genome,
    chr2exclude = "chrM",
    which = GRanges("chr6",
      ranges = IRanges(98013000, 140678000)
    )
  )
}
}
\author{
Jianhong Ou, Haibo Liu
}
